namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_dw_bwd_data_kernel[] ={ "/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_TYPES_H\n",
"#define GPU_OCL_OCL_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#define unroll_for __attribute__((opencl_unroll_hint)) for\n",
"#define for_ for\n",
"#define CONCAt2(a, b) a##b\n",
"#define CONCAT2(a, b) CONCAt2(a, b)\n",
"#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c)\n",
"#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \\\n",
"        || defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \\\n",
"        || defined(BIA_DT_F16) || defined(ACC_DT_F16)\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#if DT_F32 == 1\n",
"#define DATA_T float\n",
"#define DATA2_T float2\n",
"#define DATA4_T float4\n",
"#define DATA8_T float8\n",
"#define DATA16_T float16\n",
"#define DATA_MAX FLT_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) (float)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_float\n",
"#define CONVERT_DATA2_T convert_float2\n",
"#define CONVERT_DATA4_T convert_float4\n",
"#define CONVERT_DATA8_T convert_float8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_float\n",
"#define AS_DATA2_T as_float2\n",
"#define AS_DATA4_T as_float4\n",
"#define AS_DATA8_T as_float8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif DT_F16 == 1\n",
"#define DATA_T half\n",
"#define DATA2_T half2\n",
"#define DATA4_T half4\n",
"#define DATA8_T half8\n",
"#define DATA16_T half16\n",
"#define DATA_MAX HALF_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0h\n",
"#define DATA_ONE 1.0h\n",
"#define DEF_ACC_DATA_T half\n",
"#define DEF_ACC_DATA2_T half2\n",
"#define DEF_ACC_DATA4_T half4\n",
"#define DEF_ACC_DATA8_T half8\n",
"#define POST_OP_DATA_T half\n",
"#define TO_DATA_T(v) (half)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (half)(v)\n",
"#define DATA_TO_REF convert_half\n",
"#define CONVERT_DATA_T convert_half\n",
"#define CONVERT_DATA2_T convert_half2\n",
"#define CONVERT_DATA4_T convert_half4\n",
"#define CONVERT_DATA8_T convert_half8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_half\n",
"#define AS_DATA2_T as_half2\n",
"#define AS_DATA4_T as_half4\n",
"#define AS_DATA8_T as_half8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_BF16 == 1\n",
"#define DATA_T ushort\n",
"#define POST_OP_DATA_T float\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define DATA16_T ushort16\n",
"#define DATA_MAX as_float(0x7f7f0000)\n",
"#define DATA_MIN (-DATA_MAX)\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define TO_DATA_T(v) cvt_f32_to_bf16(v)\n",
"#define TO_DEF_ACC_DATA_T(v) cvt_bf16_to_f32(v)\n",
"#define DATA_TO_REF cvt_bf16_to_f32\n",
"#define CONVERT_DATA_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA2_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA4_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA8_T cvt_f32_to_bf16\n",
"#define CONVERT_FLOAT_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT2_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT4_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT8_T cvt_bf16_to_f32\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_ushort\n",
"#define AS_DATA2_T as_ushort2\n",
"#define AS_DATA4_T as_ushort4\n",
"#define AS_DATA8_T as_ushort8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_S8 == 1\n",
"#define DATA_T char\n",
"#define DATA2_T char2\n",
"#define DATA4_T char4\n",
"#define DATA8_T char8\n",
"#define DATA16_T char16\n",
"#define DATA_MAX CHAR_MAX\n",
"#define DATA_MIN CHAR_MIN\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T int8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_char_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_char_sat_rte\n",
"#define CONVERT_DATA2_T convert_char2_sat_rte\n",
"#define CONVERT_DATA4_T convert_char4_sat_rte\n",
"#define CONVERT_DATA8_T convert_char8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_char\n",
"#define AS_DATA2_T as_char2\n",
"#define AS_DATA4_T as_char4\n",
"#define AS_DATA8_T as_char8\n",
"#define AS_DATA16_T as_char16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_int8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_U8 == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define DATA16_T uchar16\n",
"#define DATA_MAX UCHAR_MAX\n",
"#define DATA_MIN 0\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T uint8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_uchar_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_uchar_sat_rte\n",
"#define CONVERT_DATA2_T convert_uchar2_sat_rte\n",
"#define CONVERT_DATA4_T convert_uchar4_sat_rte\n",
"#define CONVERT_DATA8_T convert_uchar8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_uchar\n",
"#define AS_DATA2_T as_uchar2\n",
"#define AS_DATA4_T as_uchar4\n",
"#define AS_DATA8_T as_uchar8\n",
"#define AS_DATA16_T as_uchar16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_uint8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_S32 == 1\n",
"#define DATA_T int\n",
"#define DATA2_T int2\n",
"#define DATA4_T int4\n",
"#define DATA8_T int8\n",
"#define DATA16_T int16\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_int_sat_rte\n",
"#define CONVERT_DATA2_T convert_int2_sat_rte\n",
"#define CONVERT_DATA4_T convert_int4_sat_rte\n",
"#define CONVERT_DATA8_T convert_int8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define POST_OP_DATA_T float\n",
"#define DATA_MIN INT_MIN\n",
"#define DATA_MAX INT_MAX\n",
"#define ROUND\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_int\n",
"#define AS_DATA2_T as_int2\n",
"#define AS_DATA4_T as_int4\n",
"#define AS_DATA8_T as_int8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif !defined(DT_UNDEF)\n",
"#error \"Unexpected data type\"\n",
"#endif\n",
"#if VECT_DT_N == 1\n",
"#define VECT_DATA_T DATA_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T\n",
"#define AS_VECT_DATA_T AS_DATA_T\n",
"#define VECT_BLOCK_READ BLOCK_READ\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE\n",
"#define VECT_UINT_READ intel_sub_group_block_read\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T\n",
"#define VECT_INT_T int\n",
"#define VECT_UINT_T uint\n",
"#define VECT_FLOAT_T float\n",
"#define VECT_CHAR_T char\n",
"#define AS_VECT_INT_T as_int\n",
"#define AS_VECT_UINT_T as_uint\n",
"#define AS_VECT_FLOAT_T as_float\n",
"#define AS_VECT_CHAR_T as_char\n",
"#elif VECT_DT_N == 2\n",
"#define VECT_DATA_T DATA2_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T\n",
"#define AS_VECT_DATA_T AS_DATA2_T\n",
"#define VECT_BLOCK_READ BLOCK_READ2\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE2\n",
"#define VECT_UINT_READ intel_sub_group_block_read2\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write2\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc2\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA2_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T\n",
"#define VECT_INT_T int2\n",
"#define VECT_UINT_T uint2\n",
"#define VECT_FLOAT_T float2\n",
"#define VECT_CHAR_T char2\n",
"#define AS_VECT_INT_T as_int2\n",
"#define AS_VECT_UINT_T as_uint2\n",
"#define AS_VECT_FLOAT_T as_float2\n",
"#define AS_VECT_CHAR_T as_char2\n",
"#elif VECT_DT_N == 4\n",
"#define VECT_DATA_T DATA4_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T\n",
"#define AS_VECT_DATA_T AS_DATA4_T\n",
"#define VECT_BLOCK_READ BLOCK_READ4\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE4\n",
"#define VECT_UINT_READ intel_sub_group_block_read4\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write4\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc4\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA4_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T\n",
"#define VECT_INT_T int4\n",
"#define VECT_UINT_T uint4\n",
"#define VECT_FLOAT_T float4\n",
"#define VECT_CHAR_T char4\n",
"#define AS_VECT_INT_T as_int4\n",
"#define AS_VECT_UINT_T as_uint4\n",
"#define AS_VECT_FLOAT_T as_float4\n",
"#define AS_VECT_CHAR_T as_char4\n",
"#elif VECT_DT_N == 8\n",
"#define VECT_DATA_T DATA8_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T\n",
"#define AS_VECT_DATA_T AS_DATA8_T\n",
"#define VECT_BLOCK_READ BLOCK_READ8\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE8\n",
"#define VECT_UINT_READ intel_sub_group_block_read8\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write8\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc8\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA8_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T\n",
"#define VECT_INT_T int8\n",
"#define VECT_UINT_T uint8\n",
"#define VECT_FLOAT_T float8\n",
"#define VECT_CHAR_T char8\n",
"#define AS_VECT_INT_T as_int8\n",
"#define AS_VECT_UINT_T as_uint8\n",
"#define AS_VECT_FLOAT_T as_float8\n",
"#define AS_VECT_CHAR_T as_char8\n",
"#endif\n",
"#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T)\n",
"#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T)\n",
"#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T)\n",
"#ifdef SRC_DATA_T\n",
"#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2)\n",
"#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4)\n",
"#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8)\n",
"#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16)\n",
"#ifdef SRC_DT_U8\n",
"#define SRC_MMAD_DATA_T uint\n",
"#define SRC_MMAD_DATA4_T uint4\n",
"#define SRC_MMAD_DATA8_T uint8\n",
"#elif SRC_DT_S8\n",
"#define SRC_MMAD_DATA_T int\n",
"#define SRC_MMAD_DATA4_T int4\n",
"#define SRC_MMAD_DATA8_T int8\n",
"#endif\n",
"#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T)\n",
"#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T)\n",
"#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T)\n",
"#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T)\n",
"#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T)\n",
"#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T)\n",
"#if SRC_DT_BF16\n",
"#define SRC_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define SRC_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define SRC_TO_REF(x) (x)\n",
"#define SRC_TO_REF8(x) (x)\n",
"#define REF_TO_SRC(x) (x)\n",
"#endif\n",
"#if SRC_DT_BF16\n",
"#define TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#elif SRC_DT_U8\n",
"#define TO_SRC(x) convert_uchar_sat_rte(x)\n",
"#elif SRC_DT_S8\n",
"#define TO_SRC(x) convert_char_sat_rte(x)\n",
"#elif SRC_DT_S32\n",
"#define TO_SRC(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_SRC(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef A_DATA_T\n",
"#define A_DATA8_T CONCAT2(A_DATA_T, 8)\n",
"#if A_DT_BF16\n",
"#define A_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define A_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_A(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define A_TO_REF(x) (x)\n",
"#define A_TO_REF8(x) (x)\n",
"#define REF_TO_A(x) (x)\n",
"#endif\n",
"#if A_DT_BF16\n",
"#define TO_A(x) cvt_f32_to_bf16(x)\n",
"#elif A_DT_U8\n",
"#define TO_A(x) convert_uchar_sat_rte(x)\n",
"#elif A_DT_S8\n",
"#define TO_A(x) convert_char_sat_rte(x)\n",
"#elif A_DT_S32\n",
"#define TO_A(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_A(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef WEI_DATA_T\n",
"#if WEI_DT_BF16\n",
"#define WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define WEI_TO_REF(x) (x)\n",
"#define REF_TO_WEI(x) (x)\n",
"#endif\n",
"#if WEI_DT_BF16\n",
"#define TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif WEI_DT_U8\n",
"#define TO_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif WEI_DT_S8\n",
"#define TO_WEI(x) convert_char_sat_rte(x)\n",
"#elif WEI_DT_S32\n",
"#define TO_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DIFF_WEI_DATA_T\n",
"#if DIFF_WEI_DT_BF16\n",
"#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define DIFF_WEI_TO_REF(x) (x)\n",
"#define REF_TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#if DIFF_WEI_DT_BF16\n",
"#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif DIFF_WEI_DT_U8\n",
"#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S8\n",
"#define TO_DIFF_WEI(x) convert_char_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S32\n",
"#define TO_DIFF_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef B_DATA_T\n",
"#if B_DT_BF16\n",
"#define B_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_B(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define B_TO_REF(x) (x)\n",
"#define REF_TO_B(x) (x)\n",
"#endif\n",
"#if B_DT_BF16\n",
"#define TO_B(x) cvt_f32_to_bf16(x)\n",
"#elif B_DT_U8\n",
"#define TO_B(x) convert_uchar_sat_rte(x)\n",
"#elif B_DT_S8\n",
"#define TO_B(x) convert_char_sat_rte(x)\n",
"#elif B_DT_S32\n",
"#define TO_B(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_B(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef BIA_DATA_T\n",
"#if BIA_DT_BF16\n",
"#define BIA_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define BIA_TO_REF(x) (x)\n",
"#define REF_TO_BIA(x) (x)\n",
"#endif\n",
"#if BIA_DT_BF16\n",
"#define TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#elif BIA_DT_U8\n",
"#define TO_BIA(x) convert_uchar_sat_rte(x)\n",
"#elif BIA_DT_S8\n",
"#define TO_BIA(x) convert_char_sat_rte(x)\n",
"#elif BIA_DT_S32\n",
"#define TO_BIA(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_BIA(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DST_DATA_T\n",
"#define DST_DATA2_T CONCAT2(DST_DATA_T, 2)\n",
"#define DST_DATA4_T CONCAT2(DST_DATA_T, 4)\n",
"#define DST_DATA8_T CONCAT2(DST_DATA_T, 8)\n",
"#define DST_DATA16_T CONCAT2(DST_DATA_T, 16)\n",
"#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T)\n",
"#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T)\n",
"#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T)\n",
"#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T)\n",
"#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T)\n",
"#if DST_DT_F32 || DST_DT_F16\n",
"#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T)\n",
"#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T)\n",
"#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T)\n",
"#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T)\n",
"#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T)\n",
"#else\n",
"#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte)\n",
"#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte)\n",
"#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte)\n",
"#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte)\n",
"#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte)\n",
"#endif\n",
"#if DST_DT_U8\n",
"#define MMAD_DATA_T uint\n",
"#define MMAD_DATA4_T uint4\n",
"#define MMAD_DATA8_T uint8\n",
"#elif DST_DT_S8\n",
"#define MMAD_DATA_T int\n",
"#define MMAD_DATA4_T int4\n",
"#define MMAD_DATA8_T int8\n",
"#endif\n",
"// Block read/write macros for dst.\n",
"#if DST_DT_U8 || DST_DT_S8\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v))\n",
"#elif DST_DT_S32 || DST_DT_F32\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write((__global uint *)ptr, as_uint(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#elif DST_DT_F16\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define DST_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define DST_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define DST_TO_REF(x) (x)\n",
"#define DST_TO_REF8(x) (x)\n",
"#define REF_TO_DST(x) (x)\n",
"#define REF_TO_DST8(x) (x)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x))\n",
"#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x))\n",
"#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif DST_DT_F16\n",
"#define TO_DST(x) convert_half(x)\n",
"#define TO_DST2(x) convert_half2(x)\n",
"#define TO_DST4(x) convert_half4(x)\n",
"#define TO_DST8(x) convert_half8(x)\n",
"#elif DST_DT_U8\n",
"#define TO_DST(x) convert_uchar_sat_rte(x)\n",
"#define TO_DST2(x) convert_uchar2_sat_rte(x)\n",
"#define TO_DST4(x) convert_uchar4_sat_rte(x)\n",
"#define TO_DST8(x) convert_uchar8_sat_rte(x)\n",
"#define TO_DST16(x) convert_uchar16_sat_rte(x)\n",
"#elif DST_DT_S8\n",
"#define TO_DST(x) convert_char_sat_rte(x)\n",
"#define TO_DST2(x) convert_char2_sat_rte(x)\n",
"#define TO_DST4(x) convert_char4_sat_rte(x)\n",
"#define TO_DST8(x) convert_char8_sat_rte(x)\n",
"#define TO_DST16(x) convert_char16_sat_rte(x)\n",
"#elif DST_DT_S32\n",
"#define TO_DST(x) convert_int_sat_rte(x)\n",
"#define TO_DST2(x) convert_int2_sat_rte(x)\n",
"#define TO_DST4(x) convert_int4_sat_rte(x)\n",
"#define TO_DST8(x) convert_int8_sat_rte(x)\n",
"#elif DST_DT_F32\n",
"#define TO_DST(x) convert_float(x)\n",
"#define TO_DST2(x) convert_float2(x)\n",
"#define TO_DST4(x) convert_float4(x)\n",
"#define TO_DST8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef C_DATA_T\n",
"#define C_DATA8_T CONCAT2(C_DATA_T, 8)\n",
"#if C_DT_BF16\n",
"#define C_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define C_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_C(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define C_TO_REF(x) (x)\n",
"#define C_TO_REF8(x) (x)\n",
"#define REF_TO_C(x) (x)\n",
"#define REF_TO_C8(x) (x)\n",
"#endif\n",
"#if C_DT_BF16\n",
"#define TO_C(x) cvt_f32_to_bf16(x)\n",
"#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif C_DT_F16\n",
"#define TO_C(x) convert_half(x)\n",
"#define TO_C8(x) convert_half8(x)\n",
"#elif C_DT_U8\n",
"#define TO_C(x) convert_uchar_sat_rte(x)\n",
"#define TO_C8(x) convert_uchar8_sat_rte(x)\n",
"#elif C_DT_S8\n",
"#define TO_C(x) convert_char_sat_rte(x)\n",
"#define TO_C8(x) convert_char8_sat_rte(x)\n",
"#elif C_DT_S32\n",
"#define TO_C(x) convert_int_sat_rte(x)\n",
"#define TO_C8(x) convert_int8_sat_rte(x)\n",
"#elif C_DT_F32\n",
"#define TO_C(x) convert_float(x)\n",
"#define TO_C8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef ACC_DATA_T\n",
"#if ACC_DT_F16\n",
"#define TO_ACC(x) convert_half(x)\n",
"#elif ACC_DT_F32\n",
"#define TO_ACC(x) convert_float(x)\n",
"#elif ACC_DT_S32\n",
"#define TO_ACC(x) convert_int(x)\n",
"#else\n",
"#error \"Unexpected accumulation data type\"\n",
"#endif\n",
"#endif\n",
"#ifdef SUM_DATA_T\n",
"#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2)\n",
"#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4)\n",
"#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8)\n",
"#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16)\n",
"#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T)\n",
"#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T)\n",
"#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T)\n",
"#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T)\n",
"#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T)\n",
"#if SUM_DT_BF16\n",
"#define SUM_TO_REF cvt_bf16_to_f32\n",
"#else\n",
"#define SUM_TO_REF\n",
"#endif\n",
"#endif\n",
"#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2)))\n",
"#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"              / CONCAT2(prefix, _B0_1)) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"                       % CONCAT2(prefix, _B0_1)) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \\\n",
"                    * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       / CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       % CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \\\n",
"                    * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       / CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       % CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \\\n",
"                    * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       / CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       % CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \\\n",
"                    * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       / CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       % CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \\\n",
"                    * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       / CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       % CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \\\n",
"                    * CONCAT2(prefix, _S5_2)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3)))\n",
"#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5)\n",
"#if NDIMS == 2\n",
"#define SRC_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1)\n",
"#elif NDIMS == 3\n",
"#define SRC_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, x3) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, x2) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2)\n",
"#elif NDIMS == 4\n",
"#define SRC_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, x3, x4) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, d, x3, x4) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3)\n",
"#elif NDIMS == 5\n",
"#define SRC_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \\\n",
"            + ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \\\n",
"            + ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, x3, x4, x5) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \\\n",
"            + ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4)\n",
"#endif\n",
"#define DST_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \\\n",
"            + ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4)\n",
"#endif\n",
"// clang-format off\n",
"// Shortcut accessors for special cases.\n",
"// x - product of the current and outer dimensions in gws[idx]\n",
"// y - the current dimension\n",
"#define GWS_OP_ZERO(x, y) 0\n",
"#define GWS_OP_FIRST(x, y) (x)\n",
"#define GWS_OP_MOD(x, y) ((x) % (y))\n",
"#define ROUND_UP(a,b) (((a) + (b) - 1) / (b))\n",
"#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0\n",
"#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1\n",
"#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2\n",
"#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3\n",
"#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4\n",
"#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5\n",
"#define GWS0_GET_BLOCK0() GWS0_BLOCK0\n",
"#define GWS0_GET_BLOCK1() GWS0_BLOCK1\n",
"#define GWS0_GET_BLOCK2() GWS0_BLOCK2\n",
"#define GWS0_GET_BLOCK3() GWS0_BLOCK3\n",
"#define GWS0_GET_BLOCK4() GWS0_BLOCK4\n",
"#define GWS0_GET_BLOCK5() GWS0_BLOCK5\n",
"#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0\n",
"#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1\n",
"#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2\n",
"#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3\n",
"#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4\n",
"#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5\n",
"#define GWS1_GET_BLOCK0() GWS1_BLOCK0\n",
"#define GWS1_GET_BLOCK1() GWS1_BLOCK1\n",
"#define GWS1_GET_BLOCK2() GWS1_BLOCK2\n",
"#define GWS1_GET_BLOCK3() GWS1_BLOCK3\n",
"#define GWS1_GET_BLOCK4() GWS1_BLOCK4\n",
"#define GWS1_GET_BLOCK5() GWS1_BLOCK5\n",
"#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0\n",
"#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1\n",
"#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2\n",
"#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3\n",
"#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4\n",
"#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5\n",
"#define GWS2_GET_BLOCK0() GWS2_BLOCK0\n",
"#define GWS2_GET_BLOCK1() GWS2_BLOCK1\n",
"#define GWS2_GET_BLOCK2() GWS2_BLOCK2\n",
"#define GWS2_GET_BLOCK3() GWS2_BLOCK3\n",
"#define GWS2_GET_BLOCK4() GWS2_BLOCK4\n",
"#define GWS2_GET_BLOCK5() GWS2_BLOCK5\n",
"// clang-format on\n",
"// With work-group qualifier, without sub-group qualifier.\n",
"#define KERNEL_ATTR_SG0 \\\n",
"    __attribute__((reqd_work_group_size( \\\n",
"            GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT)))\n",
"// With work-group and sub-group qualifiers.\n",
"#define KERNEL_ATTR_SG1 \\\n",
"    KERNEL_ATTR_SG0 \\\n",
"    __attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT)))\n",
"#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT)\n",
"// Named kernel attributes - when source contains multiple kernels.\n",
"#define NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \\\n",
"            CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name))))\n",
"#define NAMED_KERNEL_ATTR_SG1(name) \\\n",
"    NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name))))\n",
"#define NAMED_KERNEL_ATTR(name) \\\n",
"    CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name)\n",
"#endif\n",
"#if BWD_DATA == 1\n",
"__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) // attr:no-format\n",
"__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) // attr:no-format\n",
"__kernel void\n",
"gen9_conv_dw_bwd_data(__global DATA_T *diff_src, __global DATA_T *wei,\n",
"        __global DATA_T *diff_dst, __global DATA_T *bias) {\n",
"#if VER_16MB16C == 1\n",
"    const int mb_unroll = 16;\n",
"    const int ic = get_group_id(1);\n",
"    const int sp = get_group_id(0);\n",
"    const int local_id = get_local_id(1);\n",
"    int mb = get_group_id(2) * mb_unroll;\n",
"    const int g = ic * IC_BLOCK;\n",
"    const int gic = 0;\n",
"    const int id = sp / (IW * IH);\n",
"    const int ihw = sp % (IW * IH);\n",
"    const int ih = ihw / IW;\n",
"    const int iw = ihw % IW;\n",
"    diff_dst += mb * OC * G * OD * OH * OW + g * OC * OD * OH * OW * MB_BLOCK;\n",
"    DATA8_T blockC00 = (DATA8_T)DATA_ZERO;\n",
"    DATA8_T blockC01 = (DATA8_T)DATA_ZERO;\n",
"    if (WITH_BIAS) {\n",
"        const int bg_off = g * IC + gic * IC_BLOCK + local_id;\n",
"        DATA_T b = (G_WO_PADDING % IC_BLOCK == 0 || bg_off < G_WO_PADDING)\n",
"                ? bias[bg_off]\n",
"                : DATA_ZERO;\n",
"        unroll_for(int i = 0; i < 8; ++i) {\n",
"            blockC00[i] = b;\n",
"            blockC01[i] = b;\n",
"        }\n",
"    }\n",
"    wei += gic * KD * KH * KW * OC_BLOCK * IC_BLOCK\n",
"            + g * IC * OC * KD * KH * KW;\n",
"#if KH != 1 || KW != 1 || KD != 1\n",
"    for (int kd = 0; kd < KD; ++kd)\n",
"        for (int kh = 0; kh < KH; ++kh)\n",
"            for (int kw = 0; kw < KW; ++kw) {\n",
"                if (id + PD < kd * (1 + DD) || iw + PW < kw * (1 + DW)\n",
"                        || ih + PH < kh * (1 + DH))\n",
"                    continue;\n",
"                int od = id - kd * (1 + DD) + PD;\n",
"                int ow = iw - kw * (1 + DW) + PW;\n",
"                int oh = ih - kh * (1 + DH) + PH;\n",
"                if (od % SD != 0 || ow % SW != 0 || oh % SH != 0) continue;\n",
"                od /= SD;\n",
"                ow /= SW;\n",
"                oh /= SH;\n",
"                if (od >= OD || oh >= OH || ow >= OW) continue;\n",
"                const __global DATA_T *diff_dst1 = diff_dst\n",
"                        + ow * OC_BLOCK * MB_BLOCK\n",
"                        + oh * OW * OC_BLOCK * MB_BLOCK;\n",
"                diff_dst1 += od * OH * OW * OC_BLOCK * MB_BLOCK;\n",
"                const __global DATA_T *wei1 = wei + kd * KH * KW * OC_BLOCK\n",
"                        + kh * KW * OC_BLOCK + kw * OC_BLOCK;\n",
"#else\n",
"    const int kw = 0;\n",
"    int ow = (iw + PW);\n",
"    int oh = (ih + PH);\n",
"    int od = (id + PD);\n",
"    bool do_ker = ow % SW == 0 && oh % SH == 0 && od % SD == 0;\n",
"    ow /= SW;\n",
"    oh /= SH;\n",
"    od /= SD;\n",
"#if PH != 0 || PW != 0 || PD != 0\n",
"    do_ker = do_ker && (od < OD && oh < OH && ow < OW);\n",
"#endif\n",
"    if (do_ker) {\n",
"        const __global DATA_T *diff_dst1 = diff_dst + ow * OC_BLOCK * MB_BLOCK\n",
"                + oh * OW * OC_BLOCK * MB_BLOCK;\n",
"        diff_dst1 += od * OH * OW * OC_BLOCK * MB_BLOCK;\n",
"        const __global DATA_T *wei1 = wei;\n",
"#endif\n",
"#define LOAD_DIFF_DST(_block, _diff_dst, mb_chunk) \\\n",
"    { \\\n",
"        (_block) = AS_DATA8_T( \\\n",
"                BLOCK_READ8((const __global BLOCK_DATA_T *)((_diff_dst) \\\n",
"                        + (mb_chunk)*OC_BLOCK))); \\\n",
"    }\n",
"#define SAVE_SRC_DIFF(_block, _diff_src, mb_chunk) \\\n",
"    { \\\n",
"        BLOCK_WRITE8((const __global BLOCK_DATA_T *)(&( \\\n",
"                             _diff_src)[(mb_chunk)*IC_BLOCK]), \\\n",
"                AS_BLOCK_DATA8_T((_block))); \\\n",
"    }\n",
"                DATA8_T blockA0, blockA1;\n",
"                LOAD_DIFF_DST(blockA0, diff_dst1, 0);\n",
"                LOAD_DIFF_DST(blockA1, diff_dst1, 8);\n",
"                DATA_T blockB00 = AS_DATA_T(\n",
"                        BLOCK_READ((const __global BLOCK_DATA_T *)wei1));\n",
"                blockC00 = fma(blockA0, (DATA8_T)blockB00, blockC00);\n",
"                blockC01 = fma(blockA1, (DATA8_T)blockB00, blockC01);\n",
"#if KH != 1 || KW != 1 || KD != 1\n",
"            }\n",
"#else\n",
"    }\n",
"#endif\n",
"    __global DATA_T *src_write0 = diff_src + mb * IC * G * ID * IH * IW\n",
"            + gic * ID * IH * IW * IC_BLOCK * MB_BLOCK\n",
"            + g * IC * ID * IH * IW * MB_BLOCK\n",
"            + id * IH * IW * IC_BLOCK * MB_BLOCK + ih * IW * IC_BLOCK * MB_BLOCK\n",
"            + iw * IC_BLOCK * MB_BLOCK;\n",
"    SAVE_SRC_DIFF(blockC00, src_write0, 0);\n",
"    SAVE_SRC_DIFF(blockC01, src_write0, 8);\n",
"#endif\n",
"#if VER_8OW16C == 1\n",
"    const int ic = get_group_id(1);\n",
"    const int sp = get_group_id(0);\n",
"    const int local_id = get_local_id(1);\n",
"    const int mb = get_group_id(2);\n",
"    const int g = ic * IC_BLOCK;\n",
"    const int gic = 0;\n",
"    const int id = sp / (IWB * IH);\n",
"    const int ihw = sp % (IWB * IH);\n",
"    const int ih = ihw / IWB;\n",
"    const int iw = (ihw % IWB) * IW_BLOCK;\n",
"    diff_dst += mb * OC * G * OD * OH * OW + g * OC * OD * OH * OW * MB_BLOCK;\n",
"    DATA_T blockC00[IW_BLOCK] = {DATA_ZERO};\n",
"    if (WITH_BIAS) {\n",
"        const int bg_off = g * IC + gic * IC_BLOCK + local_id;\n",
"        DATA_T b = (G_WO_PADDING % IC_BLOCK == 0 || bg_off < G_WO_PADDING)\n",
"                ? bias[bg_off]\n",
"                : DATA_ZERO;\n",
"        unroll_for(int i = 0; i < IW_BLOCK; ++i) { blockC00[i] = b; }\n",
"    }\n",
"    wei += gic * KD * KH * KW * OC_BLOCK * IC_BLOCK\n",
"            + g * IC * OC * KD * KH * KW;\n",
"#if KH != 1 || KW != 1 || KD != 1\n",
"    for (int kd = 0; kd < KD; ++kd)\n",
"        for (int kh = 0; kh < KH; ++kh)\n",
"            for (int kw = 0; kw < KW; ++kw) {\n",
"                if (id + PD < kd * (1 + DD)) continue;\n",
"                if (ih + PH < kh * (1 + DH)) continue;\n",
"                int od = id - kd * (1 + DD) + PD;\n",
"                int oh = ih - kh * (1 + DH) + PH;\n",
"                if (od % SD != 0 || oh % SH != 0) continue;\n",
"                od /= SD;\n",
"                oh /= SH;\n",
"                if (od >= OD || oh >= OH) continue;\n",
"                const __global DATA_T *diff_dst1 = diff_dst\n",
"                        + oh * OW * OC_BLOCK * MB_BLOCK\n",
"                        + od * OH * OW * OC_BLOCK * MB_BLOCK;\n",
"                const __global DATA_T *wei1 = wei + kd * KH * KW * OC_BLOCK\n",
"                        + kh * KW * OC_BLOCK + kw * OC_BLOCK;\n",
"#else\n",
"    const int kw = 0;\n",
"    int oh = (ih + PH);\n",
"    int od = (id + PD);\n",
"    bool do_ker = od % SD == 0 && oh % SH == 0;\n",
"    oh /= SH;\n",
"    od /= SD;\n",
"#if PH != 0 || PW != 0 || PD != 0\n",
"    do_ker = do_ker && (oh < OH && od < OD);\n",
"#endif\n",
"    if (do_ker) {\n",
"        const __global DATA_T *diff_dst1 = diff_dst\n",
"                + oh * OW * OC_BLOCK * MB_BLOCK\n",
"                + od * OH * OW * OC_BLOCK * MB_BLOCK;\n",
"        const __global DATA_T *wei1 = wei;\n",
"#endif\n",
"                DATA_T blockB00 = AS_DATA_T(\n",
"                        BLOCK_READ((const __global BLOCK_DATA_T *)wei1));\n",
"                DATA_T blockA[IW_BLOCK];\n",
"                __attribute__((opencl_unroll_hint(IW_BLOCK))) // attr:no-format\n",
"                for (int i = 0; i < IW_BLOCK; i++) {\n",
"                    if (iw + i + PW < kw * (1 + DW)) {\n",
"                        blockA[i] = 0.0;\n",
"                        continue;\n",
"                    }\n",
"                    int ow = iw + i - kw * (1 + DW) + PW;\n",
"                    if (ow % SW != 0) {\n",
"                        blockA[i] = 0.0;\n",
"                        continue;\n",
"                    }\n",
"                    ow /= SW;\n",
"                    if (ow >= OW) {\n",
"                        blockA[i] = 0.0;\n",
"                        continue;\n",
"                    }\n",
"                    blockA[i] = AS_DATA_T(\n",
"                            BLOCK_READ((const __global BLOCK_DATA_T *)(&(\n",
"                                    diff_dst1)[ow * OC_BLOCK])));\n",
"                }\n",
"                __attribute__((opencl_unroll_hint(IW_BLOCK))) // attr:no-format\n",
"                for (int i = 0; i < IW_BLOCK; i++) {\n",
"                    blockC00[i] = fma(blockA[i], (DATA_T)blockB00, blockC00[i]);\n",
"                }\n",
"                diff_dst1 += OC_BLOCK * OD * OH * OW * MB_BLOCK;\n",
"                wei1 += IC * KD * KH * KW * OC_BLOCK;\n",
"#if KH != 1 || KW != 1 || KD != 1\n",
"            }\n",
"#else\n",
"    }\n",
"#endif\n",
"    __global DATA_T *src_write0 = diff_src + mb * IC * G * ID * IH * IW\n",
"            + gic * ID * IH * IW * IC_BLOCK * MB_BLOCK\n",
"            + g * IC * ID * IH * IW * MB_BLOCK\n",
"            + id * IH * IW * IC_BLOCK * MB_BLOCK + ih * IW * IC_BLOCK * MB_BLOCK\n",
"            + iw * IC_BLOCK * MB_BLOCK;\n",
"    for (int i = 0; i < IW_BLOCK; i++) {\n",
"        if (iw + i >= IW) continue;\n",
"        BLOCK_WRITE((__global BLOCK_DATA_T *)(&(src_write0)[i * IC_BLOCK]),\n",
"                AS_BLOCK_DATA_T(blockC00[i]));\n",
"    }\n",
"#endif\n",
"}\n",
"#endif", nullptr };
}
}
}
}