namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_reduction_kernel[] ={ "/*******************************************************************************\n",
"* Copyright 2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_TYPES_H\n",
"#define GPU_OCL_OCL_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#define unroll_for __attribute__((opencl_unroll_hint)) for\n",
"#define for_ for\n",
"#define CONCAt2(a, b) a##b\n",
"#define CONCAT2(a, b) CONCAt2(a, b)\n",
"#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c)\n",
"#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \\\n",
"        || defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \\\n",
"        || defined(BIA_DT_F16) || defined(ACC_DT_F16)\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#if DT_F32 == 1\n",
"#define DATA_T float\n",
"#define DATA2_T float2\n",
"#define DATA4_T float4\n",
"#define DATA8_T float8\n",
"#define DATA16_T float16\n",
"#define DATA_MAX FLT_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) (float)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_float\n",
"#define CONVERT_DATA2_T convert_float2\n",
"#define CONVERT_DATA4_T convert_float4\n",
"#define CONVERT_DATA8_T convert_float8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_float\n",
"#define AS_DATA2_T as_float2\n",
"#define AS_DATA4_T as_float4\n",
"#define AS_DATA8_T as_float8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif DT_F16 == 1\n",
"#define DATA_T half\n",
"#define DATA2_T half2\n",
"#define DATA4_T half4\n",
"#define DATA8_T half8\n",
"#define DATA16_T half16\n",
"#define DATA_MAX HALF_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0h\n",
"#define DATA_ONE 1.0h\n",
"#define DEF_ACC_DATA_T half\n",
"#define DEF_ACC_DATA2_T half2\n",
"#define DEF_ACC_DATA4_T half4\n",
"#define DEF_ACC_DATA8_T half8\n",
"#define POST_OP_DATA_T half\n",
"#define TO_DATA_T(v) (half)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (half)(v)\n",
"#define DATA_TO_REF convert_half\n",
"#define CONVERT_DATA_T convert_half\n",
"#define CONVERT_DATA2_T convert_half2\n",
"#define CONVERT_DATA4_T convert_half4\n",
"#define CONVERT_DATA8_T convert_half8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_half\n",
"#define AS_DATA2_T as_half2\n",
"#define AS_DATA4_T as_half4\n",
"#define AS_DATA8_T as_half8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_BF16 == 1\n",
"#define DATA_T ushort\n",
"#define POST_OP_DATA_T float\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define DATA16_T ushort16\n",
"#define DATA_MAX as_float(0x7f7f0000)\n",
"#define DATA_MIN (-DATA_MAX)\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define TO_DATA_T(v) cvt_f32_to_bf16(v)\n",
"#define TO_DEF_ACC_DATA_T(v) cvt_bf16_to_f32(v)\n",
"#define DATA_TO_REF cvt_bf16_to_f32\n",
"#define CONVERT_DATA_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA2_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA4_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA8_T cvt_f32_to_bf16\n",
"#define CONVERT_FLOAT_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT2_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT4_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT8_T cvt_bf16_to_f32\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_ushort\n",
"#define AS_DATA2_T as_ushort2\n",
"#define AS_DATA4_T as_ushort4\n",
"#define AS_DATA8_T as_ushort8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_S8 == 1\n",
"#define DATA_T char\n",
"#define DATA2_T char2\n",
"#define DATA4_T char4\n",
"#define DATA8_T char8\n",
"#define DATA16_T char16\n",
"#define DATA_MAX CHAR_MAX\n",
"#define DATA_MIN CHAR_MIN\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T int8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_char_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_char_sat_rte\n",
"#define CONVERT_DATA2_T convert_char2_sat_rte\n",
"#define CONVERT_DATA4_T convert_char4_sat_rte\n",
"#define CONVERT_DATA8_T convert_char8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_char\n",
"#define AS_DATA2_T as_char2\n",
"#define AS_DATA4_T as_char4\n",
"#define AS_DATA8_T as_char8\n",
"#define AS_DATA16_T as_char16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_int8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_U8 == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define DATA16_T uchar16\n",
"#define DATA_MAX UCHAR_MAX\n",
"#define DATA_MIN 0\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T uint8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_uchar_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_uchar_sat_rte\n",
"#define CONVERT_DATA2_T convert_uchar2_sat_rte\n",
"#define CONVERT_DATA4_T convert_uchar4_sat_rte\n",
"#define CONVERT_DATA8_T convert_uchar8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_uchar\n",
"#define AS_DATA2_T as_uchar2\n",
"#define AS_DATA4_T as_uchar4\n",
"#define AS_DATA8_T as_uchar8\n",
"#define AS_DATA16_T as_uchar16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_uint8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_S32 == 1\n",
"#define DATA_T int\n",
"#define DATA2_T int2\n",
"#define DATA4_T int4\n",
"#define DATA8_T int8\n",
"#define DATA16_T int16\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_int_sat_rte\n",
"#define CONVERT_DATA2_T convert_int2_sat_rte\n",
"#define CONVERT_DATA4_T convert_int4_sat_rte\n",
"#define CONVERT_DATA8_T convert_int8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define POST_OP_DATA_T float\n",
"#define DATA_MIN INT_MIN\n",
"#define DATA_MAX INT_MAX\n",
"#define ROUND\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_int\n",
"#define AS_DATA2_T as_int2\n",
"#define AS_DATA4_T as_int4\n",
"#define AS_DATA8_T as_int8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif !defined(DT_UNDEF)\n",
"#error \"Unexpected data type\"\n",
"#endif\n",
"#if VECT_DT_N == 1\n",
"#define VECT_DATA_T DATA_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T\n",
"#define AS_VECT_DATA_T AS_DATA_T\n",
"#define VECT_BLOCK_READ BLOCK_READ\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE\n",
"#define VECT_UINT_READ intel_sub_group_block_read\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T\n",
"#define VECT_INT_T int\n",
"#define VECT_UINT_T uint\n",
"#define VECT_FLOAT_T float\n",
"#define VECT_CHAR_T char\n",
"#define AS_VECT_INT_T as_int\n",
"#define AS_VECT_UINT_T as_uint\n",
"#define AS_VECT_FLOAT_T as_float\n",
"#define AS_VECT_CHAR_T as_char\n",
"#elif VECT_DT_N == 2\n",
"#define VECT_DATA_T DATA2_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T\n",
"#define AS_VECT_DATA_T AS_DATA2_T\n",
"#define VECT_BLOCK_READ BLOCK_READ2\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE2\n",
"#define VECT_UINT_READ intel_sub_group_block_read2\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write2\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc2\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA2_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T\n",
"#define VECT_INT_T int2\n",
"#define VECT_UINT_T uint2\n",
"#define VECT_FLOAT_T float2\n",
"#define VECT_CHAR_T char2\n",
"#define AS_VECT_INT_T as_int2\n",
"#define AS_VECT_UINT_T as_uint2\n",
"#define AS_VECT_FLOAT_T as_float2\n",
"#define AS_VECT_CHAR_T as_char2\n",
"#elif VECT_DT_N == 4\n",
"#define VECT_DATA_T DATA4_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T\n",
"#define AS_VECT_DATA_T AS_DATA4_T\n",
"#define VECT_BLOCK_READ BLOCK_READ4\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE4\n",
"#define VECT_UINT_READ intel_sub_group_block_read4\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write4\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc4\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA4_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T\n",
"#define VECT_INT_T int4\n",
"#define VECT_UINT_T uint4\n",
"#define VECT_FLOAT_T float4\n",
"#define VECT_CHAR_T char4\n",
"#define AS_VECT_INT_T as_int4\n",
"#define AS_VECT_UINT_T as_uint4\n",
"#define AS_VECT_FLOAT_T as_float4\n",
"#define AS_VECT_CHAR_T as_char4\n",
"#elif VECT_DT_N == 8\n",
"#define VECT_DATA_T DATA8_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T\n",
"#define AS_VECT_DATA_T AS_DATA8_T\n",
"#define VECT_BLOCK_READ BLOCK_READ8\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE8\n",
"#define VECT_UINT_READ intel_sub_group_block_read8\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write8\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc8\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA8_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T\n",
"#define VECT_INT_T int8\n",
"#define VECT_UINT_T uint8\n",
"#define VECT_FLOAT_T float8\n",
"#define VECT_CHAR_T char8\n",
"#define AS_VECT_INT_T as_int8\n",
"#define AS_VECT_UINT_T as_uint8\n",
"#define AS_VECT_FLOAT_T as_float8\n",
"#define AS_VECT_CHAR_T as_char8\n",
"#endif\n",
"#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T)\n",
"#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T)\n",
"#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T)\n",
"#ifdef SRC_DATA_T\n",
"#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2)\n",
"#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4)\n",
"#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8)\n",
"#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16)\n",
"#ifdef SRC_DT_U8\n",
"#define SRC_MMAD_DATA_T uint\n",
"#define SRC_MMAD_DATA4_T uint4\n",
"#define SRC_MMAD_DATA8_T uint8\n",
"#elif SRC_DT_S8\n",
"#define SRC_MMAD_DATA_T int\n",
"#define SRC_MMAD_DATA4_T int4\n",
"#define SRC_MMAD_DATA8_T int8\n",
"#endif\n",
"#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T)\n",
"#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T)\n",
"#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T)\n",
"#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T)\n",
"#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T)\n",
"#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T)\n",
"#if SRC_DT_BF16\n",
"#define SRC_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define SRC_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define SRC_TO_REF(x) (x)\n",
"#define SRC_TO_REF8(x) (x)\n",
"#define REF_TO_SRC(x) (x)\n",
"#endif\n",
"#if SRC_DT_BF16\n",
"#define TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#elif SRC_DT_U8\n",
"#define TO_SRC(x) convert_uchar_sat_rte(x)\n",
"#elif SRC_DT_S8\n",
"#define TO_SRC(x) convert_char_sat_rte(x)\n",
"#elif SRC_DT_S32\n",
"#define TO_SRC(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_SRC(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef A_DATA_T\n",
"#define A_DATA8_T CONCAT2(A_DATA_T, 8)\n",
"#if A_DT_BF16\n",
"#define A_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define A_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_A(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define A_TO_REF(x) (x)\n",
"#define A_TO_REF8(x) (x)\n",
"#define REF_TO_A(x) (x)\n",
"#endif\n",
"#if A_DT_BF16\n",
"#define TO_A(x) cvt_f32_to_bf16(x)\n",
"#elif A_DT_U8\n",
"#define TO_A(x) convert_uchar_sat_rte(x)\n",
"#elif A_DT_S8\n",
"#define TO_A(x) convert_char_sat_rte(x)\n",
"#elif A_DT_S32\n",
"#define TO_A(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_A(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef WEI_DATA_T\n",
"#if WEI_DT_BF16\n",
"#define WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define WEI_TO_REF(x) (x)\n",
"#define REF_TO_WEI(x) (x)\n",
"#endif\n",
"#if WEI_DT_BF16\n",
"#define TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif WEI_DT_U8\n",
"#define TO_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif WEI_DT_S8\n",
"#define TO_WEI(x) convert_char_sat_rte(x)\n",
"#elif WEI_DT_S32\n",
"#define TO_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DIFF_WEI_DATA_T\n",
"#if DIFF_WEI_DT_BF16\n",
"#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define DIFF_WEI_TO_REF(x) (x)\n",
"#define REF_TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#if DIFF_WEI_DT_BF16\n",
"#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif DIFF_WEI_DT_U8\n",
"#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S8\n",
"#define TO_DIFF_WEI(x) convert_char_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S32\n",
"#define TO_DIFF_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef B_DATA_T\n",
"#if B_DT_BF16\n",
"#define B_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_B(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define B_TO_REF(x) (x)\n",
"#define REF_TO_B(x) (x)\n",
"#endif\n",
"#if B_DT_BF16\n",
"#define TO_B(x) cvt_f32_to_bf16(x)\n",
"#elif B_DT_U8\n",
"#define TO_B(x) convert_uchar_sat_rte(x)\n",
"#elif B_DT_S8\n",
"#define TO_B(x) convert_char_sat_rte(x)\n",
"#elif B_DT_S32\n",
"#define TO_B(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_B(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef BIA_DATA_T\n",
"#if BIA_DT_BF16\n",
"#define BIA_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define BIA_TO_REF(x) (x)\n",
"#define REF_TO_BIA(x) (x)\n",
"#endif\n",
"#if BIA_DT_BF16\n",
"#define TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#elif BIA_DT_U8\n",
"#define TO_BIA(x) convert_uchar_sat_rte(x)\n",
"#elif BIA_DT_S8\n",
"#define TO_BIA(x) convert_char_sat_rte(x)\n",
"#elif BIA_DT_S32\n",
"#define TO_BIA(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_BIA(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DST_DATA_T\n",
"#define DST_DATA2_T CONCAT2(DST_DATA_T, 2)\n",
"#define DST_DATA4_T CONCAT2(DST_DATA_T, 4)\n",
"#define DST_DATA8_T CONCAT2(DST_DATA_T, 8)\n",
"#define DST_DATA16_T CONCAT2(DST_DATA_T, 16)\n",
"#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T)\n",
"#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T)\n",
"#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T)\n",
"#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T)\n",
"#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T)\n",
"#if DST_DT_F32 || DST_DT_F16\n",
"#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T)\n",
"#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T)\n",
"#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T)\n",
"#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T)\n",
"#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T)\n",
"#else\n",
"#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte)\n",
"#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte)\n",
"#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte)\n",
"#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte)\n",
"#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte)\n",
"#endif\n",
"#if DST_DT_U8\n",
"#define MMAD_DATA_T uint\n",
"#define MMAD_DATA4_T uint4\n",
"#define MMAD_DATA8_T uint8\n",
"#elif DST_DT_S8\n",
"#define MMAD_DATA_T int\n",
"#define MMAD_DATA4_T int4\n",
"#define MMAD_DATA8_T int8\n",
"#endif\n",
"// Block read/write macros for dst.\n",
"#if DST_DT_U8 || DST_DT_S8\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v))\n",
"#elif DST_DT_S32 || DST_DT_F32\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write((__global uint *)ptr, as_uint(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#elif DST_DT_F16\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define DST_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define DST_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define DST_TO_REF(x) (x)\n",
"#define DST_TO_REF8(x) (x)\n",
"#define REF_TO_DST(x) (x)\n",
"#define REF_TO_DST8(x) (x)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x))\n",
"#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x))\n",
"#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif DST_DT_F16\n",
"#define TO_DST(x) convert_half(x)\n",
"#define TO_DST2(x) convert_half2(x)\n",
"#define TO_DST4(x) convert_half4(x)\n",
"#define TO_DST8(x) convert_half8(x)\n",
"#elif DST_DT_U8\n",
"#define TO_DST(x) convert_uchar_sat_rte(x)\n",
"#define TO_DST2(x) convert_uchar2_sat_rte(x)\n",
"#define TO_DST4(x) convert_uchar4_sat_rte(x)\n",
"#define TO_DST8(x) convert_uchar8_sat_rte(x)\n",
"#define TO_DST16(x) convert_uchar16_sat_rte(x)\n",
"#elif DST_DT_S8\n",
"#define TO_DST(x) convert_char_sat_rte(x)\n",
"#define TO_DST2(x) convert_char2_sat_rte(x)\n",
"#define TO_DST4(x) convert_char4_sat_rte(x)\n",
"#define TO_DST8(x) convert_char8_sat_rte(x)\n",
"#define TO_DST16(x) convert_char16_sat_rte(x)\n",
"#elif DST_DT_S32\n",
"#define TO_DST(x) convert_int_sat_rte(x)\n",
"#define TO_DST2(x) convert_int2_sat_rte(x)\n",
"#define TO_DST4(x) convert_int4_sat_rte(x)\n",
"#define TO_DST8(x) convert_int8_sat_rte(x)\n",
"#elif DST_DT_F32\n",
"#define TO_DST(x) convert_float(x)\n",
"#define TO_DST2(x) convert_float2(x)\n",
"#define TO_DST4(x) convert_float4(x)\n",
"#define TO_DST8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef C_DATA_T\n",
"#define C_DATA8_T CONCAT2(C_DATA_T, 8)\n",
"#if C_DT_BF16\n",
"#define C_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define C_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_C(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define C_TO_REF(x) (x)\n",
"#define C_TO_REF8(x) (x)\n",
"#define REF_TO_C(x) (x)\n",
"#define REF_TO_C8(x) (x)\n",
"#endif\n",
"#if C_DT_BF16\n",
"#define TO_C(x) cvt_f32_to_bf16(x)\n",
"#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif C_DT_F16\n",
"#define TO_C(x) convert_half(x)\n",
"#define TO_C8(x) convert_half8(x)\n",
"#elif C_DT_U8\n",
"#define TO_C(x) convert_uchar_sat_rte(x)\n",
"#define TO_C8(x) convert_uchar8_sat_rte(x)\n",
"#elif C_DT_S8\n",
"#define TO_C(x) convert_char_sat_rte(x)\n",
"#define TO_C8(x) convert_char8_sat_rte(x)\n",
"#elif C_DT_S32\n",
"#define TO_C(x) convert_int_sat_rte(x)\n",
"#define TO_C8(x) convert_int8_sat_rte(x)\n",
"#elif C_DT_F32\n",
"#define TO_C(x) convert_float(x)\n",
"#define TO_C8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef ACC_DATA_T\n",
"#if ACC_DT_F16\n",
"#define TO_ACC(x) convert_half(x)\n",
"#elif ACC_DT_F32\n",
"#define TO_ACC(x) convert_float(x)\n",
"#elif ACC_DT_S32\n",
"#define TO_ACC(x) convert_int(x)\n",
"#else\n",
"#error \"Unexpected accumulation data type\"\n",
"#endif\n",
"#endif\n",
"#ifdef SUM_DATA_T\n",
"#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2)\n",
"#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4)\n",
"#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8)\n",
"#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16)\n",
"#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T)\n",
"#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T)\n",
"#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T)\n",
"#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T)\n",
"#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T)\n",
"#if SUM_DT_BF16\n",
"#define SUM_TO_REF cvt_bf16_to_f32\n",
"#else\n",
"#define SUM_TO_REF\n",
"#endif\n",
"#endif\n",
"#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2)))\n",
"#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"              / CONCAT2(prefix, _B0_1)) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"                       % CONCAT2(prefix, _B0_1)) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \\\n",
"                    * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       / CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       % CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \\\n",
"                    * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       / CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       % CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \\\n",
"                    * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       / CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       % CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \\\n",
"                    * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       / CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       % CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \\\n",
"                    * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       / CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       % CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \\\n",
"                    * CONCAT2(prefix, _S5_2)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3)))\n",
"#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5)\n",
"#if NDIMS == 2\n",
"#define SRC_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1)\n",
"#elif NDIMS == 3\n",
"#define SRC_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, x3) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, x2) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2)\n",
"#elif NDIMS == 4\n",
"#define SRC_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, x3, x4) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, d, x3, x4) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3)\n",
"#elif NDIMS == 5\n",
"#define SRC_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \\\n",
"            + ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \\\n",
"            + ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, x3, x4, x5) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \\\n",
"            + ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4)\n",
"#endif\n",
"#define DST_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \\\n",
"            + ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4)\n",
"#endif\n",
"// clang-format off\n",
"// Shortcut accessors for special cases.\n",
"// x - product of the current and outer dimensions in gws[idx]\n",
"// y - the current dimension\n",
"#define GWS_OP_ZERO(x, y) 0\n",
"#define GWS_OP_FIRST(x, y) (x)\n",
"#define GWS_OP_MOD(x, y) ((x) % (y))\n",
"#define ROUND_UP(a,b) (((a) + (b) - 1) / (b))\n",
"#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0\n",
"#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1\n",
"#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2\n",
"#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3\n",
"#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4\n",
"#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5\n",
"#define GWS0_GET_BLOCK0() GWS0_BLOCK0\n",
"#define GWS0_GET_BLOCK1() GWS0_BLOCK1\n",
"#define GWS0_GET_BLOCK2() GWS0_BLOCK2\n",
"#define GWS0_GET_BLOCK3() GWS0_BLOCK3\n",
"#define GWS0_GET_BLOCK4() GWS0_BLOCK4\n",
"#define GWS0_GET_BLOCK5() GWS0_BLOCK5\n",
"#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0\n",
"#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1\n",
"#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2\n",
"#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3\n",
"#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4\n",
"#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5\n",
"#define GWS1_GET_BLOCK0() GWS1_BLOCK0\n",
"#define GWS1_GET_BLOCK1() GWS1_BLOCK1\n",
"#define GWS1_GET_BLOCK2() GWS1_BLOCK2\n",
"#define GWS1_GET_BLOCK3() GWS1_BLOCK3\n",
"#define GWS1_GET_BLOCK4() GWS1_BLOCK4\n",
"#define GWS1_GET_BLOCK5() GWS1_BLOCK5\n",
"#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0\n",
"#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1\n",
"#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2\n",
"#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3\n",
"#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4\n",
"#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5\n",
"#define GWS2_GET_BLOCK0() GWS2_BLOCK0\n",
"#define GWS2_GET_BLOCK1() GWS2_BLOCK1\n",
"#define GWS2_GET_BLOCK2() GWS2_BLOCK2\n",
"#define GWS2_GET_BLOCK3() GWS2_BLOCK3\n",
"#define GWS2_GET_BLOCK4() GWS2_BLOCK4\n",
"#define GWS2_GET_BLOCK5() GWS2_BLOCK5\n",
"// clang-format on\n",
"// With work-group qualifier, without sub-group qualifier.\n",
"#define KERNEL_ATTR_SG0 \\\n",
"    __attribute__((reqd_work_group_size( \\\n",
"            GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT)))\n",
"// With work-group and sub-group qualifiers.\n",
"#define KERNEL_ATTR_SG1 \\\n",
"    KERNEL_ATTR_SG0 \\\n",
"    __attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT)))\n",
"#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT)\n",
"// Named kernel attributes - when source contains multiple kernels.\n",
"#define NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \\\n",
"            CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name))))\n",
"#define NAMED_KERNEL_ATTR_SG1(name) \\\n",
"    NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name))))\n",
"#define NAMED_KERNEL_ATTR(name) \\\n",
"    CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name)\n",
"#endif\n",
"#if defined(IS_MAX)\n",
"#define INIT_ACC -INFINITY\n",
"#elif defined(IS_MIN)\n",
"#define INIT_ACC INFINITY\n",
"#elif defined(IS_MUL)\n",
"#define INIT_ACC 1.0f\n",
"#else\n",
"#define INIT_ACC 0.0f\n",
"#endif\n",
"#if defined(IS_MAX)\n",
"#define ACCUMULATE(x, y) fmax(x, y)\n",
"#elif defined(IS_MIN)\n",
"#define ACCUMULATE(x, y) fmin(x, y)\n",
"#elif defined(IS_MEAN) || defined(IS_SUM)\n",
"#define ACCUMULATE(x, y) (x + y)\n",
"#elif defined(IS_MUL)\n",
"#define ACCUMULATE(x, y) (x * y)\n",
"#else\n",
"#define ACCUMULATE(x, y) (x + pow(fabs(y), POWER))\n",
"#endif\n",
"// We want to use some acc algorithms (like pow) only once\n",
"// for a given element\n",
"#if defined(IS_MAX) || defined(IS_MIN) || defined(IS_MUL)\n",
"#define ACCUMULATE_AGAIN(x, y) ACCUMULATE(x, y)\n",
"#else\n",
"#define ACCUMULATE_AGAIN(x, y) (x + y)\n",
"#endif\n",
"#if defined(IS_MEAN)\n",
"#define FINALIZE(x) (x / REDUCTION_SIZE)\n",
"#elif defined(IS_LP_MAX)\n",
"#define FINALIZE(x) rootn(fmax(x, EPS), POWER)\n",
"#elif defined(IS_LP_SUM)\n",
"#define FINALIZE(x) rootn(x + EPS, POWER)\n",
"#elif defined(IS_P_MAX)\n",
"#define FINALIZE(x) fmax(x, EPS)\n",
"#elif defined(IS_P_SUM)\n",
"#define FINALIZE(x) (x + EPS)\n",
"#else\n",
"#define FINALIZE(x) (x)\n",
"#endif\n",
"#if defined(IS_MAX)\n",
"#define SUB_GROUP_REDUCE(x) sub_group_reduce_max(x)\n",
"#elif defined(IS_MIN)\n",
"#define SUB_GROUP_REDUCE(x) sub_group_reduce_min(x)\n",
"#elif defined(IS_MUL)\n",
"#define SUB_GROUP_REDUCE(x) \\\n",
"    ({ \\\n",
"        float sub_group_acc = 1.0; \\\n",
"        for (int wi_id = 0; wi_id < SUB_GROUP_SIZE; wi_id++) { \\\n",
"            sub_group_acc *= intel_sub_group_shuffle(c_acc, wi_id); \\\n",
"        } \\\n",
"        sub_group_acc; \\\n",
"    })\n",
"#else\n",
"#define SUB_GROUP_REDUCE(x) sub_group_reduce_add(x)\n",
"#endif\n",
"#if INITIAL_C_CHUNKS == 1\n",
"#define C_BLOCK_READ BLOCK_READ\n",
"#define AS_C_BLOCK_DATA_T AS_DATA_T\n",
"#define CONVERT_C_BLOCK_FLOAT_T CONVERT_FLOAT_T\n",
"#define C_BLOCK_FLOAT_T float\n",
"#elif INITIAL_C_CHUNKS == 2\n",
"#define C_BLOCK_READ BLOCK_READ2\n",
"#define AS_C_BLOCK_DATA_T AS_DATA2_T\n",
"#define CONVERT_C_BLOCK_FLOAT_T CONVERT_FLOAT2_T\n",
"#define C_BLOCK_FLOAT_T float2\n",
"#endif\n",
"#define ROUND_DOWN(a, b) ((a) - ((a) % (b)))\n",
"#undef ROUND_UP\n",
"#define ROUND_UP(a, b) ROUND_DOWN((a + b - 1), (b))\n",
"// clang-format off\n",
"// C blocked or N,C blocked\n",
"#define INITIAL_SRC_OFFSET(n, c, hwd) \\\n",
"    (((n) / N_BLOCK_SIZE) * INITIAL_HWD_DIM * N_BLOCK_SIZE * ROUND_UP(INITIAL_C, C_BLOCK_SIZE) + \\\n",
"     ((n) % N_BLOCK_SIZE) * C_BLOCK_SIZE + \\\n",
"     ((c) / C_BLOCK_SIZE) * INITIAL_HWD_DIM * N_BLOCK_SIZE * C_BLOCK_SIZE + \\\n",
"     (hwd) * N_BLOCK_SIZE * C_BLOCK_SIZE + \\\n",
"     ((c) % C_BLOCK_SIZE))\n",
"#define INITIAL_DST_OFFSET(n, c, hwd) \\\n",
"    ((n / N_BLOCK_SIZE) * FINAL_HWD_DIM * N_BLOCK_SIZE * ROUND_UP(FINAL_C_DIM, C_BLOCK_SIZE) + \\\n",
"     ((n) % N_BLOCK_SIZE) * C_BLOCK_SIZE + \\\n",
"     ((c) / C_BLOCK_SIZE) * FINAL_HWD_DIM * N_BLOCK_SIZE * C_BLOCK_SIZE + \\\n",
"     (hwd) * N_BLOCK_SIZE * C_BLOCK_SIZE + \\\n",
"     ((c) % C_BLOCK_SIZE))\n",
"#define FINAL_SRC_OFFSET(n, c, hwd) INITIAL_DST_OFFSET(n, c, hwd)\n",
"#define FINAL_DST_OFFSET(n, c, hwd) \\\n",
"    ((n) / N_BLOCK_SIZE) * (FINAL_HWD_DIM / FINAL_HWD_CHUNK_SIZE) * N_BLOCK_SIZE * ROUND_UP(FINAL_C_DIM / FINAL_C_CHUNK_SIZE, C_BLOCK_SIZE) + \\\n",
"     ((n) % N_BLOCK_SIZE) * C_BLOCK_SIZE + \\\n",
"     ((c) / C_BLOCK_SIZE) * (FINAL_HWD_DIM / FINAL_HWD_CHUNK_SIZE) * N_BLOCK_SIZE * C_BLOCK_SIZE + \\\n",
"     (hwd) * N_BLOCK_SIZE * C_BLOCK_SIZE + \\\n",
"     ((c) % C_BLOCK_SIZE)\n",
"// clang-format on\n",
"#if SKIP_FINAL_PHASE\n",
"#define WRITE_INITIAL_RESULT(dst_ptr, dst_offset, data) \\\n",
"    { dst_ptr[dst_offset] = TO_DST(FINALIZE(data)); }\n",
"#define INITIAL_DST_DTYPE DST_DATA_T\n",
"#else\n",
"#define WRITE_INITIAL_RESULT(dst_ptr, dst_offset, data) \\\n",
"    { dst_ptr[dst_offset] = data; }\n",
"#define INITIAL_DST_DTYPE float\n",
"#endif\n",
"// Reduces only chunks of reduction dimensions\n",
"// in order to create more threads and increase precision\n",
"NAMED_KERNEL_ATTR(INITIAL)\n",
"__kernel void gen9_initial_reduce(\n",
"        __global SRC_DATA_T *src, __global INITIAL_DST_DTYPE *dst) {\n",
"    const int n_chunk_idx = GWS_GET_INITIAL_N();\n",
"    const int c = GWS_GET_INITIAL_C();\n",
"    const int c_block_idx = c / C_BLOCK_SIZE;\n",
"    const int hwd_chunk_idx = GWS_GET_INITIAL_HWD_CHUNK_ID();\n",
"    const int hwd_start = hwd_chunk_idx * INITIAL_HWD_CHUNK_SIZE;\n",
"    const int current_hwd_chunk = min(INITIAL_HWD_CHUNK_SIZE,\n",
"            INITIAL_HWD_DIM - hwd_chunk_idx * INITIAL_HWD_CHUNK_SIZE);\n",
"    const int aligned_hwd_chunk = ROUND_DOWN(current_hwd_chunk, VECT_DT_N);\n",
"    const int n_start = n_chunk_idx * INITIAL_N_CHUNK_SIZE;\n",
"    const int n_end = min(n_start + INITIAL_N_CHUNK_SIZE, INITIAL_N);\n",
"#if SKIP_FINAL_PHASE\n",
"    // zero pad dst memory\n",
"    for (int n_idx = n_start; n_idx < n_start + INITIAL_N_CHUNK_SIZE; n_idx++) {\n",
"        for (int c_idx = c; c_idx < c + INITIAL_C_CHUNKS * SUB_GROUP_SIZE;\n",
"                c_idx++) {\n",
"            if (n_idx >= DST_N && n_idx < DST_N_PADDED\n",
"                    || c_idx >= DST_C && c_idx < DST_C_PADDED) {\n",
"                for (int hwd_idx = hwd_start;\n",
"                        hwd_idx < hwd_start + INITIAL_HWD_CHUNK_SIZE;\n",
"                        hwd_idx++) {\n",
"                    const int dst_off = FINAL_DST_OFFSET(n_idx, c_idx, hwd_idx);\n",
"                    dst[dst_off] = TO_DST(0.0f);\n",
"                }\n",
"            }\n",
"        }\n",
"    }\n",
"#endif\n",
"    if (c >= INITIAL_C || n_start >= INITIAL_N) { return; }\n",
"    VECT_FLOAT_T vector_acc = INIT_ACC;\n",
"    for (int n = n_start; n < n_end; n++) {\n",
"        for (int hwd_id = 0; hwd_id < aligned_hwd_chunk; hwd_id += VECT_DT_N) {\n",
"            for (int c_chunk = 0; c_chunk < INITIAL_C_CHUNKS; c_chunk++) {\n",
"                // It will always read from the beginning of c block\n",
"                const int off = INITIAL_SRC_OFFSET(n, c,\n",
"                        hwd_start + hwd_id\n",
"                                + c_chunk * VECT_DT_N / INITIAL_C_CHUNKS);\n",
"                VECT_FLOAT_T data\n",
"                        = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ(\n",
"                                (const __global BLOCK_DATA_T *)&src[off])));\n",
"                vector_acc = ACCUMULATE(vector_acc, data);\n",
"            }\n",
"        }\n",
"        for (int hwd_id = aligned_hwd_chunk; hwd_id < current_hwd_chunk;\n",
"                hwd_id++) {\n",
"            const int off = INITIAL_SRC_OFFSET(n, c, hwd_start + hwd_id);\n",
"            C_BLOCK_FLOAT_T data = CONVERT_C_BLOCK_FLOAT_T(AS_C_BLOCK_DATA_T(\n",
"                    C_BLOCK_READ((const __global BLOCK_DATA_T *)&src[off])));\n",
"#if VECT_DT_N == 1\n",
"            vector_acc = ACCUMULATE(vector_acc, data);\n",
"#else // VECT_DT_N == 1\n",
"#if INITIAL_C_CHUNKS == 1\n",
"            vector_acc[0] = ACCUMULATE(vector_acc[0], data);\n",
"#elif INITIAL_C_CHUNKS == 2\n",
"            // data[0] and data[1] must be accumulated separately as they contain different C\n",
"            vector_acc[0] = ACCUMULATE(vector_acc[0], data[0]);\n",
"            vector_acc[1] = ACCUMULATE(vector_acc[1], data[1]);\n",
"#endif // INITIAL_C_CHUNKS == 1\n",
"#endif // VECT_DT_N == 1\n",
"        }\n",
"    }\n",
"#if VECT_DT_N == 1\n",
"    float acc = vector_acc;\n",
"#else // VECT_DT_N == 1\n",
"    const int elems_to_accumulate = aligned_hwd_chunk > 0 ? VECT_DT_N : 1;\n",
"#if INITIAL_C_CHUNKS == 1\n",
"    float acc = INIT_ACC;\n",
"    for (int i = 0; i < elems_to_accumulate; i++) {\n",
"        acc = ACCUMULATE_AGAIN(acc, vector_acc[i]);\n",
"    }\n",
"#elif INITIAL_C_CHUNKS == 2\n",
"    float2 acc = INIT_ACC;\n",
"    for (int i = 0; i < elems_to_accumulate; i += 2) {\n",
"        acc[0] = ACCUMULATE_AGAIN(acc[0], vector_acc[i]);\n",
"        acc[1] = ACCUMULATE_AGAIN(acc[1], vector_acc[i + 1]);\n",
"    }\n",
"#endif // INITIAL_C_CHUNKS == 1\n",
"#endif // VECT_DT_N == 1\n",
"    const int local_id = get_sub_group_local_id();\n",
"#if IS_C_REDUCED\n",
"#if INITIAL_C_CHUNKS == 2\n",
"    float c_acc = acc[0] + acc[1];\n",
"#elif INITIAL_C_CHUNKS == 1\n",
"    float c_acc = acc;\n",
"#endif // INITIAL_C_CHUNKS == 2\n",
"    const int dst_off\n",
"            = INITIAL_DST_OFFSET(n_chunk_idx, c_block_idx, hwd_chunk_idx);\n",
"    c_acc = SUB_GROUP_REDUCE(c_acc);\n",
"    if (local_id == 0) { WRITE_INITIAL_RESULT(dst, dst_off, c_acc); }\n",
"#else // IS_C_REDUCED\n",
"    const int dst_c = c + local_id;\n",
"#if INITIAL_C_CHUNKS == 1\n",
"    WRITE_INITIAL_RESULT(\n",
"            dst, INITIAL_DST_OFFSET(n_chunk_idx, dst_c, hwd_chunk_idx), acc);\n",
"#else // INITIAL_C_CHUNKS == 1\n",
"    WRITE_INITIAL_RESULT(\n",
"            dst, INITIAL_DST_OFFSET(n_chunk_idx, dst_c, hwd_chunk_idx), acc[0]);\n",
"    WRITE_INITIAL_RESULT(dst,\n",
"            INITIAL_DST_OFFSET(\n",
"                    n_chunk_idx, dst_c + SUB_GROUP_SIZE, hwd_chunk_idx),\n",
"            acc[1]);\n",
"#endif // INITIAL_C_CHUNKS == 1\n",
"#endif // IS_C_REDUCED\n",
"}\n",
"// Finalizes reduction by reducing results of initial reduction\n",
"NAMED_KERNEL_ATTR(FINAL)\n",
"__kernel void gen9_final_reduce(__global float *src, __global DST_DATA_T *dst) {\n",
"    const int n_start = GWS_GET_FINAL_N() * FINAL_N_CHUNK_SIZE;\n",
"    const int c_start = GWS_GET_FINAL_C() * FINAL_C_CHUNK_SIZE;\n",
"    const int hwd_start = GWS_GET_FINAL_HWD() * FINAL_HWD_CHUNK_SIZE;\n",
"    float acc = INIT_ACC;\n",
"    const int max_n = max(DST_N_PADDED, FINAL_N_DIM);\n",
"    const int max_c = max(DST_C_PADDED, FINAL_C_DIM);\n",
"    const int n_end = min(max_n, n_start + FINAL_N_CHUNK_SIZE);\n",
"    const int c_end = min(max_c, c_start + FINAL_C_CHUNK_SIZE);\n",
"    const int hwd_end = min(FINAL_HWD_DIM, hwd_start + FINAL_HWD_CHUNK_SIZE);\n",
"    for (int n = n_start; n < n_end; n++) {\n",
"        for (int c = c_start; c < c_end; c++) {\n",
"            for (int hwd = hwd_start; hwd < hwd_end; hwd++) {\n",
"                // zero pad dst memory\n",
"                if (n >= DST_N || c >= DST_C) {\n",
"                    const int dst_off = FINAL_DST_OFFSET(n, c, hwd);\n",
"                    dst[dst_off] = TO_DST(0.0f);\n",
"                }\n",
"                if (n < FINAL_N_DIM && c < FINAL_C_DIM) {\n",
"                    const int off = FINAL_SRC_OFFSET(n, c, hwd);\n",
"                    const float data = src[off];\n",
"                    acc = ACCUMULATE_AGAIN(acc, data);\n",
"                }\n",
"            }\n",
"        }\n",
"    }\n",
"    if (n_start < DST_N && c_start < DST_C) {\n",
"        const int off = FINAL_DST_OFFSET(n_start, c_start, hwd_start);\n",
"        dst[off] = TO_DST(FINALIZE(acc));\n",
"    }\n",
"}", nullptr };
}
}
}
}