namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ref_rnn_kernel[] ={ "/*******************************************************************************\n",
"* Copyright 2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"/*******************************************************************************\n",
"* Copyright 2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_RNN_RNN_TYPES_H\n",
"#define GPU_OCL_RNN_RNN_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_TYPES_H\n",
"#define GPU_OCL_OCL_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#define unroll_for __attribute__((opencl_unroll_hint)) for\n",
"#define for_ for\n",
"#define CONCAt2(a, b) a##b\n",
"#define CONCAT2(a, b) CONCAt2(a, b)\n",
"#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c)\n",
"#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \\\n",
"        || defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \\\n",
"        || defined(BIA_DT_F16) || defined(ACC_DT_F16)\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#if DT_F32 == 1\n",
"#define DATA_T float\n",
"#define DATA2_T float2\n",
"#define DATA4_T float4\n",
"#define DATA8_T float8\n",
"#define DATA16_T float16\n",
"#define DATA_MAX FLT_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) (float)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_float\n",
"#define CONVERT_DATA2_T convert_float2\n",
"#define CONVERT_DATA4_T convert_float4\n",
"#define CONVERT_DATA8_T convert_float8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_float\n",
"#define AS_DATA2_T as_float2\n",
"#define AS_DATA4_T as_float4\n",
"#define AS_DATA8_T as_float8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif DT_F16 == 1\n",
"#define DATA_T half\n",
"#define DATA2_T half2\n",
"#define DATA4_T half4\n",
"#define DATA8_T half8\n",
"#define DATA16_T half16\n",
"#define DATA_MAX HALF_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0h\n",
"#define DATA_ONE 1.0h\n",
"#define DEF_ACC_DATA_T half\n",
"#define DEF_ACC_DATA2_T half2\n",
"#define DEF_ACC_DATA4_T half4\n",
"#define DEF_ACC_DATA8_T half8\n",
"#define POST_OP_DATA_T half\n",
"#define TO_DATA_T(v) (half)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (half)(v)\n",
"#define DATA_TO_REF convert_half\n",
"#define CONVERT_DATA_T convert_half\n",
"#define CONVERT_DATA2_T convert_half2\n",
"#define CONVERT_DATA4_T convert_half4\n",
"#define CONVERT_DATA8_T convert_half8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_half\n",
"#define AS_DATA2_T as_half2\n",
"#define AS_DATA4_T as_half4\n",
"#define AS_DATA8_T as_half8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_BF16 == 1\n",
"#define DATA_T ushort\n",
"#define POST_OP_DATA_T float\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define DATA16_T ushort16\n",
"#define DATA_MAX as_float(0x7f7f0000)\n",
"#define DATA_MIN (-DATA_MAX)\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define TO_DATA_T(v) cvt_f32_to_bf16(v)\n",
"#define TO_DEF_ACC_DATA_T(v) cvt_bf16_to_f32(v)\n",
"#define DATA_TO_REF cvt_bf16_to_f32\n",
"#define CONVERT_DATA_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA2_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA4_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA8_T cvt_f32_to_bf16\n",
"#define CONVERT_FLOAT_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT2_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT4_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT8_T cvt_bf16_to_f32\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_ushort\n",
"#define AS_DATA2_T as_ushort2\n",
"#define AS_DATA4_T as_ushort4\n",
"#define AS_DATA8_T as_ushort8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_S8 == 1\n",
"#define DATA_T char\n",
"#define DATA2_T char2\n",
"#define DATA4_T char4\n",
"#define DATA8_T char8\n",
"#define DATA16_T char16\n",
"#define DATA_MAX CHAR_MAX\n",
"#define DATA_MIN CHAR_MIN\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T int8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_char_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_char_sat_rte\n",
"#define CONVERT_DATA2_T convert_char2_sat_rte\n",
"#define CONVERT_DATA4_T convert_char4_sat_rte\n",
"#define CONVERT_DATA8_T convert_char8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_char\n",
"#define AS_DATA2_T as_char2\n",
"#define AS_DATA4_T as_char4\n",
"#define AS_DATA8_T as_char8\n",
"#define AS_DATA16_T as_char16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_int8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_U8 == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define DATA16_T uchar16\n",
"#define DATA_MAX UCHAR_MAX\n",
"#define DATA_MIN 0\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T uint8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_uchar_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_uchar_sat_rte\n",
"#define CONVERT_DATA2_T convert_uchar2_sat_rte\n",
"#define CONVERT_DATA4_T convert_uchar4_sat_rte\n",
"#define CONVERT_DATA8_T convert_uchar8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_uchar\n",
"#define AS_DATA2_T as_uchar2\n",
"#define AS_DATA4_T as_uchar4\n",
"#define AS_DATA8_T as_uchar8\n",
"#define AS_DATA16_T as_uchar16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_uint8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_S32 == 1\n",
"#define DATA_T int\n",
"#define DATA2_T int2\n",
"#define DATA4_T int4\n",
"#define DATA8_T int8\n",
"#define DATA16_T int16\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_int_sat_rte\n",
"#define CONVERT_DATA2_T convert_int2_sat_rte\n",
"#define CONVERT_DATA4_T convert_int4_sat_rte\n",
"#define CONVERT_DATA8_T convert_int8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define POST_OP_DATA_T float\n",
"#define DATA_MIN INT_MIN\n",
"#define DATA_MAX INT_MAX\n",
"#define ROUND\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_int\n",
"#define AS_DATA2_T as_int2\n",
"#define AS_DATA4_T as_int4\n",
"#define AS_DATA8_T as_int8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif !defined(DT_UNDEF)\n",
"#error \"Unexpected data type\"\n",
"#endif\n",
"#if VECT_DT_N == 1\n",
"#define VECT_DATA_T DATA_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T\n",
"#define AS_VECT_DATA_T AS_DATA_T\n",
"#define VECT_BLOCK_READ BLOCK_READ\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE\n",
"#define VECT_UINT_READ intel_sub_group_block_read\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T\n",
"#define VECT_INT_T int\n",
"#define VECT_UINT_T uint\n",
"#define VECT_FLOAT_T float\n",
"#define VECT_CHAR_T char\n",
"#define AS_VECT_INT_T as_int\n",
"#define AS_VECT_UINT_T as_uint\n",
"#define AS_VECT_FLOAT_T as_float\n",
"#define AS_VECT_CHAR_T as_char\n",
"#elif VECT_DT_N == 2\n",
"#define VECT_DATA_T DATA2_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T\n",
"#define AS_VECT_DATA_T AS_DATA2_T\n",
"#define VECT_BLOCK_READ BLOCK_READ2\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE2\n",
"#define VECT_UINT_READ intel_sub_group_block_read2\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write2\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc2\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA2_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T\n",
"#define VECT_INT_T int2\n",
"#define VECT_UINT_T uint2\n",
"#define VECT_FLOAT_T float2\n",
"#define VECT_CHAR_T char2\n",
"#define AS_VECT_INT_T as_int2\n",
"#define AS_VECT_UINT_T as_uint2\n",
"#define AS_VECT_FLOAT_T as_float2\n",
"#define AS_VECT_CHAR_T as_char2\n",
"#elif VECT_DT_N == 4\n",
"#define VECT_DATA_T DATA4_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T\n",
"#define AS_VECT_DATA_T AS_DATA4_T\n",
"#define VECT_BLOCK_READ BLOCK_READ4\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE4\n",
"#define VECT_UINT_READ intel_sub_group_block_read4\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write4\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc4\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA4_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T\n",
"#define VECT_INT_T int4\n",
"#define VECT_UINT_T uint4\n",
"#define VECT_FLOAT_T float4\n",
"#define VECT_CHAR_T char4\n",
"#define AS_VECT_INT_T as_int4\n",
"#define AS_VECT_UINT_T as_uint4\n",
"#define AS_VECT_FLOAT_T as_float4\n",
"#define AS_VECT_CHAR_T as_char4\n",
"#elif VECT_DT_N == 8\n",
"#define VECT_DATA_T DATA8_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T\n",
"#define AS_VECT_DATA_T AS_DATA8_T\n",
"#define VECT_BLOCK_READ BLOCK_READ8\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE8\n",
"#define VECT_UINT_READ intel_sub_group_block_read8\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write8\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc8\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA8_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T\n",
"#define VECT_INT_T int8\n",
"#define VECT_UINT_T uint8\n",
"#define VECT_FLOAT_T float8\n",
"#define VECT_CHAR_T char8\n",
"#define AS_VECT_INT_T as_int8\n",
"#define AS_VECT_UINT_T as_uint8\n",
"#define AS_VECT_FLOAT_T as_float8\n",
"#define AS_VECT_CHAR_T as_char8\n",
"#endif\n",
"#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T)\n",
"#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T)\n",
"#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T)\n",
"#ifdef SRC_DATA_T\n",
"#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2)\n",
"#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4)\n",
"#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8)\n",
"#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16)\n",
"#ifdef SRC_DT_U8\n",
"#define SRC_MMAD_DATA_T uint\n",
"#define SRC_MMAD_DATA4_T uint4\n",
"#define SRC_MMAD_DATA8_T uint8\n",
"#elif SRC_DT_S8\n",
"#define SRC_MMAD_DATA_T int\n",
"#define SRC_MMAD_DATA4_T int4\n",
"#define SRC_MMAD_DATA8_T int8\n",
"#endif\n",
"#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T)\n",
"#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T)\n",
"#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T)\n",
"#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T)\n",
"#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T)\n",
"#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T)\n",
"#if SRC_DT_BF16\n",
"#define SRC_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define SRC_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define SRC_TO_REF(x) (x)\n",
"#define SRC_TO_REF8(x) (x)\n",
"#define REF_TO_SRC(x) (x)\n",
"#endif\n",
"#if SRC_DT_BF16\n",
"#define TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#elif SRC_DT_U8\n",
"#define TO_SRC(x) convert_uchar_sat_rte(x)\n",
"#elif SRC_DT_S8\n",
"#define TO_SRC(x) convert_char_sat_rte(x)\n",
"#elif SRC_DT_S32\n",
"#define TO_SRC(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_SRC(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef A_DATA_T\n",
"#define A_DATA8_T CONCAT2(A_DATA_T, 8)\n",
"#if A_DT_BF16\n",
"#define A_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define A_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_A(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define A_TO_REF(x) (x)\n",
"#define A_TO_REF8(x) (x)\n",
"#define REF_TO_A(x) (x)\n",
"#endif\n",
"#if A_DT_BF16\n",
"#define TO_A(x) cvt_f32_to_bf16(x)\n",
"#elif A_DT_U8\n",
"#define TO_A(x) convert_uchar_sat_rte(x)\n",
"#elif A_DT_S8\n",
"#define TO_A(x) convert_char_sat_rte(x)\n",
"#elif A_DT_S32\n",
"#define TO_A(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_A(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef WEI_DATA_T\n",
"#if WEI_DT_BF16\n",
"#define WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define WEI_TO_REF(x) (x)\n",
"#define REF_TO_WEI(x) (x)\n",
"#endif\n",
"#if WEI_DT_BF16\n",
"#define TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif WEI_DT_U8\n",
"#define TO_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif WEI_DT_S8\n",
"#define TO_WEI(x) convert_char_sat_rte(x)\n",
"#elif WEI_DT_S32\n",
"#define TO_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DIFF_WEI_DATA_T\n",
"#if DIFF_WEI_DT_BF16\n",
"#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define DIFF_WEI_TO_REF(x) (x)\n",
"#define REF_TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#if DIFF_WEI_DT_BF16\n",
"#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif DIFF_WEI_DT_U8\n",
"#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S8\n",
"#define TO_DIFF_WEI(x) convert_char_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S32\n",
"#define TO_DIFF_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef B_DATA_T\n",
"#if B_DT_BF16\n",
"#define B_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_B(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define B_TO_REF(x) (x)\n",
"#define REF_TO_B(x) (x)\n",
"#endif\n",
"#if B_DT_BF16\n",
"#define TO_B(x) cvt_f32_to_bf16(x)\n",
"#elif B_DT_U8\n",
"#define TO_B(x) convert_uchar_sat_rte(x)\n",
"#elif B_DT_S8\n",
"#define TO_B(x) convert_char_sat_rte(x)\n",
"#elif B_DT_S32\n",
"#define TO_B(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_B(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef BIA_DATA_T\n",
"#if BIA_DT_BF16\n",
"#define BIA_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define BIA_TO_REF(x) (x)\n",
"#define REF_TO_BIA(x) (x)\n",
"#endif\n",
"#if BIA_DT_BF16\n",
"#define TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#elif BIA_DT_U8\n",
"#define TO_BIA(x) convert_uchar_sat_rte(x)\n",
"#elif BIA_DT_S8\n",
"#define TO_BIA(x) convert_char_sat_rte(x)\n",
"#elif BIA_DT_S32\n",
"#define TO_BIA(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_BIA(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DST_DATA_T\n",
"#define DST_DATA2_T CONCAT2(DST_DATA_T, 2)\n",
"#define DST_DATA4_T CONCAT2(DST_DATA_T, 4)\n",
"#define DST_DATA8_T CONCAT2(DST_DATA_T, 8)\n",
"#define DST_DATA16_T CONCAT2(DST_DATA_T, 16)\n",
"#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T)\n",
"#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T)\n",
"#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T)\n",
"#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T)\n",
"#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T)\n",
"#if DST_DT_F32 || DST_DT_F16\n",
"#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T)\n",
"#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T)\n",
"#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T)\n",
"#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T)\n",
"#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T)\n",
"#else\n",
"#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte)\n",
"#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte)\n",
"#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte)\n",
"#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte)\n",
"#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte)\n",
"#endif\n",
"#if DST_DT_U8\n",
"#define MMAD_DATA_T uint\n",
"#define MMAD_DATA4_T uint4\n",
"#define MMAD_DATA8_T uint8\n",
"#elif DST_DT_S8\n",
"#define MMAD_DATA_T int\n",
"#define MMAD_DATA4_T int4\n",
"#define MMAD_DATA8_T int8\n",
"#endif\n",
"// Block read/write macros for dst.\n",
"#if DST_DT_U8 || DST_DT_S8\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v))\n",
"#elif DST_DT_S32 || DST_DT_F32\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write((__global uint *)ptr, as_uint(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#elif DST_DT_F16\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define DST_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define DST_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define DST_TO_REF(x) (x)\n",
"#define DST_TO_REF8(x) (x)\n",
"#define REF_TO_DST(x) (x)\n",
"#define REF_TO_DST8(x) (x)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x))\n",
"#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x))\n",
"#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif DST_DT_F16\n",
"#define TO_DST(x) convert_half(x)\n",
"#define TO_DST2(x) convert_half2(x)\n",
"#define TO_DST4(x) convert_half4(x)\n",
"#define TO_DST8(x) convert_half8(x)\n",
"#elif DST_DT_U8\n",
"#define TO_DST(x) convert_uchar_sat_rte(x)\n",
"#define TO_DST2(x) convert_uchar2_sat_rte(x)\n",
"#define TO_DST4(x) convert_uchar4_sat_rte(x)\n",
"#define TO_DST8(x) convert_uchar8_sat_rte(x)\n",
"#define TO_DST16(x) convert_uchar16_sat_rte(x)\n",
"#elif DST_DT_S8\n",
"#define TO_DST(x) convert_char_sat_rte(x)\n",
"#define TO_DST2(x) convert_char2_sat_rte(x)\n",
"#define TO_DST4(x) convert_char4_sat_rte(x)\n",
"#define TO_DST8(x) convert_char8_sat_rte(x)\n",
"#define TO_DST16(x) convert_char16_sat_rte(x)\n",
"#elif DST_DT_S32\n",
"#define TO_DST(x) convert_int_sat_rte(x)\n",
"#define TO_DST2(x) convert_int2_sat_rte(x)\n",
"#define TO_DST4(x) convert_int4_sat_rte(x)\n",
"#define TO_DST8(x) convert_int8_sat_rte(x)\n",
"#elif DST_DT_F32\n",
"#define TO_DST(x) convert_float(x)\n",
"#define TO_DST2(x) convert_float2(x)\n",
"#define TO_DST4(x) convert_float4(x)\n",
"#define TO_DST8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef C_DATA_T\n",
"#define C_DATA8_T CONCAT2(C_DATA_T, 8)\n",
"#if C_DT_BF16\n",
"#define C_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define C_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_C(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define C_TO_REF(x) (x)\n",
"#define C_TO_REF8(x) (x)\n",
"#define REF_TO_C(x) (x)\n",
"#define REF_TO_C8(x) (x)\n",
"#endif\n",
"#if C_DT_BF16\n",
"#define TO_C(x) cvt_f32_to_bf16(x)\n",
"#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif C_DT_F16\n",
"#define TO_C(x) convert_half(x)\n",
"#define TO_C8(x) convert_half8(x)\n",
"#elif C_DT_U8\n",
"#define TO_C(x) convert_uchar_sat_rte(x)\n",
"#define TO_C8(x) convert_uchar8_sat_rte(x)\n",
"#elif C_DT_S8\n",
"#define TO_C(x) convert_char_sat_rte(x)\n",
"#define TO_C8(x) convert_char8_sat_rte(x)\n",
"#elif C_DT_S32\n",
"#define TO_C(x) convert_int_sat_rte(x)\n",
"#define TO_C8(x) convert_int8_sat_rte(x)\n",
"#elif C_DT_F32\n",
"#define TO_C(x) convert_float(x)\n",
"#define TO_C8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef ACC_DATA_T\n",
"#if ACC_DT_F16\n",
"#define TO_ACC(x) convert_half(x)\n",
"#elif ACC_DT_F32\n",
"#define TO_ACC(x) convert_float(x)\n",
"#elif ACC_DT_S32\n",
"#define TO_ACC(x) convert_int(x)\n",
"#else\n",
"#error \"Unexpected accumulation data type\"\n",
"#endif\n",
"#endif\n",
"#ifdef SUM_DATA_T\n",
"#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2)\n",
"#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4)\n",
"#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8)\n",
"#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16)\n",
"#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T)\n",
"#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T)\n",
"#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T)\n",
"#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T)\n",
"#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T)\n",
"#if SUM_DT_BF16\n",
"#define SUM_TO_REF cvt_bf16_to_f32\n",
"#else\n",
"#define SUM_TO_REF\n",
"#endif\n",
"#endif\n",
"#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2)))\n",
"#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"              / CONCAT2(prefix, _B0_1)) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"                       % CONCAT2(prefix, _B0_1)) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \\\n",
"                    * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       / CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       % CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \\\n",
"                    * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       / CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       % CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \\\n",
"                    * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       / CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       % CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \\\n",
"                    * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       / CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       % CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \\\n",
"                    * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       / CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       % CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \\\n",
"                    * CONCAT2(prefix, _S5_2)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3)))\n",
"#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5)\n",
"#if NDIMS == 2\n",
"#define SRC_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1)\n",
"#elif NDIMS == 3\n",
"#define SRC_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, x3) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, x2) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2)\n",
"#elif NDIMS == 4\n",
"#define SRC_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, x3, x4) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, d, x3, x4) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3)\n",
"#elif NDIMS == 5\n",
"#define SRC_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \\\n",
"            + ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \\\n",
"            + ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, x3, x4, x5) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \\\n",
"            + ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4)\n",
"#endif\n",
"#define DST_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \\\n",
"            + ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4)\n",
"#endif\n",
"// clang-format off\n",
"// Shortcut accessors for special cases.\n",
"// x - product of the current and outer dimensions in gws[idx]\n",
"// y - the current dimension\n",
"#define GWS_OP_ZERO(x, y) 0\n",
"#define GWS_OP_FIRST(x, y) (x)\n",
"#define GWS_OP_MOD(x, y) ((x) % (y))\n",
"#define ROUND_UP(a,b) (((a) + (b) - 1) / (b))\n",
"#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0\n",
"#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1\n",
"#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2\n",
"#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3\n",
"#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4\n",
"#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5\n",
"#define GWS0_GET_BLOCK0() GWS0_BLOCK0\n",
"#define GWS0_GET_BLOCK1() GWS0_BLOCK1\n",
"#define GWS0_GET_BLOCK2() GWS0_BLOCK2\n",
"#define GWS0_GET_BLOCK3() GWS0_BLOCK3\n",
"#define GWS0_GET_BLOCK4() GWS0_BLOCK4\n",
"#define GWS0_GET_BLOCK5() GWS0_BLOCK5\n",
"#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0\n",
"#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1\n",
"#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2\n",
"#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3\n",
"#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4\n",
"#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5\n",
"#define GWS1_GET_BLOCK0() GWS1_BLOCK0\n",
"#define GWS1_GET_BLOCK1() GWS1_BLOCK1\n",
"#define GWS1_GET_BLOCK2() GWS1_BLOCK2\n",
"#define GWS1_GET_BLOCK3() GWS1_BLOCK3\n",
"#define GWS1_GET_BLOCK4() GWS1_BLOCK4\n",
"#define GWS1_GET_BLOCK5() GWS1_BLOCK5\n",
"#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0\n",
"#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1\n",
"#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2\n",
"#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3\n",
"#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4\n",
"#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5\n",
"#define GWS2_GET_BLOCK0() GWS2_BLOCK0\n",
"#define GWS2_GET_BLOCK1() GWS2_BLOCK1\n",
"#define GWS2_GET_BLOCK2() GWS2_BLOCK2\n",
"#define GWS2_GET_BLOCK3() GWS2_BLOCK3\n",
"#define GWS2_GET_BLOCK4() GWS2_BLOCK4\n",
"#define GWS2_GET_BLOCK5() GWS2_BLOCK5\n",
"// clang-format on\n",
"// With work-group qualifier, without sub-group qualifier.\n",
"#define KERNEL_ATTR_SG0 \\\n",
"    __attribute__((reqd_work_group_size( \\\n",
"            GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT)))\n",
"// With work-group and sub-group qualifiers.\n",
"#define KERNEL_ATTR_SG1 \\\n",
"    KERNEL_ATTR_SG0 \\\n",
"    __attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT)))\n",
"#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT)\n",
"// Named kernel attributes - when source contains multiple kernels.\n",
"#define NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \\\n",
"            CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name))))\n",
"#define NAMED_KERNEL_ATTR_SG1(name) \\\n",
"    NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name))))\n",
"#define NAMED_KERNEL_ATTR(name) \\\n",
"    CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name)\n",
"#endif\n",
"#if OUTPUT_DT_U8\n",
"#define TO_OUTPUT(x) convert_uchar_sat_rte(x)\n",
"#elif OUTPUT_DT_S8\n",
"#define TO_OUTPUT(x) convert_char_sat_rte(x)\n",
"#elif OUTPUT_DT_S32\n",
"#define TO_OUTPUT(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_OUTPUT(x) (x)\n",
"#endif\n",
"#if INPUT_DT_BF16\n",
"#define TO_INPUT(x) cvt_f32_to_bf16(x)\n",
"#define TO_REF(x) cvt_bf16_to_f32(x)\n",
"#else\n",
"#define TO_INPUT(x) (x)\n",
"#define TO_REF(x) (float)(x)\n",
"#endif\n",
"#if DT_F16 && !IS_FWD\n",
"#error \"FP16 is not supported for BWD\"\n",
"#endif\n",
"#define OFFTYPE ulong\n",
"#define TO_WS_STATE(x) TO_SRC(x)\n",
"#define OFF6(i0, D0, i1, D1, i2, D2, i3, D3, i4, D4, i5, D5) \\\n",
"    ((((((i0) * (D1) + (i1)) * (D2) + (i2)) * (D3) + (i3)) * (D4) + (i4)) \\\n",
"                    * (D5) \\\n",
"            + (i5))\n",
"#define OFF5(i0, D0, i1, D1, i2, D2, i3, D3, i4, D4) \\\n",
"    (((((i0) * (D1) + (i1)) * (D2) + (i2)) * (D3) + (i3)) * (D4) + (i4))\n",
"#define OFF4(i0, D0, i1, D1, i2, D2, i3, D3) \\\n",
"    ((((i0) * (D1) + (i1)) * (D2) + (i2)) * (D3) + (i3))\n",
"#define OFF3(i0, D0, i1, D1, i2, D2) (((i0) * (D1) + (i1)) * (D2) + (i2))\n",
"#define OFF2(i0, D0, i1, D1) ((i0) * (D1) + (i1))\n",
"// used for the both H- and C-states\n",
"#define OFF_WS_STATE(i0, i1, i2, i3, i4) \\\n",
"    OFF5((i0), N_LAYER + 1, (i1), N_DIR, (i2), N_ITER + 1, (i3), BATCH, (i4), \\\n",
"            STATES_WS_LD)\n",
"#define OFF_WS_DIFF_STATES(i0, i1, i2, i3, i4, i5) \\\n",
"    OFF6((i0), N_LAYER + 1, (i1), N_DIR, (i2), N_STATES + 1, (i3), N_ITER + 1, \\\n",
"            (i4), BATCH, (i5), DIFF_STATES_WS_LD)\n",
"// cannot be presented by OFF6 due to leading dimension across two dims\n",
"#define OFF_WS_GATES(i0, i1, i2, i3, i4, i5) \\\n",
"    (i0) * N_DIR *N_ITER *BATCH *GATES_WS_LD + (i1)*N_ITER *BATCH *GATES_WS_LD \\\n",
"            + (i2)*BATCH *GATES_WS_LD + (i3)*GATES_WS_LD + (i4)*DHC + (i5)\n",
"// grid offset for lbr GRU, LD = DHC\n",
"#define OFF_WS_GRID_OFFSET(i0, i1, i2, i3, i4) \\\n",
"    OFF5((i0), N_LAYER + 1, (i1), N_DIR, (i2), N_ITER + 1, (i3), BATCH, (i4), \\\n",
"            DHC)\n",
"#if N_ITER_SCRATCH_GATES == 1\n",
"// if no merge gemm, scratch_gates contain data for single cell,\n",
"// so we ignore iter dim\n",
"#define OFF_SCRATCH_MEM(i0, i1, i2, i3) \\\n",
"    (i1) * SCRATCH_GATES_LD + (i2)*DHC + (i3)\n",
"#else\n",
"#define OFF_SCRATCH_MEM(i0, i1, i2, i3) \\\n",
"    (i0) * BATCH *SCRATCH_GATES_LD + (i1)*SCRATCH_GATES_LD + (i2)*DHC + (i3)\n",
"#endif\n",
"#define OFF_WS_BIAS(i0, i1, i2, i3) \\\n",
"    OFF4((i0), N_LAYER, (i1), N_DIR, (i2), N_BIAS, (i3), DHC)\n",
"// for cell - shorter forms\n",
"#define CELL_WS_GATES(i3, i4, i5) OFF_WS_GATES(0, 0, 0, i3, i4, i5)\n",
"#define CELL_SCRATCH_MEM(i1, i2, i3) OFF_SCRATCH_MEM(0, i1, i2, i3)\n",
"#define CELL_WS_STATE(i4, i5) OFF_WS_STATE(0, 0, 0, i4, i5)\n",
"#define CELL_WS_DIFF_STATES(i2, i4, i5) OFF_WS_DIFF_STATES(0, 0, i2, 0, i4, i5)\n",
"#define CELL_WS_GRID_COMP(i3, i4) OFF_WS_GRID_OFFSET(0, 0, 0, i3, i4)\n",
"#define OFF_KER_BIAS(i0, i1) OFF2((i0), N_GATES, (i1), DHC)\n",
"#define OFF_WS_DHG1(i0, i1) OFF2((i0), BATCH, (i1), DIFF_STATES_WS_LD)\n",
"#define OFF_SCRATCHCELL(i0, i1) OFF2((i0), BATCH, (i1), STATES_WS_LD)\n",
"#define SRC_L_OFF(x0, x1, x2) \\\n",
"    (((x0) % SRC_L_B0) * SRC_L_SB0 + ((x0) / SRC_L_B0) * SRC_L_S0 \\\n",
"            + ((x1) % SRC_L_B1) * SRC_L_SB1 + ((x1) / SRC_L_B1) * SRC_L_S1 \\\n",
"            + ((x2) % SRC_L_B2) * SRC_L_SB2 + ((x2) / SRC_L_B2) * SRC_L_S2)\n",
"#define SRC_I_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % SRC_I_B0) * SRC_I_SB0 + ((x0) / SRC_I_B0) * SRC_I_S0 \\\n",
"            + ((x1) % SRC_I_B1) * SRC_I_SB1 + ((x1) / SRC_I_B1) * SRC_I_S1 \\\n",
"            + ((x2) % SRC_I_B2) * SRC_I_SB2 + ((x2) / SRC_I_B2) * SRC_I_S2 \\\n",
"            + ((x3) % SRC_I_B3) * SRC_I_SB3 + ((x3) / SRC_I_B3) * SRC_I_S3)\n",
"#define SRC_I_C_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % SRC_I_C_B0) * SRC_I_C_SB0 + ((x0) / SRC_I_C_B0) * SRC_I_C_S0 \\\n",
"            + ((x1) % SRC_I_C_B1) * SRC_I_C_SB1 \\\n",
"            + ((x1) / SRC_I_C_B1) * SRC_I_C_S1 \\\n",
"            + ((x2) % SRC_I_C_B2) * SRC_I_C_SB2 \\\n",
"            + ((x2) / SRC_I_C_B2) * SRC_I_C_S2 \\\n",
"            + ((x3) % SRC_I_C_B3) * SRC_I_C_SB3 \\\n",
"            + ((x3) / SRC_I_C_B3) * SRC_I_C_S3)\n",
"#define DST_L_OFF(x0, x1, x2) \\\n",
"    (((x0) % DST_L_B0) * DST_L_SB0 + ((x0) / DST_L_B0) * DST_L_S0 \\\n",
"            + ((x1) % DST_L_B1) * DST_L_SB1 + ((x1) / DST_L_B1) * DST_L_S1 \\\n",
"            + ((x2) % DST_L_B2) * DST_L_SB2 + ((x2) / DST_L_B2) * DST_L_S2)\n",
"#define DST_I_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % DST_I_B0) * DST_I_SB0 + ((x0) / DST_I_B0) * DST_I_S0 \\\n",
"            + ((x1) % DST_I_B1) * DST_I_SB1 + ((x1) / DST_I_B1) * DST_I_S1 \\\n",
"            + ((x2) % DST_I_B2) * DST_I_SB2 + ((x2) / DST_I_B2) * DST_I_S2 \\\n",
"            + ((x3) % DST_I_B3) * DST_I_SB3 + ((x3) / DST_I_B3) * DST_I_S3)\n",
"#define DST_I_C_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % DST_I_C_B0) * DST_I_C_SB0 + ((x0) / DST_I_C_B0) * DST_I_C_S0 \\\n",
"            + ((x1) % DST_I_C_B1) * DST_I_C_SB1 \\\n",
"            + ((x1) / DST_I_C_B1) * DST_I_C_S1 \\\n",
"            + ((x2) % DST_I_C_B2) * DST_I_C_SB2 \\\n",
"            + ((x2) / DST_I_C_B2) * DST_I_C_S2 \\\n",
"            + ((x3) % DST_I_C_B3) * DST_I_C_SB3 \\\n",
"            + ((x3) / DST_I_C_B3) * DST_I_C_S3)\n",
"#define BIAS_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % BIAS_B0) * BIAS_SB0 + ((x0) / BIAS_B0) * BIAS_S0 \\\n",
"            + ((x1) % BIAS_B1) * BIAS_SB1 + ((x1) / BIAS_B1) * BIAS_S1 \\\n",
"            + ((x2) % BIAS_B2) * BIAS_SB2 + ((x2) / BIAS_B2) * BIAS_S2 \\\n",
"            + ((x3) % BIAS_B3) * BIAS_SB3 + ((x3) / BIAS_B3) * BIAS_S3)\n",
"#define DIFF_SRC_L_OFF(x0, x1, x2) \\\n",
"    (((x0) % DIFF_SRC_L_B0) * DIFF_SRC_L_SB0 \\\n",
"            + ((x0) / DIFF_SRC_L_B0) * DIFF_SRC_L_S0 \\\n",
"            + ((x1) % DIFF_SRC_L_B1) * DIFF_SRC_L_SB1 \\\n",
"            + ((x1) / DIFF_SRC_L_B1) * DIFF_SRC_L_S1 \\\n",
"            + ((x2) % DIFF_SRC_L_B2) * DIFF_SRC_L_SB2 \\\n",
"            + ((x2) / DIFF_SRC_L_B2) * DIFF_SRC_L_S2)\n",
"#define DIFF_DST_L_OFF(x0, x1, x2) \\\n",
"    (((x0) % DIFF_DST_L_B0) * DIFF_DST_L_SB0 \\\n",
"            + ((x0) / DIFF_DST_L_B0) * DIFF_DST_L_S0 \\\n",
"            + ((x1) % DIFF_DST_L_B1) * DIFF_DST_L_SB1 \\\n",
"            + ((x1) / DIFF_DST_L_B1) * DIFF_DST_L_S1 \\\n",
"            + ((x2) % DIFF_DST_L_B2) * DIFF_DST_L_SB2 \\\n",
"            + ((x2) / DIFF_DST_L_B2) * DIFF_DST_L_S2)\n",
"#define DIFF_SRC_I_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % DIFF_SRC_I_B0) * DIFF_SRC_I_SB0 \\\n",
"            + ((x0) / DIFF_SRC_I_B0) * DIFF_SRC_I_S0 \\\n",
"            + ((x1) % DIFF_SRC_I_B1) * DIFF_SRC_I_SB1 \\\n",
"            + ((x1) / DIFF_SRC_I_B1) * DIFF_SRC_I_S1 \\\n",
"            + ((x2) % DIFF_SRC_I_B2) * DIFF_SRC_I_SB2 \\\n",
"            + ((x2) / DIFF_SRC_I_B2) * DIFF_SRC_I_S2 \\\n",
"            + ((x3) % DIFF_SRC_I_B3) * DIFF_SRC_I_SB3 \\\n",
"            + ((x3) / DIFF_SRC_I_B3) * DIFF_SRC_I_S3)\n",
"#define DIFF_DST_I_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % DIFF_DST_I_B0) * DIFF_DST_I_SB0 \\\n",
"            + ((x0) / DIFF_DST_I_B0) * DIFF_DST_I_S0 \\\n",
"            + ((x1) % DIFF_DST_I_B1) * DIFF_DST_I_SB1 \\\n",
"            + ((x1) / DIFF_DST_I_B1) * DIFF_DST_I_S1 \\\n",
"            + ((x2) % DIFF_DST_I_B2) * DIFF_DST_I_SB2 \\\n",
"            + ((x2) / DIFF_DST_I_B2) * DIFF_DST_I_S2 \\\n",
"            + ((x3) % DIFF_DST_I_B3) * DIFF_DST_I_SB3 \\\n",
"            + ((x3) / DIFF_DST_I_B3) * DIFF_DST_I_S3)\n",
"#define DIFF_SRC_I_C_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % DIFF_SRC_I_C_B0) * DIFF_SRC_I_C_SB0 \\\n",
"            + ((x0) / DIFF_SRC_I_C_B0) * DIFF_SRC_I_C_S0 \\\n",
"            + ((x1) % DIFF_SRC_I_C_B1) * DIFF_SRC_I_C_SB1 \\\n",
"            + ((x1) / DIFF_SRC_I_C_B1) * DIFF_SRC_I_C_S1 \\\n",
"            + ((x2) % DIFF_SRC_I_C_B2) * DIFF_SRC_I_C_SB2 \\\n",
"            + ((x2) / DIFF_SRC_I_C_B2) * DIFF_SRC_I_C_S2 \\\n",
"            + ((x3) % DIFF_SRC_I_C_B3) * DIFF_SRC_I_C_SB3 \\\n",
"            + ((x3) / DIFF_SRC_I_C_B3) * DIFF_SRC_I_C_S3)\n",
"#define DIFF_DST_I_C_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % DIFF_DST_I_C_B0) * DIFF_DST_I_C_SB0 \\\n",
"            + ((x0) / DIFF_DST_I_C_B0) * DIFF_DST_I_C_S0 \\\n",
"            + ((x1) % DIFF_DST_I_C_B1) * DIFF_DST_I_C_SB1 \\\n",
"            + ((x1) / DIFF_DST_I_C_B1) * DIFF_DST_I_C_S1 \\\n",
"            + ((x2) % DIFF_DST_I_C_B2) * DIFF_DST_I_C_SB2 \\\n",
"            + ((x2) / DIFF_DST_I_C_B2) * DIFF_DST_I_C_S2 \\\n",
"            + ((x3) % DIFF_DST_I_C_B3) * DIFF_DST_I_C_SB3 \\\n",
"            + ((x3) / DIFF_DST_I_C_B3) * DIFF_DST_I_C_S3)\n",
"#define DIFF_BIAS_OFF(x0, x1, x2, x3) \\\n",
"    (((x0) % DIFF_BIAS_B0) * DIFF_BIAS_SB0 \\\n",
"            + ((x0) / DIFF_BIAS_B0) * DIFF_BIAS_S0 \\\n",
"            + ((x1) % DIFF_BIAS_B1) * DIFF_BIAS_SB1 \\\n",
"            + ((x1) / DIFF_BIAS_B1) * DIFF_BIAS_S1 \\\n",
"            + ((x2) % DIFF_BIAS_B2) * DIFF_BIAS_SB2 \\\n",
"            + ((x2) / DIFF_BIAS_B2) * DIFF_BIAS_S2 \\\n",
"            + ((x3) % DIFF_BIAS_B3) * DIFF_BIAS_SB3 \\\n",
"            + ((x3) / DIFF_BIAS_B3) * DIFF_BIAS_S3)\n",
"#endif\n",
"float one_m_square(float a) {\n",
"    return 1.0f - a * a;\n",
"}\n",
"float x_m_square(float a) {\n",
"    return (1.0f - a) * a;\n",
"}\n",
"float relu_fwd(float s, float alpha) {\n",
"    return s > 0 ? s : s * alpha;\n",
"}\n",
"float tanh_fwd(float s) {\n",
"    return tanh(s);\n",
"}\n",
"float logistic_fwd(float s) {\n",
"    return 1 / (1 + exp((float)-s));\n",
"}\n",
"float logistic_bwd(float s) {\n",
"    return x_m_square(s);\n",
"}\n",
"float relu_bwd(float s, float alpha) {\n",
"    return s > 0 ? 1.f : alpha;\n",
"}\n",
"float tanh_bwd(float s) {\n",
"    return (1 - s) * (1 + s);\n",
"}\n",
"float linear(float s, float alpha) {\n",
"    return alpha * s;\n",
"}\n",
"float relu_fwd_tm(float s, float alpha) {\n",
"#if !IS_TESTMODE\n",
"    return relu_fwd(s, alpha);\n",
"#else\n",
"    return linear(s, alpha);\n",
"#endif\n",
"}\n",
"float tanh_fwd_tm(float s, float alpha) {\n",
"#if !IS_TESTMODE\n",
"    return tanh(s);\n",
"#else\n",
"    return linear(s, alpha);\n",
"#endif\n",
"}\n",
"float logistic_fwd_tm(float s, float alpha) {\n",
"#if !IS_TESTMODE\n",
"    return logistic_fwd(s);\n",
"#else\n",
"    return linear(s, alpha);\n",
"#endif\n",
"}\n",
"float relu_bwd_tm(float s, float alpha) {\n",
"#if !IS_TESTMODE\n",
"    return relu_bwd(s, alpha);\n",
"#else\n",
"    return linear(s, alpha);\n",
"#endif\n",
"}\n",
"float tanh_bwd_tm(float s, float alpha) {\n",
"#if !IS_TESTMODE\n",
"    return tanh_bwd(s);\n",
"#else\n",
"    return linear(s, alpha);\n",
"#endif\n",
"}\n",
"float logistic_bwd_tm(float s, float alpha) {\n",
"#if !IS_TESTMODE\n",
"    return logistic_bwd(s);\n",
"#else\n",
"    return linear(s, alpha);\n",
"#endif\n",
"}\n",
"float activation_fwd(float s, float alpha, float cliping) {\n",
"#if CELL_KIND == VANILLA_RNN\n",
"#if ACTIVATION_KIND == ELTWISE_RELU\n",
"    return relu_fwd_tm(s, alpha);\n",
"#elif ACTIVATION_KIND == ELTWISE_TANH\n",
"    return tanh_fwd_tm(s, alpha);\n",
"#elif ACTIVATION_KIND == ELTWISE_LOGISTIC\n",
"    return logistic_fwd_tm(s, alpha);\n",
"#else\n",
"#error \"Unsupported activation_kind\"\n",
"#endif\n",
"#else\n",
"    return 0.0f;\n",
"#endif\n",
"}\n",
"float activation_bwd(float s, float alpha, float cliping) {\n",
"#if CELL_KIND == VANILLA_RNN\n",
"#if ACTIVATION_KIND == ELTWISE_RELU\n",
"    return relu_bwd_tm(s, alpha);\n",
"#elif ACTIVATION_KIND == ELTWISE_TANH\n",
"    return tanh_bwd_tm(s, alpha);\n",
"#elif ACTIVATION_KIND == ELTWISE_LOGISTIC\n",
"    return logistic_bwd_tm(s, alpha);\n",
"#else\n",
"#error \"Unsupported activation_kind\"\n",
"#endif\n",
"#else\n",
"    return 0.0f;\n",
"#endif\n",
"}\n",
"__kernel void ref_rnn_copy_init_layer(\n",
"        __global char *ws, __global char *src_base, int lr, int rl) {\n",
"#if IS_FWD\n",
"    const int it = get_global_id(2);\n",
"    const int b = get_global_id(1);\n",
"    const int c = get_global_id(0);\n",
"    __global WS_STATE_DATA_T *dst;\n",
"    __global WS_STATE_DATA_T *dst_base\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET);\n",
"    __global WS_STATE_DATA_T *src = (__global WS_STATE_DATA_T *)src_base\n",
"            + SRC_L_OFF(it, 0, 0) + b * SLC + c;\n",
"    if (lr) {\n",
"        dst = dst_base + OFF_WS_STATE(0, 0, it + 1, b, c);\n",
"        dst[0] = src[0];\n",
"    }\n",
"    if (rl) {\n",
"        dst = dst_base + OFF_WS_STATE(0, N_DIR - 1, N_ITER - it, b, c);\n",
"        dst[0] = src[0];\n",
"    }\n",
"#else // BWD\n",
"    const int it = get_global_id(1);\n",
"    const int b = get_global_id(0);\n",
"    __global DIFF_DATA_T *dst\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET);\n",
"#if DIRECTION_KIND == CONCAT\n",
"    __global DIFF_DATA_T *src\n",
"            = (__global DIFF_DATA_T *)src_base + DIFF_DST_L_OFF(it, b, 0);\n",
"    for (int s = 0; s < DHC; s++) {\n",
"        dst[OFF_WS_DIFF_STATES(N_LAYER, 0, N_STATES, it, b, s)] = src[s];\n",
"        dst[OFF_WS_DIFF_STATES(N_LAYER, 1, N_STATES, N_ITER - it - 1, b, s)]\n",
"                = src[DHC + s];\n",
"    }\n",
"#elif DIRECTION_KIND == SUM\n",
"    __global DIFF_DATA_T *src\n",
"            = (__global DIFF_DATA_T *)src_base + DIFF_DST_L_OFF(it, b, 0);\n",
"    for (int s = 0; s < DHC; s++) {\n",
"        dst[OFF_WS_DIFF_STATES(N_LAYER, 0, N_STATES, it, b, s)] = src[s];\n",
"        dst[OFF_WS_DIFF_STATES(N_LAYER, 1, N_STATES, N_ITER - it - 1, b, s)]\n",
"                = src[s];\n",
"    }\n",
"#elif DIRECTION_KIND == L2R\n",
"    __global DIFF_DATA_T *src\n",
"            = (__global DIFF_DATA_T *)src_base + DIFF_DST_L_OFF(it, b, 0);\n",
"    for (int s = 0; s < DHC; s++) {\n",
"        dst[OFF_WS_DIFF_STATES(N_LAYER, 0, N_STATES, it, b, s)] = src[s];\n",
"    }\n",
"#elif DIRECTION_KIND == R2L\n",
"    __global DIFF_DATA_T *src = (__global DIFF_DATA_T *)src_base\n",
"            + DIFF_DST_L_OFF(N_ITER - it - 1, b, 0);\n",
"    for (int s = 0; s < DHC; s++) {\n",
"        dst[OFF_WS_DIFF_STATES(N_LAYER, 0, N_STATES, it, b, s)] = src[s];\n",
"    }\n",
"#else\n",
"#error \"Unsupported direction_kind\"\n",
"#endif\n",
"#endif\n",
"}\n",
"__kernel void ref_rnn_copy_init_iter(\n",
"        __global char *ws, __global char *src_base, __global char *src_c_base\n",
"#if IS_FWD\n",
"        ,\n",
"        const float shift, const float scale, const int quantize\n",
"#endif\n",
") {\n",
"    const int s = get_global_id(0);\n",
"    const int b = get_global_id(1);\n",
"    const int lay = get_global_id(2) / N_DIR;\n",
"    const int dir = get_global_id(2) % N_DIR;\n",
"#if IS_FWD\n",
"    __global INPUT_DATA_T *src = (__global INPUT_DATA_T *)(src_base);\n",
"    __global WS_STATE_DATA_T *dst\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET);\n",
"    if (s < SIC)\n",
"        dst[OFF_WS_STATE(lay + 1, dir, 0, b, s)] = src_base\n",
"                ? (quantize ? TO_WS_STATE(\n",
"                           src[SRC_I_OFF(lay, dir, b, s)] * scale + shift)\n",
"                            : src[SRC_I_OFF(lay, dir, b, s)])\n",
"                : TO_WS_STATE(0.0f);\n",
"#if WITH_SRC_ITER_C\n",
"    __global AUX_DATA_T *src_c = (__global AUX_DATA_T *)(src_c_base);\n",
"    __global AUX_DATA_T *dst_c\n",
"            = (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET);\n",
"    if (s < DHC)\n",
"        dst_c[OFF_WS_STATE(lay + 1, dir, 0, b, s)] = src_c_base\n",
"                ? src_c[SRC_I_C_OFF(lay, dir, b, s)]\n",
"                : TO_WS_STATE(0.0f);\n",
"#endif\n",
"#else // BWD\n",
"    __global DIFF_DATA_T *src = (__global DIFF_DATA_T *)(src_base);\n",
"    __global DIFF_DATA_T *dst\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET);\n",
"    if (s < DHC)\n",
"        dst[OFF_WS_DIFF_STATES(lay, dir, 0, N_ITER, b, s)]\n",
"                = src_base ? src[DIFF_DST_I_OFF(lay, dir, b, s)] : 0.0f;\n",
"#if WITH_DST_ITER_C\n",
"    __global DIFF_DATA_T *src_c = (__global DIFF_DATA_T *)(src_c_base);\n",
"    if (s < DHC)\n",
"        dst[OFF_WS_DIFF_STATES(lay, dir, 1, N_ITER, b, s)]\n",
"                = src_c_base ? src_c[DIFF_DST_I_C_OFF(lay, dir, b, s)] : 0.0f;\n",
"#endif\n",
"#endif\n",
"}\n",
"__kernel void ref_rnn_copy_res_layer(\n",
"        __global char *ws, __global char *dst_base, int lr, int rl\n",
"#if IS_FWD\n",
"        ,\n",
"        const float shift, const float scale, const int dequantize\n",
"#endif\n",
") {\n",
"    const int it = get_global_id(2);\n",
"    const int b = get_global_id(1);\n",
"    const int s = get_global_id(0);\n",
"#if IS_FWD\n",
"    __global WS_STATE_DATA_T *src\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET);\n",
"    __global DST_DATA_T *dst = (__global DST_DATA_T *)(dst_base);\n",
"    int dir = 0;\n",
"    if (lr) {\n",
"        bool dequantize_at_copy = dequantize && DIRECTION_KIND != SUM;\n",
"        dst[DST_L_OFF(it, b, dir * DHC + s)] = dequantize_at_copy\n",
"                ? TO_DST(((float)src[OFF_WS_STATE(N_LAYER, dir, it + 1, b, s)]\n",
"                                 - shift)\n",
"                        / scale)\n",
"                : src[OFF_WS_STATE(N_LAYER, dir, it + 1, b, s)];\n",
"        dir = 1;\n",
"    }\n",
"    if (rl) {\n",
"#if DIRECTION_KIND == SUM\n",
"        if (dequantize) {\n",
"            float val\n",
"                    = (float)src[OFF_WS_STATE(N_LAYER, dir, N_ITER - it, b, s)]\n",
"                    + dst[DST_L_OFF(it, b, s)];\n",
"            val = min(max(val, 0.f), 255.f);\n",
"            dst[DST_L_OFF(it, b, s)] = TO_DST((val - 2 * shift) / scale);\n",
"        } else {\n",
"#if defined(SRC_DT_U8) && defined(DST_DT_U8)\n",
"            dst[DST_L_OFF(it, b, s)] = convert_uchar_sat(\n",
"                    convert_short(\n",
"                            src[OFF_WS_STATE(N_LAYER, dir, N_ITER - it, b, s)])\n",
"                    + convert_short(dst[DST_L_OFF(it, b, s)]));\n",
"#else\n",
"            ACC_DATA_T temp_src = DST_TO_REF(dst[DST_L_OFF(it, b, s)]);\n",
"            temp_src += DST_TO_REF(\n",
"                    src[OFF_WS_STATE(N_LAYER, dir, N_ITER - it, b, s)]);\n",
"            dst[DST_L_OFF(it, b, s)] = REF_TO_DST(temp_src);\n",
"#endif\n",
"        }\n",
"#else\n",
"        dst[DST_L_OFF(it, b, dir * DHC + s)] = dequantize\n",
"                ? TO_DST(((float)src[OFF_WS_STATE(\n",
"                                  N_LAYER, dir, N_ITER - it, b, s)]\n",
"                                 - shift)\n",
"                        / scale)\n",
"                : src[OFF_WS_STATE(N_LAYER, dir, N_ITER - it, b, s)];\n",
"#endif\n",
"    }\n",
"#else // BWD\n",
"    __global DIFF_DATA_T *src\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET);\n",
"    __global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(dst_base);\n",
"    int dir = 0;\n",
"#if DIRECTION_KIND == R2L\n",
"    const int iter = N_ITER - 1 - it;\n",
"#else\n",
"    const int iter = it;\n",
"#endif\n",
"    DIFF_DATA_T res = src[OFF_WS_DIFF_STATES(0, 0, N_STATES, it, b, s)];\n",
"#if N_DIR > 1\n",
"    res += src[OFF_WS_DIFF_STATES(0, 1, N_STATES, N_ITER - 1 - it, b, s)];\n",
"#endif\n",
"    dst[DIFF_SRC_L_OFF(iter, b, dir * SLC + s)] = res;\n",
"#endif\n",
"}\n",
"__kernel void ref_rnn_copy_res_iter(\n",
"        __global char *ws, __global char *dst_base, __global char *dst_c_base\n",
"#if IS_FWD\n",
"        ,\n",
"        const float shift, const float scale, const int dequantize\n",
"#endif\n",
") {\n",
"    const int s = get_global_id(0);\n",
"    const int b = get_global_id(1);\n",
"    const int lay = get_global_id(2) / N_DIR;\n",
"    const int dir = get_global_id(2) % N_DIR;\n",
"#if IS_FWD\n",
"    __global WS_STATE_DATA_T *src\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET);\n",
"    __global OUTPUT_DATA_T *dst = (__global OUTPUT_DATA_T *)(dst_base);\n",
"    if (dst_base && s < DHC) {\n",
"        dst[DST_I_OFF(lay, dir, b, s)] = dequantize\n",
"                ? TO_OUTPUT(\n",
"                        ((float)src[OFF_WS_STATE(lay + 1, dir, N_ITER, b, s)]\n",
"                                - shift)\n",
"                        / scale)\n",
"                : TO_OUTPUT(src[OFF_WS_STATE(lay + 1, dir, N_ITER, b, s)]);\n",
"    }\n",
"#if WITH_DST_ITER_C\n",
"    __global AUX_DATA_T *src_c\n",
"            = (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET);\n",
"    __global AUX_DATA_T *dst_c = (__global AUX_DATA_T *)(dst_c_base);\n",
"    if (dst_c_base && s < DHC) {\n",
"        dst_c[DST_I_C_OFF(lay, dir, b, s)]\n",
"                = src_c[OFF_WS_STATE(lay + 1, dir, N_ITER, b, s)];\n",
"    }\n",
"#endif\n",
"#else // BWD\n",
"    __global DIFF_DATA_T *src\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET);\n",
"    __global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(dst_base);\n",
"    __global DIFF_DATA_T *dst_c = (__global DIFF_DATA_T *)(dst_c_base);\n",
"    if (dst_base && s < SIC) {\n",
"        dst[DIFF_SRC_I_OFF(lay, dir, b, s)]\n",
"                = src[OFF_WS_DIFF_STATES(lay, dir, 0, 0, b, s)];\n",
"    }\n",
"#if WITH_SRC_ITER_C\n",
"    if (dst_base && s < DHC) {\n",
"        dst_c[DIFF_SRC_I_C_OFF(lay, dir, b, s)]\n",
"                = src[OFF_WS_DIFF_STATES(lay, dir, 1, 0, b, s)];\n",
"    }\n",
"#endif\n",
"#endif\n",
"}\n",
"__kernel void ref_rnn_ws_set(\n",
"        __global char *ws, OFFTYPE ws_offset, float val, int ws_part) {\n",
"    if (ws_part == WS_C_STATES || ws_part == WS_DIFF_STATES\n",
"            || ws_part == WS_BIAS) {\n",
"        __global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(ws + ws_offset);\n",
"        dst[get_global_id(0)] = CONVERT_DATA_T(val);\n",
"    } else if (ws_part == WS_GATES) {\n",
"        __global ACC_DATA_T *dst = (__global ACC_DATA_T *)(ws + ws_offset);\n",
"        dst[get_global_id(0)] = TO_ACC(val);\n",
"    } else { // ws_part == WS_STATES\n",
"        __global WS_STATE_DATA_T *dst\n",
"                = (__global WS_STATE_DATA_T *)(ws + ws_offset);\n",
"        dst[get_global_id(0)] = TO_WS_STATE(val);\n",
"    }\n",
"}\n",
"// useful for debug\n",
"#if DEBUGPRINT\n",
"__kernel void ref_rnn_ws_print(const __global char *ws) {\n",
"    {\n",
"        __global ACC_DATA_T *wt = (__global ACC_DATA_T *)(ws + WS_GATES_OFFSET);\n",
"        printf(\"ws_gates: off %d\\n\", WS_GATES_OFFSET);\n",
"        printf(\"[lay,dir,iter,batch]\\n\");\n",
"        for_(int j = 0; j < N_LAYER; j++)\n",
"        for_(int dir = 0; dir < N_DIR; dir++)\n",
"        for_(int i = 0; i < N_ITER; i++)\n",
"        for (int b = 0; b < BATCH; b++) {\n",
"            printf(\"[%d,%d,%d,%d]: \", j, dir, i, b);\n",
"            for_(int g = 0; g < N_GATES; g++)\n",
"            for (int s = 0; s < DHC; s++) {\n",
"                printf(\" %f\",\n",
"                        SRC_TO_REF(*(wt + OFF_WS_GATES(j, dir, i, b, g, s))));\n",
"            }\n",
"            printf(\"\\n\");\n",
"        }\n",
"    }\n",
"    {\n",
"        __global WS_STATE_DATA_T *wt\n",
"                = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET);\n",
"        printf(\"ws_states (H): off %d\\n\", WS_STATES_OFFSET);\n",
"        printf(\"[lay,dir,iter]\\n\");\n",
"        for_(int j = 0; j < N_LAYER + 1; j++)\n",
"        for_(int dir = 0; dir < N_DIR; dir++)\n",
"        for (int i = 1; i < N_ITER + 1; i++) {\n",
"            printf(\"[%d,%d,%d] : \", j, dir, i);\n",
"            for_(int b = 0; b < BATCH; b++)\n",
"            for (int s = 0; s < WIC; s++) {\n",
"                printf(\" %f\",\n",
"                        SRC_TO_REF(*(wt + OFF_WS_STATE(j, dir, i, b, s))));\n",
"            }\n",
"            printf(\"\\n\");\n",
"        }\n",
"    }\n",
"#if IS_TRAINING && CELL_KIND == LBR_GRU\n",
"    {\n",
"        __global ACC_DATA_T *wt\n",
"                = (__global ACC_DATA_T *)(ws + WS_GRID_COMP_OFFSET);\n",
"        printf(\"ws_grid: off %d\\n\", WS_GRID_COMP_OFFSET);\n",
"        printf(\"[lay,dir,iter,batch]\\n\");\n",
"        for_(int j = 0; j < N_LAYER; j++)\n",
"        for_(int dir = 0; dir < N_DIR; dir++)\n",
"        for_(int i = 0; i < N_ITER; i++)\n",
"        for (int b = 0; b < BATCH; b++) {\n",
"            printf(\"[%d,%d,%d,%d]: \", j, dir, i, b);\n",
"            for (int s = 0; s < DHC; s++) {\n",
"                printf(\" %f\", *(wt + OFF_WS_GRID_OFFSET(j, dir, i, b, s)));\n",
"            }\n",
"            printf(\"\\n\");\n",
"        }\n",
"    }\n",
"#endif\n",
"#if IS_FWD && CELL_KIND == VANILLA_LSTM\n",
"    {\n",
"        __global AUX_DATA_T *wt\n",
"                = (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET);\n",
"        printf(\"ws_states (C): off %d\\n\", WS_C_STATE_OFFSET);\n",
"        printf(\"[lay,dir,iter]\\n\");\n",
"        for_(int j = 0; j < N_LAYER; j++)\n",
"        for_(int dir = 0; dir < N_DIR; dir++)\n",
"        for (int i = 0; i < N_ITER + 1; i++) {\n",
"            printf(\"[%d,%d,%d] : \", j, dir, i);\n",
"            for_(int b = 0; b < BATCH; b++)\n",
"            for (int s = 0; s < WIC; s++) {\n",
"                printf(\" %f\", *(wt + OFF_WS_STATE(j, dir, i, b, s)));\n",
"            }\n",
"            printf(\"\\n\");\n",
"        }\n",
"    }\n",
"#endif\n",
"#if !IS_FWD\n",
"    {\n",
"        __global DIFF_DATA_T *wt\n",
"                = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET);\n",
"        printf(\"ws_diff_states: off %d\\n\", WS_DIFF_STATES_OFFSET);\n",
"        printf(\"[lay,dir,state,iter]\\n\");\n",
"        for_(int j = 0; j < N_LAYER; j++)\n",
"        for_(int dir = 0; dir < N_DIR; dir++)\n",
"        for_(int st = 0; st < N_STATES + 1; st++)\n",
"        for (int i = 0; i < N_ITER + 1; i++) {\n",
"            printf(\"[%d,%d,%d,%d] : \", j, dir, st, i);\n",
"            for_(int b = 0; b < BATCH; b++)\n",
"            for (int s = 0; s < WIC; s++) {\n",
"                printf(\" %f\", *(wt + OFF_WS_DIFF_STATES(j, dir, st, i, b, s)));\n",
"            }\n",
"            printf(\"\\n\");\n",
"        }\n",
"    }\n",
"#endif\n",
"#if COPY_BIAS\n",
"    {\n",
"        __global AUX_DATA_T *wt = (__global AUX_DATA_T *)(ws + WS_BIAS_OFFSET);\n",
"        printf(\"ws_bias: off %d\\n\", WS_BIAS_OFFSET);\n",
"        printf(\"[lay,dir]\\n\");\n",
"        for_(int j = 0; j < N_LAYER; j++)\n",
"        for_(int dir = 0; dir < N_DIR; dir++)\n",
"        {\n",
"            printf(\"[%d,%d] : \", j, dir);\n",
"            for_(int nb = 0; nb < N_BIAS; nb++)\n",
"            for (int dhc = 0; dhc < DHC; dhc++) {\n",
"                printf(\" %f\", *(wt + OFF_WS_BIAS(j, dir, nb, dhc)));\n",
"            }\n",
"            printf(\"\\n\");\n",
"        }\n",
"    }\n",
"#endif\n",
"}\n",
"#endif\n",
"__kernel void ref_rnn_bias_prepare(__global char *ws, __global float *scales,\n",
"        __global char *wei_layer, __global char *wei_iter, __global float *bias,\n",
"        float data_shift, float data_scale) {\n",
"#if COPY_BIAS\n",
"    const int dhc = get_global_id(0);\n",
"    const int nbias = get_global_id(1);\n",
"    const int layer = get_global_id(2) / N_DIR;\n",
"    const int dir = get_global_id(2) % N_DIR;\n",
"    __global float *ws_bias = (__global float *)(ws + WS_BIAS_OFFSET);\n",
"    const float wei_scale\n",
"#if WEI_QPARAM_MASK\n",
"            = scales[nbias * DHC + dhc];\n",
"#else\n",
"            = scales[0];\n",
"#endif\n",
"#define COMP_OFF(i0, i1, i2, i3) \\\n",
"    ((((i0) * (N_DIR) + (i1)) * (N_BIAS) + (i2)) * (DHC) + (i3))\n",
"#define COMP_WEI_LAYER_OFF (WEI_L_D0 * WEI_L_S0)\n",
"#define COMP_WEI_ITER_OFF (WEI_I_D0 * WEI_I_S0)\n",
"    __global char *temp = (__global char *)(wei_iter + COMP_WEI_ITER_OFF);\n",
"    __global float *wei_iter_comp\n",
"            = (__global float *)(((unsigned long)temp + (sizeof(float) - 1))\n",
"                    & -sizeof(float));\n",
"    temp = (__global char *)(wei_layer + COMP_WEI_LAYER_OFF);\n",
"    __global float *wei_layer_comp\n",
"            = (__global float *)(((unsigned long)temp + (sizeof(float) - 1))\n",
"                    & -sizeof(float));\n",
"    const int off = COMP_OFF(layer, dir, nbias, dhc);\n",
"    const float comp = wei_layer_comp[off] + wei_iter_comp[off];\n",
"    ws_bias[OFF_WS_BIAS(layer, dir, nbias, dhc)]\n",
"            = bias[BIAS_OFF(layer, dir, nbias, dhc)]\n",
"            - comp * data_shift / (wei_scale * data_scale);\n",
"#endif\n",
"}\n",
"#if IS_INT8 && CELL_KIND == VANILLA_LSTM\n",
"WS_STATE_DATA_T q_d(float f, float data_scale, float data_shift) {\n",
"    float qf = f * data_scale + data_shift;\n",
"    return TO_WS_STATE(qf);\n",
"}\n",
"float deq_w(ACC_DATA_T s, int gate, int j, __global float *scales,\n",
"        float data_scale) {\n",
"#if WEI_QPARAM_MASK\n",
"    float wei_scale = scales[gate * DHC + j];\n",
"#else\n",
"    float wei_scale = scales[0];\n",
"#endif\n",
"    return (float)(s) / (wei_scale * data_scale);\n",
"}\n",
"// for int8 LSTM\n",
"__kernel void ref_rnn_elemwise_fwd(int dir, int lay, int iter,\n",
"        __global char *ws, __global char *scr_gates, __global float *scales,\n",
"        __global float *bias_base, float alpha, float data_shift,\n",
"        float data_scale, __global float *tm_scales, float tm_cscale) {\n",
"    const int i = get_global_id(1); // batch\n",
"    const int j = get_global_id(0); // dhc\n",
"    const __global float *c_states_tm1_l\n",
"            = (__global float *)(ws + WS_C_STATE_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter, 0, 0);\n",
"    __global float *ws_bias = (__global float *)(ws + WS_BIAS_OFFSET);\n",
"    __global ACC_DATA_T *ws_gates\n",
"            = (__global ACC_DATA_T *)(ws + WS_GATES_OFFSET)\n",
"            + OFF_WS_GATES(lay, dir, iter, 0, 0, 0);\n",
"    __global ACC_DATA_T *scratch_gates = (__global ACC_DATA_T *)(scr_gates)\n",
"            + OFF_SCRATCH_MEM(iter, 0, 0, 0);\n",
"    __global WS_STATE_DATA_T *h_states_t_l\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0);\n",
"    __global float *c_states_t_l = (__global float *)(ws + WS_C_STATE_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0);\n",
"    float G0 = logistic_fwd_tm(deq_w(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)],\n",
"                                       0, j, scales, data_scale)\n",
"                    + ws_bias[OFF_WS_BIAS(lay, dir, 0, j)],\n",
"            tm_scales[0]);\n",
"    float G1 = logistic_fwd_tm(deq_w(scratch_gates[CELL_SCRATCH_MEM(i, 1, j)],\n",
"                                       1, j, scales, data_scale)\n",
"                    + ws_bias[OFF_WS_BIAS(lay, dir, 1, j)],\n",
"            tm_scales[1]);\n",
"    float G2 = tanh_fwd_tm(deq_w(scratch_gates[CELL_SCRATCH_MEM(i, 2, j)], 2, j,\n",
"                                   scales, data_scale)\n",
"                    + ws_bias[OFF_WS_BIAS(lay, dir, 2, j)],\n",
"            tm_scales[2]);\n",
"    float G3 = logistic_fwd_tm(deq_w(scratch_gates[CELL_SCRATCH_MEM(i, 3, j)],\n",
"                                       3, j, scales, data_scale)\n",
"                    + ws_bias[OFF_WS_BIAS(lay, dir, 3, j)],\n",
"            tm_scales[3]);\n",
"    float tmp = G1 * c_states_tm1_l[CELL_WS_STATE(i, j)] + G0 * G2;\n",
"    h_states_t_l[CELL_WS_STATE(i, j)]\n",
"            = q_d(G3 * tanh_fwd_tm(tmp, tm_cscale), data_scale, data_shift);\n",
"    c_states_t_l[CELL_WS_STATE(i, j)] = tmp;\n",
"}\n",
"#else\n",
"__kernel void ref_rnn_elemwise_fwd(\n",
"        int dir, int lay, int iter, __global char *ws, __global char *scr_gates,\n",
"        __global AUX_DATA_T *bias_base, float alpha, __global float *tm_scales,\n",
"        float tm_cscale\n",
"#if CELL_KIND == LBR_GRU\n",
"        ,\n",
"        __global char *scr_cell\n",
"#endif\n",
"#if CELL_KIND == VANILLA_GRU\n",
"        ,\n",
"        int n_part\n",
"#endif\n",
") {\n",
"    const int i = get_global_id(1); // batch\n",
"    const int j = get_global_id(0); // dhc\n",
"    const __global AUX_DATA_T *c_states_tm1_l\n",
"            = (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter, 0, 0);\n",
"    const __global AUX_DATA_T *bias = bias_base + BIAS_OFF(lay, dir, 0, 0);\n",
"    __global AUX_DATA_T *ws_gates\n",
"            = (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET)\n",
"            + OFF_WS_GATES(lay, dir, iter, 0, 0, 0);\n",
"    __global AUX_DATA_T *scratch_gates = (__global AUX_DATA_T *)(scr_gates)\n",
"            + OFF_SCRATCH_MEM(iter, 0, 0, 0);\n",
"    // dst_iter & dst_layer --> h_states_t_l\n",
"    __global WS_STATE_DATA_T *h_states_t_l\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0);\n",
"#if CELL_KIND == VANILLA_LSTM\n",
"    __global AUX_DATA_T *c_states_t_l\n",
"            = (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0);\n",
"    float g_i = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 0, j)]\n",
"                    + bias[OFF_KER_BIAS(0, j)],\n",
"            tm_scales[0]);\n",
"    float g_f = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 1, j)]\n",
"                    + bias[OFF_KER_BIAS(1, j)],\n",
"            tm_scales[1]);\n",
"    float g_z = tanh_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 2, j)]\n",
"                    + bias[OFF_KER_BIAS(2, j)],\n",
"            tm_scales[2]);\n",
"    float g_o = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 3, j)]\n",
"                    + bias[OFF_KER_BIAS(3, j)],\n",
"            tm_scales[3]);\n",
"#if IS_TRAINING\n",
"    ws_gates[CELL_WS_GATES(i, 0, j)] = g_i;\n",
"    ws_gates[CELL_WS_GATES(i, 1, j)] = g_f;\n",
"    ws_gates[CELL_WS_GATES(i, 2, j)] = g_z;\n",
"    ws_gates[CELL_WS_GATES(i, 3, j)] = g_o;\n",
"#endif\n",
"    float Ct = g_f * c_states_tm1_l[CELL_WS_STATE(i, j)] + g_i * g_z;\n",
"    float Ht = g_o * tanh_fwd_tm(Ct, tm_cscale);\n",
"    h_states_t_l[CELL_WS_STATE(i, j)] = TO_INPUT(Ht);\n",
"    c_states_t_l[CELL_WS_STATE(i, j)] = Ct;\n",
"#elif CELL_KIND == VANILLA_RNN\n",
"    float g = activation_fwd((float)scratch_gates[CELL_SCRATCH_MEM(i, 0, j)]\n",
"                    + bias[OFF_KER_BIAS(0, j)],\n",
"#if IS_TESTMODE\n",
"            tm_scales[0], 0);\n",
"#else\n",
"            alpha, 0);\n",
"#endif\n",
"#if IS_TRAINING\n",
"    ws_gates[CELL_WS_GATES(i, 0, j)] = g;\n",
"#endif\n",
"    h_states_t_l[CELL_WS_STATE(i, j)] = TO_INPUT(g);\n",
"#elif CELL_KIND == LBR_GRU\n",
"    // AUX and SCRATCH data type is same for fwd prop\n",
"    __global AUX_DATA_T *scratch_cell = (__global AUX_DATA_T *)(scr_cell);\n",
"    __global WS_STATE_DATA_T *src_iter\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter, 0, 0);\n",
"    __global AUX_DATA_T *ws_grid\n",
"            = (__global AUX_DATA_T *)(ws + WS_GRID_COMP_OFFSET)\n",
"            + OFF_WS_GRID_OFFSET(lay, dir, iter, 0, 0);\n",
"    float Wh_b = (float)scratch_cell[CELL_SCRATCH_MEM(i, 2, j)]\n",
"            + bias[OFF_KER_BIAS(3, j)];\n",
"    float G0 = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 0, j)]\n",
"                    + (float)scratch_cell[CELL_SCRATCH_MEM(i, 0, j)]\n",
"                    + bias[OFF_KER_BIAS(0, j)],\n",
"            tm_scales[0]);\n",
"    float G1 = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 1, j)]\n",
"                    + (float)scratch_cell[CELL_SCRATCH_MEM(i, 1, j)]\n",
"                    + bias[OFF_KER_BIAS(1, j)],\n",
"            tm_scales[1]);\n",
"    float G2 = tanh_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 2, j)]\n",
"                    + G1 * Wh_b + bias[OFF_KER_BIAS(2, j)],\n",
"            tm_scales[2]);\n",
"    float Ht = G0 * TO_REF(src_iter[CELL_WS_STATE(i, j)]) + (1 - G0) * G2;\n",
"    h_states_t_l[CELL_WS_STATE(i, j)] = TO_INPUT(Ht);\n",
"#if IS_TRAINING\n",
"    ws_gates[CELL_WS_GATES(i, 0, j)] = G0;\n",
"    ws_gates[CELL_WS_GATES(i, 1, j)] = G1;\n",
"    ws_gates[CELL_WS_GATES(i, 2, j)] = G2;\n",
"    ws_grid[CELL_WS_GRID_COMP(i, j)] = Wh_b;\n",
"#endif\n",
"#elif CELL_KIND == VANILLA_GRU\n",
"    __global WS_STATE_DATA_T *src_iter\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter, 0, 0);\n",
"    if (n_part == 1) {\n",
"        float G0 = logistic_fwd_tm(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)]\n",
"                        + bias[OFF_KER_BIAS(0, j)],\n",
"                tm_scales[0]);\n",
"        float G1 = logistic_fwd_tm(scratch_gates[CELL_SCRATCH_MEM(i, 1, j)]\n",
"                        + bias[OFF_KER_BIAS(1, j)],\n",
"                tm_scales[1]);\n",
"        /* TODO from CPU: Can be optimized for fwd_training by using\n",
"        ws_gates instead of scratch_gates in p2 */\n",
"        scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(G0);\n",
"        scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] = TO_INPUT(G1);\n",
"        float tmp = TO_REF(src_iter[CELL_WS_STATE(i, j)]);\n",
"        h_states_t_l[CELL_WS_STATE(i, j)] = TO_INPUT(tmp * G1);\n",
"#if IS_TRAINING\n",
"        ws_gates[CELL_WS_GATES(i, 0, j)] = G0;\n",
"        ws_gates[CELL_WS_GATES(i, 1, j)] = G1;\n",
"#endif\n",
"    } else if (n_part == 2) {\n",
"        float G0 = TO_REF(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)]);\n",
"        float G2 = tanh_fwd_tm(scratch_gates[CELL_SCRATCH_MEM(i, 2, j)]\n",
"                        + bias[OFF_KER_BIAS(2, j)],\n",
"                tm_scales[2]);\n",
"        float tmp = TO_REF(src_iter[CELL_WS_STATE(i, j)]);\n",
"        h_states_t_l[CELL_WS_STATE(i, j)]\n",
"                = TO_INPUT(tmp * G0 + (1.0f - G0) * G2);\n",
"#if IS_TRAINING\n",
"        ws_gates[CELL_WS_GATES(i, 2, j)] = G2;\n",
"#endif\n",
"    }\n",
"#else\n",
"#error \"Wrong Cell Kind\"\n",
"#endif\n",
"}\n",
"#endif\n",
"__kernel void ref_rnn_elemwise_bwd(\n",
"        int dir, int lay, int iter, __global char *ws, __global char *scr_gates,\n",
"        __global AUX_DATA_T *bias_base, float alpha, __global float *tm_scales,\n",
"        float tm_cscale\n",
"#if CELL_KIND == LBR_GRU\n",
"        ,\n",
"        __global char *scr_gate_r\n",
"#endif\n",
"#if CELL_KIND == VANILLA_GRU\n",
"        ,\n",
"        int n_part, __global char *scr_cell\n",
"#endif\n",
") {\n",
"    const int i = get_global_id(1); // batch\n",
"    const int j = get_global_id(0); // dhc\n",
"#if CELL_KIND == VANILLA_LSTM\n",
"    __global AUX_DATA_T *ws_gates\n",
"            = (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET)\n",
"            + OFF_WS_GATES(lay, dir, iter, 0, 0, 0);\n",
"    __global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates)\n",
"            + OFF_SCRATCH_MEM(iter, 0, 0, 0);\n",
"    __global AUX_DATA_T *c_states_t_l\n",
"            = (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0);\n",
"    __global AUX_DATA_T *c_states_tm1_l\n",
"            = (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter, 0, 0);\n",
"    __global DIFF_DATA_T *diff_states_t_l\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay, dir, 0, iter, 0, 0);\n",
"    __global DIFF_DATA_T *diff_states_tp1_l\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay, dir, 0, iter + 1, 0, 0);\n",
"    __global DIFF_DATA_T *diff_states_t_lp1\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay + 1, dir, 0, iter, 0, 0);\n",
"    float Ct = c_states_t_l[CELL_WS_STATE(i, j)];\n",
"    /// @todo save it in the workspace in fwd pass or recompute it to\n",
"    /// save bw\n",
"    float tanhCt = tanh_fwd_tm(Ct, tm_cscale);\n",
"    // we have 2 incoming diffs on Ht\n",
"    float dHt = (float)diff_states_tp1_l[CELL_WS_DIFF_STATES(0, i, j)]\n",
"            + diff_states_t_lp1[CELL_WS_DIFF_STATES(N_STATES, i, j)];\n",
"    float dCt = (float)diff_states_tp1_l[CELL_WS_DIFF_STATES(1, i, j)]\n",
"            + one_m_square(tanhCt) * ws_gates[CELL_WS_GATES(i, 3, j)] * dHt;\n",
"    float dG1 = (float)c_states_tm1_l[CELL_WS_STATE(i, j)] * dCt\n",
"            * x_m_square(ws_gates[CELL_WS_GATES(i, 1, j)]);\n",
"    float dG0 = ws_gates[CELL_WS_GATES(i, 2, j)] * dCt\n",
"            * x_m_square(ws_gates[CELL_WS_GATES(i, 0, j)]);\n",
"    float dG3 = tanhCt * dHt * x_m_square(ws_gates[CELL_WS_GATES(i, 3, j)]);\n",
"    float dG2 = ws_gates[CELL_WS_GATES(i, 0, j)] * dCt\n",
"            * one_m_square(ws_gates[CELL_WS_GATES(i, 2, j)]);\n",
"    diff_states_t_l[CELL_WS_DIFF_STATES(1, i, j)]\n",
"            = dCt * ws_gates[CELL_WS_GATES(i, 1, j)];\n",
"    scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(dG0);\n",
"    scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] = TO_INPUT(dG1);\n",
"    scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] = TO_INPUT(dG2);\n",
"    scratch_gates[CELL_SCRATCH_MEM(i, 3, j)] = TO_INPUT(dG3);\n",
"#elif CELL_KIND == LBR_GRU\n",
"    __global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates)\n",
"            + OFF_SCRATCH_MEM(iter, 0, 0, 0);\n",
"    __global SRC_DATA_T *scratch_gate_r = (__global SRC_DATA_T *)(scr_gate_r);\n",
"    __global AUX_DATA_T *ws_gates\n",
"            = (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET)\n",
"            + OFF_WS_GATES(lay, dir, iter, 0, 0, 0);\n",
"    __global AUX_DATA_T *ws_grid\n",
"            = (__global AUX_DATA_T *)(ws + WS_GRID_COMP_OFFSET)\n",
"            + OFF_WS_GRID_OFFSET(lay, dir, iter, 0, 0);\n",
"    __global DIFF_DATA_T *diff_src_iter\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay, dir, 0, iter, 0, 0);\n",
"    __global DIFF_DATA_T *diff_dst_iter\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay, dir, 0, iter + 1, 0, 0);\n",
"    __global DIFF_DATA_T *diff_dst_layer\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay + 1, dir, 0, iter, 0, 0);\n",
"    __global WS_STATE_DATA_T *src_iter //h_states_tm1_l\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter, 0, 0);\n",
"    float h = TO_REF(src_iter[CELL_WS_STATE(i, j)]);\n",
"    float Wh_b = ws_grid[CELL_WS_GRID_COMP(i, j)];\n",
"    float dHt = diff_dst_iter[CELL_WS_DIFF_STATES(0, i, j)]\n",
"            + diff_dst_layer[CELL_WS_DIFF_STATES(N_STATES, i, j)];\n",
"    float dG0 = (h - ws_gates[CELL_WS_GATES(i, 2, j)]) * dHt\n",
"            * x_m_square(ws_gates[CELL_WS_GATES(i, 0, j)]);\n",
"    float dG2 = (1.0f - ws_gates[CELL_WS_GATES(i, 0, j)])\n",
"            * one_m_square(ws_gates[CELL_WS_GATES(i, 2, j)]) * dHt;\n",
"    float dG1 = Wh_b * dG2 * x_m_square(ws_gates[CELL_WS_GATES(i, 1, j)]);\n",
"    diff_src_iter[CELL_WS_DIFF_STATES(0, i, j)]\n",
"            = dHt * ws_gates[CELL_WS_GATES(i, 0, j)];\n",
"    scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(dG0);\n",
"    scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] = TO_INPUT(dG1);\n",
"    scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] = TO_INPUT(dG2);\n",
"    scratch_gate_r[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(dG0);\n",
"    scratch_gate_r[CELL_SCRATCH_MEM(i, 1, j)] = TO_INPUT(dG1);\n",
"    scratch_gate_r[CELL_SCRATCH_MEM(i, 2, j)]\n",
"            = TO_INPUT(dG2 * ws_gates[CELL_WS_GATES(i, 1, j)]);\n",
"#elif CELL_KIND == VANILLA_RNN\n",
"    __global AUX_DATA_T *ws_gates\n",
"            = (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET)\n",
"            + OFF_WS_GATES(lay, dir, iter, i, 0, j);\n",
"    __global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates)\n",
"            + OFF_SCRATCH_MEM(iter, i, 0, j);\n",
"    __global DIFF_DATA_T *ws_diff_states\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET);\n",
"    __global DIFF_DATA_T *diff_states_t_lp1 = ws_diff_states\n",
"            + OFF_WS_DIFF_STATES(lay + 1, dir, N_STATES, iter, i, j);\n",
"    __global DIFF_DATA_T *diff_states_tp1_l\n",
"            = ws_diff_states + OFF_WS_DIFF_STATES(lay, dir, 0, iter + 1, i, j);\n",
"    const float dH = (float)diff_states_t_lp1[0] + diff_states_tp1_l[0];\n",
"    float g = ws_gates[0];\n",
"#if IS_TESTMODE\n",
"    scratch_gates[0] = TO_INPUT(dH * activation_bwd(g, tm_scales[0], 0.));\n",
"#else\n",
"    scratch_gates[0] = TO_INPUT(dH * activation_bwd(g, alpha, 0.));\n",
"#endif\n",
"#elif CELL_KIND == VANILLA_GRU\n",
"    __global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates)\n",
"            + OFF_SCRATCH_MEM(iter, 0, 0, 0);\n",
"    __global AUX_DATA_T *ws_gates\n",
"            = (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET)\n",
"            + OFF_WS_GATES(lay, dir, iter, 0, 0, 0);\n",
"    __global DIFF_DATA_T *diff_src_iter\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay, dir, 0, iter, 0, 0);\n",
"    __global DIFF_DATA_T *diff_dst_iter\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay, dir, 0, iter + 1, 0, 0);\n",
"    __global DIFF_DATA_T *diff_dst_layer\n",
"            = (__global DIFF_DATA_T *)(ws + WS_DIFF_STATES_OFFSET)\n",
"            + OFF_WS_DIFF_STATES(lay + 1, dir, 0, iter, 0, 0);\n",
"    __global WS_STATE_DATA_T *src_iter //h_states_tm1_l\n",
"            = (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET)\n",
"            + OFF_WS_STATE(lay + 1, dir, iter, 0, 0);\n",
"    float h = TO_REF(src_iter[CELL_WS_STATE(i, j)]);\n",
"    if (n_part == 1) {\n",
"        float dHt = diff_dst_iter[CELL_WS_DIFF_STATES(0, i, j)]\n",
"                + diff_dst_layer[CELL_WS_DIFF_STATES(N_STATES, i, j)];\n",
"        float dG2 = (1.0f - ws_gates[CELL_WS_GATES(i, 0, j)]) * dHt\n",
"                * one_m_square(ws_gates[CELL_WS_GATES(i, 2, j)]);\n",
"        float dG0 = (h - ws_gates[CELL_WS_GATES(i, 2, j)]) * dHt\n",
"                * x_m_square(ws_gates[CELL_WS_GATES(i, 0, j)]);\n",
"        diff_src_iter[CELL_WS_DIFF_STATES(0, i, j)]\n",
"                = dHt * ws_gates[CELL_WS_GATES(i, 0, j)];\n",
"        scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(dG0);\n",
"        scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] = TO_INPUT(dG2);\n",
"    } else if (n_part == 2) {\n",
"        __global SRC_DATA_T *scratch_cell = (__global SRC_DATA_T *)(scr_cell);\n",
"        __global DIFF_DATA_T *dhG1\n",
"                = (__global DIFF_DATA_T *)(ws + SCRATCH_HDG1_OFFSET);\n",
"        float dG1 = ws_gates[CELL_WS_GATES(i, 1, j)];\n",
"        diff_src_iter[CELL_WS_DIFF_STATES(0, i, j)]\n",
"                += dhG1[OFF_WS_DHG1(i, j)] * dG1;\n",
"        scratch_gates[CELL_SCRATCH_MEM(i, 1, j)]\n",
"                = TO_INPUT(dhG1[OFF_WS_DHG1(i, j)] * h * x_m_square(dG1));\n",
"        scratch_cell[OFF_SCRATCHCELL(i, j)] = TO_INPUT(dG1 * h);\n",
"    }\n",
"#else\n",
"#error \"Wrong Cell Kind\"\n",
"#endif\n",
"}\n",
"__kernel void ref_rnn_gates_reduction(int dir, int lay, int iter,\n",
"        __global DIFF_DATA_T *diff_bias_base, __global char *scratch_gates,\n",
"        __global char *scratch_cell) {\n",
"#if !IS_FWD\n",
"    const int i = get_global_id(0); // n_gates\n",
"    const int k = get_global_id(1); // dhc\n",
"    __global DIFF_DATA_T *diff_bias\n",
"            = diff_bias_base + DIFF_BIAS_OFF(lay, dir, 0, 0);\n",
"    __global SRC_DATA_T *gates = (__global SRC_DATA_T *)(scratch_gates)\n",
"            + OFF_SCRATCH_MEM(iter, 0, 0, 0);\n",
"    for (int j = 0; j < BATCH; j++) {\n",
"        diff_bias[i * DHC + k] += SRC_TO_REF(gates[CELL_SCRATCH_MEM(j, i, k)]);\n",
"    }\n",
"#if CELL_KIND == LBR_GRU\n",
"    __global SRC_DATA_T *gate_r = (__global SRC_DATA_T *)(scratch_cell);\n",
"    // Adding i == 0 to run this loop only once\n",
"    for (int j = 0; j < BATCH && i == 0; j++) {\n",
"        diff_bias[3 * DHC + k] += SRC_TO_REF(gate_r[CELL_SCRATCH_MEM(j, 2, k)]);\n",
"    }\n",
"#endif\n",
"#endif\n",
"}", nullptr };
}
}
}
}