namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *simple_concat_kernel[] ={ "/*******************************************************************************\n",
"* Copyright 2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#if DATA_TYPE_SIZE == 4\n",
"#define DATA_T uint\n",
"#define DATA2_T uint2\n",
"#define DATA4_T uint4\n",
"#define DATA8_T uint8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#elif DATA_TYPE_SIZE == 2\n",
"#define DATA_T ushort\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#elif DATA_TYPE_SIZE == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#endif\n",
"#define CHECK_AND_GET(N, M) \\\n",
"    if (get_global_id(2) >= OFFSET##N \\\n",
"            && (M == N_INPUTS || get_global_id(2) < OFFSET##M)) { \\\n",
"        src = src##N + get_global_id(1) * SRC##N##_EXT_OFFSET + x \\\n",
"                - OFFSET##N * INNER_OFFSET; \\\n",
"    }\n",
"#if BLOCK != 1\n",
"__attribute__((intel_reqd_sub_group_size(SIMD)))\n",
"#endif\n",
"__kernel void\n",
"simple_concat(__global DATA_T *dst, __global const DATA_T *src0\n",
"#if N_INPUTS > 1\n",
"        ,\n",
"        __global const DATA_T *src1\n",
"#endif\n",
"#if N_INPUTS > 2\n",
"        ,\n",
"        __global const DATA_T *src2\n",
"#endif\n",
"#if N_INPUTS > 3\n",
"        ,\n",
"        __global const DATA_T *src3\n",
"#endif\n",
"#if N_INPUTS > 4\n",
"        ,\n",
"        __global const DATA_T *src4\n",
"#endif\n",
"#if N_INPUTS > 5\n",
"        ,\n",
"        __global const DATA_T *src5\n",
"#endif\n",
"#if N_INPUTS > 6\n",
"        ,\n",
"        __global const DATA_T *src6\n",
"#endif\n",
"#if N_INPUTS > 7\n",
"        ,\n",
"        __global const DATA_T *src7\n",
"#endif\n",
"#if N_INPUTS > 8\n",
"        ,\n",
"        __global const DATA_T *src8\n",
"#endif\n",
"#if N_INPUTS > 9\n",
"        ,\n",
"        __global const DATA_T *src9\n",
"#endif\n",
"#if N_INPUTS > 10\n",
"        ,\n",
"        __global const DATA_T *src10\n",
"#endif\n",
"#if N_INPUTS > 11\n",
"        ,\n",
"        __global const DATA_T *src11\n",
"#endif\n",
"#if N_INPUTS > 12\n",
"        ,\n",
"        __global const DATA_T *src12\n",
"#endif\n",
"#if N_INPUTS > 13\n",
"        ,\n",
"        __global const DATA_T *src13\n",
"#endif\n",
"#if N_INPUTS > 14\n",
"        ,\n",
"        __global const DATA_T *src14\n",
"#endif\n",
"#if N_INPUTS > 15\n",
"        ,\n",
"        __global const DATA_T *src15\n",
"#endif\n",
") {\n",
"    DATA8_T A0, A1, A2, A3;\n",
"    DATA_T B;\n",
"    DATA2_T C;\n",
"    DATA4_T D;\n",
"    const size_t x = get_global_id(0) * (BLOCK / SIMD)\n",
"            + get_global_id(2) * INNER_OFFSET;\n",
"    __global const DATA_T *src;\n",
"    CHECK_AND_GET(0, 1)\n",
"#if N_INPUTS > 1\n",
"    CHECK_AND_GET(1, 2)\n",
"#endif\n",
"#if N_INPUTS > 2\n",
"    CHECK_AND_GET(2, 3)\n",
"#endif\n",
"#if N_INPUTS > 3\n",
"    CHECK_AND_GET(3, 4)\n",
"#endif\n",
"#if N_INPUTS > 4\n",
"    CHECK_AND_GET(4, 5)\n",
"#endif\n",
"#if N_INPUTS > 5\n",
"    CHECK_AND_GET(5, 6)\n",
"#endif\n",
"#if N_INPUTS > 6\n",
"    CHECK_AND_GET(6, 7)\n",
"#endif\n",
"#if N_INPUTS > 7\n",
"    CHECK_AND_GET(7, 8)\n",
"#endif\n",
"#if N_INPUTS > 8\n",
"    CHECK_AND_GET(8, 9)\n",
"#endif\n",
"#if N_INPUTS > 9\n",
"    CHECK_AND_GET(9, 10)\n",
"#endif\n",
"#if N_INPUTS > 10\n",
"    CHECK_AND_GET(10, 11)\n",
"#endif\n",
"#if N_INPUTS > 11\n",
"    CHECK_AND_GET(11, 12)\n",
"#endif\n",
"#if N_INPUTS > 12\n",
"    CHECK_AND_GET(12, 13)\n",
"#endif\n",
"#if N_INPUTS > 13\n",
"    CHECK_AND_GET(13, 14)\n",
"#endif\n",
"#if N_INPUTS > 14\n",
"    CHECK_AND_GET(14, 15)\n",
"#endif\n",
"#if N_INPUTS > 15\n",
"    CHECK_AND_GET(15, 16)\n",
"#endif\n",
"#if BLOCK == 1\n",
"    B = src[0];\n",
"#elif BLOCK == SIMD\n",
"    B = BLOCK_READ(src);\n",
"#elif BLOCK == 2 * SIMD\n",
"    C = BLOCK_READ2(src);\n",
"#elif BLOCK == 3 * SIMD\n",
"    C = BLOCK_READ2(src);\n",
"    B = BLOCK_READ(&src[2 * SIMD]);\n",
"#elif BLOCK == 4 * SIMD\n",
"    D = BLOCK_READ4(src);\n",
"#elif BLOCK == 5 * SIMD\n",
"    D = BLOCK_READ4(src);\n",
"    B = BLOCK_READ(&src[4 * SIMD]);\n",
"#elif BLOCK == 6 * SIMD\n",
"    D = BLOCK_READ4(src);\n",
"    C = BLOCK_READ2(&src[4 * SIMD]);\n",
"#elif BLOCK == 7 * SIMD\n",
"    B = BLOCK_READ(src);\n",
"    C = BLOCK_READ2(&src[SIMD]);\n",
"    D = BLOCK_READ4(&src[3 * SIMD]);\n",
"#elif BLOCK >= 8 * SIMD\n",
"    A0 = BLOCK_READ8(src);\n",
"#elif BLOCK >= 16 * SIMD\n",
"    A1 = BLOCK_READ8(&src[8 * SIMD]);\n",
"#elif BLOCK >= 24 * SIMD\n",
"    A2 = BLOCK_READ8(&src[16 * SIMD]);\n",
"#elif BLOCK >= 32 * SIMD\n",
"    A3 = BLOCK_READ8(&src[24 * SIMD]);\n",
"#endif\n",
"    dst += get_global_id(1) * DST_EXT_OFFSET + x;\n",
"#if BLOCK == 1\n",
"    dst[0] = B;\n",
"#elif BLOCK == SIMD\n",
"    BLOCK_WRITE(dst, B);\n",
"#elif BLOCK == 2 * SIMD\n",
"    BLOCK_WRITE2(dst, C);\n",
"#elif BLOCK == 3 * SIMD\n",
"    BLOCK_WRITE2(dst, C);\n",
"    BLOCK_WRITE(&dst[2 * SIMD], B);\n",
"#elif BLOCK == 4 * SIMD\n",
"    BLOCK_WRITE4(dst, D);\n",
"#elif BLOCK == 5 * SIMD\n",
"    BLOCK_WRITE4(dst, D);\n",
"    BLOCK_WRITE(&dst[4 * SIMD], B);\n",
"#elif BLOCK == 6 * SIMD\n",
"    BLOCK_WRITE4(dst, D);\n",
"    BLOCK_WRITE2(&dst[4 * SIMD], C);\n",
"#elif BLOCK == 7 * SIMD\n",
"    BLOCK_WRITE(dst, B);\n",
"    BLOCK_WRITE2(&dst[SIMD], C);\n",
"    BLOCK_WRITE4(&dst[3 * SIMD], D);\n",
"#elif BLOCK >= 8 * SIMD\n",
"    BLOCK_WRITE8(dst, A0);\n",
"#elif BLOCK >= 16 * SIMD\n",
"    BLOCK_WRITE8(&dst[8 * SIMD], A1);\n",
"#elif BLOCK >= 24 * SIMD\n",
"    BLOCK_WRITE8(&dst[16 * SIMD], A2);\n",
"#elif BLOCK >= 32 * SIMD\n",
"    BLOCK_WRITE8(&dst[24 * SIMD], A3);\n",
"#endif\n",
"}", nullptr };
}
}
}
}