namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *simple_reorder_kernel[] ={ "/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#define DT_UNDEF 1\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_TYPES_H\n",
"#define GPU_OCL_OCL_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#define unroll_for __attribute__((opencl_unroll_hint)) for\n",
"#define for_ for\n",
"#define CONCAt2(a, b) a##b\n",
"#define CONCAT2(a, b) CONCAt2(a, b)\n",
"#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c)\n",
"#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \\\n",
"        || defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \\\n",
"        || defined(BIA_DT_F16) || defined(ACC_DT_F16)\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#if DT_F32 == 1\n",
"#define DATA_T float\n",
"#define DATA2_T float2\n",
"#define DATA4_T float4\n",
"#define DATA8_T float8\n",
"#define DATA16_T float16\n",
"#define DATA_MAX FLT_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) (float)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_float\n",
"#define CONVERT_DATA2_T convert_float2\n",
"#define CONVERT_DATA4_T convert_float4\n",
"#define CONVERT_DATA8_T convert_float8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_float\n",
"#define AS_DATA2_T as_float2\n",
"#define AS_DATA4_T as_float4\n",
"#define AS_DATA8_T as_float8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif DT_F16 == 1\n",
"#define DATA_T half\n",
"#define DATA2_T half2\n",
"#define DATA4_T half4\n",
"#define DATA8_T half8\n",
"#define DATA16_T half16\n",
"#define DATA_MAX HALF_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0h\n",
"#define DATA_ONE 1.0h\n",
"#define DEF_ACC_DATA_T half\n",
"#define DEF_ACC_DATA2_T half2\n",
"#define DEF_ACC_DATA4_T half4\n",
"#define DEF_ACC_DATA8_T half8\n",
"#define POST_OP_DATA_T half\n",
"#define TO_DATA_T(v) (half)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (half)(v)\n",
"#define DATA_TO_REF convert_half\n",
"#define CONVERT_DATA_T convert_half\n",
"#define CONVERT_DATA2_T convert_half2\n",
"#define CONVERT_DATA4_T convert_half4\n",
"#define CONVERT_DATA8_T convert_half8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_half\n",
"#define AS_DATA2_T as_half2\n",
"#define AS_DATA4_T as_half4\n",
"#define AS_DATA8_T as_half8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_BF16 == 1\n",
"#define DATA_T ushort\n",
"#define POST_OP_DATA_T float\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define DATA16_T ushort16\n",
"#define DATA_MAX as_float(0x7f7f0000)\n",
"#define DATA_MIN (-DATA_MAX)\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define TO_DATA_T(v) cvt_f32_to_bf16(v)\n",
"#define TO_DEF_ACC_DATA_T(v) cvt_bf16_to_f32(v)\n",
"#define DATA_TO_REF cvt_bf16_to_f32\n",
"#define CONVERT_DATA_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA2_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA4_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA8_T cvt_f32_to_bf16\n",
"#define CONVERT_FLOAT_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT2_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT4_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT8_T cvt_bf16_to_f32\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_ushort\n",
"#define AS_DATA2_T as_ushort2\n",
"#define AS_DATA4_T as_ushort4\n",
"#define AS_DATA8_T as_ushort8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_S8 == 1\n",
"#define DATA_T char\n",
"#define DATA2_T char2\n",
"#define DATA4_T char4\n",
"#define DATA8_T char8\n",
"#define DATA16_T char16\n",
"#define DATA_MAX CHAR_MAX\n",
"#define DATA_MIN CHAR_MIN\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T int8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_char_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_char_sat_rte\n",
"#define CONVERT_DATA2_T convert_char2_sat_rte\n",
"#define CONVERT_DATA4_T convert_char4_sat_rte\n",
"#define CONVERT_DATA8_T convert_char8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_char\n",
"#define AS_DATA2_T as_char2\n",
"#define AS_DATA4_T as_char4\n",
"#define AS_DATA8_T as_char8\n",
"#define AS_DATA16_T as_char16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_int8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_U8 == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define DATA16_T uchar16\n",
"#define DATA_MAX UCHAR_MAX\n",
"#define DATA_MIN 0\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T uint8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_uchar_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_uchar_sat_rte\n",
"#define CONVERT_DATA2_T convert_uchar2_sat_rte\n",
"#define CONVERT_DATA4_T convert_uchar4_sat_rte\n",
"#define CONVERT_DATA8_T convert_uchar8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_uchar\n",
"#define AS_DATA2_T as_uchar2\n",
"#define AS_DATA4_T as_uchar4\n",
"#define AS_DATA8_T as_uchar8\n",
"#define AS_DATA16_T as_uchar16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_uint8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_S32 == 1\n",
"#define DATA_T int\n",
"#define DATA2_T int2\n",
"#define DATA4_T int4\n",
"#define DATA8_T int8\n",
"#define DATA16_T int16\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_int_sat_rte\n",
"#define CONVERT_DATA2_T convert_int2_sat_rte\n",
"#define CONVERT_DATA4_T convert_int4_sat_rte\n",
"#define CONVERT_DATA8_T convert_int8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define POST_OP_DATA_T float\n",
"#define DATA_MIN INT_MIN\n",
"#define DATA_MAX INT_MAX\n",
"#define ROUND\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_int\n",
"#define AS_DATA2_T as_int2\n",
"#define AS_DATA4_T as_int4\n",
"#define AS_DATA8_T as_int8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif !defined(DT_UNDEF)\n",
"#error \"Unexpected data type\"\n",
"#endif\n",
"#if VECT_DT_N == 1\n",
"#define VECT_DATA_T DATA_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T\n",
"#define AS_VECT_DATA_T AS_DATA_T\n",
"#define VECT_BLOCK_READ BLOCK_READ\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE\n",
"#define VECT_UINT_READ intel_sub_group_block_read\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T\n",
"#define VECT_INT_T int\n",
"#define VECT_UINT_T uint\n",
"#define VECT_FLOAT_T float\n",
"#define VECT_CHAR_T char\n",
"#define AS_VECT_INT_T as_int\n",
"#define AS_VECT_UINT_T as_uint\n",
"#define AS_VECT_FLOAT_T as_float\n",
"#define AS_VECT_CHAR_T as_char\n",
"#elif VECT_DT_N == 2\n",
"#define VECT_DATA_T DATA2_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T\n",
"#define AS_VECT_DATA_T AS_DATA2_T\n",
"#define VECT_BLOCK_READ BLOCK_READ2\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE2\n",
"#define VECT_UINT_READ intel_sub_group_block_read2\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write2\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc2\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA2_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T\n",
"#define VECT_INT_T int2\n",
"#define VECT_UINT_T uint2\n",
"#define VECT_FLOAT_T float2\n",
"#define VECT_CHAR_T char2\n",
"#define AS_VECT_INT_T as_int2\n",
"#define AS_VECT_UINT_T as_uint2\n",
"#define AS_VECT_FLOAT_T as_float2\n",
"#define AS_VECT_CHAR_T as_char2\n",
"#elif VECT_DT_N == 4\n",
"#define VECT_DATA_T DATA4_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T\n",
"#define AS_VECT_DATA_T AS_DATA4_T\n",
"#define VECT_BLOCK_READ BLOCK_READ4\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE4\n",
"#define VECT_UINT_READ intel_sub_group_block_read4\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write4\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc4\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA4_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T\n",
"#define VECT_INT_T int4\n",
"#define VECT_UINT_T uint4\n",
"#define VECT_FLOAT_T float4\n",
"#define VECT_CHAR_T char4\n",
"#define AS_VECT_INT_T as_int4\n",
"#define AS_VECT_UINT_T as_uint4\n",
"#define AS_VECT_FLOAT_T as_float4\n",
"#define AS_VECT_CHAR_T as_char4\n",
"#elif VECT_DT_N == 8\n",
"#define VECT_DATA_T DATA8_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T\n",
"#define AS_VECT_DATA_T AS_DATA8_T\n",
"#define VECT_BLOCK_READ BLOCK_READ8\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE8\n",
"#define VECT_UINT_READ intel_sub_group_block_read8\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write8\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc8\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA8_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T\n",
"#define VECT_INT_T int8\n",
"#define VECT_UINT_T uint8\n",
"#define VECT_FLOAT_T float8\n",
"#define VECT_CHAR_T char8\n",
"#define AS_VECT_INT_T as_int8\n",
"#define AS_VECT_UINT_T as_uint8\n",
"#define AS_VECT_FLOAT_T as_float8\n",
"#define AS_VECT_CHAR_T as_char8\n",
"#endif\n",
"#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T)\n",
"#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T)\n",
"#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T)\n",
"#ifdef SRC_DATA_T\n",
"#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2)\n",
"#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4)\n",
"#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8)\n",
"#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16)\n",
"#ifdef SRC_DT_U8\n",
"#define SRC_MMAD_DATA_T uint\n",
"#define SRC_MMAD_DATA4_T uint4\n",
"#define SRC_MMAD_DATA8_T uint8\n",
"#elif SRC_DT_S8\n",
"#define SRC_MMAD_DATA_T int\n",
"#define SRC_MMAD_DATA4_T int4\n",
"#define SRC_MMAD_DATA8_T int8\n",
"#endif\n",
"#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T)\n",
"#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T)\n",
"#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T)\n",
"#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T)\n",
"#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T)\n",
"#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T)\n",
"#if SRC_DT_BF16\n",
"#define SRC_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define SRC_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define SRC_TO_REF(x) (x)\n",
"#define SRC_TO_REF8(x) (x)\n",
"#define REF_TO_SRC(x) (x)\n",
"#endif\n",
"#if SRC_DT_BF16\n",
"#define TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#elif SRC_DT_U8\n",
"#define TO_SRC(x) convert_uchar_sat_rte(x)\n",
"#elif SRC_DT_S8\n",
"#define TO_SRC(x) convert_char_sat_rte(x)\n",
"#elif SRC_DT_S32\n",
"#define TO_SRC(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_SRC(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef A_DATA_T\n",
"#define A_DATA8_T CONCAT2(A_DATA_T, 8)\n",
"#if A_DT_BF16\n",
"#define A_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define A_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_A(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define A_TO_REF(x) (x)\n",
"#define A_TO_REF8(x) (x)\n",
"#define REF_TO_A(x) (x)\n",
"#endif\n",
"#if A_DT_BF16\n",
"#define TO_A(x) cvt_f32_to_bf16(x)\n",
"#elif A_DT_U8\n",
"#define TO_A(x) convert_uchar_sat_rte(x)\n",
"#elif A_DT_S8\n",
"#define TO_A(x) convert_char_sat_rte(x)\n",
"#elif A_DT_S32\n",
"#define TO_A(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_A(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef WEI_DATA_T\n",
"#if WEI_DT_BF16\n",
"#define WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define WEI_TO_REF(x) (x)\n",
"#define REF_TO_WEI(x) (x)\n",
"#endif\n",
"#if WEI_DT_BF16\n",
"#define TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif WEI_DT_U8\n",
"#define TO_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif WEI_DT_S8\n",
"#define TO_WEI(x) convert_char_sat_rte(x)\n",
"#elif WEI_DT_S32\n",
"#define TO_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DIFF_WEI_DATA_T\n",
"#if DIFF_WEI_DT_BF16\n",
"#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define DIFF_WEI_TO_REF(x) (x)\n",
"#define REF_TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#if DIFF_WEI_DT_BF16\n",
"#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif DIFF_WEI_DT_U8\n",
"#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S8\n",
"#define TO_DIFF_WEI(x) convert_char_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S32\n",
"#define TO_DIFF_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef B_DATA_T\n",
"#if B_DT_BF16\n",
"#define B_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_B(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define B_TO_REF(x) (x)\n",
"#define REF_TO_B(x) (x)\n",
"#endif\n",
"#if B_DT_BF16\n",
"#define TO_B(x) cvt_f32_to_bf16(x)\n",
"#elif B_DT_U8\n",
"#define TO_B(x) convert_uchar_sat_rte(x)\n",
"#elif B_DT_S8\n",
"#define TO_B(x) convert_char_sat_rte(x)\n",
"#elif B_DT_S32\n",
"#define TO_B(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_B(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef BIA_DATA_T\n",
"#if BIA_DT_BF16\n",
"#define BIA_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define BIA_TO_REF(x) (x)\n",
"#define REF_TO_BIA(x) (x)\n",
"#endif\n",
"#if BIA_DT_BF16\n",
"#define TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#elif BIA_DT_U8\n",
"#define TO_BIA(x) convert_uchar_sat_rte(x)\n",
"#elif BIA_DT_S8\n",
"#define TO_BIA(x) convert_char_sat_rte(x)\n",
"#elif BIA_DT_S32\n",
"#define TO_BIA(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_BIA(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DST_DATA_T\n",
"#define DST_DATA2_T CONCAT2(DST_DATA_T, 2)\n",
"#define DST_DATA4_T CONCAT2(DST_DATA_T, 4)\n",
"#define DST_DATA8_T CONCAT2(DST_DATA_T, 8)\n",
"#define DST_DATA16_T CONCAT2(DST_DATA_T, 16)\n",
"#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T)\n",
"#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T)\n",
"#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T)\n",
"#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T)\n",
"#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T)\n",
"#if DST_DT_F32 || DST_DT_F16\n",
"#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T)\n",
"#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T)\n",
"#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T)\n",
"#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T)\n",
"#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T)\n",
"#else\n",
"#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte)\n",
"#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte)\n",
"#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte)\n",
"#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte)\n",
"#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte)\n",
"#endif\n",
"#if DST_DT_U8\n",
"#define MMAD_DATA_T uint\n",
"#define MMAD_DATA4_T uint4\n",
"#define MMAD_DATA8_T uint8\n",
"#elif DST_DT_S8\n",
"#define MMAD_DATA_T int\n",
"#define MMAD_DATA4_T int4\n",
"#define MMAD_DATA8_T int8\n",
"#endif\n",
"// Block read/write macros for dst.\n",
"#if DST_DT_U8 || DST_DT_S8\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v))\n",
"#elif DST_DT_S32 || DST_DT_F32\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write((__global uint *)ptr, as_uint(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#elif DST_DT_F16\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define DST_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define DST_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define DST_TO_REF(x) (x)\n",
"#define DST_TO_REF8(x) (x)\n",
"#define REF_TO_DST(x) (x)\n",
"#define REF_TO_DST8(x) (x)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x))\n",
"#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x))\n",
"#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif DST_DT_F16\n",
"#define TO_DST(x) convert_half(x)\n",
"#define TO_DST2(x) convert_half2(x)\n",
"#define TO_DST4(x) convert_half4(x)\n",
"#define TO_DST8(x) convert_half8(x)\n",
"#elif DST_DT_U8\n",
"#define TO_DST(x) convert_uchar_sat_rte(x)\n",
"#define TO_DST2(x) convert_uchar2_sat_rte(x)\n",
"#define TO_DST4(x) convert_uchar4_sat_rte(x)\n",
"#define TO_DST8(x) convert_uchar8_sat_rte(x)\n",
"#define TO_DST16(x) convert_uchar16_sat_rte(x)\n",
"#elif DST_DT_S8\n",
"#define TO_DST(x) convert_char_sat_rte(x)\n",
"#define TO_DST2(x) convert_char2_sat_rte(x)\n",
"#define TO_DST4(x) convert_char4_sat_rte(x)\n",
"#define TO_DST8(x) convert_char8_sat_rte(x)\n",
"#define TO_DST16(x) convert_char16_sat_rte(x)\n",
"#elif DST_DT_S32\n",
"#define TO_DST(x) convert_int_sat_rte(x)\n",
"#define TO_DST2(x) convert_int2_sat_rte(x)\n",
"#define TO_DST4(x) convert_int4_sat_rte(x)\n",
"#define TO_DST8(x) convert_int8_sat_rte(x)\n",
"#elif DST_DT_F32\n",
"#define TO_DST(x) convert_float(x)\n",
"#define TO_DST2(x) convert_float2(x)\n",
"#define TO_DST4(x) convert_float4(x)\n",
"#define TO_DST8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef C_DATA_T\n",
"#define C_DATA8_T CONCAT2(C_DATA_T, 8)\n",
"#if C_DT_BF16\n",
"#define C_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define C_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_C(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define C_TO_REF(x) (x)\n",
"#define C_TO_REF8(x) (x)\n",
"#define REF_TO_C(x) (x)\n",
"#define REF_TO_C8(x) (x)\n",
"#endif\n",
"#if C_DT_BF16\n",
"#define TO_C(x) cvt_f32_to_bf16(x)\n",
"#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif C_DT_F16\n",
"#define TO_C(x) convert_half(x)\n",
"#define TO_C8(x) convert_half8(x)\n",
"#elif C_DT_U8\n",
"#define TO_C(x) convert_uchar_sat_rte(x)\n",
"#define TO_C8(x) convert_uchar8_sat_rte(x)\n",
"#elif C_DT_S8\n",
"#define TO_C(x) convert_char_sat_rte(x)\n",
"#define TO_C8(x) convert_char8_sat_rte(x)\n",
"#elif C_DT_S32\n",
"#define TO_C(x) convert_int_sat_rte(x)\n",
"#define TO_C8(x) convert_int8_sat_rte(x)\n",
"#elif C_DT_F32\n",
"#define TO_C(x) convert_float(x)\n",
"#define TO_C8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef ACC_DATA_T\n",
"#if ACC_DT_F16\n",
"#define TO_ACC(x) convert_half(x)\n",
"#elif ACC_DT_F32\n",
"#define TO_ACC(x) convert_float(x)\n",
"#elif ACC_DT_S32\n",
"#define TO_ACC(x) convert_int(x)\n",
"#else\n",
"#error \"Unexpected accumulation data type\"\n",
"#endif\n",
"#endif\n",
"#ifdef SUM_DATA_T\n",
"#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2)\n",
"#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4)\n",
"#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8)\n",
"#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16)\n",
"#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T)\n",
"#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T)\n",
"#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T)\n",
"#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T)\n",
"#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T)\n",
"#if SUM_DT_BF16\n",
"#define SUM_TO_REF cvt_bf16_to_f32\n",
"#else\n",
"#define SUM_TO_REF\n",
"#endif\n",
"#endif\n",
"#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2)))\n",
"#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"              / CONCAT2(prefix, _B0_1)) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"                       % CONCAT2(prefix, _B0_1)) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \\\n",
"                    * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       / CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       % CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \\\n",
"                    * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       / CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       % CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \\\n",
"                    * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       / CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       % CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \\\n",
"                    * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       / CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       % CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \\\n",
"                    * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       / CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       % CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \\\n",
"                    * CONCAT2(prefix, _S5_2)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3)))\n",
"#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5)\n",
"#if NDIMS == 2\n",
"#define SRC_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1)\n",
"#elif NDIMS == 3\n",
"#define SRC_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, x3) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, x2) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2)\n",
"#elif NDIMS == 4\n",
"#define SRC_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, x3, x4) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, d, x3, x4) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3)\n",
"#elif NDIMS == 5\n",
"#define SRC_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \\\n",
"            + ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \\\n",
"            + ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, x3, x4, x5) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \\\n",
"            + ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4)\n",
"#endif\n",
"#define DST_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \\\n",
"            + ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4)\n",
"#endif\n",
"// clang-format off\n",
"// Shortcut accessors for special cases.\n",
"// x - product of the current and outer dimensions in gws[idx]\n",
"// y - the current dimension\n",
"#define GWS_OP_ZERO(x, y) 0\n",
"#define GWS_OP_FIRST(x, y) (x)\n",
"#define GWS_OP_MOD(x, y) ((x) % (y))\n",
"#define ROUND_UP(a,b) (((a) + (b) - 1) / (b))\n",
"#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0\n",
"#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1\n",
"#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2\n",
"#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3\n",
"#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4\n",
"#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5\n",
"#define GWS0_GET_BLOCK0() GWS0_BLOCK0\n",
"#define GWS0_GET_BLOCK1() GWS0_BLOCK1\n",
"#define GWS0_GET_BLOCK2() GWS0_BLOCK2\n",
"#define GWS0_GET_BLOCK3() GWS0_BLOCK3\n",
"#define GWS0_GET_BLOCK4() GWS0_BLOCK4\n",
"#define GWS0_GET_BLOCK5() GWS0_BLOCK5\n",
"#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0\n",
"#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1\n",
"#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2\n",
"#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3\n",
"#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4\n",
"#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5\n",
"#define GWS1_GET_BLOCK0() GWS1_BLOCK0\n",
"#define GWS1_GET_BLOCK1() GWS1_BLOCK1\n",
"#define GWS1_GET_BLOCK2() GWS1_BLOCK2\n",
"#define GWS1_GET_BLOCK3() GWS1_BLOCK3\n",
"#define GWS1_GET_BLOCK4() GWS1_BLOCK4\n",
"#define GWS1_GET_BLOCK5() GWS1_BLOCK5\n",
"#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0\n",
"#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1\n",
"#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2\n",
"#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3\n",
"#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4\n",
"#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5\n",
"#define GWS2_GET_BLOCK0() GWS2_BLOCK0\n",
"#define GWS2_GET_BLOCK1() GWS2_BLOCK1\n",
"#define GWS2_GET_BLOCK2() GWS2_BLOCK2\n",
"#define GWS2_GET_BLOCK3() GWS2_BLOCK3\n",
"#define GWS2_GET_BLOCK4() GWS2_BLOCK4\n",
"#define GWS2_GET_BLOCK5() GWS2_BLOCK5\n",
"// clang-format on\n",
"// With work-group qualifier, without sub-group qualifier.\n",
"#define KERNEL_ATTR_SG0 \\\n",
"    __attribute__((reqd_work_group_size( \\\n",
"            GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT)))\n",
"// With work-group and sub-group qualifiers.\n",
"#define KERNEL_ATTR_SG1 \\\n",
"    KERNEL_ATTR_SG0 \\\n",
"    __attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT)))\n",
"#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT)\n",
"// Named kernel attributes - when source contains multiple kernels.\n",
"#define NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \\\n",
"            CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name))))\n",
"#define NAMED_KERNEL_ATTR_SG1(name) \\\n",
"    NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name))))\n",
"#define NAMED_KERNEL_ATTR(name) \\\n",
"    CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name)\n",
"#endif\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#if SRC_DT_F16 || DST_DT_F16\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#undef SRC_OFF\n",
"#undef DST_OFF\n",
"#define SRC_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    OFF_MD(SRC, (x0), (x1), (x2), (x3), (x4), (x5))\n",
"#define DST_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    OFF_MD(DST, (x0), (x1), (x2), (x3), (x4), (x5))\n",
"#define SRC_OFF_G(gr, x0, x1, x2, x3, x4) \\\n",
"    OFF_MD(SRC, gr, (x0), (x1), (x2), (x3), (x4))\n",
"#define DST_OFF_G(gr, x0, x1, x2, x3, x4) \\\n",
"    OFF_MD(DST, gr, (x0), (x1), (x2), (x3), (x4))\n",
"#if SRC_DT_S8\n",
"#define SRC_BLOCK_READ(src) \\\n",
"    as_char(intel_sub_group_block_read_uc((const __global uchar *)(src)))\n",
"#define SRC_BLOCK_READ8(src) \\\n",
"    as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src)))\n",
"#define SRC_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val))\n",
"#define SRC_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val))\n",
"#endif // SRC_DT_S8\n",
"#if SRC_DT_U8\n",
"#define SRC_BLOCK_READ(src) \\\n",
"    as_uchar(intel_sub_group_block_read_uc((const __global uchar *)(src)))\n",
"#define SRC_BLOCK_READ8(src) \\\n",
"    as_uchar8(intel_sub_group_block_read_uc8((const __global uchar *)(src)))\n",
"#define SRC_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val))\n",
"#define SRC_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val))\n",
"#endif // SRC_DT_U8\n",
"#if SRC_DT_F16\n",
"#define SRC_BLOCK_READ(src) \\\n",
"    as_half(intel_sub_group_block_read_us((const __global ushort *)(src)))\n",
"#define SRC_BLOCK_READ8(src) \\\n",
"    as_half8(intel_sub_group_block_read_us8((const __global ushort *)(src)))\n",
"#define SRC_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val))\n",
"#define SRC_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val))\n",
"#endif // SRC_DT_F16\n",
"#if SRC_DT_S32\n",
"#define SRC_BLOCK_READ(src) \\\n",
"    as_int(intel_sub_group_block_read((const __global uint *)(src)))\n",
"#define SRC_BLOCK_READ8(src) \\\n",
"    as_int8(intel_sub_group_block_read8((const __global uint *)(src)))\n",
"#define SRC_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write((__global uint *)(dst), as_uint(val))\n",
"#define SRC_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val))\n",
"#endif // SRC_DT_S32\n",
"#if SRC_DT_F32\n",
"#define SRC_BLOCK_READ(src) \\\n",
"    as_float(intel_sub_group_block_read((const __global uint *)(src)))\n",
"#define SRC_BLOCK_READ8(src) \\\n",
"    as_float8(intel_sub_group_block_read8((const __global uint *)(src)))\n",
"#define SRC_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write((__global uint *)(dst), as_uint(val))\n",
"#define SRC_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val))\n",
"#endif // SRC_DT_F32\n",
"#if SRC_DT_BF16\n",
"#define SRC_BLOCK_READ(src) \\\n",
"    as_ushort(intel_sub_group_block_read_us((const __global ushort *)(src)))\n",
"#define SRC_BLOCK_READ8(src) \\\n",
"    as_ushort8(intel_sub_group_block_read_us8((const __global ushort *)(src)))\n",
"#define SRC_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val))\n",
"#define SRC_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val))\n",
"#endif // SRC_DT_F16\n",
"#if DST_DT_S8\n",
"#define DST_BLOCK_READ(src) \\\n",
"    as_char(intel_sub_group_block_read_uc((const __global uchar *)(src)))\n",
"#define DST_BLOCK_READ8(src) \\\n",
"    as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src)))\n",
"#define DST_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val))\n",
"#define DST_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val))\n",
"#endif // DST_DT_S8\n",
"#if DST_DT_U8\n",
"#define DST_BLOCK_READ(src) \\\n",
"    as_uchar(intel_sub_group_block_read_uc((const __global uchar *)(src)))\n",
"#define DST_BLOCK_READ8(src) \\\n",
"    as_uchar8(intel_sub_group_block_read_uc8((const __global uchar *)(src)))\n",
"#define DST_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val))\n",
"#define DST_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val))\n",
"#endif // SRC_DT_U8\n",
"#if DST_DT_F16\n",
"#define DST_BLOCK_READ(src) \\\n",
"    as_half(intel_sub_group_block_read_us((const __global ushort *)(src)))\n",
"#define DST_BLOCK_READ8(src) \\\n",
"    as_half8(intel_sub_group_block_read_us8((const __global ushort *)(src)))\n",
"#define DST_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val))\n",
"#define DST_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val))\n",
"#endif // DST_DT_F16\n",
"#if DST_DT_S32\n",
"#define DST_BLOCK_READ(src) \\\n",
"    as_int(intel_sub_group_block_read((const __global uint *)(src)))\n",
"#define DST_BLOCK_READ8(src) \\\n",
"    as_int8(intel_sub_group_block_read8((const __global uint *)(src)))\n",
"#define DST_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write((__global uint *)(dst), as_uint(val))\n",
"#define DST_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val))\n",
"#endif // DST_DT_S32\n",
"#if DST_DT_F32\n",
"#define DST_BLOCK_READ(src) \\\n",
"    as_float(intel_sub_group_block_read((const __global uint *)(src)))\n",
"#define DST_BLOCK_READ8(src) \\\n",
"    as_float8(intel_sub_group_block_read8((const __global uint *)(src)))\n",
"#define DST_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write((__global uint *)(dst), as_uint(val))\n",
"#define DST_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val))\n",
"#endif // DST_DT_F32\n",
"#if DST_DT_BF16\n",
"#define DST_BLOCK_READ(src) \\\n",
"    as_ushort(intel_sub_group_block_read_us((const __global ushort *)(src)))\n",
"#define DST_BLOCK_READ8(src) \\\n",
"    as_ushort8(intel_sub_group_block_read_us8((const __global ushort *)(src)))\n",
"#define DST_BLOCK_WRITE(dst, val) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val))\n",
"#define DST_BLOCK_WRITE8(dst, val) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val))\n",
"#endif // SRC_DT_F16\n",
"#if SRC_DT_BF16 && DST_DT_BF16\n",
"#define SRC_TO_DST(x) (x)\n",
"#define SRC_TO_DST8(x) (x)\n",
"#else\n",
"#define SRC_TO_DST(x) TO_DST(SRC_TO_REF(x))\n",
"#define SRC_TO_DST8(x) TO_DST8(SRC_TO_REF8(x))\n",
"#endif\n",
"#if WITH_SUM_A\n",
"#define REORDER(_dst, _src, _a, _b) \\\n",
"    do { \\\n",
"        const float _x = SRC_TO_REF(_src); \\\n",
"        const float _s = _a * _x; \\\n",
"        _dst = TO_DST(_s); \\\n",
"    } while (0)\n",
"#define REORDER8(_dst, _src, _a, _b) \\\n",
"    do { \\\n",
"        const float8 _x = convert_float8(SRC_TO_REF8(_src)); \\\n",
"        const float8 _s = _a * _x; \\\n",
"        _dst = TO_DST8(_s); \\\n",
"    } while (0)\n",
"#elif WITH_SUM_AB\n",
"#define REORDER(_dst, _src, _a, _b) \\\n",
"    do { \\\n",
"        const float _x = SRC_TO_REF(_src); \\\n",
"        const float _y = DST_TO_REF(_dst); \\\n",
"        const float _s = _a * _x + _b * _y; \\\n",
"        _dst = TO_DST(_s); \\\n",
"    } while (0)\n",
"#define REORDER8(_dst, _src, _a, _b) \\\n",
"    do { \\\n",
"        const float8 _x = convert_float8(SRC_TO_REF8(_src)); \\\n",
"        const float8 _y = convert_float8(DST_TO_REF8(_dst)); \\\n",
"        const float8 _s = _a * _x + _b * _y; \\\n",
"        _dst = TO_DST8(_s); \\\n",
"    } while (0)\n",
"#elif SCALE_QUANT\n",
"#define REORDER(_out, _src, _a, _b) \\\n",
"    do { \\\n",
"        const float _x = SRC_TO_REF(_src); \\\n",
"        const float _s = _a * _x + _b; \\\n",
"        _out = TO_DST(_s); \\\n",
"    } while (0)\n",
"#define REORDER8(_out, _src, _a, _b) \\\n",
"    do { \\\n",
"        const float8 _x = convert_float8(SRC_TO_REF8(_src)); \\\n",
"        const float8 _s = _a * _x + _b; \\\n",
"        _out = TO_DST8(_s); \\\n",
"    } while (0)\n",
"#else // WITH_SUM_AB == 0\n",
"#define REORDER(_dst, _src, _a, _b) \\\n",
"    do { \\\n",
"        _dst = SRC_TO_DST(_src); \\\n",
"    } while (0)\n",
"#define REORDER8(_dst, _src, _a, _b) \\\n",
"    do { \\\n",
"        _dst = SRC_TO_DST8(_src); \\\n",
"    } while (0)\n",
"#endif // WITH_SUM_AB\n",
"#if SCALE_QUANT\n",
"#define MASK_D(_d) ((SCALE_MASK >> _d) & 1)\n",
"#define SCALE_D0 (MASK_D(0) ? SRC_D0 : 1)\n",
"#define SCALE_D1 (MASK_D(1) ? SRC_D1 : 1)\n",
"#define SCALE_D2 (MASK_D(2) ? SRC_D2 : 1)\n",
"#define SCALE_D3 (MASK_D(3) ? SRC_D3 : 1)\n",
"#define SCALE_D4 (MASK_D(4) ? SRC_D4 : 1)\n",
"#define SCALE_D5 (MASK_D(5) ? SRC_D5 : 1)\n",
"#define SCALE_S0 (SCALE_D1 * SCALE_D2 * SCALE_D3 * SCALE_D4 * SCALE_D5)\n",
"#define SCALE_S1 (SCALE_D2 * SCALE_D3 * SCALE_D4 * SCALE_D5)\n",
"#define SCALE_S2 (SCALE_D3 * SCALE_D4 * SCALE_D5)\n",
"#define SCALE_S3 (SCALE_D4 * SCALE_D5)\n",
"#define SCALE_S4 (SCALE_D5)\n",
"#define SCALE_S5 (1)\n",
"#define SCALE_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    ((x0)*SCALE_S0 * MASK_D(0) + (x1)*SCALE_S1 * MASK_D(1) \\\n",
"            + (x2)*SCALE_S2 * MASK_D(2) + (x3)*SCALE_S3 * MASK_D(3) \\\n",
"            + (x4)*SCALE_S4 * MASK_D(4) + (x5)*SCALE_S5 * MASK_D(5))\n",
"#endif // SCALE_QUANT\n",
"KERNEL_ATTR\n",
"__kernel void simple_reorder(__global SRC_DATA_T *src, __global DST_DATA_T *dst,\n",
"        float alpha, float beta, __global float *scales) {\n",
"    src += SRC_OFFSET0;\n",
"    dst += DST_OFFSET0;\n",
"#if REF_REORDER\n",
"    const int d0 = GWS_GET_D0();\n",
"    const int d1_blk_start = GWS_GET_D1();\n",
"    const int d2_blk_start = GWS_GET_D2();\n",
"    const int d3_blk_start = GWS_GET_D3();\n",
"    const int d4_blk_start = GWS_GET_D4();\n",
"    const int d5_blk_start = GWS_GET_D5();\n",
"    const int d1_blk_end = d1_blk_start + GWS_GET_D1_BLOCK();\n",
"    const int d2_blk_end = d2_blk_start + GWS_GET_D2_BLOCK();\n",
"    const int d3_blk_end = d3_blk_start + GWS_GET_D3_BLOCK();\n",
"    const int d4_blk_end = d4_blk_start + GWS_GET_D4_BLOCK();\n",
"    const int d5_blk_end = d5_blk_start + GWS_GET_D5_BLOCK();\n",
"    for (int d1 = d1_blk_start; d1 < d1_blk_end; ++d1) {\n",
"        for (int d2 = d2_blk_start; d2 < d2_blk_end; ++d2) {\n",
"            for (int d3 = d3_blk_start; d3 < d3_blk_end; ++d3) {\n",
"                for (int d4 = d4_blk_start; d4 < d4_blk_end; ++d4) {\n",
"                    for (int d5 = d5_blk_start; d5 < d5_blk_end; ++d5) {\n",
"                        const int src_off = SRC_OFF(d0, d1, d2, d3, d4, d5);\n",
"                        const int dst_off = DST_OFF(d0, d1, d2, d3, d4, d5);\n",
"#if PAD_FILL_ZERO == 1\n",
"                        int pad_d0 = d0 >= SRC_D0;\n",
"                        int pad_d1 = NDIMS > 1 && d1 >= SRC_D1;\n",
"                        int pad_d2 = NDIMS > 2 && d2 >= SRC_D2;\n",
"                        int pad_d3 = NDIMS > 3 && d3 >= SRC_D3;\n",
"                        int pad_d4 = NDIMS > 4 && d4 >= SRC_D4;\n",
"                        int pad_d5 = NDIMS > 5 && d5 >= SRC_D5;\n",
"                        if (pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4\n",
"                                || pad_d5) {\n",
"                            dst[dst_off] = 0;\n",
"                            continue;\n",
"                        }\n",
"#endif\n",
"#if SCALE_QUANT\n",
"                        alpha = scales[SCALE_OFF(d0, d1, d2, d3, d4, d5)];\n",
"#endif\n",
"                        REORDER(dst[dst_off], src[src_off], alpha, beta);\n",
"                    }\n",
"                }\n",
"            }\n",
"        }\n",
"    }\n",
"#elif ALT_OFFSETS\n",
"    // This implementation uses two main features:\n",
"    // 1. Extremely simple offset calculations. It works on 2D-4D tensors with\n",
"    // plain format. Coordinates of up to 3 dimensions are passed unmodified\n",
"    // through get_global_id(). 4th dimension, if there is one, is passed as\n",
"    // block size.\n",
"    // 2. Uses work group size at least 8. If that would mean using nonuniform\n",
"    // work groups, number of work items will be padded to keep them uniform.\n",
"    const int d0 = get_global_id(0);\n",
"    const int d1 = get_global_id(1);\n",
"    const int d2 = get_global_id(2);\n",
"#ifdef LIMIT_MAX_D0\n",
"    // padding for uniform work groups, don't write there\n",
"    if (d0 >= LIMIT_MAX_D0) { return; }\n",
"#endif\n",
"    const int src_base = S0 * d0 + S1 * d1 + S2 * d2;\n",
"    const int dst_base = D0 * d0 + D1 * d1 + D2 * d2;\n",
"    for (int db = 0; db < BLK; ++db) {\n",
"        const int src_off = src_base + db * SB;\n",
"        const int dst_off = dst_base + db * DB;\n",
"        REORDER(dst[dst_off], src[src_off], alpha, beta);\n",
"    }\n",
"#elif PLAIN_xFxE_TO_ABCDEF\n",
"    const int d0 = GWS_GET_D0();\n",
"    const int d1 = GWS_GET_D1();\n",
"    const int d2 = GWS_GET_D2();\n",
"    const int d3 = GWS_GET_D3();\n",
"    const int d4 = GWS_GET_D4();\n",
"    const int d5 = GWS_GET_D5();\n",
"#if WITH_SUM_AB\n",
"#define SUM_OUTPUT 1\n",
"#else\n",
"#define SUM_OUTPUT 0\n",
"#endif\n",
"    const unsigned sglid = get_sub_group_local_id();\n",
"#define REORDER_BLOCK(block_size, src_memory, src_swap, src_offset) \\\n",
"    { \\\n",
"        unroll_for(unsigned sidx = 0; sidx < block_size; ++sidx) { \\\n",
"            const unsigned src_off \\\n",
"                    = SRC_OFF(d0, d1, d2, d3, d4, sidx + src_offset); \\\n",
"            src_memory[sidx] = SRC_BLOCK_READ(&src[src_off]); \\\n",
"        } \\\n",
"        unroll_for(int j = 0; j < SUB_GROUP_SIZE; j++) \\\n",
"                unroll_for(int i = 0; i < block_size; i++) { \\\n",
"            unsigned x = (i + j * block_size) / SUB_GROUP_SIZE; \\\n",
"            unsigned y = (i + j * block_size) % SUB_GROUP_SIZE; \\\n",
"            unsigned sg_src = (i + j * block_size) / block_size; \\\n",
"            src_swap[x][y] = intel_sub_group_shuffle(src_mem[i], sg_src); \\\n",
"        } \\\n",
"\\\n",
"        DST_DATA_T dst_tmp; \\\n",
"        unsigned dst_off; \\\n",
"        if (block_size < 16) dst_off = DST_OFF(d0, d1, d2, d3, d4, 0); \\\n",
"\\\n",
"        unroll_for(unsigned sidx = 0; sidx < block_size; ++sidx) { \\\n",
"            if (block_size >= 16) \\\n",
"                dst_off = DST_OFF(d0, d1, d2, d3, d4 + sidx, src_offset); \\\n",
"            if (SUM_OUTPUT) dst_tmp = DST_BLOCK_READ(&dst[dst_off]); \\\n",
"            REORDER(dst_tmp, src_swap[sidx][sglid], alpha, beta); \\\n",
"            DST_BLOCK_WRITE(&dst[dst_off], dst_tmp); \\\n",
"            if (block_size < 16) dst_off += SUB_GROUP_SIZE; \\\n",
"        } \\\n",
"    }\n",
"#if DST_D5 > 16\n",
"    unsigned block_size = 16;\n",
"#else\n",
"    unsigned block_size = DST_D5;\n",
"#endif\n",
"    SRC_DATA_T src_mem[16];\n",
"    SRC_DATA_T src_all[16][SUB_GROUP_SIZE];\n",
"    REORDER_BLOCK(block_size, src_mem, src_all, d5);\n",
"#elif TRANSPOSE_NXN || LOCAL_NXN\n",
"    // Fast reorder in which a subgroup of N work items loads N disjoint sets\n",
"    // of N sequential addresses, transposes the NxN matrix and writes it back\n",
"    // as N sets of N addresses. N = 8 or 16. Sets are strided in src by the\n",
"    // dimansion that'll be last in dst and strided in dst by dimension that\n",
"    // was last in src.\n",
"    // One version uses intel_sub_group_read/write functions to perform\n",
"    // the transposition. It needs no auxiliary mem accesses, but uses a lot\n",
"    // of private registers.\n",
"    // The other version uses local memory to performs transposition. It\n",
"    // would be slower but uses few private registers, so it's actually faster\n",
"    // on Gen9 architecture where private data would otherwise spill over to\n",
"    // global mem.\n",
"    //\n",
"    // LocalNxN kernel shares local memory across work items. In general that\n",
"    // doesn't work without barriers. Here we take caution to only access\n",
"    // data that was produced by work items in the same *sub*group. Those\n",
"    // are guaranteed to execute simultaneously, so no barriers are needed.\n",
"#define BATCH_SIZE SUB_GROUP_SIZE\n",
"    int sgId = get_sub_group_local_id();\n",
"    int sg_off = get_sub_group_id() * SUB_GROUP_SIZE * BATCH_SIZE;\n",
"    const int d0 = GWS_GET_D0();\n",
"    const int d1 = GWS_GET_D1();\n",
"    const int d2 = GWS_GET_D2();\n",
"    const int d3 = GWS_GET_D3();\n",
"    const int d4 = GWS_GET_D4();\n",
"    const int d5 = GWS_GET_D5();\n",
"    const int d0_block = GWS_GET_D0_BLOCK();\n",
"    const int d1_block = GWS_GET_D1_BLOCK();\n",
"    const int d2_block = GWS_GET_D2_BLOCK();\n",
"    const int d3_block = GWS_GET_D3_BLOCK();\n",
"    const int d4_block = GWS_GET_D4_BLOCK();\n",
"    const int d5_block = GWS_GET_D5_BLOCK();\n",
"#ifdef TRANSPOSE_NXN\n",
"    SRC_DATA_T src_buf[SUB_GROUP_SIZE];\n",
"    SRC_DATA_T dst_buf[SUB_GROUP_SIZE];\n",
"#else\n",
"    __local SRC_DATA_T tmp[SG_PER_WG * BATCH_SIZE];\n",
"#endif\n",
"    SRC_DATA_T send_buf;\n",
"#if PAD_FILL_ZERO == 1\n",
"    const int pad_d0 = d0 >= SRC_D0;\n",
"    const int pad_d1 = NDIMS > 1 && d1 >= SRC_D1;\n",
"    const int pad_d2 = NDIMS > 2 && d2 >= SRC_D2;\n",
"    const int pad_d3 = NDIMS > 3 && d3 >= SRC_D3;\n",
"    const int pad_d4 = NDIMS > 4 && d4 >= SRC_D4;\n",
"    const int pad_d5 = NDIMS > 5 && d5 >= SRC_D5;\n",
"    const int pad = pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5;\n",
"#else\n",
"    const int pad = 0;\n",
"#endif\n",
"    if (!pad) {\n",
"        for_(int d0i = 0; d0i < d0_block; d0i++)\n",
"        for_(int d1i = 0; d1i < d1_block; d1i++)\n",
"        for_(int d2i = 0; d2i < d2_block; d2i++)\n",
"        for_(int d3i = 0; d3i < d3_block; d3i++)\n",
"        for_(int d4i = 0; d4i < d4_block; d4i++)\n",
"        for (int d5i = 0; d5i < d5_block; d5i++) {\n",
"            const int iter = d0i + d1i + d2i + d3i + d4i + d5i;\n",
"            const int src_off = SRC_OFF(\n",
"                    d0 + d0i, d1 + d1i, d2 + d2i, d3 + d3i, d4 + d4i, d5 + d5i);\n",
"#ifdef TRANSPOSE_NXN\n",
"            src_buf[iter] = SRC_BLOCK_READ(&src[src_off]);\n",
"#else\n",
"            tmp[sg_off + iter * SUB_GROUP_SIZE + sgId]\n",
"                    = SRC_BLOCK_READ(&src[src_off]);\n",
"#endif\n",
"        }\n",
"#ifdef TRANSPOSE_NXN\n",
"        // Share and transpose. Each work item keeps 1 own value and\n",
"        // gets (N-1) values from other work items\n",
"        dst_buf[sgId] = src_buf[sgId];\n",
"        for (int i = 1; i < SUB_GROUP_SIZE; i++) {\n",
"            send_buf = src_buf[(i + sgId) % BATCH_SIZE];\n",
"            dst_buf[(BATCH_SIZE + sgId - i) % BATCH_SIZE]\n",
"                    = intel_sub_group_shuffle(\n",
"                            send_buf, (BATCH_SIZE + sgId - i) % BATCH_SIZE);\n",
"        }\n",
"#endif\n",
"    }\n",
"    for_(int d0i = 0; d0i < d0_block; d0i++)\n",
"    for_(int d1i = 0; d1i < d1_block; d1i++)\n",
"    for_(int d2i = 0; d2i < d2_block; d2i++)\n",
"    for_(int d3i = 0; d3i < d3_block; d3i++)\n",
"    for_(int d4i = 0; d4i < d4_block; d4i++)\n",
"    for (int d5i = 0; d5i < d5_block; d5i++) {\n",
"        const int iter = d0i + d1i + d2i + d3i + d4i + d5i;\n",
"#if DST_BLOCK_DIM == 0\n",
"        const int dst_off = DST_OFF(d0 + iter, d1, d2, d3, d4, d5);\n",
"#elif DST_BLOCK_DIM == 1\n",
"        const int dst_off = DST_OFF(d0, d1 + iter, d2, d3, d4, d5);\n",
"#elif DST_BLOCK_DIM == 2\n",
"        const int dst_off = DST_OFF(d0, d1, d2 + iter, d3, d4, d5);\n",
"#elif DST_BLOCK_DIM == 3\n",
"        const int dst_off = DST_OFF(d0, d1, d2, d3 + iter, d4, d5);\n",
"#elif DST_BLOCK_DIM == 4\n",
"        const int dst_off = DST_OFF(d0, d1, d2, d3, d4 + iter, d5);\n",
"#elif DST_BLOCK_DIM == 5\n",
"        const int dst_off = DST_OFF(d0, d1, d2, d3, d4, d5 + iter);\n",
"#endif\n",
"        DST_DATA_T dst_tmp;\n",
"        if (!pad) {\n",
"#if WITH_SUM_AB\n",
"            dst_tmp = DST_BLOCK_READ(&dst[dst_off]);\n",
"#endif\n",
"#if SCALE_QUANT\n",
"            alpha = scales[SCALE_OFF(d0, d1, d2, d3, d4, d5)];\n",
"#endif\n",
"#ifdef TRANSPOSE_NXN\n",
"            REORDER(dst_tmp, dst_buf[iter], alpha, beta);\n",
"#else\n",
"            send_buf = tmp[sg_off + sgId * SUB_GROUP_SIZE + iter];\n",
"            REORDER(dst_tmp, send_buf, alpha, beta);\n",
"#endif\n",
"        } else {\n",
"            dst_tmp = 0;\n",
"        }\n",
"        DST_BLOCK_WRITE(&dst[dst_off], dst_tmp);\n",
"    }\n",
"#elif REORDER_NCHW\n",
"#define BIGGER_THAN_16 (SRC_D1 >= 16)\n",
"    int sgId = get_sub_group_local_id();\n",
"    const int d0 = GWS_GET_D0();\n",
"    const int d1 = GWS_GET_D1();\n",
"    const int d2 = GWS_GET_D2();\n",
"    const int d3 = GWS_GET_D3();\n",
"    const int d1_block = GWS_GET_D1_BLOCK();\n",
"    SRC_DATA_T src_buf[SUB_GROUP_SIZE];\n",
"    SRC_DATA_T dst_buf[SUB_GROUP_SIZE];\n",
"#if BIGGER_THAN_16\n",
"    SRC_DATA_T send_buf;\n",
"#else\n",
"    SRC_DATA_T exch_buf[d1_block][SUB_GROUP_SIZE];\n",
"#endif\n",
"#if BIGGER_THAN_16\n",
"#define STRIDE_S SRC_D1\n",
"#else\n",
"#define STRIDE_S 16\n",
"#endif\n",
"#define STRIDE_D (SRC_D2 * SRC_D3)\n",
"    for (int i = 0; i < d1_block; i++) {\n",
"        int src_off = SRC_OFF(d0, d1, d2, d3, 0, 0) + STRIDE_S * i;\n",
"        src_buf[i] = SRC_BLOCK_READ(&src[src_off]);\n",
"    }\n",
"#if BIGGER_THAN_16\n",
"    for (int i = 0; i < SUB_GROUP_SIZE; i++) {\n",
"        send_buf = src_buf[(i + sgId) % 16];\n",
"        dst_buf[(16 + sgId - i) % 16]\n",
"                = intel_sub_group_shuffle(send_buf, (16 + sgId - i) % 16);\n",
"    }\n",
"#else\n",
"    for (int i = 0; i < d1_block; i++) {\n",
"        for (int sg = 0; sg < SUB_GROUP_SIZE; sg++) {\n",
"            exch_buf[i][sg] = intel_sub_group_shuffle(src_buf[i], sg);\n",
"        }\n",
"    }\n",
"    for (int i = 0; i < d1_block; i++) {\n",
"        int ofs = i + sgId * d1_block;\n",
"        dst_buf[i] = exch_buf[ofs / SUB_GROUP_SIZE][ofs % SUB_GROUP_SIZE];\n",
"    }\n",
"#endif\n",
"    for (int i = 0; i < d1_block; i++) {\n",
"        int dst_off = DST_OFF(d0, d1, d2, d3, 0, 0) + STRIDE_D * i;\n",
"        DST_DATA_T dst_tmp;\n",
"#if WITH_SUM_AB\n",
"        dst_tmp = DST_BLOCK_READ(&dst[dst_off]);\n",
"#endif\n",
"        REORDER(dst_tmp, dst_buf[i], alpha, beta);\n",
"        DST_BLOCK_WRITE(&dst[dst_off], dst_tmp);\n",
"    }\n",
"#elif PLAIN_TO_ABCD4AXB\n",
"    int sglid = get_sub_group_local_id();\n",
"    const int d0 = GWS_GET_D0();\n",
"    const int d1 = GWS_GET_D1();\n",
"    const int d2 = GWS_GET_D2();\n",
"    const int d3 = GWS_GET_D3();\n",
"    const int d0_block = GWS_GET_D0_BLOCK();\n",
"    const int d1_block = GWS_GET_D1_BLOCK();\n",
"    const int d01_block = d0_block * d1_block;\n",
"    SRC_DATA_T tmp_buf[d01_block] = {0};\n",
"    const int d0_inner_block = min(d0_block, SRC_D0);\n",
"    const int d1_inner_block = min(d1_block, SRC_D1);\n",
"    for (int d0_inner = 0; d0_inner < d0_inner_block; d0_inner++) {\n",
"        for (int d1_inner = 0; d1_inner < d1_inner_block; d1_inner++) {\n",
"            if (SRC_D0 % d0_inner_block != 0 && d0 + d0_inner >= SRC_D0)\n",
"                continue;\n",
"            if (SRC_D1 % d1_inner_block != 0 && d1 + d1_inner >= SRC_D1)\n",
"                continue;\n",
"            if (SRC_S3_0 == 1) {\n",
"                // abcd layout.\n",
"                int src_off\n",
"                        = SRC_OFF(d0 + d0_inner, d1 + d1_inner, d2, d3, 0, 0);\n",
"                tmp_buf[d0_inner * d1_block + d1_inner]\n",
"                        = SRC_BLOCK_READ(&src[src_off]);\n",
"            } else {\n",
"                // acdb layout.\n",
"                int src_off = SRC_OFF(\n",
"                        d0 + d0_inner, d1 + d1_inner, d2, d3 + sglid, 0, 0);\n",
"                tmp_buf[d0_inner * d1_block + d1_inner] = src[src_off];\n",
"            }\n",
"        }\n",
"    }\n",
"    SRC_DATA_T src_all[d01_block][SUB_GROUP_SIZE];\n",
"    for (int i = 0; i < d01_block; i++)\n",
"        for (int j = 0; j < SUB_GROUP_SIZE; j++)\n",
"            src_all[i][j] = intel_sub_group_shuffle(tmp_buf[i], j);\n",
"    for (int d = 0; d < SUB_GROUP_SIZE; d += 8) {\n",
"        SRC_DATA8_T src_tmp;\n",
"        for (int i = 0; i < 8; i++)\n",
"            src_tmp[i] = src_all[sglid][d + i];\n",
"        int dst_off = DST_OFF(d0, d1, d2, d3 + d, 0, 0);\n",
"        DST_DATA8_T dst_tmp;\n",
"#if WITH_SUM_AB\n",
"        dst_tmp = DST_BLOCK_READ8(&dst[dst_off]);\n",
"#endif\n",
"        REORDER8(dst_tmp, src_tmp, alpha, beta);\n",
"        DST_BLOCK_WRITE8(&dst[dst_off], dst_tmp);\n",
"    }\n",
"#elif PLAIN_TO_AB_XX_8AYB\n",
"    // Reorders 2D plain format to a blocked one, where last two\n",
"    // blocks are 8a4b or 8a2b. Supports formats with more block layers.\n",
"    //\n",
"    // Uses subgroup size 16\n",
"    // Each subgroup will read 8 sets of 16 values. Sets are not\n",
"    // adjacent in src, they are strided by 0th dim\n",
"    // All those 8*16 values will be shared between work items in subgroup\n",
"    // Each WI selects a set of 8 values out of 8*16 to write back\n",
"    // Each subgroup will write 8 sets of 16 values. Sets are adjacent in dst.\n",
"    //\n",
"    // TODO: make it generic across number of dimensions, for now only works with 2D\n",
"    // TODO: reduce shuffles from 8*16 to 28(?) - even though it doesn't improve perf\n",
"    // TODO: the two dst_buf<-tmp_buf formulas should be unified\n",
"    int sgId = get_sub_group_local_id();\n",
"    const int d0 = GWS_GET_D0();\n",
"    const int d1 = GWS_GET_D1();\n",
"    const int d0b = GWS_GET_D0_BLOCK();\n",
"    const int d1b = GWS_GET_D1_BLOCK();\n",
"    SRC_DATA_T src_buf[d0b];\n",
"    DST_DATA_T dst_buf[d0b];\n",
"    for (int d0i = 0; d0i < d0b; ++d0i) {\n",
"        const int src_off = SRC_OFF(d0 + d0i, d1, 0, 0, 0, 0);\n",
"        src_buf[d0i] = SRC_BLOCK_READ(&src[src_off]);\n",
"    }\n",
"    SRC_DATA_T tmp_buf[d0b][SUB_GROUP_SIZE];\n",
"    for (int i = 0; i < d0b; i++) {\n",
"        for (int sg = 0; sg < SUB_GROUP_SIZE; sg++) {\n",
"            tmp_buf[i][sg] = intel_sub_group_shuffle(src_buf[i], sg);\n",
"        }\n",
"    }\n",
"#if BLK_L == 4\n",
"    for (int d0i = 0; d0i < d0b; ++d0i) {\n",
"        dst_buf[d0i] = tmp_buf[(d0i % 2 * BLK_L) + sgId / BLK_L]\n",
"                              [(d0i / 2) * BLK_L + sgId % BLK_L];\n",
"    }\n",
"#else // BLK_L == 2\n",
"    for (int d0i = 0; d0i < d0b; ++d0i) {\n",
"        dst_buf[d0i] = tmp_buf[sgId / BLK_L][d0i * BLK_L + sgId % BLK_L];\n",
"    }\n",
"#endif\n",
"    for (int d0i = 0; d0i < d0b; ++d0i) {\n",
"        const int dst_off = DST_OFF(d0, d1, 0, 0, 0, 0) + SUB_GROUP_SIZE * d0i;\n",
"        DST_DATA_T dst_tmp;\n",
"#if WITH_SUM_AB\n",
"        dst_tmp = DST_BLOCK_READ(&dst[dst_off]);\n",
"#endif\n",
"        REORDER(dst_tmp, dst_buf[d0i], alpha, beta);\n",
"        DST_BLOCK_WRITE(&dst[dst_off], dst_tmp);\n",
"    }\n",
"#elif VECTORIZE_LAST_DIM\n",
"    const int d0 = GWS_GET_D0();\n",
"    const int d1 = GWS_GET_D1();\n",
"    const int d2 = GWS_GET_D2();\n",
"    const int d3 = GWS_GET_D3();\n",
"    const int d4 = GWS_GET_D4();\n",
"    const int d5 = GWS_GET_D5();\n",
"    const int d0_block = GWS_GET_D0_BLOCK();\n",
"    const int d1_block = GWS_GET_D1_BLOCK();\n",
"    const int d2_block = GWS_GET_D2_BLOCK();\n",
"    const int d3_block = GWS_GET_D3_BLOCK();\n",
"    const int d4_block = GWS_GET_D4_BLOCK();\n",
"    for_(int d0i = 0; d0i < d0_block; d0i++)\n",
"    for_(int d1i = 0; d1i < d1_block; d1i++)\n",
"    for_(int d2i = 0; d2i < d2_block; d2i++)\n",
"    for_(int d3i = 0; d3i < d3_block; d3i++)\n",
"    for (int d4i = 0; d4i < d4_block; d4i++) {\n",
"        int src_off\n",
"                = SRC_OFF(d0 + d0i, d1 + d1i, d2 + d2i, d3 + d3i, d4 + d4i, d5);\n",
"        SRC_DATA_T src_tmp = SRC_BLOCK_READ(&src[src_off]);\n",
"        int dst_off\n",
"                = DST_OFF(d0 + d0i, d1 + d1i, d2 + d2i, d3 + d3i, d4 + d4i, d5);\n",
"        DST_DATA_T dst_tmp;\n",
"#if WITH_SUM_AB\n",
"        dst_tmp = DST_BLOCK_READ(&dst[dst_off]);\n",
"#endif\n",
"        REORDER(dst_tmp, src_tmp, alpha, beta);\n",
"        DST_BLOCK_WRITE(&dst[dst_off], dst_tmp);\n",
"    }\n",
"#elif PAD_INNERMOST\n",
"    int sgId = get_sub_group_local_id();\n",
"    int d[6];\n",
"    int blk[6];\n",
"    int b[6] = {0, 0, 0, 0, 0, 0};\n",
"    d[0] = GWS_GET_D0();\n",
"    d[1] = GWS_GET_D1();\n",
"    d[2] = GWS_GET_D2();\n",
"    d[3] = GWS_GET_D3();\n",
"    d[4] = GWS_GET_D4();\n",
"    d[5] = GWS_GET_D5();\n",
"    blk[0] = GWS_GET_D0_BLOCK();\n",
"    blk[1] = GWS_GET_D1_BLOCK();\n",
"    blk[2] = GWS_GET_D2_BLOCK();\n",
"    blk[3] = GWS_GET_D3_BLOCK();\n",
"    blk[4] = GWS_GET_D4_BLOCK();\n",
"    blk[5] = GWS_GET_D5_BLOCK();\n",
"    __local SRC_DATA_T cache[SG_PER_WG * GROUP * GROUP * VECT_SIZE];\n",
"    // offset to local memory for given subgroup\n",
"    int sg_off = get_sub_group_id() * VECT_SIZE * (GROUP * GROUP);\n",
"    for (int i = 0; i < blk[SRC_LOOP_DIM]; i++) {\n",
"        b[SRC_LOOP_DIM] = i;\n",
"        const int src_off = SRC_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],\n",
"                d[3] + b[3], d[4] + b[4], d[5] + b[5]);\n",
"        unroll_for(int j = 0; j < GROUP; j++) {\n",
"            int coff = sg_off + VECT_SIZE * GROUP * i + VECT_SIZE * j;\n",
"            int soff = src_off + INNERMOST_SIZE * j;\n",
"            if (sgId < INNERMOST_SIZE) {\n",
"                cache[coff + sgId] = src[soff + sgId];\n",
"            } else {\n",
"                cache[coff + sgId] = 0;\n",
"            }\n",
"        }\n",
"    }\n",
"    b[SRC_LOOP_DIM] = 0;\n",
"    for (int i = 0; i < blk[DST_LOOP_DIM]; i++) {\n",
"        b[DST_LOOP_DIM] = i;\n",
"        const int dst_off = DST_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],\n",
"                d[3] + b[3], d[4] + b[4], d[5] + b[5]);\n",
"        unroll_for(int j = 0; j < GROUP; j++) {\n",
"            int coff = sg_off + VECT_SIZE * GROUP * j + VECT_SIZE * i;\n",
"            int doff = dst_off + VECT_SIZE * j;\n",
"            DST_DATA_T dst_tmp;\n",
"#if WITH_SUM_AB\n",
"            dst_tmp = DST_BLOCK_READ(&dst[doff + sgId]);\n",
"#endif\n",
"            REORDER(dst_tmp, cache[coff + sgId], alpha, beta);\n",
"            dst[doff + sgId] = dst_tmp;\n",
"        }\n",
"    }\n",
"#elif VECTORIZE_GROUPS\n",
"    int d[6];\n",
"    int blk[6];\n",
"    int b[6] = {0, 0, 0, 0, 0, 0};\n",
"    d[0] = GWS_GET_D0();\n",
"    d[1] = GWS_GET_D1();\n",
"    d[2] = GWS_GET_D2();\n",
"    d[3] = GWS_GET_D3();\n",
"    d[4] = GWS_GET_D4();\n",
"    d[5] = GWS_GET_D5();\n",
"    blk[0] = GWS_GET_D0_BLOCK();\n",
"    blk[1] = GWS_GET_D1_BLOCK();\n",
"    blk[2] = GWS_GET_D2_BLOCK();\n",
"    blk[3] = GWS_GET_D3_BLOCK();\n",
"    blk[4] = GWS_GET_D4_BLOCK();\n",
"    blk[5] = GWS_GET_D5_BLOCK();\n",
"    SRC_DATA_T cache[GROUP * GROUP];\n",
"    // there will be blocks on 2 dimensions\n",
"    // order of loops is important: one dim gets adjacent data, the other does not\n",
"    // that order will be inverted in dst's loops\n",
"    // There will be GROUP reads of SIMD{VECT} items, each with\n",
"    // sizeof(SRC_DATA_T) bytes, and they all point to contiguous mem area.\n",
"    // GROUP and VECT must be selected in such way that resulting mem\n",
"    // accesses could be combined into full cache line accesses by mem ccontroller\n",
"    int coeff = (VECT_DIM == SRC_LOOP_DIM ? get_sub_group_size() : 1);\n",
"    for (int i = 0; i < blk[SRC_LOOP_DIM]; i++) {\n",
"        b[SRC_LOOP_DIM] = coeff * i;\n",
"        const int src_off = SRC_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],\n",
"                d[3] + b[3], d[4] + b[4], d[5] + b[5]);\n",
"        unroll_for(int j = 0; j < GROUP; j++) {\n",
"            int cidx = GROUP * i + j;\n",
"            int sidx = src_off + get_sub_group_size() * j;\n",
"            cache[cidx] = SRC_BLOCK_READ(&src[sidx]);\n",
"        }\n",
"    }\n",
"    b[SRC_LOOP_DIM] = 0;\n",
"    coeff = (VECT_DIM == DST_LOOP_DIM ? get_sub_group_size() : 1);\n",
"    for (int i = 0; i < blk[DST_LOOP_DIM]; i++) {\n",
"        b[DST_LOOP_DIM] = coeff * i;\n",
"        const int dst_off = DST_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],\n",
"                d[3] + b[3], d[4] + b[4], d[5] + b[5]);\n",
"        unroll_for(int j = 0; j < GROUP; j++) {\n",
"            int cidx = i + j * GROUP;\n",
"            int didx = dst_off + get_sub_group_size() * j;\n",
"            DST_DATA_T dst_tmp;\n",
"#if WITH_SUM_AB\n",
"            dst_tmp = DST_BLOCK_READ(&dst[didx]);\n",
"#endif\n",
"            REORDER(dst_tmp, cache[cidx], alpha, beta);\n",
"            DST_BLOCK_WRITE(&dst[didx], dst_tmp);\n",
"        }\n",
"    }\n",
"#elif USE_DENSE_VECT\n",
"    const int d0_blk_start = GWS_GET_D0();\n",
"    const int d0_blk_end = d0_blk_start + (GWS_GET_D0_BLOCK() * 16);\n",
"    for (int d0 = d0_blk_start; d0 < d0_blk_end; d0 += 128) {\n",
"        SRC_DATA8_T src_tmp = SRC_BLOCK_READ8(&src[d0]);\n",
"        DST_DATA8_T dst_tmp;\n",
"#if WITH_SUM_AB\n",
"        dst_tmp = DST_BLOCK_READ8(&dst[d0]);\n",
"#endif\n",
"        REORDER8(dst_tmp, src_tmp, alpha, beta);\n",
"        DST_BLOCK_WRITE8(&dst[d0], dst_tmp);\n",
"    }\n",
"#else // unroll_* kernels start here\n",
"    const int d0 = GWS_GET_D0();\n",
"    const int d1 = GWS_GET_D1();\n",
"    const int d2 = GWS_GET_D2();\n",
"    const int d3 = GWS_GET_D3();\n",
"    const int d4 = GWS_GET_D4();\n",
"    const int d5 = GWS_GET_D5();\n",
"    const int local_id = get_sub_group_local_id();\n",
"// unroll_16a16b\n",
"#if SRC_16A16B || DST_16A16B || SRC_16B16A || DST_16B16A\n",
"    src += SRC_OFF(d0, d1, d2, d3, d4, d5);\n",
"    dst += DST_OFF(d0, d1, d2, d3, d4, d5);\n",
"    SRC_DATA8_T in0, in1;\n",
"#if SRC_16A16B || SRC_16B16A\n",
"    in0 = SRC_BLOCK_READ8(&src[0]);\n",
"    in1 = SRC_BLOCK_READ8(&src[8 * 16]);\n",
"#else\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if DST_16B16A\n",
"        in0[i] = src[SRC_OFF(local_id, i, 0, 0, 0, 0)];\n",
"        in1[i] = src[SRC_OFF(local_id, i + 8, 0, 0, 0, 0)];\n",
"#else\n",
"        in0[i] = src[SRC_OFF(i, local_id, 0, 0, 0, 0)];\n",
"        in1[i] = src[SRC_OFF(i + 8, local_id, 0, 0, 0, 0)];\n",
"#endif // DST_16B16A\n",
"    }\n",
"#endif // SRC_16A16B || SRC_16B16A\n",
"    DST_DATA8_T dst0, dst1;\n",
"#if (SRC_16A16B || SRC_16B16A) && (DST_16A16B || DST_16B16A)\n",
"#if WITH_SUM_AB\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if SRC_16B16A\n",
"        dst0[i] = dst[DST_OFF(local_id, i + 0, 0, 0, 0, 0)];\n",
"        dst1[i] = dst[DST_OFF(local_id, i + 8, 0, 0, 0, 0)];\n",
"#else\n",
"        dst0[i] = dst[DST_OFF(i + 0, local_id, 0, 0, 0, 0)];\n",
"        dst1[i] = dst[DST_OFF(i + 8, local_id, 0, 0, 0, 0)];\n",
"#endif // SRC_16B16A\n",
"    }\n",
"#endif // WITH_SUM_AB\n",
"#elif DST_16A16B || DST_16B16A\n",
"#if WITH_SUM_AB\n",
"    dst0 = DST_BLOCK_READ8(&dst[0]);\n",
"    dst1 = DST_BLOCK_READ8(&dst[8 * 16]);\n",
"#endif // WITH_SUM_AB\n",
"#else\n",
"#if WITH_SUM_AB\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if SRC_16B16A\n",
"        dst0[i] = dst[DST_OFF(local_id, i + 0, 0, 0, 0, 0)];\n",
"        dst1[i] = dst[DST_OFF(local_id, i + 8, 0, 0, 0, 0)];\n",
"#else\n",
"        dst0[i] = dst[DST_OFF(i + 0, local_id, 0, 0, 0, 0)];\n",
"        dst1[i] = dst[DST_OFF(i + 8, local_id, 0, 0, 0, 0)];\n",
"#endif // SRC_16B16A\n",
"    }\n",
"#endif // WITH_SUM_AB\n",
"#endif // (SRC_16A16B || SRC_16B16A) && (DST_16A16B || DST_16B16A)\n",
"    REORDER8(dst0, in0, alpha, beta);\n",
"    REORDER8(dst1, in1, alpha, beta);\n",
"#if (SRC_16A16B || SRC_16B16A) && (DST_16A16B || DST_16B16A)\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if SRC_16B16A\n",
"        dst[DST_OFF(local_id, i + 0, 0, 0, 0, 0)] = dst0[i];\n",
"        dst[DST_OFF(local_id, i + 8, 0, 0, 0, 0)] = dst1[i];\n",
"#else\n",
"        dst[DST_OFF(i + 0, local_id, 0, 0, 0, 0)] = dst0[i];\n",
"        dst[DST_OFF(i + 8, local_id, 0, 0, 0, 0)] = dst1[i];\n",
"#endif // SRC_16B16A\n",
"    }\n",
"#elif DST_16A16B || DST_16B16A\n",
"    DST_BLOCK_WRITE8(&dst[0], dst0);\n",
"    DST_BLOCK_WRITE8(&dst[8 * 16], dst1);\n",
"#else\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if SRC_16B16A\n",
"        dst[DST_OFF(local_id, i + 0, 0, 0, 0, 0)] = dst0[i];\n",
"        dst[DST_OFF(local_id, i + 8, 0, 0, 0, 0)] = dst1[i];\n",
"#else\n",
"        dst[DST_OFF(i + 0, local_id, 0, 0, 0, 0)] = dst0[i];\n",
"        dst[DST_OFF(i + 8, local_id, 0, 0, 0, 0)] = dst1[i];\n",
"#endif // SRC_16B16A\n",
"    }\n",
"#endif // (SRC_16A16B || SRC_16B16A) && (DST_16A16B || DST_16B16A)\n",
"// unroll_16b\n",
"#elif SRC_16B || DST_16B\n",
"    SRC_DATA_T src_tmp;\n",
"#if SRC_16B\n",
"    src += SRC_OFF(d0, d1, d2, d3, d4, d5);\n",
"    src_tmp = SRC_BLOCK_READ(&src[0]);\n",
"#else\n",
"    src += SRC_OFF(d0, d1 + local_id, d2, d3, d4, d5);\n",
"    src_tmp = src[0];\n",
"#endif // SRC_16B\n",
"    DST_DATA_T dst_tmp;\n",
"#if DST_16B\n",
"    dst += DST_OFF(d0, d1, d2, d3, d4, d5);\n",
"#if WITH_SUM_AB\n",
"    dst_tmp = DST_BLOCK_READ(&dst[0]);\n",
"#endif // WITH_SUM_AB\n",
"#else\n",
"    dst += DST_OFF(d0, d1 + local_id, d2, d3, d4, d5);\n",
"#if WITH_SUM_AB\n",
"    dst_tmp = dst[0];\n",
"#endif // WITH_SUM_AB\n",
"#endif // DST_16B\n",
"    REORDER(dst_tmp, src_tmp, alpha, beta);\n",
"#if DST_16B\n",
"    DST_BLOCK_WRITE(&dst[0], dst_tmp);\n",
"#else\n",
"    dst[0] = dst_tmp;\n",
"#endif // DST_16B\n",
"// unroll_16b16c\n",
"#elif SRC_16B16C || DST_16B16C || SRC_16C16B || DST_16C16B\n",
"    const int g = d0;\n",
"    SRC_DATA8_T in0, in1;\n",
"#if SRC_16B16C || SRC_16C16B\n",
"    src += SRC_OFF_G(g, d1, d2, d3, d4, d5);\n",
"    in0 = SRC_BLOCK_READ8(&src[0]);\n",
"    in1 = SRC_BLOCK_READ8(&src[8 * 16]);\n",
"#else\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if DST_16C16B\n",
"        in0[i] = src[SRC_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)];\n",
"        in1[i] = src[SRC_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)];\n",
"#else\n",
"        in0[i] = src[SRC_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)];\n",
"        in1[i] = src[SRC_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)];\n",
"#endif // DST_16C16B\n",
"    }\n",
"#endif // SRC_16B16C || SRC_16C16B\n",
"    DST_DATA8_T dst0, dst1;\n",
"#if (SRC_16B16C || SRC_16C16B) && (DST_16B16C || DST_16C16B)\n",
"#if WITH_SUM_AB\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if SRC_16C16B\n",
"        dst0[i] = dst[DST_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)];\n",
"        dst1[i] = dst[DST_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)];\n",
"#else\n",
"        dst0[i] = dst[DST_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)];\n",
"        dst1[i] = dst[DST_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)];\n",
"#endif // SRC_16C16B\n",
"    }\n",
"#endif // WITH_SUM_AB\n",
"#elif DST_16B16C || DST_16C16B\n",
"    dst += DST_OFF_G(g, d1, d2, d3, d4, d5);\n",
"#if WITH_SUM_AB\n",
"    dst0 = DST_BLOCK_READ8(&dst[0]);\n",
"    dst1 = DST_BLOCK_READ8(&dst[8 * 16]);\n",
"#endif // WITH_SUM_AB\n",
"#else\n",
"#if WITH_SUM_AB\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if SRC_16C16B\n",
"        dst0[i] = dst[DST_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)];\n",
"        dst1[i] = dst[DST_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)];\n",
"#else\n",
"        dst0[i] = dst[DST_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)];\n",
"        dst1[i] = dst[DST_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)];\n",
"#endif // SRC_16C16B\n",
"    }\n",
"#endif // WITH_SUM_AB\n",
"#endif // (SRC_16B16C || SRC_16C16B) && (DST_16B16C || DST_16C16B)\n",
"    REORDER8(dst0, in0, alpha, beta);\n",
"    REORDER8(dst1, in1, alpha, beta);\n",
"#if (SRC_16B16C || SRC_16C16B) && (DST_16B16C || DST_16C16B)\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if SRC_16C16B\n",
"        dst[DST_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)] = dst0[i];\n",
"        dst[DST_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)] = dst1[i];\n",
"#else\n",
"        dst[DST_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)] = dst0[i];\n",
"        dst[DST_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)] = dst1[i];\n",
"#endif // SRC_16C16B\n",
"    }\n",
"#elif DST_16B16C || DST_16C16B\n",
"    DST_BLOCK_WRITE8(&dst[0], dst0);\n",
"    DST_BLOCK_WRITE8(&dst[8 * 16], dst1);\n",
"#else\n",
"    for (int i = 0; i < 8; i++) {\n",
"#if SRC_16C16B\n",
"        dst[DST_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)] = dst0[i];\n",
"        dst[DST_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)] = dst1[i];\n",
"#else\n",
"        dst[DST_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)] = dst0[i];\n",
"        dst[DST_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)] = dst1[i];\n",
"#endif // SRC_16C16B\n",
"    }\n",
"#endif // (SRC_16B16C || SRC_16C16B) && (DST_16B16C || DST_16C16B)\n",
"#endif // SRC_16B16C || DST_16B16C || SRC_16C16B || DST_16C16B\n",
"#endif // REF_REORDER, PLAIN_xFxE_TO_ABCDEF, TRANSPOSE_16X16 etc.\n",
"}", nullptr };
}
}
}
}