namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_fwd_data_kernel[] ={ "/*******************************************************************************\n",
"* Copyright 2020-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_POST_OPS_H\n",
"#define GPU_OCL_OCL_POST_OPS_H\n",
"#ifndef SUB_GROUP_SIZE\n",
"#define SUB_GROUP_SIZE get_sub_group_size()\n",
"#endif\n",
"#if WITH_POST_OP\n",
"#if !WITH_ELTWISE\n",
"#undef WITH_ELTWISE\n",
"#define WITH_ELTWISE 1\n",
"#endif\n",
"/*******************************************************************************\n",
"* Copyright 2020-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_ELTWISE_H\n",
"#define GPU_OCL_OCL_ELTWISE_H\n",
"#if WITH_ELTWISE\n",
"#if DT_F16 == 1\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#ifndef DATA_MAX\n",
"#if DT_F16 == 1\n",
"#define DATA_MAX HALF_MAX\n",
"#elif DT_S8 == 1\n",
"#define DATA_MAX CHAR_MAX\n",
"#elif DT_U8 == 1\n",
"#define DATA_MAX UCHAR_MAX\n",
"#else\n",
"#define DATA_MAX FLT_MAX\n",
"#endif\n",
"#endif\n",
"#ifndef ELTWISE_ALPHA0\n",
"#define ELTWISE_ALPHA0 0\n",
"#endif\n",
"float relu_fwd(float s, float alpha) {\n",
"    return s > 0 ? s : (ELTWISE_ALPHA0 ? 0 : s * alpha);\n",
"}\n",
"float relu_bwd(float dd, float s, float alpha) {\n",
"    return s > 0 ? dd : dd * alpha;\n",
"}\n",
"float relu_bwd_use_dst(float dd, float d, float alpha) {\n",
"    return d > 0 ? dd : dd * alpha;\n",
"}\n",
"float linear_fwd(float s, float alpha, float beta) {\n",
"    return alpha * s + beta;\n",
"}\n",
"float linear_bwd(float dd, float alpha) {\n",
"    return dd * alpha;\n",
"}\n",
"float bounded_relu_fwd(float s, float alpha) {\n",
"    s = s > 0 ? s : 0;\n",
"    return s > alpha ? alpha : s;\n",
"}\n",
"float bounded_relu_bwd(float dd, float s, float alpha) {\n",
"    return dd * (0 < s && s <= alpha ? 1 : 0);\n",
"}\n",
"float soft_relu_fwd(float s) {\n",
"    return s < log((float)DATA_MAX) ? log1p(exp(s)) : s;\n",
"}\n",
"float soft_relu_bwd(float dd, float s) {\n",
"    return dd / (1 + exp(-s));\n",
"}\n",
"float logsigmoid_fwd(float s) {\n",
"    return -soft_relu_fwd(-s);\n",
"}\n",
"float logsigmoid_bwd(float dd, float s) {\n",
"    return soft_relu_bwd(dd, -s);\n",
"}\n",
"float logistic_fwd(float s) {\n",
"    return 1.0f / (1.0f + exp(-s));\n",
"}\n",
"float logistic_bwd(float dd, float s) {\n",
"    float v = logistic_fwd(s);\n",
"    return dd * v * (1 - v);\n",
"}\n",
"float logistic_bwd_use_dst(float dd, float d) {\n",
"    return dd * d * (1 - d);\n",
"}\n",
"float square_fwd(float s) {\n",
"    return s * s;\n",
"}\n",
"float square_bwd(float dd, float s) {\n",
"    return dd * 2 * s;\n",
"}\n",
"float sqrt_fwd(float s) {\n",
"    return sqrt(s);\n",
"}\n",
"float sqrt_bwd(float dd, float s) {\n",
"    return dd / (2 * sqrt(s));\n",
"}\n",
"float sqrt_bwd_use_dst(float dd, float d) {\n",
"    return dd / (2 * d);\n",
"}\n",
"float abs_fwd(float s) {\n",
"    return s > 0 ? s : -s;\n",
"}\n",
"float abs_bwd(float dd, float s) {\n",
"    return s > 0 ? dd : s < 0 ? -dd : 0;\n",
"}\n",
"float tanh_fwd(float s) {\n",
"    return tanh(s);\n",
"}\n",
"float tanh_bwd(float dd, float s) {\n",
"    float e = tanh_fwd(s);\n",
"    return dd * (1 - e) * (1 + e);\n",
"}\n",
"float tanh_bwd_use_dst(float dd, float d) {\n",
"    return dd * (1 - d) * (1 + d);\n",
"}\n",
"float mish_fwd(float s) {\n",
"    return s * tanh_fwd(soft_relu_fwd(s));\n",
"}\n",
"float mish_bwd(float dd, float s) {\n",
"    const float tanh = tanh_fwd(soft_relu_fwd(s));\n",
"    const float srelu_bwd = soft_relu_bwd(1.0f, s);\n",
"    const float derivative = tanh + s * srelu_bwd * (1 - pow(tanh, 2.0f));\n",
"    return dd * derivative;\n",
"}\n",
"float elu_fwd(float s, float alpha) {\n",
"    return s > 0 ? s : alpha * expm1(s);\n",
"}\n",
"float elu_bwd(float dd, float s, float alpha) {\n",
"    return dd * (s > 0 ? 1 : alpha * exp(s));\n",
"}\n",
"float elu_bwd_use_dst(float dd, float d, float alpha) {\n",
"    return dd * (d > 0 ? 1 : d + alpha);\n",
"}\n",
"float exp_fwd(float s) {\n",
"    return exp(s);\n",
"}\n",
"float exp_bwd(float dd, float s) {\n",
"    return dd * exp_fwd(s);\n",
"}\n",
"float exp_bwd_use_dst(float dd, float d) {\n",
"    return dd * d;\n",
"}\n",
"float gelu_tanh_fwd(float s) {\n",
"    const float sqrt_2_over_pi = 0.79788458347320556640625f;\n",
"    const float fitting_const = 0.044715f;\n",
"    const float g = sqrt_2_over_pi * s * (1.f + fitting_const * s * s);\n",
"    return (0.5f * s * (1.f + tanh_fwd(g)));\n",
"}\n",
"float gelu_tanh_bwd(float dd, float s) {\n",
"    const float sqrt_2_over_pi = 0.79788458347320556640625f;\n",
"    const float fitting_const = 0.044715f;\n",
"    const float g = sqrt_2_over_pi * s * (1.f + fitting_const * s * s);\n",
"    const float dg = sqrt_2_over_pi * (1.f + 3.f * fitting_const * s * s);\n",
"    const float v = tanh_fwd(g);\n",
"    return dd * 0.5f * (1.f + v) * (1.f + s * (1.f - v) * dg);\n",
"}\n",
"float swish_fwd(float s, float alpha) {\n",
"    float w = -alpha * s;\n",
"    return s / (1.0f + exp(w));\n",
"}\n",
"float swish_bwd(float dd, float s, float alpha) {\n",
"    float v = logistic_fwd(alpha * s);\n",
"    return dd * (v + s * alpha * v * (1.0f - v));\n",
"}\n",
"float log_fwd(float s) {\n",
"    return log(s);\n",
"}\n",
"float log_bwd(float dd, float s) {\n",
"    return dd / s;\n",
"}\n",
"float clip_fwd(float s, float alpha, float beta) {\n",
"    s = s > alpha ? s : alpha;\n",
"    return s > beta ? beta : s;\n",
"}\n",
"float clip_bwd(float dd, float s, float alpha, float beta) {\n",
"    return dd * (alpha < s && s <= beta ? 1 : 0);\n",
"}\n",
"float clip_v2_fwd(float s, float alpha, float beta) {\n",
"    s = s > alpha ? s : alpha;\n",
"    return s < beta ? s : beta;\n",
"}\n",
"float clip_v2_bwd(float dd, float s, float alpha, float beta) {\n",
"    return dd * (alpha < s && s < beta ? 1 : 0);\n",
"}\n",
"float clip_v2_bwd_use_dst(float dd, float d, float alpha, float beta) {\n",
"    return dd * (alpha < d && d < beta ? 1 : 0);\n",
"}\n",
"float pow_fwd(float s, float alpha, float beta) {\n",
"    return alpha * pow(s, beta);\n",
"}\n",
"float pow_bwd(float dd, float s, float alpha, float beta) {\n",
"    if (beta == 0) return 0;\n",
"    float v = pow_fwd(s, alpha * beta, beta - 1);\n",
"    return dd * v;\n",
"}\n",
"float gelu_erf_fwd(float s) {\n",
"    const float sqrt_2_over_2 = 0.707106769084930419921875f;\n",
"    float v = s * sqrt_2_over_2;\n",
"    return 0.5f * s * (1.f + erf(v));\n",
"}\n",
"float gelu_erf_bwd(float dd, float s) {\n",
"    const float two_over_sqrt_pi = 1.12837922573089599609375f;\n",
"    const float sqrt_2_over_2 = 0.707106769084930419921875f;\n",
"    float v = s * sqrt_2_over_2;\n",
"    return dd * 0.5f * (1.f + erf(v) + v * two_over_sqrt_pi * exp(-v * v));\n",
"}\n",
"float round_fwd(float s) {\n",
"    return (float)rint((float)s);\n",
"}\n",
"float hardswish_fwd(float s) {\n",
"    return (s / 6.f) * bounded_relu_fwd(s + 3.f, 6.f);\n",
"}\n",
"float hardswish_bwd(float dd, float s) {\n",
"    return (s < 3.f && s > -3.f ? dd * (2 * s + 3.f) / 6.f\n",
"                                : s >= 3.f ? dd : 0.f);\n",
"}\n",
"float fwd_eltwise_common(\n",
"        int eltwise_alg, float x, float alpha_, float beta_, float scale_) {\n",
"    switch (eltwise_alg) {\n",
"        case RELU: return scale_ * relu_fwd(x, alpha_); break;\n",
"        case LINEAR: return scale_ * linear_fwd(x, alpha_, beta_); break;\n",
"        case BOUNDED_RELU: return scale_ * bounded_relu_fwd(x, alpha_); break;\n",
"        case SOFT_RELU: return scale_ * soft_relu_fwd(x); break;\n",
"        case LOGSIGMOID: return scale_ * logsigmoid_fwd(x); break;\n",
"        case MISH: return scale_ * mish_fwd(x); break;\n",
"        case LOGISTIC: return scale_ * logistic_fwd(x); break;\n",
"        case TANH: return scale_ * tanh_fwd(x); break;\n",
"        case ELU: return scale_ * elu_fwd(x, alpha_); break;\n",
"        case SQUARE: return scale_ * square_fwd(x); break;\n",
"        case SQRT: return scale_ * sqrt_fwd(x); break;\n",
"        case ABS: return scale_ * abs_fwd(x); break;\n",
"        case EXP: return scale_ * exp_fwd(x); break;\n",
"        case GELU_TANH: return scale_ * gelu_tanh_fwd(x); break;\n",
"        case SWISH: return scale_ * swish_fwd(x, alpha_); break;\n",
"        case LOG: return scale_ * log_fwd(x); break;\n",
"        case CLIP: return scale_ * clip_fwd(x, alpha_, beta_); break;\n",
"        case CLIP_V2: return scale_ * clip_v2_fwd(x, alpha_, beta_); break;\n",
"        case POW: return scale_ * pow_fwd(x, alpha_, beta_); break;\n",
"        case GELU_ERF: return scale_ * gelu_erf_fwd(x); break;\n",
"        case ROUND: return scale_ * round_fwd(x); break;\n",
"        case RELU_DST: return scale_ * relu_fwd(x, alpha_); break;\n",
"        case LOGISTIC_DST: return scale_ * logistic_fwd(x); break;\n",
"        case TANH_DST: return scale_ * tanh_fwd(x); break;\n",
"        case ELU_DST: return scale_ * elu_fwd(x, alpha_); break;\n",
"        case SQRT_DST: return scale_ * sqrt_fwd(x); break;\n",
"        case EXP_DST: return scale_ * exp_fwd(x); break;\n",
"        case CLIP_V2_DST: return scale_ * clip_v2_fwd(x, alpha_, beta_); break;\n",
"        case HARDSWISH: return scale_ * hardswish_fwd(x); break;\n",
"        default: return x; break;\n",
"    }\n",
"}\n",
"float fwd_eltwise(float x, float alpha_, float beta_, float scale_) {\n",
"#ifdef ELTWISE_ALG\n",
"    return fwd_eltwise_common(ELTWISE_ALG, x, alpha_, beta_, scale_);\n",
"#else\n",
"    return x;\n",
"#endif\n",
"}\n",
"float bwd_eltwise(float x, float y, float alpha_, float beta_) {\n",
"#ifdef ELTWISE_ALG\n",
"    switch (ELTWISE_ALG) {\n",
"        case RELU: return relu_bwd(x, y, alpha_); break;\n",
"        case LINEAR: return linear_bwd(x, alpha_); break;\n",
"        case BOUNDED_RELU: return bounded_relu_bwd(x, y, alpha_); break;\n",
"        case SOFT_RELU: return soft_relu_bwd(x, y); break;\n",
"        case LOGSIGMOID: return logsigmoid_bwd(x, y); break;\n",
"        case MISH: return mish_bwd(x, y); break;\n",
"        case LOGISTIC: return logistic_bwd(x, y); break;\n",
"        case TANH: return tanh_bwd(x, y); break;\n",
"        case ELU: return elu_bwd(x, y, alpha_); break;\n",
"        case SQUARE: return square_bwd(x, y); break;\n",
"        case SQRT: return sqrt_bwd(x, y); break;\n",
"        case ABS: return abs_bwd(x, y); break;\n",
"        case EXP: return exp_bwd(x, y); break;\n",
"        case GELU_TANH: return gelu_tanh_bwd(x, y); break;\n",
"        case SWISH: return swish_bwd(x, y, alpha_); break;\n",
"        case LOG: return log_bwd(x, y); break;\n",
"        case CLIP: return clip_bwd(x, y, alpha_, beta_); break;\n",
"        case CLIP_V2: return clip_v2_bwd(x, y, alpha_, beta_); break;\n",
"        case POW: return pow_bwd(x, y, alpha_, beta_); break;\n",
"        case GELU_ERF: return gelu_erf_bwd(x, y); break;\n",
"        case HARDSWISH: return hardswish_bwd(x, y); break;\n",
"        case RELU_DST: return relu_bwd_use_dst(x, y, alpha_); break;\n",
"        case LOGISTIC_DST: return logistic_bwd_use_dst(x, y); break;\n",
"        case TANH_DST: return tanh_bwd_use_dst(x, y); break;\n",
"        case ELU_DST: return elu_bwd_use_dst(x, y, alpha_); break;\n",
"        case SQRT_DST: return sqrt_bwd_use_dst(x, y); break;\n",
"        case EXP_DST: return exp_bwd_use_dst(x, y); break;\n",
"        case CLIP_V2_DST:\n",
"            return clip_v2_bwd_use_dst(x, y, alpha_, beta_);\n",
"            break;\n",
"        default: return x; break;\n",
"    }\n",
"#else\n",
"    return x;\n",
"#endif\n",
"}\n",
"#endif // WITH_ELTWISE\n",
"#endif // GPU_OCL_OCL_ELTWISE_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_TYPES_H\n",
"#define GPU_OCL_OCL_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#define unroll_for __attribute__((opencl_unroll_hint)) for\n",
"#define for_ for\n",
"#define CONCAt2(a, b) a##b\n",
"#define CONCAT2(a, b) CONCAt2(a, b)\n",
"#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c)\n",
"#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \\\n",
"        || defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \\\n",
"        || defined(BIA_DT_F16) || defined(ACC_DT_F16)\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#if DT_F32 == 1\n",
"#define DATA_T float\n",
"#define DATA2_T float2\n",
"#define DATA4_T float4\n",
"#define DATA8_T float8\n",
"#define DATA16_T float16\n",
"#define DATA_MAX FLT_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) (float)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_float\n",
"#define CONVERT_DATA2_T convert_float2\n",
"#define CONVERT_DATA4_T convert_float4\n",
"#define CONVERT_DATA8_T convert_float8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_float\n",
"#define AS_DATA2_T as_float2\n",
"#define AS_DATA4_T as_float4\n",
"#define AS_DATA8_T as_float8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif DT_F16 == 1\n",
"#define DATA_T half\n",
"#define DATA2_T half2\n",
"#define DATA4_T half4\n",
"#define DATA8_T half8\n",
"#define DATA16_T half16\n",
"#define DATA_MAX HALF_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0h\n",
"#define DATA_ONE 1.0h\n",
"#define DEF_ACC_DATA_T half\n",
"#define DEF_ACC_DATA2_T half2\n",
"#define DEF_ACC_DATA4_T half4\n",
"#define DEF_ACC_DATA8_T half8\n",
"#define POST_OP_DATA_T half\n",
"#define TO_DATA_T(v) (half)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (half)(v)\n",
"#define DATA_TO_REF convert_half\n",
"#define CONVERT_DATA_T convert_half\n",
"#define CONVERT_DATA2_T convert_half2\n",
"#define CONVERT_DATA4_T convert_half4\n",
"#define CONVERT_DATA8_T convert_half8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_half\n",
"#define AS_DATA2_T as_half2\n",
"#define AS_DATA4_T as_half4\n",
"#define AS_DATA8_T as_half8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_BF16 == 1\n",
"#define DATA_T ushort\n",
"#define POST_OP_DATA_T float\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define DATA16_T ushort16\n",
"#define DATA_MAX as_float(0x7f7f0000)\n",
"#define DATA_MIN (-DATA_MAX)\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define TO_DATA_T(v) cvt_f32_to_bf16(v)\n",
"#define TO_DEF_ACC_DATA_T(v) cvt_bf16_to_f32(v)\n",
"#define DATA_TO_REF cvt_bf16_to_f32\n",
"#define CONVERT_DATA_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA2_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA4_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA8_T cvt_f32_to_bf16\n",
"#define CONVERT_FLOAT_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT2_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT4_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT8_T cvt_bf16_to_f32\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_ushort\n",
"#define AS_DATA2_T as_ushort2\n",
"#define AS_DATA4_T as_ushort4\n",
"#define AS_DATA8_T as_ushort8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_S8 == 1\n",
"#define DATA_T char\n",
"#define DATA2_T char2\n",
"#define DATA4_T char4\n",
"#define DATA8_T char8\n",
"#define DATA16_T char16\n",
"#define DATA_MAX CHAR_MAX\n",
"#define DATA_MIN CHAR_MIN\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T int8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_char_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_char_sat_rte\n",
"#define CONVERT_DATA2_T convert_char2_sat_rte\n",
"#define CONVERT_DATA4_T convert_char4_sat_rte\n",
"#define CONVERT_DATA8_T convert_char8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_char\n",
"#define AS_DATA2_T as_char2\n",
"#define AS_DATA4_T as_char4\n",
"#define AS_DATA8_T as_char8\n",
"#define AS_DATA16_T as_char16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_int8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_U8 == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define DATA16_T uchar16\n",
"#define DATA_MAX UCHAR_MAX\n",
"#define DATA_MIN 0\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T uint8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_uchar_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_uchar_sat_rte\n",
"#define CONVERT_DATA2_T convert_uchar2_sat_rte\n",
"#define CONVERT_DATA4_T convert_uchar4_sat_rte\n",
"#define CONVERT_DATA8_T convert_uchar8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_uchar\n",
"#define AS_DATA2_T as_uchar2\n",
"#define AS_DATA4_T as_uchar4\n",
"#define AS_DATA8_T as_uchar8\n",
"#define AS_DATA16_T as_uchar16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_uint8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_S32 == 1\n",
"#define DATA_T int\n",
"#define DATA2_T int2\n",
"#define DATA4_T int4\n",
"#define DATA8_T int8\n",
"#define DATA16_T int16\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_int_sat_rte\n",
"#define CONVERT_DATA2_T convert_int2_sat_rte\n",
"#define CONVERT_DATA4_T convert_int4_sat_rte\n",
"#define CONVERT_DATA8_T convert_int8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define POST_OP_DATA_T float\n",
"#define DATA_MIN INT_MIN\n",
"#define DATA_MAX INT_MAX\n",
"#define ROUND\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_int\n",
"#define AS_DATA2_T as_int2\n",
"#define AS_DATA4_T as_int4\n",
"#define AS_DATA8_T as_int8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif !defined(DT_UNDEF)\n",
"#error \"Unexpected data type\"\n",
"#endif\n",
"#if VECT_DT_N == 1\n",
"#define VECT_DATA_T DATA_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T\n",
"#define AS_VECT_DATA_T AS_DATA_T\n",
"#define VECT_BLOCK_READ BLOCK_READ\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE\n",
"#define VECT_UINT_READ intel_sub_group_block_read\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T\n",
"#define VECT_INT_T int\n",
"#define VECT_UINT_T uint\n",
"#define VECT_FLOAT_T float\n",
"#define VECT_CHAR_T char\n",
"#define AS_VECT_INT_T as_int\n",
"#define AS_VECT_UINT_T as_uint\n",
"#define AS_VECT_FLOAT_T as_float\n",
"#define AS_VECT_CHAR_T as_char\n",
"#elif VECT_DT_N == 2\n",
"#define VECT_DATA_T DATA2_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T\n",
"#define AS_VECT_DATA_T AS_DATA2_T\n",
"#define VECT_BLOCK_READ BLOCK_READ2\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE2\n",
"#define VECT_UINT_READ intel_sub_group_block_read2\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write2\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc2\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA2_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T\n",
"#define VECT_INT_T int2\n",
"#define VECT_UINT_T uint2\n",
"#define VECT_FLOAT_T float2\n",
"#define VECT_CHAR_T char2\n",
"#define AS_VECT_INT_T as_int2\n",
"#define AS_VECT_UINT_T as_uint2\n",
"#define AS_VECT_FLOAT_T as_float2\n",
"#define AS_VECT_CHAR_T as_char2\n",
"#elif VECT_DT_N == 4\n",
"#define VECT_DATA_T DATA4_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T\n",
"#define AS_VECT_DATA_T AS_DATA4_T\n",
"#define VECT_BLOCK_READ BLOCK_READ4\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE4\n",
"#define VECT_UINT_READ intel_sub_group_block_read4\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write4\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc4\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA4_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T\n",
"#define VECT_INT_T int4\n",
"#define VECT_UINT_T uint4\n",
"#define VECT_FLOAT_T float4\n",
"#define VECT_CHAR_T char4\n",
"#define AS_VECT_INT_T as_int4\n",
"#define AS_VECT_UINT_T as_uint4\n",
"#define AS_VECT_FLOAT_T as_float4\n",
"#define AS_VECT_CHAR_T as_char4\n",
"#elif VECT_DT_N == 8\n",
"#define VECT_DATA_T DATA8_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T\n",
"#define AS_VECT_DATA_T AS_DATA8_T\n",
"#define VECT_BLOCK_READ BLOCK_READ8\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE8\n",
"#define VECT_UINT_READ intel_sub_group_block_read8\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write8\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc8\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA8_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T\n",
"#define VECT_INT_T int8\n",
"#define VECT_UINT_T uint8\n",
"#define VECT_FLOAT_T float8\n",
"#define VECT_CHAR_T char8\n",
"#define AS_VECT_INT_T as_int8\n",
"#define AS_VECT_UINT_T as_uint8\n",
"#define AS_VECT_FLOAT_T as_float8\n",
"#define AS_VECT_CHAR_T as_char8\n",
"#endif\n",
"#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T)\n",
"#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T)\n",
"#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T)\n",
"#ifdef SRC_DATA_T\n",
"#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2)\n",
"#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4)\n",
"#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8)\n",
"#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16)\n",
"#ifdef SRC_DT_U8\n",
"#define SRC_MMAD_DATA_T uint\n",
"#define SRC_MMAD_DATA4_T uint4\n",
"#define SRC_MMAD_DATA8_T uint8\n",
"#elif SRC_DT_S8\n",
"#define SRC_MMAD_DATA_T int\n",
"#define SRC_MMAD_DATA4_T int4\n",
"#define SRC_MMAD_DATA8_T int8\n",
"#endif\n",
"#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T)\n",
"#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T)\n",
"#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T)\n",
"#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T)\n",
"#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T)\n",
"#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T)\n",
"#if SRC_DT_BF16\n",
"#define SRC_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define SRC_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define SRC_TO_REF(x) (x)\n",
"#define SRC_TO_REF8(x) (x)\n",
"#define REF_TO_SRC(x) (x)\n",
"#endif\n",
"#if SRC_DT_BF16\n",
"#define TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#elif SRC_DT_U8\n",
"#define TO_SRC(x) convert_uchar_sat_rte(x)\n",
"#elif SRC_DT_S8\n",
"#define TO_SRC(x) convert_char_sat_rte(x)\n",
"#elif SRC_DT_S32\n",
"#define TO_SRC(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_SRC(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef A_DATA_T\n",
"#define A_DATA8_T CONCAT2(A_DATA_T, 8)\n",
"#if A_DT_BF16\n",
"#define A_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define A_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_A(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define A_TO_REF(x) (x)\n",
"#define A_TO_REF8(x) (x)\n",
"#define REF_TO_A(x) (x)\n",
"#endif\n",
"#if A_DT_BF16\n",
"#define TO_A(x) cvt_f32_to_bf16(x)\n",
"#elif A_DT_U8\n",
"#define TO_A(x) convert_uchar_sat_rte(x)\n",
"#elif A_DT_S8\n",
"#define TO_A(x) convert_char_sat_rte(x)\n",
"#elif A_DT_S32\n",
"#define TO_A(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_A(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef WEI_DATA_T\n",
"#if WEI_DT_BF16\n",
"#define WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define WEI_TO_REF(x) (x)\n",
"#define REF_TO_WEI(x) (x)\n",
"#endif\n",
"#if WEI_DT_BF16\n",
"#define TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif WEI_DT_U8\n",
"#define TO_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif WEI_DT_S8\n",
"#define TO_WEI(x) convert_char_sat_rte(x)\n",
"#elif WEI_DT_S32\n",
"#define TO_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DIFF_WEI_DATA_T\n",
"#if DIFF_WEI_DT_BF16\n",
"#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define DIFF_WEI_TO_REF(x) (x)\n",
"#define REF_TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#if DIFF_WEI_DT_BF16\n",
"#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif DIFF_WEI_DT_U8\n",
"#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S8\n",
"#define TO_DIFF_WEI(x) convert_char_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S32\n",
"#define TO_DIFF_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef B_DATA_T\n",
"#if B_DT_BF16\n",
"#define B_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_B(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define B_TO_REF(x) (x)\n",
"#define REF_TO_B(x) (x)\n",
"#endif\n",
"#if B_DT_BF16\n",
"#define TO_B(x) cvt_f32_to_bf16(x)\n",
"#elif B_DT_U8\n",
"#define TO_B(x) convert_uchar_sat_rte(x)\n",
"#elif B_DT_S8\n",
"#define TO_B(x) convert_char_sat_rte(x)\n",
"#elif B_DT_S32\n",
"#define TO_B(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_B(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef BIA_DATA_T\n",
"#if BIA_DT_BF16\n",
"#define BIA_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define BIA_TO_REF(x) (x)\n",
"#define REF_TO_BIA(x) (x)\n",
"#endif\n",
"#if BIA_DT_BF16\n",
"#define TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#elif BIA_DT_U8\n",
"#define TO_BIA(x) convert_uchar_sat_rte(x)\n",
"#elif BIA_DT_S8\n",
"#define TO_BIA(x) convert_char_sat_rte(x)\n",
"#elif BIA_DT_S32\n",
"#define TO_BIA(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_BIA(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DST_DATA_T\n",
"#define DST_DATA2_T CONCAT2(DST_DATA_T, 2)\n",
"#define DST_DATA4_T CONCAT2(DST_DATA_T, 4)\n",
"#define DST_DATA8_T CONCAT2(DST_DATA_T, 8)\n",
"#define DST_DATA16_T CONCAT2(DST_DATA_T, 16)\n",
"#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T)\n",
"#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T)\n",
"#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T)\n",
"#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T)\n",
"#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T)\n",
"#if DST_DT_F32 || DST_DT_F16\n",
"#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T)\n",
"#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T)\n",
"#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T)\n",
"#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T)\n",
"#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T)\n",
"#else\n",
"#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte)\n",
"#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte)\n",
"#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte)\n",
"#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte)\n",
"#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte)\n",
"#endif\n",
"#if DST_DT_U8\n",
"#define MMAD_DATA_T uint\n",
"#define MMAD_DATA4_T uint4\n",
"#define MMAD_DATA8_T uint8\n",
"#elif DST_DT_S8\n",
"#define MMAD_DATA_T int\n",
"#define MMAD_DATA4_T int4\n",
"#define MMAD_DATA8_T int8\n",
"#endif\n",
"// Block read/write macros for dst.\n",
"#if DST_DT_U8 || DST_DT_S8\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v))\n",
"#elif DST_DT_S32 || DST_DT_F32\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write((__global uint *)ptr, as_uint(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#elif DST_DT_F16\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define DST_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define DST_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define DST_TO_REF(x) (x)\n",
"#define DST_TO_REF8(x) (x)\n",
"#define REF_TO_DST(x) (x)\n",
"#define REF_TO_DST8(x) (x)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x))\n",
"#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x))\n",
"#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif DST_DT_F16\n",
"#define TO_DST(x) convert_half(x)\n",
"#define TO_DST2(x) convert_half2(x)\n",
"#define TO_DST4(x) convert_half4(x)\n",
"#define TO_DST8(x) convert_half8(x)\n",
"#elif DST_DT_U8\n",
"#define TO_DST(x) convert_uchar_sat_rte(x)\n",
"#define TO_DST2(x) convert_uchar2_sat_rte(x)\n",
"#define TO_DST4(x) convert_uchar4_sat_rte(x)\n",
"#define TO_DST8(x) convert_uchar8_sat_rte(x)\n",
"#define TO_DST16(x) convert_uchar16_sat_rte(x)\n",
"#elif DST_DT_S8\n",
"#define TO_DST(x) convert_char_sat_rte(x)\n",
"#define TO_DST2(x) convert_char2_sat_rte(x)\n",
"#define TO_DST4(x) convert_char4_sat_rte(x)\n",
"#define TO_DST8(x) convert_char8_sat_rte(x)\n",
"#define TO_DST16(x) convert_char16_sat_rte(x)\n",
"#elif DST_DT_S32\n",
"#define TO_DST(x) convert_int_sat_rte(x)\n",
"#define TO_DST2(x) convert_int2_sat_rte(x)\n",
"#define TO_DST4(x) convert_int4_sat_rte(x)\n",
"#define TO_DST8(x) convert_int8_sat_rte(x)\n",
"#elif DST_DT_F32\n",
"#define TO_DST(x) convert_float(x)\n",
"#define TO_DST2(x) convert_float2(x)\n",
"#define TO_DST4(x) convert_float4(x)\n",
"#define TO_DST8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef C_DATA_T\n",
"#define C_DATA8_T CONCAT2(C_DATA_T, 8)\n",
"#if C_DT_BF16\n",
"#define C_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define C_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_C(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define C_TO_REF(x) (x)\n",
"#define C_TO_REF8(x) (x)\n",
"#define REF_TO_C(x) (x)\n",
"#define REF_TO_C8(x) (x)\n",
"#endif\n",
"#if C_DT_BF16\n",
"#define TO_C(x) cvt_f32_to_bf16(x)\n",
"#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif C_DT_F16\n",
"#define TO_C(x) convert_half(x)\n",
"#define TO_C8(x) convert_half8(x)\n",
"#elif C_DT_U8\n",
"#define TO_C(x) convert_uchar_sat_rte(x)\n",
"#define TO_C8(x) convert_uchar8_sat_rte(x)\n",
"#elif C_DT_S8\n",
"#define TO_C(x) convert_char_sat_rte(x)\n",
"#define TO_C8(x) convert_char8_sat_rte(x)\n",
"#elif C_DT_S32\n",
"#define TO_C(x) convert_int_sat_rte(x)\n",
"#define TO_C8(x) convert_int8_sat_rte(x)\n",
"#elif C_DT_F32\n",
"#define TO_C(x) convert_float(x)\n",
"#define TO_C8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef ACC_DATA_T\n",
"#if ACC_DT_F16\n",
"#define TO_ACC(x) convert_half(x)\n",
"#elif ACC_DT_F32\n",
"#define TO_ACC(x) convert_float(x)\n",
"#elif ACC_DT_S32\n",
"#define TO_ACC(x) convert_int(x)\n",
"#else\n",
"#error \"Unexpected accumulation data type\"\n",
"#endif\n",
"#endif\n",
"#ifdef SUM_DATA_T\n",
"#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2)\n",
"#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4)\n",
"#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8)\n",
"#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16)\n",
"#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T)\n",
"#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T)\n",
"#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T)\n",
"#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T)\n",
"#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T)\n",
"#if SUM_DT_BF16\n",
"#define SUM_TO_REF cvt_bf16_to_f32\n",
"#else\n",
"#define SUM_TO_REF\n",
"#endif\n",
"#endif\n",
"#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2)))\n",
"#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"              / CONCAT2(prefix, _B0_1)) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"                       % CONCAT2(prefix, _B0_1)) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \\\n",
"                    * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       / CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       % CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \\\n",
"                    * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       / CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       % CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \\\n",
"                    * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       / CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       % CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \\\n",
"                    * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       / CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       % CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \\\n",
"                    * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       / CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       % CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \\\n",
"                    * CONCAT2(prefix, _S5_2)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3)))\n",
"#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5)\n",
"#if NDIMS == 2\n",
"#define SRC_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1)\n",
"#elif NDIMS == 3\n",
"#define SRC_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, x3) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, x2) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2)\n",
"#elif NDIMS == 4\n",
"#define SRC_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, x3, x4) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, d, x3, x4) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3)\n",
"#elif NDIMS == 5\n",
"#define SRC_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \\\n",
"            + ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \\\n",
"            + ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, x3, x4, x5) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \\\n",
"            + ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4)\n",
"#endif\n",
"#define DST_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \\\n",
"            + ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4)\n",
"#endif\n",
"// clang-format off\n",
"// Shortcut accessors for special cases.\n",
"// x - product of the current and outer dimensions in gws[idx]\n",
"// y - the current dimension\n",
"#define GWS_OP_ZERO(x, y) 0\n",
"#define GWS_OP_FIRST(x, y) (x)\n",
"#define GWS_OP_MOD(x, y) ((x) % (y))\n",
"#define ROUND_UP(a,b) (((a) + (b) - 1) / (b))\n",
"#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0\n",
"#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1\n",
"#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2\n",
"#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3\n",
"#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4\n",
"#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5\n",
"#define GWS0_GET_BLOCK0() GWS0_BLOCK0\n",
"#define GWS0_GET_BLOCK1() GWS0_BLOCK1\n",
"#define GWS0_GET_BLOCK2() GWS0_BLOCK2\n",
"#define GWS0_GET_BLOCK3() GWS0_BLOCK3\n",
"#define GWS0_GET_BLOCK4() GWS0_BLOCK4\n",
"#define GWS0_GET_BLOCK5() GWS0_BLOCK5\n",
"#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0\n",
"#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1\n",
"#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2\n",
"#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3\n",
"#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4\n",
"#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5\n",
"#define GWS1_GET_BLOCK0() GWS1_BLOCK0\n",
"#define GWS1_GET_BLOCK1() GWS1_BLOCK1\n",
"#define GWS1_GET_BLOCK2() GWS1_BLOCK2\n",
"#define GWS1_GET_BLOCK3() GWS1_BLOCK3\n",
"#define GWS1_GET_BLOCK4() GWS1_BLOCK4\n",
"#define GWS1_GET_BLOCK5() GWS1_BLOCK5\n",
"#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0\n",
"#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1\n",
"#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2\n",
"#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3\n",
"#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4\n",
"#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5\n",
"#define GWS2_GET_BLOCK0() GWS2_BLOCK0\n",
"#define GWS2_GET_BLOCK1() GWS2_BLOCK1\n",
"#define GWS2_GET_BLOCK2() GWS2_BLOCK2\n",
"#define GWS2_GET_BLOCK3() GWS2_BLOCK3\n",
"#define GWS2_GET_BLOCK4() GWS2_BLOCK4\n",
"#define GWS2_GET_BLOCK5() GWS2_BLOCK5\n",
"// clang-format on\n",
"// With work-group qualifier, without sub-group qualifier.\n",
"#define KERNEL_ATTR_SG0 \\\n",
"    __attribute__((reqd_work_group_size( \\\n",
"            GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT)))\n",
"// With work-group and sub-group qualifiers.\n",
"#define KERNEL_ATTR_SG1 \\\n",
"    KERNEL_ATTR_SG0 \\\n",
"    __attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT)))\n",
"#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT)\n",
"// Named kernel attributes - when source contains multiple kernels.\n",
"#define NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \\\n",
"            CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name))))\n",
"#define NAMED_KERNEL_ATTR_SG1(name) \\\n",
"    NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name))))\n",
"#define NAMED_KERNEL_ATTR(name) \\\n",
"    CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name)\n",
"#endif\n",
"float fwd_Xnary(unsigned algorithm, float x, float y, float alpha, float beta,\n",
"        float scale) {\n",
"    switch (algorithm) {\n",
"        // binary\n",
"        case BINARY_ADD: return x + y; break;\n",
"        case BINARY_MUL: return x * y; break;\n",
"        case BINARY_MIN: return x < y ? x : y; break;\n",
"        case BINARY_MAX: return x > y ? x : y; break;\n",
"        case BINARY_DIV: return x / y; break;\n",
"        case BINARY_SUB: return x - y; break;\n",
"        case BINARY_GE: return x >= y; break;\n",
"        case BINARY_GT: return x > y; break;\n",
"        case BINARY_LE: return x <= y; break;\n",
"        case BINARY_LT: return x < y; break;\n",
"        case BINARY_EQ: return x == y; break;\n",
"        case BINARY_NE: return x != y; break;\n",
"        // unary\n",
"        default:\n",
"            return fwd_eltwise_common(algorithm, x, alpha, beta, scale);\n",
"            break;\n",
"    }\n",
"}\n",
"#define CONV_BIN_ARG_TO_FLOAT(idx, bin_arg_val) \\\n",
"    ({ \\\n",
"        float ret_val; \\\n",
"        if (CONCAT3(PO_, idx, _BIN_ARG_DT_IS_BF16)) \\\n",
"            ret_val = cvt_bf16_to_f32(bin_arg_val); \\\n",
"        else \\\n",
"            ret_val = convert_float(bin_arg_val); \\\n",
"\\\n",
"        ret_val; \\\n",
"    })\n",
"#define FWD_XNARY_GENERIC_DT(algorithm, result, result_elem_dt, arg0_ptr, \\\n",
"        arg0_len, arg1_ptr, arg1_len, alpha, beta, scale) \\\n",
"    { \\\n",
"        const unsigned out_len = max((unsigned)arg0_len, (unsigned)arg1_len); \\\n",
"        result_elem_dt *res_ptr = (result_elem_dt *)(&result); \\\n",
"        unroll_for(unsigned idx = 0; idx < out_len; ++idx) { \\\n",
"            if (arg0_len == 1 && arg1_len == 1) { \\\n",
"                *res_ptr = fwd_Xnary(algorithm, convert_float(*arg0_ptr), \\\n",
"                        convert_float(*arg1_ptr), alpha, beta, scale); \\\n",
"            } else if (arg0_len == 1) { \\\n",
"                res_ptr[idx] = fwd_Xnary(algorithm, convert_float(*arg0_ptr), \\\n",
"                        convert_float(arg1_ptr[idx]), alpha, beta, scale); \\\n",
"            } else if (arg1_len == 1) { \\\n",
"                res_ptr[idx] \\\n",
"                        = fwd_Xnary(algorithm, convert_float(arg0_ptr[idx]), \\\n",
"                                convert_float(*arg1_ptr), alpha, beta, scale); \\\n",
"            } else { \\\n",
"                res_ptr[idx] = fwd_Xnary(algorithm, \\\n",
"                        convert_float(arg0_ptr[idx]), \\\n",
"                        convert_float(arg1_ptr[idx]), alpha, beta, scale); \\\n",
"            } \\\n",
"        } \\\n",
"    }\n",
"#define FMA_BLOCK( \\\n",
"        block_size, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b) \\\n",
"    unroll_for(; nof_elems >= block_size; acc_ptr += block_size, \\\n",
"               a_ptr += block_size, nof_elems -= block_size) { \\\n",
"        CONCAT2(acc_elem_dt, block_size) \\\n",
"        a_conv = CONCAT3(convert_, acc_elem_dt, block_size)( \\\n",
"                *((CONCAT2(a_elem_dt, block_size) *)a_ptr)); \\\n",
"        *((CONCAT2(acc_elem_dt, block_size) *)acc_ptr) = fma( \\\n",
"                a_conv, b, *((CONCAT2(acc_elem_dt, block_size) *)acc_ptr)); \\\n",
"    }\n",
"#define FMA_MIXED(acc_nof_elems, a, a_elem_dt, b, acc, acc_elem_dt) \\\n",
"    { \\\n",
"        unsigned nof_elems = acc_nof_elems; \\\n",
"        a_elem_dt *a_ptr = (a_elem_dt *)(&a); \\\n",
"        acc_elem_dt *acc_ptr = (acc_elem_dt *)(&acc); \\\n",
"        FMA_BLOCK(8, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \\\n",
"        FMA_BLOCK(4, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \\\n",
"        FMA_BLOCK(2, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \\\n",
"        if (nof_elems == 1) { *acc_ptr += (*a_ptr) * b; } \\\n",
"    }\n",
"#define FILL_BIN_ARG_SERIAL(idx, dest_ptr, x0, x0_s, x1, x1_s, x1_incr, x2, \\\n",
"        x2_s, x3, x3_s, x4, x4_s, x5, x5_s) \\\n",
"    unroll_for(unsigned x0_idx = x0, bin_arg_offset = 0; x0_idx < x0 + x0_s; \\\n",
"               ++x0_idx) { \\\n",
"        unroll_for(unsigned x1_idx = x1; x1_idx < x1 + x1_s; \\\n",
"                   x1_idx += x1_incr) { \\\n",
"            unroll_for(unsigned x2_idx = x2; x2_idx < x2 + x2_s; ++x2_idx) { \\\n",
"                unroll_for(unsigned x3_idx = x3; x3_idx < x3 + x3_s; \\\n",
"                           ++x3_idx) { \\\n",
"                    unroll_for(unsigned x4_idx = x4; x4_idx < x4 + x4_s; \\\n",
"                               ++x4_idx) { \\\n",
"                        unroll_for(unsigned x5_idx = x5; x5_idx < x5 + x5_s; \\\n",
"                                   ++x5_idx, ++bin_arg_offset) { \\\n",
"                            const unsigned bin_arg_glob_off = OFF_MD( \\\n",
"                                    CONCAT3(PO_, idx, _BIN_ARG), \\\n",
"                                    x0_idx % CONCAT3(PO_, idx, _BIN_ARG_D0), \\\n",
"                                    x1_idx % CONCAT3(PO_, idx, _BIN_ARG_D1), \\\n",
"                                    x2_idx % CONCAT3(PO_, idx, _BIN_ARG_D2), \\\n",
"                                    x3_idx % CONCAT3(PO_, idx, _BIN_ARG_D3), \\\n",
"                                    x4_idx % CONCAT3(PO_, idx, _BIN_ARG_D4), \\\n",
"                                    x5_idx % CONCAT3(PO_, idx, _BIN_ARG_D5)); \\\n",
"                            dest_ptr[bin_arg_offset] = CONV_BIN_ARG_TO_FLOAT( \\\n",
"                                    idx, \\\n",
"                                    CONCAT3(po_, idx, \\\n",
"                                            _binary_arg)[bin_arg_glob_off]); \\\n",
"                        } \\\n",
"                    } \\\n",
"                } \\\n",
"            } \\\n",
"        } \\\n",
"    }\n",
"// explicitly define sub group reads and data type with post fix \"1\" which are\n",
"// required in FILL_WITH_BLOCK_READ macro. In that function number of elements\n",
"// is appended to it so it works for 2,4 but for 1 there is no such name.\n",
"#define intel_sub_group_block_read_uc1 intel_sub_group_block_read_uc\n",
"#define intel_sub_group_block_read_us1 intel_sub_group_block_read_us\n",
"#define intel_sub_group_block_read1 intel_sub_group_block_read\n",
"#define uchar1 uchar\n",
"#define ushort1 ushort\n",
"#define uint1 uint\n",
"#define FILL_WITH_BLOCK_READ(idx, src_ptr, dst_ptr, nelem, data_type) \\\n",
"    { \\\n",
"        data_type tmp_storage[nelem]; \\\n",
"        if (sizeof(data_type) == 1) { \\\n",
"            *((CONCAT2(uchar, nelem) *)(&tmp_storage)) \\\n",
"                    = (CONCAT2(intel_sub_group_block_read_uc, nelem)( \\\n",
"                            (__global uchar *)(src_ptr))); \\\n",
"        } \\\n",
"        if (sizeof(data_type) == 2) { \\\n",
"            *((CONCAT2(ushort, nelem) *)(&tmp_storage)) \\\n",
"                    = CONCAT2(intel_sub_group_block_read_us, nelem)( \\\n",
"                            (__global ushort *)(src_ptr)); \\\n",
"        } \\\n",
"        if (sizeof(data_type) == 4) { \\\n",
"            *((CONCAT2(uint, nelem) *)(&tmp_storage)) \\\n",
"                    = CONCAT2(intel_sub_group_block_read, nelem)( \\\n",
"                            (__global uint *)(src_ptr)); \\\n",
"        } \\\n",
"        unroll_for(unsigned s_index = 0; s_index < nelem; ++s_index) { \\\n",
"            dst_ptr[s_index] \\\n",
"                    = CONV_BIN_ARG_TO_FLOAT(idx, tmp_storage[s_index]); \\\n",
"        } \\\n",
"    }\n",
"#define X_NELEMS(x) ({ x / SUB_GROUP_SIZE; })\n",
"#define CONDITIONAL_FILL( \\\n",
"        idx, blocked_coord, nelem, src_ptr, dst_ptr, data_type) \\\n",
"    if (blocked_coord / SUB_GROUP_SIZE == nelem) \\\n",
"        FILL_WITH_BLOCK_READ(idx, src_ptr, dst_ptr, nelem, data_type);\n",
"#define FILL_BIN_ARG_TRY_BLOCK(idx, dest_ptr, dest_size, x0, x0_s, x1, x1_s, \\\n",
"        x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s) \\\n",
"    { \\\n",
"        unroll_for(unsigned x0_idx = x0, arg_off = 0; x0_idx < x0 + x0_s; \\\n",
"                   ++x0_idx, arg_off += X_NELEMS(x1_s)) { \\\n",
"            const unsigned bin_arg_glob_off \\\n",
"                    = OFF_MD(CONCAT3(PO_, idx, _BIN_ARG), \\\n",
"                            x0_idx % CONCAT3(PO_, idx, _BIN_ARG_D0), \\\n",
"                            x1 % CONCAT3(PO_, idx, _BIN_ARG_D1), \\\n",
"                            x2 % CONCAT3(PO_, idx, _BIN_ARG_D2), \\\n",
"                            x3 % CONCAT3(PO_, idx, _BIN_ARG_D3), \\\n",
"                            x4 % CONCAT3(PO_, idx, _BIN_ARG_D4), \\\n",
"                            x5 % CONCAT3(PO_, idx, _BIN_ARG_D5)); \\\n",
"\\\n",
"            CONDITIONAL_FILL(idx, x1_s, 1, \\\n",
"                    (CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \\\n",
"                    (dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \\\n",
"            CONDITIONAL_FILL(idx, x1_s, 2, \\\n",
"                    (CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \\\n",
"                    (dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \\\n",
"            CONDITIONAL_FILL(idx, x1_s, 4, \\\n",
"                    (CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \\\n",
"                    (dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \\\n",
"        } \\\n",
"    }\n",
"#define REPLICATE_DATA( \\\n",
"        dest_ptr, dest_size, x0_s, x1_s, x2_s, x3_s, x4_s, x5_s) \\\n",
"    { \\\n",
"        const unsigned copy_size \\\n",
"                = x0_s * X_NELEMS(x1_s) * x2_s * x3_s * x4_s * x5_s; \\\n",
"        unroll_for(unsigned fid = copy_size; fid < dest_size; ++fid) { \\\n",
"            *(dest_ptr + fid) = *(dest_ptr + (fid % copy_size)); \\\n",
"        } \\\n",
"    }\n",
"#define IS_BURSTABLE(idx, x0, x0_s, x1, x1_s, x2, x2_s, x3, x3_s, x4, x4_s, \\\n",
"        x5, x5_s, is_burst) \\\n",
"    ({ \\\n",
"        bool is_burstable = is_burst; \\\n",
"        if (x0_s > CONCAT3(PO_, idx, _BIN_ARG_D0) && x0_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x1_s > CONCAT3(PO_, idx, _BIN_ARG_D1) && x1_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x2_s > CONCAT3(PO_, idx, _BIN_ARG_D2) && x2_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x3_s > CONCAT3(PO_, idx, _BIN_ARG_D3) && x3_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x4_s > CONCAT3(PO_, idx, _BIN_ARG_D4) && x4_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x5_s > CONCAT3(PO_, idx, _BIN_ARG_D5) && x5_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (CONCAT3(PO_, idx, _BIN_ARG_D0) * CONCAT3(PO_, idx, _BIN_ARG_D1) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D2) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D2) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D3) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D4) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D5) \\\n",
"                == 1) \\\n",
"            is_burstable = false; \\\n",
"\\\n",
"        is_burstable; \\\n",
"    })\n",
"#define BINARY_ARG_IS_SCALAR(idx) ({ false; })\n",
"#define APPLY_PO_BINARY(idx, accumulator, acc_elem_dt, x0, x0_s, x1, x1_s, \\\n",
"        x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, is_burst) \\\n",
"    { \\\n",
"        const unsigned bin_arg_size = BINARY_ARG_IS_SCALAR(idx) \\\n",
"                ? 1 \\\n",
"                : sizeof(accumulator) / sizeof(acc_elem_dt); \\\n",
"        float bin_arg[bin_arg_size]; \\\n",
"        float *bin_arg_ptr = &bin_arg[0]; \\\n",
"        const bool use_burst_read = IS_BURSTABLE(idx, x0, x0_s, x1, x1_s, x2, \\\n",
"                x2_s, x3, x3_s, x4, x4_s, x5, x5_s, is_burst); \\\n",
"        const unsigned x1_jump = is_burst ? SUB_GROUP_SIZE : 1; \\\n",
"        if (use_burst_read) { \\\n",
"            FILL_BIN_ARG_TRY_BLOCK(idx, bin_arg_ptr, bin_arg_size, x0, x0_s, \\\n",
"                    x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                    x5_s); \\\n",
"        } else { \\\n",
"            FILL_BIN_ARG_SERIAL(idx, bin_arg_ptr, x0, x0_s, (x1 + x1_incr), \\\n",
"                    x1_s, x1_jump, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s); \\\n",
"        } \\\n",
"        REPLICATE_DATA(bin_arg_ptr, bin_arg_size, x0_s, x1_s, x2_s, x3_s, \\\n",
"                x4_s, x5_s); \\\n",
"        FWD_XNARY_GENERIC_DT(CONCAT3(PO_, idx, _ALG), accumulator, \\\n",
"                acc_elem_dt, ((acc_elem_dt *)(&accumulator)), \\\n",
"                (sizeof(accumulator) / sizeof(acc_elem_dt)), bin_arg_ptr, \\\n",
"                bin_arg_size, 0.0f, 0.0f, 0.0f); \\\n",
"    }\n",
"#define APPLY_PO_SUM(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt) \\\n",
"    { \\\n",
"        unsigned acc_size = sizeof(accumulator) / sizeof(acc_elem_dt); \\\n",
"        FMA_MIXED(acc_size, sum_src, sum_elem_dt, \\\n",
"                CONCAT3(po_, idx, _sum_scale), accumulator, acc_elem_dt); \\\n",
"    }\n",
"#define APPLY_PO_ELTWISE(idx, accumulator, acc_elem_dt) \\\n",
"    { \\\n",
"        FWD_XNARY_GENERIC_DT(CONCAT3(PO_, idx, _ALG), accumulator, \\\n",
"                acc_elem_dt, ((acc_elem_dt *)(&accumulator)), \\\n",
"                (sizeof(accumulator) / sizeof(acc_elem_dt)), \\\n",
"                ((acc_elem_dt *)(&accumulator)), \\\n",
"                (sizeof(accumulator) / sizeof(acc_elem_dt)), \\\n",
"                CONCAT3(po_, idx, _eltwise_alpha), \\\n",
"                CONCAT3(po_, idx, _eltwise_beta), \\\n",
"                CONCAT3(po_, idx, _eltwise_scale)); \\\n",
"    }\n",
"#define APPLY_PO_STAGE(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"        x0, x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \\\n",
"        is_burst) \\\n",
"    switch (CONCAT3(PO_, idx, _KIND)) { \\\n",
"        case PO_BINARY: \\\n",
"            APPLY_PO_BINARY(idx, accumulator, acc_elem_dt, x0, x0_s, x1, x1_s, \\\n",
"                    x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \\\n",
"                    is_burst); \\\n",
"            break; \\\n",
"        case PO_ELTWISE: APPLY_PO_ELTWISE(idx, accumulator, acc_elem_dt); \\\n",
"                break; \\\n",
"        case PO_SUM: \\\n",
"            APPLY_PO_SUM(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt); \\\n",
"            break; \\\n",
"    }\n",
"#define APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"        x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \\\n",
"        is_burst) \\\n",
"    { \\\n",
"        APPLY_PO_STAGE(0, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(1, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(2, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(3, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(4, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(5, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(6, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(7, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(8, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(9, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"    }\n",
"#define APPLY_POST_OPS_TRY_BURST(accumulator, acc_elem_dt, sum_src, \\\n",
"        sum_elem_dt, mb_start, mb_size, oc_start, oc_size, oc_serial_incr) \\\n",
"    APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"            mb_start, mb_size, oc_start, oc_size, oc_serial_incr, 0, 1, 0, 1, \\\n",
"            0, 1, 0, 1, true)\n",
"#define APPLY_POST_OPS_SERIAL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"        mb_start, mb_size, oc_start, oc_size, d2_start, d2_size, d3_start, \\\n",
"        d3_size, d4_start, d4_size, d5_start, d5_size) \\\n",
"    APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"            mb_start, mb_size, oc_start, oc_size, 0, d2_start, d2_size, \\\n",
"            d3_start, d3_size, d4_start, d4_size, d5_start, d5_size, false)\n",
"#define APPLY_POST_OPS_SERIAL_BINARY_2D(accumulator, acc_elem_dt, sum_src, \\\n",
"        sum_elem_dt, mb_start, mb_size, oc_start, oc_size) \\\n",
"    APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"            mb_start, mb_size, oc_start, oc_size, 0, 0, 1, 0, 1, 0, 1, 0, 1, \\\n",
"            false)\n",
"#else\n",
"#define APPLY_POST_OPS_SERIAL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"        mb_start, mb_size, oc_start, oc_size, d2_start, d2_size, d3_start, \\\n",
"        d3_size, d4_start, d4_size, d5_start, d5_size) \\\n",
"    {}\n",
"#define APPLY_POST_OPS_SERIAL_BINARY_2D(accumulator, acc_elem_dt, sum_src, \\\n",
"        sum_elem_dt, mb_start, mb_size, oc_start, oc_size) \\\n",
"    {}\n",
"#define APPLY_POST_OPS_TRY_BURST(accumulator, acc_elem_dt, sum_src, \\\n",
"        sum_elem_dt, mb_start, mb_size, oc_start, oc_size, oc_serial_incr) \\\n",
"    {}\n",
"#endif // WITH_POST_OP\n",
"#endif\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_TYPES_H\n",
"#define GPU_OCL_OCL_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#define unroll_for __attribute__((opencl_unroll_hint)) for\n",
"#define for_ for\n",
"#define CONCAt2(a, b) a##b\n",
"#define CONCAT2(a, b) CONCAt2(a, b)\n",
"#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c)\n",
"#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \\\n",
"        || defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \\\n",
"        || defined(BIA_DT_F16) || defined(ACC_DT_F16)\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#if DT_F32 == 1\n",
"#define DATA_T float\n",
"#define DATA2_T float2\n",
"#define DATA4_T float4\n",
"#define DATA8_T float8\n",
"#define DATA16_T float16\n",
"#define DATA_MAX FLT_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) (float)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_float\n",
"#define CONVERT_DATA2_T convert_float2\n",
"#define CONVERT_DATA4_T convert_float4\n",
"#define CONVERT_DATA8_T convert_float8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_float\n",
"#define AS_DATA2_T as_float2\n",
"#define AS_DATA4_T as_float4\n",
"#define AS_DATA8_T as_float8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif DT_F16 == 1\n",
"#define DATA_T half\n",
"#define DATA2_T half2\n",
"#define DATA4_T half4\n",
"#define DATA8_T half8\n",
"#define DATA16_T half16\n",
"#define DATA_MAX HALF_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0h\n",
"#define DATA_ONE 1.0h\n",
"#define DEF_ACC_DATA_T half\n",
"#define DEF_ACC_DATA2_T half2\n",
"#define DEF_ACC_DATA4_T half4\n",
"#define DEF_ACC_DATA8_T half8\n",
"#define POST_OP_DATA_T half\n",
"#define TO_DATA_T(v) (half)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (half)(v)\n",
"#define DATA_TO_REF convert_half\n",
"#define CONVERT_DATA_T convert_half\n",
"#define CONVERT_DATA2_T convert_half2\n",
"#define CONVERT_DATA4_T convert_half4\n",
"#define CONVERT_DATA8_T convert_half8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_half\n",
"#define AS_DATA2_T as_half2\n",
"#define AS_DATA4_T as_half4\n",
"#define AS_DATA8_T as_half8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_BF16 == 1\n",
"#define DATA_T ushort\n",
"#define POST_OP_DATA_T float\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define DATA16_T ushort16\n",
"#define DATA_MAX as_float(0x7f7f0000)\n",
"#define DATA_MIN (-DATA_MAX)\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define TO_DATA_T(v) cvt_f32_to_bf16(v)\n",
"#define TO_DEF_ACC_DATA_T(v) cvt_bf16_to_f32(v)\n",
"#define DATA_TO_REF cvt_bf16_to_f32\n",
"#define CONVERT_DATA_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA2_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA4_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA8_T cvt_f32_to_bf16\n",
"#define CONVERT_FLOAT_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT2_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT4_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT8_T cvt_bf16_to_f32\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_ushort\n",
"#define AS_DATA2_T as_ushort2\n",
"#define AS_DATA4_T as_ushort4\n",
"#define AS_DATA8_T as_ushort8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_S8 == 1\n",
"#define DATA_T char\n",
"#define DATA2_T char2\n",
"#define DATA4_T char4\n",
"#define DATA8_T char8\n",
"#define DATA16_T char16\n",
"#define DATA_MAX CHAR_MAX\n",
"#define DATA_MIN CHAR_MIN\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T int8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_char_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_char_sat_rte\n",
"#define CONVERT_DATA2_T convert_char2_sat_rte\n",
"#define CONVERT_DATA4_T convert_char4_sat_rte\n",
"#define CONVERT_DATA8_T convert_char8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_char\n",
"#define AS_DATA2_T as_char2\n",
"#define AS_DATA4_T as_char4\n",
"#define AS_DATA8_T as_char8\n",
"#define AS_DATA16_T as_char16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_int8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_U8 == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define DATA16_T uchar16\n",
"#define DATA_MAX UCHAR_MAX\n",
"#define DATA_MIN 0\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T uint8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_uchar_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_uchar_sat_rte\n",
"#define CONVERT_DATA2_T convert_uchar2_sat_rte\n",
"#define CONVERT_DATA4_T convert_uchar4_sat_rte\n",
"#define CONVERT_DATA8_T convert_uchar8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_uchar\n",
"#define AS_DATA2_T as_uchar2\n",
"#define AS_DATA4_T as_uchar4\n",
"#define AS_DATA8_T as_uchar8\n",
"#define AS_DATA16_T as_uchar16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_uint8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_S32 == 1\n",
"#define DATA_T int\n",
"#define DATA2_T int2\n",
"#define DATA4_T int4\n",
"#define DATA8_T int8\n",
"#define DATA16_T int16\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_int_sat_rte\n",
"#define CONVERT_DATA2_T convert_int2_sat_rte\n",
"#define CONVERT_DATA4_T convert_int4_sat_rte\n",
"#define CONVERT_DATA8_T convert_int8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define POST_OP_DATA_T float\n",
"#define DATA_MIN INT_MIN\n",
"#define DATA_MAX INT_MAX\n",
"#define ROUND\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_int\n",
"#define AS_DATA2_T as_int2\n",
"#define AS_DATA4_T as_int4\n",
"#define AS_DATA8_T as_int8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif !defined(DT_UNDEF)\n",
"#error \"Unexpected data type\"\n",
"#endif\n",
"#if VECT_DT_N == 1\n",
"#define VECT_DATA_T DATA_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T\n",
"#define AS_VECT_DATA_T AS_DATA_T\n",
"#define VECT_BLOCK_READ BLOCK_READ\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE\n",
"#define VECT_UINT_READ intel_sub_group_block_read\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T\n",
"#define VECT_INT_T int\n",
"#define VECT_UINT_T uint\n",
"#define VECT_FLOAT_T float\n",
"#define VECT_CHAR_T char\n",
"#define AS_VECT_INT_T as_int\n",
"#define AS_VECT_UINT_T as_uint\n",
"#define AS_VECT_FLOAT_T as_float\n",
"#define AS_VECT_CHAR_T as_char\n",
"#elif VECT_DT_N == 2\n",
"#define VECT_DATA_T DATA2_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T\n",
"#define AS_VECT_DATA_T AS_DATA2_T\n",
"#define VECT_BLOCK_READ BLOCK_READ2\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE2\n",
"#define VECT_UINT_READ intel_sub_group_block_read2\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write2\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc2\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA2_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T\n",
"#define VECT_INT_T int2\n",
"#define VECT_UINT_T uint2\n",
"#define VECT_FLOAT_T float2\n",
"#define VECT_CHAR_T char2\n",
"#define AS_VECT_INT_T as_int2\n",
"#define AS_VECT_UINT_T as_uint2\n",
"#define AS_VECT_FLOAT_T as_float2\n",
"#define AS_VECT_CHAR_T as_char2\n",
"#elif VECT_DT_N == 4\n",
"#define VECT_DATA_T DATA4_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T\n",
"#define AS_VECT_DATA_T AS_DATA4_T\n",
"#define VECT_BLOCK_READ BLOCK_READ4\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE4\n",
"#define VECT_UINT_READ intel_sub_group_block_read4\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write4\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc4\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA4_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T\n",
"#define VECT_INT_T int4\n",
"#define VECT_UINT_T uint4\n",
"#define VECT_FLOAT_T float4\n",
"#define VECT_CHAR_T char4\n",
"#define AS_VECT_INT_T as_int4\n",
"#define AS_VECT_UINT_T as_uint4\n",
"#define AS_VECT_FLOAT_T as_float4\n",
"#define AS_VECT_CHAR_T as_char4\n",
"#elif VECT_DT_N == 8\n",
"#define VECT_DATA_T DATA8_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T\n",
"#define AS_VECT_DATA_T AS_DATA8_T\n",
"#define VECT_BLOCK_READ BLOCK_READ8\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE8\n",
"#define VECT_UINT_READ intel_sub_group_block_read8\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write8\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc8\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA8_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T\n",
"#define VECT_INT_T int8\n",
"#define VECT_UINT_T uint8\n",
"#define VECT_FLOAT_T float8\n",
"#define VECT_CHAR_T char8\n",
"#define AS_VECT_INT_T as_int8\n",
"#define AS_VECT_UINT_T as_uint8\n",
"#define AS_VECT_FLOAT_T as_float8\n",
"#define AS_VECT_CHAR_T as_char8\n",
"#endif\n",
"#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T)\n",
"#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T)\n",
"#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T)\n",
"#ifdef SRC_DATA_T\n",
"#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2)\n",
"#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4)\n",
"#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8)\n",
"#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16)\n",
"#ifdef SRC_DT_U8\n",
"#define SRC_MMAD_DATA_T uint\n",
"#define SRC_MMAD_DATA4_T uint4\n",
"#define SRC_MMAD_DATA8_T uint8\n",
"#elif SRC_DT_S8\n",
"#define SRC_MMAD_DATA_T int\n",
"#define SRC_MMAD_DATA4_T int4\n",
"#define SRC_MMAD_DATA8_T int8\n",
"#endif\n",
"#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T)\n",
"#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T)\n",
"#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T)\n",
"#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T)\n",
"#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T)\n",
"#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T)\n",
"#if SRC_DT_BF16\n",
"#define SRC_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define SRC_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define SRC_TO_REF(x) (x)\n",
"#define SRC_TO_REF8(x) (x)\n",
"#define REF_TO_SRC(x) (x)\n",
"#endif\n",
"#if SRC_DT_BF16\n",
"#define TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#elif SRC_DT_U8\n",
"#define TO_SRC(x) convert_uchar_sat_rte(x)\n",
"#elif SRC_DT_S8\n",
"#define TO_SRC(x) convert_char_sat_rte(x)\n",
"#elif SRC_DT_S32\n",
"#define TO_SRC(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_SRC(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef A_DATA_T\n",
"#define A_DATA8_T CONCAT2(A_DATA_T, 8)\n",
"#if A_DT_BF16\n",
"#define A_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define A_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_A(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define A_TO_REF(x) (x)\n",
"#define A_TO_REF8(x) (x)\n",
"#define REF_TO_A(x) (x)\n",
"#endif\n",
"#if A_DT_BF16\n",
"#define TO_A(x) cvt_f32_to_bf16(x)\n",
"#elif A_DT_U8\n",
"#define TO_A(x) convert_uchar_sat_rte(x)\n",
"#elif A_DT_S8\n",
"#define TO_A(x) convert_char_sat_rte(x)\n",
"#elif A_DT_S32\n",
"#define TO_A(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_A(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef WEI_DATA_T\n",
"#if WEI_DT_BF16\n",
"#define WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define WEI_TO_REF(x) (x)\n",
"#define REF_TO_WEI(x) (x)\n",
"#endif\n",
"#if WEI_DT_BF16\n",
"#define TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif WEI_DT_U8\n",
"#define TO_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif WEI_DT_S8\n",
"#define TO_WEI(x) convert_char_sat_rte(x)\n",
"#elif WEI_DT_S32\n",
"#define TO_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DIFF_WEI_DATA_T\n",
"#if DIFF_WEI_DT_BF16\n",
"#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define DIFF_WEI_TO_REF(x) (x)\n",
"#define REF_TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#if DIFF_WEI_DT_BF16\n",
"#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif DIFF_WEI_DT_U8\n",
"#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S8\n",
"#define TO_DIFF_WEI(x) convert_char_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S32\n",
"#define TO_DIFF_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef B_DATA_T\n",
"#if B_DT_BF16\n",
"#define B_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_B(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define B_TO_REF(x) (x)\n",
"#define REF_TO_B(x) (x)\n",
"#endif\n",
"#if B_DT_BF16\n",
"#define TO_B(x) cvt_f32_to_bf16(x)\n",
"#elif B_DT_U8\n",
"#define TO_B(x) convert_uchar_sat_rte(x)\n",
"#elif B_DT_S8\n",
"#define TO_B(x) convert_char_sat_rte(x)\n",
"#elif B_DT_S32\n",
"#define TO_B(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_B(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef BIA_DATA_T\n",
"#if BIA_DT_BF16\n",
"#define BIA_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define BIA_TO_REF(x) (x)\n",
"#define REF_TO_BIA(x) (x)\n",
"#endif\n",
"#if BIA_DT_BF16\n",
"#define TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#elif BIA_DT_U8\n",
"#define TO_BIA(x) convert_uchar_sat_rte(x)\n",
"#elif BIA_DT_S8\n",
"#define TO_BIA(x) convert_char_sat_rte(x)\n",
"#elif BIA_DT_S32\n",
"#define TO_BIA(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_BIA(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DST_DATA_T\n",
"#define DST_DATA2_T CONCAT2(DST_DATA_T, 2)\n",
"#define DST_DATA4_T CONCAT2(DST_DATA_T, 4)\n",
"#define DST_DATA8_T CONCAT2(DST_DATA_T, 8)\n",
"#define DST_DATA16_T CONCAT2(DST_DATA_T, 16)\n",
"#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T)\n",
"#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T)\n",
"#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T)\n",
"#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T)\n",
"#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T)\n",
"#if DST_DT_F32 || DST_DT_F16\n",
"#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T)\n",
"#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T)\n",
"#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T)\n",
"#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T)\n",
"#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T)\n",
"#else\n",
"#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte)\n",
"#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte)\n",
"#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte)\n",
"#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte)\n",
"#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte)\n",
"#endif\n",
"#if DST_DT_U8\n",
"#define MMAD_DATA_T uint\n",
"#define MMAD_DATA4_T uint4\n",
"#define MMAD_DATA8_T uint8\n",
"#elif DST_DT_S8\n",
"#define MMAD_DATA_T int\n",
"#define MMAD_DATA4_T int4\n",
"#define MMAD_DATA8_T int8\n",
"#endif\n",
"// Block read/write macros for dst.\n",
"#if DST_DT_U8 || DST_DT_S8\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v))\n",
"#elif DST_DT_S32 || DST_DT_F32\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write((__global uint *)ptr, as_uint(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#elif DST_DT_F16\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define DST_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define DST_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define DST_TO_REF(x) (x)\n",
"#define DST_TO_REF8(x) (x)\n",
"#define REF_TO_DST(x) (x)\n",
"#define REF_TO_DST8(x) (x)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x))\n",
"#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x))\n",
"#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif DST_DT_F16\n",
"#define TO_DST(x) convert_half(x)\n",
"#define TO_DST2(x) convert_half2(x)\n",
"#define TO_DST4(x) convert_half4(x)\n",
"#define TO_DST8(x) convert_half8(x)\n",
"#elif DST_DT_U8\n",
"#define TO_DST(x) convert_uchar_sat_rte(x)\n",
"#define TO_DST2(x) convert_uchar2_sat_rte(x)\n",
"#define TO_DST4(x) convert_uchar4_sat_rte(x)\n",
"#define TO_DST8(x) convert_uchar8_sat_rte(x)\n",
"#define TO_DST16(x) convert_uchar16_sat_rte(x)\n",
"#elif DST_DT_S8\n",
"#define TO_DST(x) convert_char_sat_rte(x)\n",
"#define TO_DST2(x) convert_char2_sat_rte(x)\n",
"#define TO_DST4(x) convert_char4_sat_rte(x)\n",
"#define TO_DST8(x) convert_char8_sat_rte(x)\n",
"#define TO_DST16(x) convert_char16_sat_rte(x)\n",
"#elif DST_DT_S32\n",
"#define TO_DST(x) convert_int_sat_rte(x)\n",
"#define TO_DST2(x) convert_int2_sat_rte(x)\n",
"#define TO_DST4(x) convert_int4_sat_rte(x)\n",
"#define TO_DST8(x) convert_int8_sat_rte(x)\n",
"#elif DST_DT_F32\n",
"#define TO_DST(x) convert_float(x)\n",
"#define TO_DST2(x) convert_float2(x)\n",
"#define TO_DST4(x) convert_float4(x)\n",
"#define TO_DST8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef C_DATA_T\n",
"#define C_DATA8_T CONCAT2(C_DATA_T, 8)\n",
"#if C_DT_BF16\n",
"#define C_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define C_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_C(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define C_TO_REF(x) (x)\n",
"#define C_TO_REF8(x) (x)\n",
"#define REF_TO_C(x) (x)\n",
"#define REF_TO_C8(x) (x)\n",
"#endif\n",
"#if C_DT_BF16\n",
"#define TO_C(x) cvt_f32_to_bf16(x)\n",
"#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif C_DT_F16\n",
"#define TO_C(x) convert_half(x)\n",
"#define TO_C8(x) convert_half8(x)\n",
"#elif C_DT_U8\n",
"#define TO_C(x) convert_uchar_sat_rte(x)\n",
"#define TO_C8(x) convert_uchar8_sat_rte(x)\n",
"#elif C_DT_S8\n",
"#define TO_C(x) convert_char_sat_rte(x)\n",
"#define TO_C8(x) convert_char8_sat_rte(x)\n",
"#elif C_DT_S32\n",
"#define TO_C(x) convert_int_sat_rte(x)\n",
"#define TO_C8(x) convert_int8_sat_rte(x)\n",
"#elif C_DT_F32\n",
"#define TO_C(x) convert_float(x)\n",
"#define TO_C8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef ACC_DATA_T\n",
"#if ACC_DT_F16\n",
"#define TO_ACC(x) convert_half(x)\n",
"#elif ACC_DT_F32\n",
"#define TO_ACC(x) convert_float(x)\n",
"#elif ACC_DT_S32\n",
"#define TO_ACC(x) convert_int(x)\n",
"#else\n",
"#error \"Unexpected accumulation data type\"\n",
"#endif\n",
"#endif\n",
"#ifdef SUM_DATA_T\n",
"#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2)\n",
"#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4)\n",
"#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8)\n",
"#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16)\n",
"#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T)\n",
"#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T)\n",
"#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T)\n",
"#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T)\n",
"#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T)\n",
"#if SUM_DT_BF16\n",
"#define SUM_TO_REF cvt_bf16_to_f32\n",
"#else\n",
"#define SUM_TO_REF\n",
"#endif\n",
"#endif\n",
"#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2)))\n",
"#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"              / CONCAT2(prefix, _B0_1)) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"                       % CONCAT2(prefix, _B0_1)) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \\\n",
"                    * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       / CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       % CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \\\n",
"                    * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       / CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       % CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \\\n",
"                    * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       / CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       % CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \\\n",
"                    * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       / CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       % CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \\\n",
"                    * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       / CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       % CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \\\n",
"                    * CONCAT2(prefix, _S5_2)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3)))\n",
"#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5)\n",
"#if NDIMS == 2\n",
"#define SRC_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1)\n",
"#elif NDIMS == 3\n",
"#define SRC_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, x3) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, x2) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2)\n",
"#elif NDIMS == 4\n",
"#define SRC_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, x3, x4) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, d, x3, x4) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3)\n",
"#elif NDIMS == 5\n",
"#define SRC_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \\\n",
"            + ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \\\n",
"            + ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, x3, x4, x5) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \\\n",
"            + ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4)\n",
"#endif\n",
"#define DST_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \\\n",
"            + ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4)\n",
"#endif\n",
"// clang-format off\n",
"// Shortcut accessors for special cases.\n",
"// x - product of the current and outer dimensions in gws[idx]\n",
"// y - the current dimension\n",
"#define GWS_OP_ZERO(x, y) 0\n",
"#define GWS_OP_FIRST(x, y) (x)\n",
"#define GWS_OP_MOD(x, y) ((x) % (y))\n",
"#define ROUND_UP(a,b) (((a) + (b) - 1) / (b))\n",
"#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0\n",
"#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1\n",
"#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2\n",
"#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3\n",
"#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4\n",
"#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5\n",
"#define GWS0_GET_BLOCK0() GWS0_BLOCK0\n",
"#define GWS0_GET_BLOCK1() GWS0_BLOCK1\n",
"#define GWS0_GET_BLOCK2() GWS0_BLOCK2\n",
"#define GWS0_GET_BLOCK3() GWS0_BLOCK3\n",
"#define GWS0_GET_BLOCK4() GWS0_BLOCK4\n",
"#define GWS0_GET_BLOCK5() GWS0_BLOCK5\n",
"#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0\n",
"#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1\n",
"#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2\n",
"#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3\n",
"#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4\n",
"#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5\n",
"#define GWS1_GET_BLOCK0() GWS1_BLOCK0\n",
"#define GWS1_GET_BLOCK1() GWS1_BLOCK1\n",
"#define GWS1_GET_BLOCK2() GWS1_BLOCK2\n",
"#define GWS1_GET_BLOCK3() GWS1_BLOCK3\n",
"#define GWS1_GET_BLOCK4() GWS1_BLOCK4\n",
"#define GWS1_GET_BLOCK5() GWS1_BLOCK5\n",
"#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0\n",
"#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1\n",
"#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2\n",
"#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3\n",
"#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4\n",
"#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5\n",
"#define GWS2_GET_BLOCK0() GWS2_BLOCK0\n",
"#define GWS2_GET_BLOCK1() GWS2_BLOCK1\n",
"#define GWS2_GET_BLOCK2() GWS2_BLOCK2\n",
"#define GWS2_GET_BLOCK3() GWS2_BLOCK3\n",
"#define GWS2_GET_BLOCK4() GWS2_BLOCK4\n",
"#define GWS2_GET_BLOCK5() GWS2_BLOCK5\n",
"// clang-format on\n",
"// With work-group qualifier, without sub-group qualifier.\n",
"#define KERNEL_ATTR_SG0 \\\n",
"    __attribute__((reqd_work_group_size( \\\n",
"            GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT)))\n",
"// With work-group and sub-group qualifiers.\n",
"#define KERNEL_ATTR_SG1 \\\n",
"    KERNEL_ATTR_SG0 \\\n",
"    __attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT)))\n",
"#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT)\n",
"// Named kernel attributes - when source contains multiple kernels.\n",
"#define NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \\\n",
"            CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name))))\n",
"#define NAMED_KERNEL_ATTR_SG1(name) \\\n",
"    NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name))))\n",
"#define NAMED_KERNEL_ATTR(name) \\\n",
"    CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name)\n",
"#endif\n",
"/*******************************************************************************\n",
" * Copyright 2020-2021 Intel Corporation\n",
" *\n",
" * Licensed under the Apache License, Version 2.0 (the \"License\");\n",
" * you may not use this file except in compliance with the License.\n",
" * You may obtain a copy of the License at\n",
" *\n",
" *     http://www.apache.org/licenses/LICENSE-2.0\n",
" *\n",
" * Unless required by applicable law or agreed to in writing, software\n",
" * distributed under the License is distributed on an \"AS IS\" BASIS,\n",
" * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
" * See the License for the specific language governing permissions and\n",
" * limitations under the License.\n",
" *******************************************************************************/\n",
"#ifndef GPU_OCL_OFFSETS_H\n",
"#define GPU_OCL_OFFSETS_H\n",
"int off_ncdhw(int n, int c, int d, int h, int w, int C, int D, int H, int W) {\n",
"    int off = 0;\n",
"    off += n * C * D * H * W;\n",
"    off += c * D * H * W;\n",
"    off += d * H * W;\n",
"    off += h * W;\n",
"    off += w;\n",
"    return off;\n",
"}\n",
"int off_ndhwc(int n, int c, int d, int h, int w, int C, int D, int H, int W) {\n",
"    int off = 0;\n",
"    off += n * D * H * W * C;\n",
"    off += d * H * W * C;\n",
"    off += h * W * C;\n",
"    off += w * C;\n",
"    off += c;\n",
"    return off;\n",
"}\n",
"int off_nCdhw16c(\n",
"        int n, int c, int d, int h, int w, int C, int D, int H, int W) {\n",
"    int off = 0;\n",
"    off += n * (C / 16) * D * H * W * 16;\n",
"    off += (c / 16) * D * H * W * 16;\n",
"    off += d * H * W * 16;\n",
"    off += h * W * 16;\n",
"    off += w * 16;\n",
"    off += c % 16;\n",
"    return off;\n",
"}\n",
"int off_NCdhw16n16c(\n",
"        int n, int c, int d, int h, int w, int C, int D, int H, int W) {\n",
"    int off = 0;\n",
"    off += (n / 16) * (C / 16) * D * H * W * 16 * 16;\n",
"    off += (c / 16) * D * H * W * 16 * 16;\n",
"    off += d * H * W * 16 * 16;\n",
"    off += h * W * 16 * 16;\n",
"    off += w * 16 * 16;\n",
"    off += (n % 16) * 16;\n",
"    off += (c % 16);\n",
"    return off;\n",
"}\n",
"int off_nCdhw32c(\n",
"        int n, int c, int d, int h, int w, int C, int D, int H, int W) {\n",
"    int c_32_block = OC % 32 ? (32 + OC - (OC % 32)) : OC;\n",
"    int off = 0;\n",
"    off += n * (c_32_block / 32) * G * D * H * W * 32;\n",
"    off += (c / 32) * D * H * W * 32;\n",
"    off += d * H * W * 32;\n",
"    off += h * W * 32;\n",
"    off += w * 32;\n",
"    off += c % 32;\n",
"    return off;\n",
"}\n",
"int off_NCdhw32n16c(\n",
"        int n, int c, int d, int h, int w, int C, int D, int H, int W) {\n",
"    int off = 0;\n",
"    off += (n / 32) * (C / 16) * D * H * W * 32 * 16;\n",
"    off += (c / 16) * D * H * W * 32 * 16;\n",
"    off += d * H * W * 32 * 16;\n",
"    off += h * W * 32 * 16;\n",
"    off += w * 32 * 16;\n",
"    off += (n % 32) * 16;\n",
"    off += (c % 16);\n",
"    return off;\n",
"}\n",
"int off_NCdhw32n32c(\n",
"        int n, int c, int d, int h, int w, int C, int D, int H, int W) {\n",
"    int c_32_block = OC % 32 ? (32 + OC - (OC % 32)) : OC;\n",
"    int off = 0;\n",
"    off += (n / 32) * (c_32_block / 32) * D * H * W * 32 * 32;\n",
"    off += (c / 32) * D * H * W * 32 * 32;\n",
"    off += d * H * W * 32 * 32;\n",
"    off += h * W * 32 * 32;\n",
"    off += w * 32 * 32;\n",
"    off += (n % 32) * 32;\n",
"    off += (c % 32);\n",
"    return off;\n",
"}\n",
"int off_gOdhwi16o(int g, int o, int i, int d, int h, int w, int O, int I, int D,\n",
"        int H, int W) {\n",
"    int off = 0;\n",
"    off += g * (O / 16) * D * H * W * I * 16;\n",
"    off += (o / 16) * D * H * W * I * 16;\n",
"    off += d * H * W * I * 16;\n",
"    off += h * W * I * 16;\n",
"    off += w * I * 16;\n",
"    off += i * 16;\n",
"    off += (o % 16);\n",
"    return off;\n",
"}\n",
"int off_gOIdhw16i16o(int g, int o, int i, int d, int h, int w, int O, int I,\n",
"        int D, int H, int W) {\n",
"    int off = 0;\n",
"    off += g * (O / 16) * (I / 16) * D * H * W * 16 * 16;\n",
"    off += (o / 16) * (I / 16) * D * H * W * 16 * 16;\n",
"    off += (i / 16) * D * H * W * 16 * 16;\n",
"    off += d * H * W * 16 * 16;\n",
"    off += h * W * 16 * 16;\n",
"    off += w * 16 * 16;\n",
"    off += (i % 16) * 16;\n",
"    off += (o % 16);\n",
"    return off;\n",
"}\n",
"int off_gIOdhw16i16o(int g, int o, int i, int d, int h, int w, int O, int I,\n",
"        int D, int H, int W) {\n",
"    int off = 0;\n",
"    off += g * (I / 16) * (O / 16) * D * H * W * 16 * 16;\n",
"    off += (i / 16) * (O / 16) * D * H * W * 16 * 16;\n",
"    off += (o / 16) * D * H * W * 16 * 16;\n",
"    off += d * H * W * 16 * 16;\n",
"    off += h * W * 16 * 16;\n",
"    off += w * 16 * 16;\n",
"    off += (i % 16) * 16;\n",
"    off += (o % 16);\n",
"    return off;\n",
"}\n",
"int src_off(int n, int c, int d, int h, int w) {\n",
"#if SRC_NCHW\n",
"    return off_ncdhw(n, c, d, h, w, G * IC, ID, IH, IW);\n",
"#elif SRC_NHWC\n",
"    return off_ndhwc(n, c, d, h, w, G * IC, ID, IH, IW);\n",
"#elif SRC_W16C\n",
"    return off_nCdhw16c(n, c, d, h, w, G * IC, ID, IH, IW);\n",
"#elif SRC_16N16C\n",
"    return off_NCdhw16n16c(n, c, d, h, w, G * IC, ID, IH, IW);\n",
"#else\n",
"#error \"Unknown layout\"\n",
"#endif\n",
"}\n",
"int wei_off(int g, int o, int i, int d, int h, int w) {\n",
"#if WEI_I16O\n",
"    return off_gOdhwi16o(g, o, i, d, h, w, OC, IC, KD, KH, KW);\n",
"#elif WEI_16I16O\n",
"    return off_gOIdhw16i16o(g, o, i, d, h, w, OC, IC, KD, KH, KW);\n",
"#elif WEI_16I16O_FLIPPED\n",
"    return off_gIOdhw16i16o(g, o, i, d, h, w, OC, IC, KD, KH, KW);\n",
"#else\n",
"#error \"Unknown layout\"\n",
"#endif\n",
"    return 0;\n",
"}\n",
"int dst_off(int n, int c, int d, int h, int w) {\n",
"#if DST_NCHW\n",
"    return off_ncdhw(n, c, d, h, w, G * OC_WO_PADDING, OD, OH, OW);\n",
"#elif DST_NHWC\n",
"    return off_ndhwc(n, c, d, h, w, G * OC, OD, OH, OW);\n",
"#elif DST_W16C\n",
"    return off_nCdhw16c(n, c, d, h, w, G * OC, OD, OH, OW);\n",
"#elif DST_16N16C\n",
"    return off_NCdhw16n16c(n, c, d, h, w, G * OC, OD, OH, OW);\n",
"#elif DST_W32C\n",
"    return off_nCdhw32c(n, c, d, h, w, G * OC, OD, OH, OW);\n",
"#elif DST_32N16C\n",
"    return off_NCdhw32n16c(n, c, d, h, w, G * OC, OD, OH, OW);\n",
"#elif DST_32N32C\n",
"    return off_NCdhw32n32c(n, c, d, h, w, G * OC, OD, OH, OW);\n",
"#else\n",
"#error \"Unknown layout\"\n",
"#endif\n",
"}\n",
"#endif // GPU_OCL_OFFSETS_H\n",
"#define BASE_OC_TAIL (SUB_GROUP_SIZE - (OC - OC_WO_PADDING))\n",
"#define _BLOCK_READ_DST(v, n_c, ptr) \\\n",
"    if (n_c == 8) \\\n",
"        (*(DATA8_T *)(v)) = CONVERT_DATA8_T( \\\n",
"                vload8(0, (const __global DST_DATA_T *)(ptr))); \\\n",
"    if (n_c == 4) \\\n",
"        (*(DATA4_T *)(v)) = CONVERT_DATA4_T( \\\n",
"                vload4(0, (const __global DST_DATA_T *)(ptr))); \\\n",
"    if (n_c == 2) \\\n",
"        (*(DATA2_T *)(v)) = CONVERT_DATA2_T( \\\n",
"                vload2(0, (const __global DST_DATA_T *)(ptr))); \\\n",
"    if (n_c == 1) \\\n",
"        (*(DATA_T *)(v)) = CONVERT_DATA_T(*(__global DST_DATA_T *)(ptr));\n",
"#define _BLOCK_READ8(ptr) \\\n",
"    AS_DATA8_T(BLOCK_READ8((const __global BLOCK_DATA_T *)(ptr)))\n",
"#define _BLOCK_READ4(ptr) \\\n",
"    AS_DATA4_T(BLOCK_READ4((const __global BLOCK_DATA_T *)(ptr)))\n",
"#define _BLOCK_READ2(ptr) \\\n",
"    AS_DATA2_T(BLOCK_READ2((const __global BLOCK_DATA_T *)(ptr)))\n",
"#define _BLOCK_READ(ptr) \\\n",
"    AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)(ptr)))\n",
"#ifdef DST_DT_S8\n",
"#if DST_NCHW\n",
"#define _BLOCK_WRITE8(ptr, v) \\\n",
"    vstore8(CONVERT_DST_DATA8_T(v), 0, (__global DST_DATA_T *)(ptr));\n",
"#define _BLOCK_WRITE4(ptr, v) \\\n",
"    vstore4(CONVERT_DST_DATA4_T(v), 0, (__global DST_DATA_T *)(ptr));\n",
"#define _BLOCK_WRITE2(ptr, v) \\\n",
"    vstore2(CONVERT_DST_DATA2_T(v), 0, (__global DST_DATA_T *)(ptr));\n",
"#define _BLOCK_WRITE(ptr, v) \\\n",
"    *(__global DST_DATA_T *)(ptr) = CONVERT_DST_DATA_T(v);\n",
"#else\n",
"#define _BLOCK_WRITE8(ptr, v) \\\n",
"    BLOCK_WRITE_DST8((__global DST_DATA_T *)(ptr), CONVERT_DST_DATA8_T(v));\n",
"#define _BLOCK_WRITE4(ptr, v) \\\n",
"    BLOCK_WRITE_DST4((__global DST_DATA_T *)(ptr), CONVERT_DST_DATA4_T(v));\n",
"#define _BLOCK_WRITE2(ptr, v) \\\n",
"    BLOCK_WRITE_DST2((__global DST_DATA_T *)(ptr), CONVERT_DST_DATA2_T(v));\n",
"#define _BLOCK_WRITE(ptr, v) \\\n",
"    BLOCK_WRITE_DST((__global DST_DATA_T *)(ptr), CONVERT_DST_DATA_T(v));\n",
"#endif\n",
"#else\n",
"#define _BLOCK_WRITE8(ptr, v) \\\n",
"    BLOCK_WRITE8((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA8_T(v));\n",
"#define _BLOCK_WRITE4(ptr, v) \\\n",
"    BLOCK_WRITE4((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA4_T(v));\n",
"#define _BLOCK_WRITE2(ptr, v) \\\n",
"    BLOCK_WRITE2((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA2_T(v));\n",
"#define _BLOCK_WRITE(ptr, v) \\\n",
"    BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA_T(v));\n",
"#endif\n",
"#define IS_3D (OD > 1)\n",
"#define IS_1STCONV (IC == 3)\n",
"#define HAS_PAD_D (PD > 0 || (OD - 1) * SD - PD + (KD - 1) * (1 + DD) >= ID)\n",
"#define HAS_PAD_H (PH > 0 || (OH - 1) * SH - PH + (KH - 1) * (1 + DH) >= IH)\n",
"#define HAS_PAD_W (PW > 0 || (OW - 1) * SW - PW + (KW - 1) * (1 + DW) >= IW)\n",
"#define ENABLE_SRC_BUF (MB_BLOCK == 1 && KW >= 3)\n",
"#define W_VEC (IS_1STCONV && ENABLE_SRC_BUF && KW >= 5 && SW <= 3)\n",
"#define C_VEC (!W_VEC)\n",
"#define IC_INNER (C_VEC ? (IC < 16 ? IC : 16) : 1)\n",
"#define IC_OUTER (IC_BLOCK / IC_INNER)\n",
"#define OC_OUTER (OC_BLOCK / 16)\n",
"#define IW_BLOCK (SW * (OW_BLOCK - 1) + (KW - 1) * (1 + DW) + 1)\n",
"#define OW_INNER (C_VEC ? 1 : 16)\n",
"#define IW_INNER OW_INNER\n",
"#define OW_OUTER ((OW_BLOCK + OW_INNER - 1) / OW_INNER)\n",
"#define IW_OUTER ((IW_BLOCK + IW_INNER - 1) / IW_INNER)\n",
"#define C_SIZE (MB_BLOCK * OC_OUTER * OW_BLOCK)\n",
"#if OW_BLOCK >= 32\n",
"#error \"Block is too big for unrolled_read and unrolled_write.\"\n",
"#endif\n",
"// Layout is:\n",
"// - cwn[16c] for NCdhw16n16c (16c is mapped to sub-group)\n",
"// - ncw[16c] for others (16c is mapped to sub-group)\n",
"int src_idx_c_vec(int mb_block, int ic_outer, int ow_outer) {\n",
"    if (SRC_16N16C)\n",
"        return ic_outer * OW_BLOCK * MB_BLOCK + ow_outer * MB_BLOCK + mb_block;\n",
"    return mb_block * IC_OUTER * OW_BLOCK + ic_outer * OW_BLOCK + ow_outer;\n",
"}\n",
"// Layout is ncW[16w] (16w is mapped to sub-group).\n",
"int src_idx_w_vec(int mb_block, int ic_outer, int ow_outer) {\n",
"    return mb_block * IC_OUTER * OW_OUTER + ic_outer * OW_OUTER + ow_outer;\n",
"}\n",
"int src_idx(int mb_block, int ic_outer, int ow_outer) {\n",
"    if (C_VEC) return src_idx_c_vec(mb_block, ic_outer, ow_outer);\n",
"    return src_idx_w_vec(mb_block, ic_outer, ow_outer);\n",
"}\n",
"// Same as src_idx_c_vec but contains contiguous input spatial (even unused).\n",
"int src_buf_idx_c_vec(int mb_block, int ic_outer, int iw_outer) {\n",
"    if (SRC_16N16C)\n",
"        return mb_block * IC_OUTER * IW_OUTER + ic_outer * IW_OUTER + iw_outer;\n",
"    return ic_outer * IW_OUTER * MB_BLOCK + iw_outer * MB_BLOCK + mb_block;\n",
"}\n",
"// Same as src_idx_w_vec but contains contiguous input spatial (even unused).\n",
"int src_buf_idx_w_vec(int mb_block, int ic_outer, int iw_outer) {\n",
"    return mb_block * IC_OUTER * IW_OUTER + ic_outer * IW_OUTER + iw_outer;\n",
"}\n",
"int src_buf_idx(int mb_block, int ic_outer, int iw_outer) {\n",
"    if (C_VEC) return src_buf_idx_c_vec(mb_block, ic_outer, iw_outer);\n",
"    return src_buf_idx_w_vec(mb_block, ic_outer, iw_outer);\n",
"}\n",
"// Layout is IO16i[16o] (16o is mapped to sub-group).\n",
"int wei_idx_c_vec(int oc_outer, int ic_outer) {\n",
"    return ic_outer * OC_OUTER * IC_INNER + oc_outer * IC_INNER;\n",
"}\n",
"// Layout is Oi[16o] (16o is mapped to sub-group).\n",
"int wei_idx_w_vec(int oc_outer, int ic_outer) {\n",
"    return oc_outer * IC_OUTER + ic_outer;\n",
"}\n",
"int wei_idx(int oc_outer, int ic_outer) {\n",
"    if (C_VEC) return wei_idx_c_vec(oc_outer, ic_outer);\n",
"    return wei_idx_w_vec(oc_outer, ic_outer);\n",
"}\n",
"// Layout is:\n",
"// - cwn[16c] for NCdhw16n16c (16c is mapped to sub-group)\n",
"// - ncw[16c] for nCdhw16c (16c is mapped to sub-group)\n",
"int dst_idx(int mb_block, int oc_outer, int ow_block) {\n",
"    if (DST_16N16C)\n",
"        return oc_outer * OW_BLOCK * MB_BLOCK + ow_block * MB_BLOCK + mb_block;\n",
"    return mb_block * OC_OUTER * OW_BLOCK + oc_outer * OW_BLOCK + ow_block;\n",
"}\n",
"#define copy(dst, src, n) \\\n",
"    do { \\\n",
"        for (int i = 0; i < (n); i++) \\\n",
"            (dst)[i] = (src)[i]; \\\n",
"    } while (0)\n",
"// block[i].j = ptr[i * 16 + j], 0 <= i < n, 0 <= j < 16\n",
"#define unrolled_read(n, block, ptr) \\\n",
"    do { \\\n",
"        if ((n)&16) { \\\n",
"            *((DATA8_T *)(block)) = _BLOCK_READ8((ptr)); \\\n",
"            *((DATA8_T *)((block) + 8)) = _BLOCK_READ8((ptr) + 8 * 16); \\\n",
"        } \\\n",
"        if ((n)&8) \\\n",
"            *((DATA8_T *)((block) + ((n) & ~15))) \\\n",
"                    = _BLOCK_READ8((ptr) + ((n) & ~15) * 16); \\\n",
"        if ((n)&4) \\\n",
"            *((DATA4_T *)((block) + ((n) & ~7))) \\\n",
"                    = _BLOCK_READ4((ptr) + ((n) & ~7) * 16); \\\n",
"        if ((n)&2) \\\n",
"            *((DATA2_T *)((block) + ((n) & ~3))) \\\n",
"                    = _BLOCK_READ2((ptr) + ((n) & ~3) * 16); \\\n",
"        if ((n)&1) \\\n",
"            *((block) + ((n) & ~1)) = _BLOCK_READ((ptr) + ((n) & ~1) * 16); \\\n",
"    } while (0)\n",
"// block[0].i = ptr[i * stride], 0 <= i < n\n",
"// block[0].i = 0, n <= i < 16\n",
"#define strided_read(block, ptr, n, stride) \\\n",
"    do { \\\n",
"        if ((n) == 16 && (stride) == 1) { \\\n",
"            (block)[0] = _BLOCK_READ((ptr)); \\\n",
"        } else { \\\n",
"            int local_id = get_local_id(0); \\\n",
"            (block)[0] = (local_id < (n)) ? (ptr)[local_id * (stride)] : 0; \\\n",
"        } \\\n",
"    } while (0)\n",
"// ptr[i * 16 + j] = block[i].j, 0 <= i < n, 0 <= j < 16\n",
"#if DST_NCHW\n",
"#define unrolled_write(n, block, ptr) \\\n",
"    do { \\\n",
"        if ((n)&16) { \\\n",
"            _BLOCK_WRITE8((ptr), *(DATA8_T *)((block))); \\\n",
"            _BLOCK_WRITE8((ptr) + 8 * 16, *(DATA8_T *)((block) + 8)); \\\n",
"        } \\\n",
"        if ((n)&8) \\\n",
"            _BLOCK_WRITE8( \\\n",
"                    (ptr) + ((n) & ~15), *(DATA8_T *)((block) + ((n) & ~15))); \\\n",
"        if ((n)&4) \\\n",
"            _BLOCK_WRITE4( \\\n",
"                    (ptr) + ((n) & ~7), *(DATA4_T *)((block) + ((n) & ~7))); \\\n",
"        if ((n)&2) \\\n",
"            _BLOCK_WRITE2( \\\n",
"                    (ptr) + ((n) & ~3), *(DATA2_T *)((block) + ((n) & ~3))); \\\n",
"        if ((n)&1) _BLOCK_WRITE((ptr) + ((n) & ~1), *((block) + ((n) & ~1))); \\\n",
"    } while (0)\n",
"#else\n",
"#define unrolled_write(n, block, ptr) \\\n",
"    do { \\\n",
"        if ((n)&16) { \\\n",
"            _BLOCK_WRITE8((ptr), *(DATA8_T *)((block))); \\\n",
"            _BLOCK_WRITE8((ptr) + 8 * 16, *(DATA8_T *)((block) + 8)); \\\n",
"        } \\\n",
"        if ((n)&8) \\\n",
"            _BLOCK_WRITE8((ptr) + ((n) & ~15) * 16, \\\n",
"                    *(DATA8_T *)((block) + ((n) & ~15))); \\\n",
"        if ((n)&4) \\\n",
"            _BLOCK_WRITE4((ptr) + ((n) & ~7) * 16, \\\n",
"                    *(DATA4_T *)((block) + ((n) & ~7))); \\\n",
"        if ((n)&2) \\\n",
"            _BLOCK_WRITE2((ptr) + ((n) & ~3) * 16, \\\n",
"                    *(DATA2_T *)((block) + ((n) & ~3))); \\\n",
"        if ((n)&1) \\\n",
"            _BLOCK_WRITE((ptr) + ((n) & ~1) * 16, *((block) + ((n) & ~1))); \\\n",
"    } while (0)\n",
"#endif\n",
"// Supports C vectorization only.\n",
"#define multiply_row(C, A, B, mb_block, oc_outer, ic_outer, ow_outer) \\\n",
"    do { \\\n",
"        int b_off = wei_idx((oc_outer), (ic_outer)); \\\n",
"        int c_off = dst_idx((mb_block), (oc_outer), (ow_outer)); \\\n",
"        for (int ic_inner = 0; ic_inner < min(IC_WO_PADDING, IC_INNER); \\\n",
"                ic_inner++) { \\\n",
"            (C)[c_off] = fma(intel_sub_group_shuffle((A), ic_inner), \\\n",
"                    (B)[b_off + ic_inner], (C)[c_off]); \\\n",
"        } \\\n",
"    } while (0)\n",
"// Supports C vectorization only.\n",
"#define read_src_and_multiply_w16c_dense(ptr, iw, kw, C, B) \\\n",
"    do { \\\n",
"        for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) \\\n",
"            for (int ic_outer = 0; ic_outer < IC_OUTER; ic_outer++) { \\\n",
"                int idx = src_idx(mb_block, ic_outer, 0); \\\n",
"                for (int ow_block = 0; ow_block < OW_BLOCK; ow_block += 8) { \\\n",
"                    int ow_bound = min(8, OW_BLOCK - ow_block); \\\n",
"                    DATA_T A[8]; \\\n",
"                    int off = src_off(mb_block, ic_outer * IC_INNER, 0, 0, \\\n",
"                            ow_block + (kw) * (1 + DW)); \\\n",
"                    unrolled_read(ow_bound, A, &(ptr)[off]); \\\n",
"                    for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \\\n",
"                        for (int i = 0; i < ow_bound; i++) { \\\n",
"                            multiply_row((C), A[i], (B), mb_block, oc_outer, \\\n",
"                                    ic_outer, ow_block + i); \\\n",
"                        } \\\n",
"                    } \\\n",
"                } \\\n",
"            } \\\n",
"    } while (0)\n",
"// Supports C vectorization only.\n",
"#define read_src_and_multiply_16n16c(ptr, iw, kw, do_w_check, C, B) \\\n",
"    do { \\\n",
"        for (int ow_block = 0; ow_block < OW_BLOCK; ow_block++) { \\\n",
"            int iw_off = ow_block * SW + (kw) * (1 + DW); \\\n",
"            if ((do_w_check) && HAS_PAD_W \\\n",
"                    && ((iw) + iw_off < 0 || (iw) + iw_off >= IW)) \\\n",
"                continue; \\\n",
"            for (int ic_outer = 0; ic_outer < IC_OUTER; ic_outer++) \\\n",
"                __attribute__((opencl_unroll_hint)) /*  attr:no-format */ \\\n",
"                        for (int mb_block = 0; mb_block < MB_BLOCK; \\\n",
"                                mb_block += 8) { \\\n",
"                    int mb_bound = min(8, MB_BLOCK - mb_block); \\\n",
"                    DATA_T A[8]; \\\n",
"                    int off = src_off( \\\n",
"                            mb_block, ic_outer * IC_INNER, 0, 0, iw_off); \\\n",
"                    unrolled_read(mb_bound, A, &(ptr)[off]); \\\n",
"                    for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \\\n",
"                        for (int i = 0; i < mb_bound; i++) { \\\n",
"                            multiply_row((C), A[i], (B), mb_block + i, \\\n",
"                                    oc_outer, ic_outer, ow_block); \\\n",
"                        } \\\n",
"                    } \\\n",
"                } \\\n",
"        } \\\n",
"    } while (0)\n",
"// Supports C vectorization only.\n",
"#define read_src_and_multiply_common(ptr, iw, kw, do_w_check, C, B) \\\n",
"    do { \\\n",
"        for (int i = 0; i < OW_BLOCK; i++) { \\\n",
"            int iw_off = i * SW + (kw) * (1 + DW); \\\n",
"            if ((do_w_check) && HAS_PAD_W \\\n",
"                    && ((iw) + iw_off < 0 || (iw) + iw_off >= IW)) \\\n",
"                continue; \\\n",
"            for (int ic_outer = 0; ic_outer < IC_OUTER; ic_outer++) { \\\n",
"                for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \\\n",
"                    int off = src_off( \\\n",
"                            mb_block, ic_outer * IC_INNER, 0, 0, iw_off); \\\n",
"                    DATA_T A; \\\n",
"                    strided_read(&A, &(ptr)[off], IC_INNER, \\\n",
"                            src_off(0, 1, 0, 0, 0)); \\\n",
"                    for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \\\n",
"                        int b_off = wei_idx(oc_outer, ic_outer); \\\n",
"                        int c_off = dst_idx(mb_block, oc_outer, i); \\\n",
"                        for (int ic_inner = 0; \\\n",
"                                ic_inner < min(IC_WO_PADDING, IC_INNER); \\\n",
"                                ic_inner++) { \\\n",
"                            (C)[c_off] = fma( \\\n",
"                                    intel_sub_group_shuffle(A, ic_inner), \\\n",
"                                    (B)[b_off + ic_inner], (C)[c_off]); \\\n",
"                        } \\\n",
"                    } \\\n",
"                } \\\n",
"            } \\\n",
"        } \\\n",
"    } while (0)\n",
"// Read MB_BLOCK x IC_BLOCK x OW_BLOCK block of src.\n",
"// Supports C vectorization only.\n",
"#define read_src_and_multiply(ptr, iw, kw, do_w_check, C, B) \\\n",
"    do { \\\n",
"        if (SRC_W16C && (!(do_w_check) || (!HAS_PAD_W && SW == 1))) { \\\n",
"            read_src_and_multiply_w16c_dense((ptr), (iw), (kw), (C), (B)); \\\n",
"        } else if (SRC_16N16C) { \\\n",
"            read_src_and_multiply_16n16c( \\\n",
"                    (ptr), (iw), (kw), (do_w_check), (C), (B)); \\\n",
"        } else { \\\n",
"            read_src_and_multiply_common( \\\n",
"                    (ptr), (iw), (kw), (do_w_check), (C), (B)); \\\n",
"        } \\\n",
"    } while (0)\n",
"#define read_src_buf(buf, ptr, iw) \\\n",
"    do { \\\n",
"        for (int iw_outer = 0; iw_outer < IW_OUTER; iw_outer++) { \\\n",
"            int iw_inner = (C_VEC ? 0 : get_local_id(0)); \\\n",
"            int iw_block = iw_outer * IW_INNER + iw_inner; \\\n",
"            if (HAS_PAD_W && ((iw) + iw_block < 0 || (iw) + iw_block >= IW)) \\\n",
"                continue; \\\n",
"            for (int ic_outer = 0; ic_outer < IC_OUTER; ic_outer++) { \\\n",
"                for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \\\n",
"                    int off = src_off( \\\n",
"                            mb_block, ic_outer * IC_INNER, 0, 0, iw_block); \\\n",
"                    int idx = src_buf_idx(mb_block, ic_outer, iw_outer); \\\n",
"                    if (C_VEC) { \\\n",
"                        strided_read(&(buf)[idx], &(ptr)[off], IC_INNER, \\\n",
"                                src_off(0, 1, 0, 0, 0)); \\\n",
"                    } else { \\\n",
"                        (buf)[idx] = (ptr)[off]; \\\n",
"                    } \\\n",
"                } \\\n",
"            } \\\n",
"        } \\\n",
"    } while (0)\n",
"// Read IC_BLOCK x OC_BLOCK block of weights.\n",
"#define read_wei_block(block, ptr) \\\n",
"    do { \\\n",
"        for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \\\n",
"            int ic_bound = min(IC_WO_PADDING, IC_BLOCK); \\\n",
"            for (int ic_block = 0; ic_block < ic_bound; ic_block += 16) { \\\n",
"                int off = wei_off(0, oc_outer * 16, ic_block, 0, 0, 0); \\\n",
"                int idx = wei_idx(oc_outer, ic_block); \\\n",
"                unrolled_read(min(16, ic_bound - ic_block), &(block)[idx], \\\n",
"                        &(ptr)[off]); \\\n",
"            } \\\n",
"        } \\\n",
"    } while (0)\n",
"#define read_wei_and_multiply_c_vec(wei, kw, C, A) \\\n",
"    do { \\\n",
"        for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \\\n",
"            int ic_bound1 = min(IC_WO_PADDING, IC_BLOCK); \\\n",
"            for (int ic_block = 0; ic_block < ic_bound1; ic_block += 8) { \\\n",
"                int ic_bound2 = min(8, ic_bound1 - ic_block); \\\n",
"                int off = wei_off(0, oc_outer * 16, ic_block, 0, 0, 0); \\\n",
"                DATA_T B[8]; \\\n",
"                unrolled_read(ic_bound2, B, &(wei)[off]); \\\n",
"                for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \\\n",
"                    for (int ow_block = 0; ow_block < OW_BLOCK; ow_block++) { \\\n",
"                        int iw_off = ow_block * SW + (kw) * (1 + DW); \\\n",
"                        int buf_idx = src_buf_idx(mb_block, 0, iw_off); \\\n",
"                        int c_off = dst_idx(mb_block, oc_outer, ow_block); \\\n",
"                        for (int i = 0; i < ic_bound2; i++) { \\\n",
"                            (C)[c_off] \\\n",
"                                    = fma(intel_sub_group_shuffle( \\\n",
"                                                  (A)[buf_idx], ic_block + i), \\\n",
"                                            B[i], (C)[c_off]); \\\n",
"                        } \\\n",
"                    } \\\n",
"                } \\\n",
"            } \\\n",
"        } \\\n",
"    } while (0)\n",
"DATA_T shuffle_a_value(int mb_block, int ic_block, int ow_outer, int ow_inner,\n",
"        int kw, const DATA_T *A) {\n",
"    int iw_off0 = ow_outer * OW_INNER * SW + kw * (1 + DW);\n",
"    int iw_outer0 = iw_off0 / IW_INNER;\n",
"    int buf_idx0 = src_buf_idx(mb_block, ic_block, iw_outer0);\n",
"    int iw_off = iw_off0 + ow_inner * SW;\n",
"    int iw_outer = iw_off / IW_INNER;\n",
"    DATA4_T A_shuf = 0;\n",
"    for (int i = 0; i < SW + 1; i++) {\n",
"        A_shuf[i] = (iw_outer0 + i < IW_OUTER) ? A[buf_idx0 + i] : 0;\n",
"    }\n",
"    A_shuf = AS_DATA4_T(intel_sub_group_shuffle(\n",
"            AS_BLOCK_DATA4_T(A_shuf), iw_off % IW_INNER));\n",
"    return A_shuf[iw_outer - iw_outer0];\n",
"}\n",
"#define read_wei_and_multiply_w_vec(wei, kw, C, A) \\\n",
"    do { \\\n",
"        for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \\\n",
"            int ic_bound1 = min(IC_WO_PADDING, IC_BLOCK); \\\n",
"            for (int ic_block = 0; ic_block < ic_bound1; ic_block += 8) { \\\n",
"                int ic_bound2 = min(8, ic_bound1 - ic_block); \\\n",
"                int off = wei_off(0, oc_outer * 16, ic_block, 0, 0, 0); \\\n",
"                DATA_T B[8]; \\\n",
"                unrolled_read(ic_bound2, B, &(wei)[off]); \\\n",
"                for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) \\\n",
"                    /*  IC_INNER is 1 with W vectorization. */ \\\n",
"                    for (int ic_inner = 0; ic_inner < ic_bound2; ic_inner++) \\\n",
"                        for (int ow_outer = 0; ow_outer < OW_OUTER; \\\n",
"                                ow_outer++) { \\\n",
"                            int ow_bound = min( \\\n",
"                                    OW_INNER, OW_BLOCK - ow_outer * OW_INNER); \\\n",
"                            for (int i = 0; i < ow_bound; i++) { \\\n",
"                                DATA_T A_val = shuffle_a_value(mb_block, \\\n",
"                                        ic_block + ic_inner, ow_outer, i, \\\n",
"                                        (kw), (A)); \\\n",
"                                int c_off = dst_idx(mb_block, oc_outer, \\\n",
"                                        ow_outer * OW_INNER + i); \\\n",
"                                (C)[c_off] = fma(A_val, \\\n",
"                                        B[ic_block + ic_inner], (C)[c_off]); \\\n",
"                            } \\\n",
"                        } \\\n",
"            } \\\n",
"        } \\\n",
"    } while (0)\n",
"#define read_wei_and_multiply(wei, kw, C, A) \\\n",
"    do { \\\n",
"        if (W_VEC) \\\n",
"            read_wei_and_multiply_w_vec((wei), (kw), (C), (A)); \\\n",
"        else \\\n",
"            read_wei_and_multiply_c_vec((wei), (kw), (C), (A)); \\\n",
"    } while (0)\n",
"// Read MB_BLOCK x OC_BLOCK x OW_BLOCK block of dst.\n",
"#define read_dst_block(block, ptr, ow) \\\n",
"    do { \\\n",
"        if (DST_NCHW) { \\\n",
"            for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \\\n",
"                int n_channels = min(min(C_SIZE, OW - ow), OW_BLOCK); \\\n",
"                bool w_oc_tail = BASE_OC_TAIL > 0 \\\n",
"                        && OC_WO_PADDING - (ocb ? ocb : SUB_GROUP_SIZE) \\\n",
"                                < OC_BLOCK; \\\n",
"                int loc_oc_tail = w_oc_tail ? BASE_OC_TAIL : SUB_GROUP_SIZE; \\\n",
"                int oc_loop = (!w_oc_tail || sglid < loc_oc_tail) \\\n",
"                        ? C_SIZE \\\n",
"                        : n_channels; \\\n",
"                for (int oc_outer = 0; oc_outer < oc_loop; oc_outer += 1) { \\\n",
"                    int oc_tail_idx = ((sglid < loc_oc_tail \\\n",
"                                               && oc_outer >= n_channels) \\\n",
"                                    ? (sglid + (16 * (C_SIZE / OW_BLOCK - 1))) \\\n",
"                                    : sglid); \\\n",
"                    int off = dst_off( \\\n",
"                            0, oc_tail_idx, 0, 0, (oc_outer % n_channels)); \\\n",
"                    int idx = oc_outer; \\\n",
"                    _BLOCK_READ_DST(&(block)[idx], 1, &(ptr)[off]); \\\n",
"                } \\\n",
"            } \\\n",
"        } else { \\\n",
"            int ow_bound = (OW % OW_BLOCK == 0) ? OW_BLOCK \\\n",
"                                                : min(OW_BLOCK, OW - (ow)); \\\n",
"            for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) \\\n",
"                for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) \\\n",
"                    for (int ow_block = 0; ow_block < ow_bound; ow_block++) { \\\n",
"                        int off = dst_off( \\\n",
"                                mb_block, oc_outer * 16, 0, 0, ow_block); \\\n",
"                        int idx = dst_idx(mb_block, oc_outer, ow_block); \\\n",
"                        if (DST_W32C) { \\\n",
"                            int off = dst_off( \\\n",
"                                    mb_block, oc_outer * 16, 0, 0, 0); \\\n",
"                            int idx = dst_idx(mb_block, oc_outer, 0); \\\n",
"                            for (int i = 0; i < OW_BLOCK && ow + i < OW; \\\n",
"                                    ++i) { \\\n",
"                                *((DATA_T *)&(block)[idx + i]) \\\n",
"                                        = CONVERT_DATA_T(BLOCK_READ_DST( \\\n",
"                                                &(ptr)[off + (32 * i)])); \\\n",
"                            } \\\n",
"                        } else if (DST_32N32C) { \\\n",
"                            int off = dst_off(mb_block, \\\n",
"                                    oc_outer * (DST_32N32C ? 32 : 16), 0, 0, \\\n",
"                                    ow_block); \\\n",
"                            int idx = dst_idx(mb_block, oc_outer, ow_block); \\\n",
"                            mb_block ? mb_block += 31 : mb_block; \\\n",
"                            for (int i = 0; i < 16; ++i) { \\\n",
"                                *((DATA_T *)&(block)[idx + i]) \\\n",
"                                        = CONVERT_DATA_T(BLOCK_READ_DST( \\\n",
"                                                &(ptr)[off + (32 * i)])); \\\n",
"                            } \\\n",
"                        } else { \\\n",
"                            (block)[idx] = _BLOCK_READ(&(ptr)[off]); \\\n",
"                        } \\\n",
"                    } \\\n",
"        } \\\n",
"    } while (0)\n",
"#define write_dst_block(block, ptr, ow) \\\n",
"    do { \\\n",
"        if (DST_W16C || DST_W32C) { \\\n",
"            for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) \\\n",
"                for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \\\n",
"                    int off = dst_off(mb_block, oc_outer * 16, 0, 0, 0); \\\n",
"                    int idx = dst_idx(mb_block, oc_outer, 0); \\\n",
"                    if (DST_W32C) { \\\n",
"                        for (int i = 0; i < OW_BLOCK && ow + i < OW; ++i) { \\\n",
"                            unrolled_write(1, &(block)[idx + i], \\\n",
"                                    &(ptr)[off + (32 * i)]); \\\n",
"                        } \\\n",
"                    } else if (OW % OW_BLOCK == 0 || (ow) + OW_BLOCK <= OW) { \\\n",
"                        unrolled_write(OW_BLOCK, &(block)[idx], &(ptr)[off]); \\\n",
"                    } else { \\\n",
"                        unrolled_write( \\\n",
"                                OW % OW_BLOCK, &(block)[idx], &(ptr)[off]); \\\n",
"                    } \\\n",
"                } \\\n",
"        } else if (DST_16N16C || DST_32N32C) { \\\n",
"            int ow_bound = (OW % OW_BLOCK == 0) ? OW_BLOCK \\\n",
"                                                : min(OW_BLOCK, OW - (ow)); \\\n",
"            for (int ow_block = 0; ow_block < ow_bound; ow_block++) \\\n",
"                for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) \\\n",
"                    for (int mb_block = 0; mb_block < MB_BLOCK; \\\n",
"                            mb_block += (DST_32N32C ? 32 : 16)) { \\\n",
"                        int off = dst_off(mb_block, \\\n",
"                                oc_outer * (DST_32N32C ? 32 : 16), 0, 0, \\\n",
"                                ow_block); \\\n",
"                        int idx = dst_idx(mb_block, oc_outer, ow_block); \\\n",
"                        if (DST_32N32C && MB > 8) { \\\n",
"                            for (int i = 0; i < C_SIZE; ++i) { \\\n",
"                                unrolled_write(1, &(block)[idx + i], \\\n",
"                                        &(ptr)[off + (32 * i)]); \\\n",
"                            } \\\n",
"                        } else { \\\n",
"                            unrolled_write(min(16, MB_BLOCK), &(block)[idx], \\\n",
"                                    &(ptr)[off]); \\\n",
"                        } \\\n",
"                    } \\\n",
"        } else if (DST_NCHW && sglid < OC_WO_PADDING - oc) { \\\n",
"            for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \\\n",
"                int n_channels = min(min(C_SIZE, OW - ow), OW_BLOCK); \\\n",
"                bool w_oc_tail = BASE_OC_TAIL > 0 \\\n",
"                        && OC_WO_PADDING - (ocb ? ocb : SUB_GROUP_SIZE) \\\n",
"                                < OC_BLOCK; \\\n",
"                int loc_oc_tail = w_oc_tail ? BASE_OC_TAIL : SUB_GROUP_SIZE; \\\n",
"                int oc_loop = (!w_oc_tail || sglid < loc_oc_tail) \\\n",
"                        ? C_SIZE \\\n",
"                        : n_channels; \\\n",
"                for (int oc_outer = 0; oc_outer < oc_loop; oc_outer += 1) { \\\n",
"                    int oc_tail_idx = ((sglid < loc_oc_tail \\\n",
"                                               && oc_outer >= n_channels) \\\n",
"                                    ? (sglid + (16 * (C_SIZE / OW_BLOCK - 1))) \\\n",
"                                    : sglid); \\\n",
"                    int off = dst_off( \\\n",
"                            0, oc_tail_idx, 0, 0, (oc_outer % n_channels)); \\\n",
"                    int idx = oc_outer; \\\n",
"                    unrolled_write(1, &(block)[oc_outer], &(ptr)[off]); \\\n",
"                } \\\n",
"            } \\\n",
"        } \\\n",
"    } while (0)\n",
"#define loop_ic_outermost(src, wei, C, id, ih, iw) \\\n",
"    do { \\\n",
"        __attribute__((opencl_unroll_hint(1))) /*  attr:no-format */ \\\n",
"                for (int ic = 0; ic < IC; ic += IC_BLOCK) { \\\n",
"            __attribute__((opencl_unroll_hint(1))) /*  attr:no-format */ \\\n",
"                    for (int kd = 0; kd < KD; kd++) { \\\n",
"                if (HAS_PAD_D \\\n",
"                        && ((id) + kd * (1 + DD) < 0 \\\n",
"                                || (id) + kd * (1 + DD) >= ID)) \\\n",
"                    continue; \\\n",
"                __attribute__((opencl_unroll_hint(1))) /*  attr:no-format */ \\\n",
"                        for (int kh = 0; kh < KH; kh++) { \\\n",
"                    if (HAS_PAD_H \\\n",
"                            && ((ih) + kh * (1 + DH) < 0 \\\n",
"                                    || (ih) + kh * (1 + DH) >= IH)) \\\n",
"                        continue; \\\n",
"                    const __global DATA_T *src1 = (src) \\\n",
"                            + src_off(0, 0, kd * (1 + DD), kh * (1 + DH), 0); \\\n",
"                    DATA_T A_buf[MB_BLOCK * IC_OUTER * IW_OUTER] = {0}; \\\n",
"                    if (ENABLE_SRC_BUF) read_src_buf(A_buf, src1, (iw)); \\\n",
"                    __attribute__( \\\n",
"                            (opencl_unroll_hint(KW))) /*  attr:no-format */ \\\n",
"                            for (int kw = 0; kw < KW; kw++) { \\\n",
"                        const __global DATA_T *wei1 \\\n",
"                                = (wei) + wei_off(0, 0, 0, kd, kh, kw); \\\n",
"                        DATA_T B[IC_OUTER * OC_OUTER * IC_INNER]; \\\n",
"                        if (ENABLE_SRC_BUF) { \\\n",
"                            read_wei_and_multiply(wei1, kw, (C), A_buf); \\\n",
"                        } else { \\\n",
"                            read_wei_block(B, wei1); \\\n",
"                            read_src_and_multiply(src1, (iw), kw, 1, (C), B); \\\n",
"                        } \\\n",
"                    } \\\n",
"                } \\\n",
"            } \\\n",
"            (src) += src_off(0, IC_BLOCK, 0, 0, 0); \\\n",
"            (wei) += wei_off(0, 0, IC_BLOCK, 0, 0, 0); \\\n",
"        } \\\n",
"    } while (0)\n",
"#define loop_kdhw_outermost(src, wei, C, id, ih, iw) \\\n",
"    do { \\\n",
"        for (int kd = 0; kd < KD; kd++) { \\\n",
"            if (HAS_PAD_D \\\n",
"                    && ((id) + kd * (1 + DD) < 0 \\\n",
"                            || (id) + kd * (1 + DD) >= ID)) \\\n",
"                continue; \\\n",
"            for (int kh = 0; kh < KH; kh++) { \\\n",
"                if (HAS_PAD_H \\\n",
"                        && ((ih) + kh * (1 + DH) < 0 \\\n",
"                                || (ih) + kh * (1 + DH) >= IH)) \\\n",
"                    continue; \\\n",
"                for (int kw = 0; kw < KW; kw++) { \\\n",
"                    if (HAS_PAD_W \\\n",
"                            && ((iw) + kw * (1 + DW) < 0 \\\n",
"                                    || (iw) + kw * (1 + DW) >= IW)) \\\n",
"                        continue; \\\n",
"                    /*  XXX: kw offset is applied in read_src_and_multiply(). */ \\\n",
"                    const __global DATA_T *src1 = (src) \\\n",
"                            + src_off(0, 0, kd * (1 + DD), kh * (1 + DH), 0); \\\n",
"                    const __global DATA_T *wei1 \\\n",
"                            = (wei) + wei_off(0, 0, 0, kd, kh, kw); \\\n",
"                    __attribute__((opencl_unroll_hint)) /*  attr:no-format */ \\\n",
"                            for (int ic = 0; ic < IC; ic += IC_BLOCK) { \\\n",
"                        DATA_T B[IC_OUTER * OC_OUTER * IC_INNER]; \\\n",
"                        read_wei_block(B, wei1); \\\n",
"                        read_src_and_multiply(src1, (iw), kw, 0, (C), B); \\\n",
"                        src1 += src_off(0, IC_BLOCK, 0, 0, 0); \\\n",
"                        wei1 += wei_off(0, 0, IC_BLOCK, 0, 0, 0); \\\n",
"                    } \\\n",
"                } \\\n",
"            } \\\n",
"        } \\\n",
"    } while (0)\n",
"__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))\n",
"__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) __kernel void\n",
"gen9_conv_fwd(const __global DATA_T *src, const __global DATA_T *wei,\n",
"        const __global DATA_T *bia, __global DST_DATA_T *dst POST_OP_ARGS) {\n",
"    int local_id = get_local_id(0);\n",
"    int sglid = get_sub_group_local_id();\n",
"    int g_ocb = get_group_id(0);\n",
"    int g = g_ocb / (OCB / OC_BLOCK);\n",
"    int ocb = g_ocb % (OCB / OC_BLOCK) * OC_BLOCK;\n",
"    int odhw = get_group_id(1) / (OMB / MB_BLOCK);\n",
"    int omb = get_group_id(1) % (OMB / MB_BLOCK) * MB_BLOCK;\n",
"    int ohw = IS_3D ? odhw % (OWB * OHB) : odhw;\n",
"    int od = IS_3D ? odhw / (OWB * OHB) : 0;\n",
"    int oh = (ohw / OWB) * OH_BLOCK;\n",
"    int ow = (ohw % OWB) * OW_BLOCK;\n",
"    int ocb_idx_omb_idx = get_group_id(2);\n",
"    int ocb_idx = ocb_idx_omb_idx / (MB / OMB);\n",
"    int omb_idx = ocb_idx_omb_idx % (MB / OMB);\n",
"    int oc = ocb_idx * OCB + ocb;\n",
"    int mb = omb_idx * OMB + omb;\n",
"    int ih = oh * SH - PH;\n",
"    int iw = ow * SW - PW;\n",
"    int id = od * SD - PD;\n",
"    // Vector type variables have less chance of being spilled for half data\n",
"    // type.\n",
"#if DT_F16 && C_SIZE == 8\n",
"    DATA8_T C = 0;\n",
"#elif DT_F16 && C_SIZE == 16\n",
"    DATA16_T C = 0;\n",
"#else\n",
"    DATA_T C[C_SIZE] = {0};\n",
"#endif\n",
"    src += src_off(mb, g * IC, id, ih, iw);\n",
"    wei += wei_off(g, oc, 0, 0, 0, 0);\n",
"#ifdef DST_DT_S8\n",
"    dst += dst_off(mb, g * OC + oc, od, oh, ow);\n",
"#else\n",
"    dst += dst_off(mb, g * OC + oc, od, oh, ow);\n",
"#endif\n",
"    if ((DST_32N32C || DST_W32C) && (OC_BLOCK % 32 != 0)\n",
"            && oc > OC_WO_PADDING) {\n",
"        write_dst_block((DATA_T *)(&C), dst, ow);\n",
"        return;\n",
"    }\n",
"    if (WITH_BIAS) {\n",
"        for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) {\n",
"            for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) {\n",
"                const int bg_off = g * OC;\n",
"                const int bc_off = oc + oc_outer * 16 + local_id;\n",
"#if DT_F16\n",
"                if (OC_WO_PADDING % OC_BLOCK == 0 || bc_off < OC_WO_PADDING) {\n",
"                    for (int ow_block = 0; ow_block < OW_BLOCK; ow_block++) {\n",
"                        const int c_off = dst_idx(mb_block, oc_outer, ow_block);\n",
"                        C[c_off] = bia[bg_off + bc_off];\n",
"                    } // ow_block\n",
"                } // copy-bias\n",
"#else\n",
"                for (int ow_block = 0; ow_block < OW_BLOCK; ow_block++) {\n",
"                    const int c_off = dst_idx(mb_block, oc_outer, ow_block);\n",
"                    C[c_off] = (OC_WO_PADDING % OC_BLOCK == 0\n",
"                                       || bc_off < OC_WO_PADDING)\n",
"                            ? bia[bg_off + bc_off]\n",
"                            : DATA_ZERO;\n",
"                }\n",
"#endif\n",
"            } // oc_outer\n",
"        } // mb_block\n",
"    } // if-bias\n",
"    if (OW_BLOCK == 1) {\n",
"        loop_kdhw_outermost(src, wei, C, id, ih, iw);\n",
"    } else {\n",
"        loop_ic_outermost(src, wei, C, id, ih, iw);\n",
"    }\n",
"    DATA_T S[MB_BLOCK * OC_OUTER * OW_BLOCK];\n",
"    if (WITH_SUM) { read_dst_block(S, dst, ow); }\n",
"#if WITH_POST_OP\n",
"    if (OW_BLOCK == 1) {\n",
"        const int po_mb = mb;\n",
"        const int po_oc = (g * OC + oc) % (OC * G);\n",
"        APPLY_POST_OPS_TRY_BURST(C, DATA_T, S, DATA_T, po_mb, MB_BLOCK, po_oc,\n",
"                OC_OUTER * SUB_GROUP_SIZE, sglid);\n",
"    } else {\n",
"        unroll_for(int mb_idx = 0; mb_idx < MB_BLOCK; ++mb_idx) {\n",
"            unroll_for(int oc_idx = 0; oc_idx < OC_OUTER; ++oc_idx) {\n",
"                const int po_mb = (mb + mb_idx) % MB;\n",
"                const int po_oc = (g * OC + oc + (oc_idx * 16)) % (OC * G);\n",
"                float acc_ow[OW_BLOCK];\n",
"                float sum_ow[OW_BLOCK];\n",
"                unroll_for(int ow_idx = 0; ow_idx < OW_BLOCK; ++ow_idx) {\n",
"                    acc_ow[ow_idx]\n",
"                            = CONVERT_FLOAT_T(C[mb_idx * OC_OUTER * OW_BLOCK\n",
"                                    + oc_idx * OW_BLOCK + ow_idx]);\n",
"                    sum_ow[ow_idx]\n",
"                            = CONVERT_FLOAT_T(S[mb_idx * OC_OUTER * OW_BLOCK\n",
"                                    + oc_idx * OW_BLOCK + ow_idx]);\n",
"                }\n",
"                APPLY_POST_OPS_TRY_BURST(acc_ow, float, sum_ow, float, po_mb, 1,\n",
"                        po_oc, SUB_GROUP_SIZE, sglid);\n",
"                unroll_for(int ow_idx = 0; ow_idx < OW_BLOCK; ++ow_idx) {\n",
"                    C[mb_idx * OC_OUTER * OW_BLOCK + oc_idx * OW_BLOCK + ow_idx]\n",
"                            = acc_ow[ow_idx];\n",
"                }\n",
"            }\n",
"        }\n",
"    }\n",
"#endif // #if WITH_POST_OP\n",
"    write_dst_block((DATA_T *)(&C), dst, ow);\n",
"}", nullptr };
}
}
}
}