namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_gemm_compute_kernel[] ={ "/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_POST_OPS_H\n",
"#define GPU_OCL_OCL_POST_OPS_H\n",
"#ifndef SUB_GROUP_SIZE\n",
"#define SUB_GROUP_SIZE get_sub_group_size()\n",
"#endif\n",
"#if WITH_POST_OP\n",
"#if !WITH_ELTWISE\n",
"#undef WITH_ELTWISE\n",
"#define WITH_ELTWISE 1\n",
"#endif\n",
"/*******************************************************************************\n",
"* Copyright 2020-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_ELTWISE_H\n",
"#define GPU_OCL_OCL_ELTWISE_H\n",
"#if WITH_ELTWISE\n",
"#if DT_F16 == 1\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#ifndef DATA_MAX\n",
"#if DT_F16 == 1\n",
"#define DATA_MAX HALF_MAX\n",
"#elif DT_S8 == 1\n",
"#define DATA_MAX CHAR_MAX\n",
"#elif DT_U8 == 1\n",
"#define DATA_MAX UCHAR_MAX\n",
"#else\n",
"#define DATA_MAX FLT_MAX\n",
"#endif\n",
"#endif\n",
"#ifndef ELTWISE_ALPHA0\n",
"#define ELTWISE_ALPHA0 0\n",
"#endif\n",
"float relu_fwd(float s, float alpha) {\n",
"    return s > 0 ? s : (ELTWISE_ALPHA0 ? 0 : s * alpha);\n",
"}\n",
"float relu_bwd(float dd, float s, float alpha) {\n",
"    return s > 0 ? dd : dd * alpha;\n",
"}\n",
"float relu_bwd_use_dst(float dd, float d, float alpha) {\n",
"    return d > 0 ? dd : dd * alpha;\n",
"}\n",
"float linear_fwd(float s, float alpha, float beta) {\n",
"    return alpha * s + beta;\n",
"}\n",
"float linear_bwd(float dd, float alpha) {\n",
"    return dd * alpha;\n",
"}\n",
"float bounded_relu_fwd(float s, float alpha) {\n",
"    s = s > 0 ? s : 0;\n",
"    return s > alpha ? alpha : s;\n",
"}\n",
"float bounded_relu_bwd(float dd, float s, float alpha) {\n",
"    return dd * (0 < s && s <= alpha ? 1 : 0);\n",
"}\n",
"float soft_relu_fwd(float s) {\n",
"    return s < log((float)DATA_MAX) ? log1p(exp(s)) : s;\n",
"}\n",
"float soft_relu_bwd(float dd, float s) {\n",
"    return dd / (1 + exp(-s));\n",
"}\n",
"float logsigmoid_fwd(float s) {\n",
"    return -soft_relu_fwd(-s);\n",
"}\n",
"float logsigmoid_bwd(float dd, float s) {\n",
"    return soft_relu_bwd(dd, -s);\n",
"}\n",
"float logistic_fwd(float s) {\n",
"    return 1.0f / (1.0f + exp(-s));\n",
"}\n",
"float logistic_bwd(float dd, float s) {\n",
"    float v = logistic_fwd(s);\n",
"    return dd * v * (1 - v);\n",
"}\n",
"float logistic_bwd_use_dst(float dd, float d) {\n",
"    return dd * d * (1 - d);\n",
"}\n",
"float square_fwd(float s) {\n",
"    return s * s;\n",
"}\n",
"float square_bwd(float dd, float s) {\n",
"    return dd * 2 * s;\n",
"}\n",
"float sqrt_fwd(float s) {\n",
"    return sqrt(s);\n",
"}\n",
"float sqrt_bwd(float dd, float s) {\n",
"    return dd / (2 * sqrt(s));\n",
"}\n",
"float sqrt_bwd_use_dst(float dd, float d) {\n",
"    return dd / (2 * d);\n",
"}\n",
"float abs_fwd(float s) {\n",
"    return s > 0 ? s : -s;\n",
"}\n",
"float abs_bwd(float dd, float s) {\n",
"    return s > 0 ? dd : s < 0 ? -dd : 0;\n",
"}\n",
"float tanh_fwd(float s) {\n",
"    return tanh(s);\n",
"}\n",
"float tanh_bwd(float dd, float s) {\n",
"    float e = tanh_fwd(s);\n",
"    return dd * (1 - e) * (1 + e);\n",
"}\n",
"float tanh_bwd_use_dst(float dd, float d) {\n",
"    return dd * (1 - d) * (1 + d);\n",
"}\n",
"float mish_fwd(float s) {\n",
"    return s * tanh_fwd(soft_relu_fwd(s));\n",
"}\n",
"float mish_bwd(float dd, float s) {\n",
"    const float tanh = tanh_fwd(soft_relu_fwd(s));\n",
"    const float srelu_bwd = soft_relu_bwd(1.0f, s);\n",
"    const float derivative = tanh + s * srelu_bwd * (1 - pow(tanh, 2.0f));\n",
"    return dd * derivative;\n",
"}\n",
"float elu_fwd(float s, float alpha) {\n",
"    return s > 0 ? s : alpha * expm1(s);\n",
"}\n",
"float elu_bwd(float dd, float s, float alpha) {\n",
"    return dd * (s > 0 ? 1 : alpha * exp(s));\n",
"}\n",
"float elu_bwd_use_dst(float dd, float d, float alpha) {\n",
"    return dd * (d > 0 ? 1 : d + alpha);\n",
"}\n",
"float exp_fwd(float s) {\n",
"    return exp(s);\n",
"}\n",
"float exp_bwd(float dd, float s) {\n",
"    return dd * exp_fwd(s);\n",
"}\n",
"float exp_bwd_use_dst(float dd, float d) {\n",
"    return dd * d;\n",
"}\n",
"float gelu_tanh_fwd(float s) {\n",
"    const float sqrt_2_over_pi = 0.79788458347320556640625f;\n",
"    const float fitting_const = 0.044715f;\n",
"    const float g = sqrt_2_over_pi * s * (1.f + fitting_const * s * s);\n",
"    return (0.5f * s * (1.f + tanh_fwd(g)));\n",
"}\n",
"float gelu_tanh_bwd(float dd, float s) {\n",
"    const float sqrt_2_over_pi = 0.79788458347320556640625f;\n",
"    const float fitting_const = 0.044715f;\n",
"    const float g = sqrt_2_over_pi * s * (1.f + fitting_const * s * s);\n",
"    const float dg = sqrt_2_over_pi * (1.f + 3.f * fitting_const * s * s);\n",
"    const float v = tanh_fwd(g);\n",
"    return dd * 0.5f * (1.f + v) * (1.f + s * (1.f - v) * dg);\n",
"}\n",
"float swish_fwd(float s, float alpha) {\n",
"    float w = -alpha * s;\n",
"    return s / (1.0f + exp(w));\n",
"}\n",
"float swish_bwd(float dd, float s, float alpha) {\n",
"    float v = logistic_fwd(alpha * s);\n",
"    return dd * (v + s * alpha * v * (1.0f - v));\n",
"}\n",
"float log_fwd(float s) {\n",
"    return log(s);\n",
"}\n",
"float log_bwd(float dd, float s) {\n",
"    return dd / s;\n",
"}\n",
"float clip_fwd(float s, float alpha, float beta) {\n",
"    s = s > alpha ? s : alpha;\n",
"    return s > beta ? beta : s;\n",
"}\n",
"float clip_bwd(float dd, float s, float alpha, float beta) {\n",
"    return dd * (alpha < s && s <= beta ? 1 : 0);\n",
"}\n",
"float clip_v2_fwd(float s, float alpha, float beta) {\n",
"    s = s > alpha ? s : alpha;\n",
"    return s < beta ? s : beta;\n",
"}\n",
"float clip_v2_bwd(float dd, float s, float alpha, float beta) {\n",
"    return dd * (alpha < s && s < beta ? 1 : 0);\n",
"}\n",
"float clip_v2_bwd_use_dst(float dd, float d, float alpha, float beta) {\n",
"    return dd * (alpha < d && d < beta ? 1 : 0);\n",
"}\n",
"float pow_fwd(float s, float alpha, float beta) {\n",
"    return alpha * pow(s, beta);\n",
"}\n",
"float pow_bwd(float dd, float s, float alpha, float beta) {\n",
"    if (beta == 0) return 0;\n",
"    float v = pow_fwd(s, alpha * beta, beta - 1);\n",
"    return dd * v;\n",
"}\n",
"float gelu_erf_fwd(float s) {\n",
"    const float sqrt_2_over_2 = 0.707106769084930419921875f;\n",
"    float v = s * sqrt_2_over_2;\n",
"    return 0.5f * s * (1.f + erf(v));\n",
"}\n",
"float gelu_erf_bwd(float dd, float s) {\n",
"    const float two_over_sqrt_pi = 1.12837922573089599609375f;\n",
"    const float sqrt_2_over_2 = 0.707106769084930419921875f;\n",
"    float v = s * sqrt_2_over_2;\n",
"    return dd * 0.5f * (1.f + erf(v) + v * two_over_sqrt_pi * exp(-v * v));\n",
"}\n",
"float round_fwd(float s) {\n",
"    return (float)rint((float)s);\n",
"}\n",
"float hardswish_fwd(float s) {\n",
"    return (s / 6.f) * bounded_relu_fwd(s + 3.f, 6.f);\n",
"}\n",
"float hardswish_bwd(float dd, float s) {\n",
"    return (s < 3.f && s > -3.f ? dd * (2 * s + 3.f) / 6.f\n",
"                                : s >= 3.f ? dd : 0.f);\n",
"}\n",
"float fwd_eltwise_common(\n",
"        int eltwise_alg, float x, float alpha_, float beta_, float scale_) {\n",
"    switch (eltwise_alg) {\n",
"        case RELU: return scale_ * relu_fwd(x, alpha_); break;\n",
"        case LINEAR: return scale_ * linear_fwd(x, alpha_, beta_); break;\n",
"        case BOUNDED_RELU: return scale_ * bounded_relu_fwd(x, alpha_); break;\n",
"        case SOFT_RELU: return scale_ * soft_relu_fwd(x); break;\n",
"        case LOGSIGMOID: return scale_ * logsigmoid_fwd(x); break;\n",
"        case MISH: return scale_ * mish_fwd(x); break;\n",
"        case LOGISTIC: return scale_ * logistic_fwd(x); break;\n",
"        case TANH: return scale_ * tanh_fwd(x); break;\n",
"        case ELU: return scale_ * elu_fwd(x, alpha_); break;\n",
"        case SQUARE: return scale_ * square_fwd(x); break;\n",
"        case SQRT: return scale_ * sqrt_fwd(x); break;\n",
"        case ABS: return scale_ * abs_fwd(x); break;\n",
"        case EXP: return scale_ * exp_fwd(x); break;\n",
"        case GELU_TANH: return scale_ * gelu_tanh_fwd(x); break;\n",
"        case SWISH: return scale_ * swish_fwd(x, alpha_); break;\n",
"        case LOG: return scale_ * log_fwd(x); break;\n",
"        case CLIP: return scale_ * clip_fwd(x, alpha_, beta_); break;\n",
"        case CLIP_V2: return scale_ * clip_v2_fwd(x, alpha_, beta_); break;\n",
"        case POW: return scale_ * pow_fwd(x, alpha_, beta_); break;\n",
"        case GELU_ERF: return scale_ * gelu_erf_fwd(x); break;\n",
"        case ROUND: return scale_ * round_fwd(x); break;\n",
"        case RELU_DST: return scale_ * relu_fwd(x, alpha_); break;\n",
"        case LOGISTIC_DST: return scale_ * logistic_fwd(x); break;\n",
"        case TANH_DST: return scale_ * tanh_fwd(x); break;\n",
"        case ELU_DST: return scale_ * elu_fwd(x, alpha_); break;\n",
"        case SQRT_DST: return scale_ * sqrt_fwd(x); break;\n",
"        case EXP_DST: return scale_ * exp_fwd(x); break;\n",
"        case CLIP_V2_DST: return scale_ * clip_v2_fwd(x, alpha_, beta_); break;\n",
"        case HARDSWISH: return scale_ * hardswish_fwd(x); break;\n",
"        default: return x; break;\n",
"    }\n",
"}\n",
"float fwd_eltwise(float x, float alpha_, float beta_, float scale_) {\n",
"#ifdef ELTWISE_ALG\n",
"    return fwd_eltwise_common(ELTWISE_ALG, x, alpha_, beta_, scale_);\n",
"#else\n",
"    return x;\n",
"#endif\n",
"}\n",
"float bwd_eltwise(float x, float y, float alpha_, float beta_) {\n",
"#ifdef ELTWISE_ALG\n",
"    switch (ELTWISE_ALG) {\n",
"        case RELU: return relu_bwd(x, y, alpha_); break;\n",
"        case LINEAR: return linear_bwd(x, alpha_); break;\n",
"        case BOUNDED_RELU: return bounded_relu_bwd(x, y, alpha_); break;\n",
"        case SOFT_RELU: return soft_relu_bwd(x, y); break;\n",
"        case LOGSIGMOID: return logsigmoid_bwd(x, y); break;\n",
"        case MISH: return mish_bwd(x, y); break;\n",
"        case LOGISTIC: return logistic_bwd(x, y); break;\n",
"        case TANH: return tanh_bwd(x, y); break;\n",
"        case ELU: return elu_bwd(x, y, alpha_); break;\n",
"        case SQUARE: return square_bwd(x, y); break;\n",
"        case SQRT: return sqrt_bwd(x, y); break;\n",
"        case ABS: return abs_bwd(x, y); break;\n",
"        case EXP: return exp_bwd(x, y); break;\n",
"        case GELU_TANH: return gelu_tanh_bwd(x, y); break;\n",
"        case SWISH: return swish_bwd(x, y, alpha_); break;\n",
"        case LOG: return log_bwd(x, y); break;\n",
"        case CLIP: return clip_bwd(x, y, alpha_, beta_); break;\n",
"        case CLIP_V2: return clip_v2_bwd(x, y, alpha_, beta_); break;\n",
"        case POW: return pow_bwd(x, y, alpha_, beta_); break;\n",
"        case GELU_ERF: return gelu_erf_bwd(x, y); break;\n",
"        case HARDSWISH: return hardswish_bwd(x, y); break;\n",
"        case RELU_DST: return relu_bwd_use_dst(x, y, alpha_); break;\n",
"        case LOGISTIC_DST: return logistic_bwd_use_dst(x, y); break;\n",
"        case TANH_DST: return tanh_bwd_use_dst(x, y); break;\n",
"        case ELU_DST: return elu_bwd_use_dst(x, y, alpha_); break;\n",
"        case SQRT_DST: return sqrt_bwd_use_dst(x, y); break;\n",
"        case EXP_DST: return exp_bwd_use_dst(x, y); break;\n",
"        case CLIP_V2_DST:\n",
"            return clip_v2_bwd_use_dst(x, y, alpha_, beta_);\n",
"            break;\n",
"        default: return x; break;\n",
"    }\n",
"#else\n",
"    return x;\n",
"#endif\n",
"}\n",
"#endif // WITH_ELTWISE\n",
"#endif // GPU_OCL_OCL_ELTWISE_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_TYPES_H\n",
"#define GPU_OCL_OCL_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#define unroll_for __attribute__((opencl_unroll_hint)) for\n",
"#define for_ for\n",
"#define CONCAt2(a, b) a##b\n",
"#define CONCAT2(a, b) CONCAt2(a, b)\n",
"#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c)\n",
"#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \\\n",
"        || defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \\\n",
"        || defined(BIA_DT_F16) || defined(ACC_DT_F16)\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#if DT_F32 == 1\n",
"#define DATA_T float\n",
"#define DATA2_T float2\n",
"#define DATA4_T float4\n",
"#define DATA8_T float8\n",
"#define DATA16_T float16\n",
"#define DATA_MAX FLT_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) (float)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_float\n",
"#define CONVERT_DATA2_T convert_float2\n",
"#define CONVERT_DATA4_T convert_float4\n",
"#define CONVERT_DATA8_T convert_float8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_float\n",
"#define AS_DATA2_T as_float2\n",
"#define AS_DATA4_T as_float4\n",
"#define AS_DATA8_T as_float8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif DT_F16 == 1\n",
"#define DATA_T half\n",
"#define DATA2_T half2\n",
"#define DATA4_T half4\n",
"#define DATA8_T half8\n",
"#define DATA16_T half16\n",
"#define DATA_MAX HALF_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0h\n",
"#define DATA_ONE 1.0h\n",
"#define DEF_ACC_DATA_T half\n",
"#define DEF_ACC_DATA2_T half2\n",
"#define DEF_ACC_DATA4_T half4\n",
"#define DEF_ACC_DATA8_T half8\n",
"#define POST_OP_DATA_T half\n",
"#define TO_DATA_T(v) (half)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (half)(v)\n",
"#define DATA_TO_REF convert_half\n",
"#define CONVERT_DATA_T convert_half\n",
"#define CONVERT_DATA2_T convert_half2\n",
"#define CONVERT_DATA4_T convert_half4\n",
"#define CONVERT_DATA8_T convert_half8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_half\n",
"#define AS_DATA2_T as_half2\n",
"#define AS_DATA4_T as_half4\n",
"#define AS_DATA8_T as_half8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_BF16 == 1\n",
"#define DATA_T ushort\n",
"#define POST_OP_DATA_T float\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define DATA16_T ushort16\n",
"#define DATA_MAX as_float(0x7f7f0000)\n",
"#define DATA_MIN (-DATA_MAX)\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define TO_DATA_T(v) cvt_f32_to_bf16(v)\n",
"#define TO_DEF_ACC_DATA_T(v) cvt_bf16_to_f32(v)\n",
"#define DATA_TO_REF cvt_bf16_to_f32\n",
"#define CONVERT_DATA_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA2_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA4_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA8_T cvt_f32_to_bf16\n",
"#define CONVERT_FLOAT_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT2_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT4_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT8_T cvt_bf16_to_f32\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_ushort\n",
"#define AS_DATA2_T as_ushort2\n",
"#define AS_DATA4_T as_ushort4\n",
"#define AS_DATA8_T as_ushort8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_S8 == 1\n",
"#define DATA_T char\n",
"#define DATA2_T char2\n",
"#define DATA4_T char4\n",
"#define DATA8_T char8\n",
"#define DATA16_T char16\n",
"#define DATA_MAX CHAR_MAX\n",
"#define DATA_MIN CHAR_MIN\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T int8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_char_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_char_sat_rte\n",
"#define CONVERT_DATA2_T convert_char2_sat_rte\n",
"#define CONVERT_DATA4_T convert_char4_sat_rte\n",
"#define CONVERT_DATA8_T convert_char8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_char\n",
"#define AS_DATA2_T as_char2\n",
"#define AS_DATA4_T as_char4\n",
"#define AS_DATA8_T as_char8\n",
"#define AS_DATA16_T as_char16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_int8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_U8 == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define DATA16_T uchar16\n",
"#define DATA_MAX UCHAR_MAX\n",
"#define DATA_MIN 0\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T uint8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_uchar_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_uchar_sat_rte\n",
"#define CONVERT_DATA2_T convert_uchar2_sat_rte\n",
"#define CONVERT_DATA4_T convert_uchar4_sat_rte\n",
"#define CONVERT_DATA8_T convert_uchar8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_uchar\n",
"#define AS_DATA2_T as_uchar2\n",
"#define AS_DATA4_T as_uchar4\n",
"#define AS_DATA8_T as_uchar8\n",
"#define AS_DATA16_T as_uchar16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_uint8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_S32 == 1\n",
"#define DATA_T int\n",
"#define DATA2_T int2\n",
"#define DATA4_T int4\n",
"#define DATA8_T int8\n",
"#define DATA16_T int16\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_int_sat_rte\n",
"#define CONVERT_DATA2_T convert_int2_sat_rte\n",
"#define CONVERT_DATA4_T convert_int4_sat_rte\n",
"#define CONVERT_DATA8_T convert_int8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define POST_OP_DATA_T float\n",
"#define DATA_MIN INT_MIN\n",
"#define DATA_MAX INT_MAX\n",
"#define ROUND\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_int\n",
"#define AS_DATA2_T as_int2\n",
"#define AS_DATA4_T as_int4\n",
"#define AS_DATA8_T as_int8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif !defined(DT_UNDEF)\n",
"#error \"Unexpected data type\"\n",
"#endif\n",
"#if VECT_DT_N == 1\n",
"#define VECT_DATA_T DATA_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T\n",
"#define AS_VECT_DATA_T AS_DATA_T\n",
"#define VECT_BLOCK_READ BLOCK_READ\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE\n",
"#define VECT_UINT_READ intel_sub_group_block_read\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T\n",
"#define VECT_INT_T int\n",
"#define VECT_UINT_T uint\n",
"#define VECT_FLOAT_T float\n",
"#define VECT_CHAR_T char\n",
"#define AS_VECT_INT_T as_int\n",
"#define AS_VECT_UINT_T as_uint\n",
"#define AS_VECT_FLOAT_T as_float\n",
"#define AS_VECT_CHAR_T as_char\n",
"#elif VECT_DT_N == 2\n",
"#define VECT_DATA_T DATA2_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T\n",
"#define AS_VECT_DATA_T AS_DATA2_T\n",
"#define VECT_BLOCK_READ BLOCK_READ2\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE2\n",
"#define VECT_UINT_READ intel_sub_group_block_read2\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write2\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc2\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA2_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T\n",
"#define VECT_INT_T int2\n",
"#define VECT_UINT_T uint2\n",
"#define VECT_FLOAT_T float2\n",
"#define VECT_CHAR_T char2\n",
"#define AS_VECT_INT_T as_int2\n",
"#define AS_VECT_UINT_T as_uint2\n",
"#define AS_VECT_FLOAT_T as_float2\n",
"#define AS_VECT_CHAR_T as_char2\n",
"#elif VECT_DT_N == 4\n",
"#define VECT_DATA_T DATA4_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T\n",
"#define AS_VECT_DATA_T AS_DATA4_T\n",
"#define VECT_BLOCK_READ BLOCK_READ4\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE4\n",
"#define VECT_UINT_READ intel_sub_group_block_read4\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write4\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc4\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA4_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T\n",
"#define VECT_INT_T int4\n",
"#define VECT_UINT_T uint4\n",
"#define VECT_FLOAT_T float4\n",
"#define VECT_CHAR_T char4\n",
"#define AS_VECT_INT_T as_int4\n",
"#define AS_VECT_UINT_T as_uint4\n",
"#define AS_VECT_FLOAT_T as_float4\n",
"#define AS_VECT_CHAR_T as_char4\n",
"#elif VECT_DT_N == 8\n",
"#define VECT_DATA_T DATA8_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T\n",
"#define AS_VECT_DATA_T AS_DATA8_T\n",
"#define VECT_BLOCK_READ BLOCK_READ8\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE8\n",
"#define VECT_UINT_READ intel_sub_group_block_read8\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write8\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc8\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA8_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T\n",
"#define VECT_INT_T int8\n",
"#define VECT_UINT_T uint8\n",
"#define VECT_FLOAT_T float8\n",
"#define VECT_CHAR_T char8\n",
"#define AS_VECT_INT_T as_int8\n",
"#define AS_VECT_UINT_T as_uint8\n",
"#define AS_VECT_FLOAT_T as_float8\n",
"#define AS_VECT_CHAR_T as_char8\n",
"#endif\n",
"#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T)\n",
"#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T)\n",
"#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T)\n",
"#ifdef SRC_DATA_T\n",
"#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2)\n",
"#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4)\n",
"#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8)\n",
"#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16)\n",
"#ifdef SRC_DT_U8\n",
"#define SRC_MMAD_DATA_T uint\n",
"#define SRC_MMAD_DATA4_T uint4\n",
"#define SRC_MMAD_DATA8_T uint8\n",
"#elif SRC_DT_S8\n",
"#define SRC_MMAD_DATA_T int\n",
"#define SRC_MMAD_DATA4_T int4\n",
"#define SRC_MMAD_DATA8_T int8\n",
"#endif\n",
"#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T)\n",
"#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T)\n",
"#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T)\n",
"#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T)\n",
"#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T)\n",
"#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T)\n",
"#if SRC_DT_BF16\n",
"#define SRC_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define SRC_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define SRC_TO_REF(x) (x)\n",
"#define SRC_TO_REF8(x) (x)\n",
"#define REF_TO_SRC(x) (x)\n",
"#endif\n",
"#if SRC_DT_BF16\n",
"#define TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#elif SRC_DT_U8\n",
"#define TO_SRC(x) convert_uchar_sat_rte(x)\n",
"#elif SRC_DT_S8\n",
"#define TO_SRC(x) convert_char_sat_rte(x)\n",
"#elif SRC_DT_S32\n",
"#define TO_SRC(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_SRC(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef A_DATA_T\n",
"#define A_DATA8_T CONCAT2(A_DATA_T, 8)\n",
"#if A_DT_BF16\n",
"#define A_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define A_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_A(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define A_TO_REF(x) (x)\n",
"#define A_TO_REF8(x) (x)\n",
"#define REF_TO_A(x) (x)\n",
"#endif\n",
"#if A_DT_BF16\n",
"#define TO_A(x) cvt_f32_to_bf16(x)\n",
"#elif A_DT_U8\n",
"#define TO_A(x) convert_uchar_sat_rte(x)\n",
"#elif A_DT_S8\n",
"#define TO_A(x) convert_char_sat_rte(x)\n",
"#elif A_DT_S32\n",
"#define TO_A(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_A(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef WEI_DATA_T\n",
"#if WEI_DT_BF16\n",
"#define WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define WEI_TO_REF(x) (x)\n",
"#define REF_TO_WEI(x) (x)\n",
"#endif\n",
"#if WEI_DT_BF16\n",
"#define TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif WEI_DT_U8\n",
"#define TO_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif WEI_DT_S8\n",
"#define TO_WEI(x) convert_char_sat_rte(x)\n",
"#elif WEI_DT_S32\n",
"#define TO_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DIFF_WEI_DATA_T\n",
"#if DIFF_WEI_DT_BF16\n",
"#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define DIFF_WEI_TO_REF(x) (x)\n",
"#define REF_TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#if DIFF_WEI_DT_BF16\n",
"#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif DIFF_WEI_DT_U8\n",
"#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S8\n",
"#define TO_DIFF_WEI(x) convert_char_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S32\n",
"#define TO_DIFF_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef B_DATA_T\n",
"#if B_DT_BF16\n",
"#define B_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_B(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define B_TO_REF(x) (x)\n",
"#define REF_TO_B(x) (x)\n",
"#endif\n",
"#if B_DT_BF16\n",
"#define TO_B(x) cvt_f32_to_bf16(x)\n",
"#elif B_DT_U8\n",
"#define TO_B(x) convert_uchar_sat_rte(x)\n",
"#elif B_DT_S8\n",
"#define TO_B(x) convert_char_sat_rte(x)\n",
"#elif B_DT_S32\n",
"#define TO_B(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_B(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef BIA_DATA_T\n",
"#if BIA_DT_BF16\n",
"#define BIA_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define BIA_TO_REF(x) (x)\n",
"#define REF_TO_BIA(x) (x)\n",
"#endif\n",
"#if BIA_DT_BF16\n",
"#define TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#elif BIA_DT_U8\n",
"#define TO_BIA(x) convert_uchar_sat_rte(x)\n",
"#elif BIA_DT_S8\n",
"#define TO_BIA(x) convert_char_sat_rte(x)\n",
"#elif BIA_DT_S32\n",
"#define TO_BIA(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_BIA(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DST_DATA_T\n",
"#define DST_DATA2_T CONCAT2(DST_DATA_T, 2)\n",
"#define DST_DATA4_T CONCAT2(DST_DATA_T, 4)\n",
"#define DST_DATA8_T CONCAT2(DST_DATA_T, 8)\n",
"#define DST_DATA16_T CONCAT2(DST_DATA_T, 16)\n",
"#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T)\n",
"#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T)\n",
"#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T)\n",
"#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T)\n",
"#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T)\n",
"#if DST_DT_F32 || DST_DT_F16\n",
"#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T)\n",
"#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T)\n",
"#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T)\n",
"#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T)\n",
"#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T)\n",
"#else\n",
"#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte)\n",
"#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte)\n",
"#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte)\n",
"#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte)\n",
"#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte)\n",
"#endif\n",
"#if DST_DT_U8\n",
"#define MMAD_DATA_T uint\n",
"#define MMAD_DATA4_T uint4\n",
"#define MMAD_DATA8_T uint8\n",
"#elif DST_DT_S8\n",
"#define MMAD_DATA_T int\n",
"#define MMAD_DATA4_T int4\n",
"#define MMAD_DATA8_T int8\n",
"#endif\n",
"// Block read/write macros for dst.\n",
"#if DST_DT_U8 || DST_DT_S8\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v))\n",
"#elif DST_DT_S32 || DST_DT_F32\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write((__global uint *)ptr, as_uint(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#elif DST_DT_F16\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define DST_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define DST_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define DST_TO_REF(x) (x)\n",
"#define DST_TO_REF8(x) (x)\n",
"#define REF_TO_DST(x) (x)\n",
"#define REF_TO_DST8(x) (x)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x))\n",
"#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x))\n",
"#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif DST_DT_F16\n",
"#define TO_DST(x) convert_half(x)\n",
"#define TO_DST2(x) convert_half2(x)\n",
"#define TO_DST4(x) convert_half4(x)\n",
"#define TO_DST8(x) convert_half8(x)\n",
"#elif DST_DT_U8\n",
"#define TO_DST(x) convert_uchar_sat_rte(x)\n",
"#define TO_DST2(x) convert_uchar2_sat_rte(x)\n",
"#define TO_DST4(x) convert_uchar4_sat_rte(x)\n",
"#define TO_DST8(x) convert_uchar8_sat_rte(x)\n",
"#define TO_DST16(x) convert_uchar16_sat_rte(x)\n",
"#elif DST_DT_S8\n",
"#define TO_DST(x) convert_char_sat_rte(x)\n",
"#define TO_DST2(x) convert_char2_sat_rte(x)\n",
"#define TO_DST4(x) convert_char4_sat_rte(x)\n",
"#define TO_DST8(x) convert_char8_sat_rte(x)\n",
"#define TO_DST16(x) convert_char16_sat_rte(x)\n",
"#elif DST_DT_S32\n",
"#define TO_DST(x) convert_int_sat_rte(x)\n",
"#define TO_DST2(x) convert_int2_sat_rte(x)\n",
"#define TO_DST4(x) convert_int4_sat_rte(x)\n",
"#define TO_DST8(x) convert_int8_sat_rte(x)\n",
"#elif DST_DT_F32\n",
"#define TO_DST(x) convert_float(x)\n",
"#define TO_DST2(x) convert_float2(x)\n",
"#define TO_DST4(x) convert_float4(x)\n",
"#define TO_DST8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef C_DATA_T\n",
"#define C_DATA8_T CONCAT2(C_DATA_T, 8)\n",
"#if C_DT_BF16\n",
"#define C_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define C_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_C(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define C_TO_REF(x) (x)\n",
"#define C_TO_REF8(x) (x)\n",
"#define REF_TO_C(x) (x)\n",
"#define REF_TO_C8(x) (x)\n",
"#endif\n",
"#if C_DT_BF16\n",
"#define TO_C(x) cvt_f32_to_bf16(x)\n",
"#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif C_DT_F16\n",
"#define TO_C(x) convert_half(x)\n",
"#define TO_C8(x) convert_half8(x)\n",
"#elif C_DT_U8\n",
"#define TO_C(x) convert_uchar_sat_rte(x)\n",
"#define TO_C8(x) convert_uchar8_sat_rte(x)\n",
"#elif C_DT_S8\n",
"#define TO_C(x) convert_char_sat_rte(x)\n",
"#define TO_C8(x) convert_char8_sat_rte(x)\n",
"#elif C_DT_S32\n",
"#define TO_C(x) convert_int_sat_rte(x)\n",
"#define TO_C8(x) convert_int8_sat_rte(x)\n",
"#elif C_DT_F32\n",
"#define TO_C(x) convert_float(x)\n",
"#define TO_C8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef ACC_DATA_T\n",
"#if ACC_DT_F16\n",
"#define TO_ACC(x) convert_half(x)\n",
"#elif ACC_DT_F32\n",
"#define TO_ACC(x) convert_float(x)\n",
"#elif ACC_DT_S32\n",
"#define TO_ACC(x) convert_int(x)\n",
"#else\n",
"#error \"Unexpected accumulation data type\"\n",
"#endif\n",
"#endif\n",
"#ifdef SUM_DATA_T\n",
"#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2)\n",
"#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4)\n",
"#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8)\n",
"#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16)\n",
"#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T)\n",
"#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T)\n",
"#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T)\n",
"#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T)\n",
"#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T)\n",
"#if SUM_DT_BF16\n",
"#define SUM_TO_REF cvt_bf16_to_f32\n",
"#else\n",
"#define SUM_TO_REF\n",
"#endif\n",
"#endif\n",
"#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2)))\n",
"#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"              / CONCAT2(prefix, _B0_1)) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"                       % CONCAT2(prefix, _B0_1)) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \\\n",
"                    * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       / CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       % CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \\\n",
"                    * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       / CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       % CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \\\n",
"                    * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       / CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       % CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \\\n",
"                    * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       / CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       % CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \\\n",
"                    * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       / CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       % CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \\\n",
"                    * CONCAT2(prefix, _S5_2)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3)))\n",
"#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5)\n",
"#if NDIMS == 2\n",
"#define SRC_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1)\n",
"#elif NDIMS == 3\n",
"#define SRC_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, x3) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, x2) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2)\n",
"#elif NDIMS == 4\n",
"#define SRC_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, x3, x4) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, d, x3, x4) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3)\n",
"#elif NDIMS == 5\n",
"#define SRC_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \\\n",
"            + ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \\\n",
"            + ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, x3, x4, x5) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \\\n",
"            + ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4)\n",
"#endif\n",
"#define DST_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \\\n",
"            + ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4)\n",
"#endif\n",
"// clang-format off\n",
"// Shortcut accessors for special cases.\n",
"// x - product of the current and outer dimensions in gws[idx]\n",
"// y - the current dimension\n",
"#define GWS_OP_ZERO(x, y) 0\n",
"#define GWS_OP_FIRST(x, y) (x)\n",
"#define GWS_OP_MOD(x, y) ((x) % (y))\n",
"#define ROUND_UP(a,b) (((a) + (b) - 1) / (b))\n",
"#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0\n",
"#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1\n",
"#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2\n",
"#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3\n",
"#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4\n",
"#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5\n",
"#define GWS0_GET_BLOCK0() GWS0_BLOCK0\n",
"#define GWS0_GET_BLOCK1() GWS0_BLOCK1\n",
"#define GWS0_GET_BLOCK2() GWS0_BLOCK2\n",
"#define GWS0_GET_BLOCK3() GWS0_BLOCK3\n",
"#define GWS0_GET_BLOCK4() GWS0_BLOCK4\n",
"#define GWS0_GET_BLOCK5() GWS0_BLOCK5\n",
"#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0\n",
"#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1\n",
"#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2\n",
"#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3\n",
"#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4\n",
"#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5\n",
"#define GWS1_GET_BLOCK0() GWS1_BLOCK0\n",
"#define GWS1_GET_BLOCK1() GWS1_BLOCK1\n",
"#define GWS1_GET_BLOCK2() GWS1_BLOCK2\n",
"#define GWS1_GET_BLOCK3() GWS1_BLOCK3\n",
"#define GWS1_GET_BLOCK4() GWS1_BLOCK4\n",
"#define GWS1_GET_BLOCK5() GWS1_BLOCK5\n",
"#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0\n",
"#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1\n",
"#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2\n",
"#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3\n",
"#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4\n",
"#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5\n",
"#define GWS2_GET_BLOCK0() GWS2_BLOCK0\n",
"#define GWS2_GET_BLOCK1() GWS2_BLOCK1\n",
"#define GWS2_GET_BLOCK2() GWS2_BLOCK2\n",
"#define GWS2_GET_BLOCK3() GWS2_BLOCK3\n",
"#define GWS2_GET_BLOCK4() GWS2_BLOCK4\n",
"#define GWS2_GET_BLOCK5() GWS2_BLOCK5\n",
"// clang-format on\n",
"// With work-group qualifier, without sub-group qualifier.\n",
"#define KERNEL_ATTR_SG0 \\\n",
"    __attribute__((reqd_work_group_size( \\\n",
"            GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT)))\n",
"// With work-group and sub-group qualifiers.\n",
"#define KERNEL_ATTR_SG1 \\\n",
"    KERNEL_ATTR_SG0 \\\n",
"    __attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT)))\n",
"#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT)\n",
"// Named kernel attributes - when source contains multiple kernels.\n",
"#define NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \\\n",
"            CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name))))\n",
"#define NAMED_KERNEL_ATTR_SG1(name) \\\n",
"    NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name))))\n",
"#define NAMED_KERNEL_ATTR(name) \\\n",
"    CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name)\n",
"#endif\n",
"float fwd_Xnary(unsigned algorithm, float x, float y, float alpha, float beta,\n",
"        float scale) {\n",
"    switch (algorithm) {\n",
"        // binary\n",
"        case BINARY_ADD: return x + y; break;\n",
"        case BINARY_MUL: return x * y; break;\n",
"        case BINARY_MIN: return x < y ? x : y; break;\n",
"        case BINARY_MAX: return x > y ? x : y; break;\n",
"        case BINARY_DIV: return x / y; break;\n",
"        case BINARY_SUB: return x - y; break;\n",
"        case BINARY_GE: return x >= y; break;\n",
"        case BINARY_GT: return x > y; break;\n",
"        case BINARY_LE: return x <= y; break;\n",
"        case BINARY_LT: return x < y; break;\n",
"        case BINARY_EQ: return x == y; break;\n",
"        case BINARY_NE: return x != y; break;\n",
"        // unary\n",
"        default:\n",
"            return fwd_eltwise_common(algorithm, x, alpha, beta, scale);\n",
"            break;\n",
"    }\n",
"}\n",
"#define CONV_BIN_ARG_TO_FLOAT(idx, bin_arg_val) \\\n",
"    ({ \\\n",
"        float ret_val; \\\n",
"        if (CONCAT3(PO_, idx, _BIN_ARG_DT_IS_BF16)) \\\n",
"            ret_val = cvt_bf16_to_f32(bin_arg_val); \\\n",
"        else \\\n",
"            ret_val = convert_float(bin_arg_val); \\\n",
"\\\n",
"        ret_val; \\\n",
"    })\n",
"#define FWD_XNARY_GENERIC_DT(algorithm, result, result_elem_dt, arg0_ptr, \\\n",
"        arg0_len, arg1_ptr, arg1_len, alpha, beta, scale) \\\n",
"    { \\\n",
"        const unsigned out_len = max((unsigned)arg0_len, (unsigned)arg1_len); \\\n",
"        result_elem_dt *res_ptr = (result_elem_dt *)(&result); \\\n",
"        unroll_for(unsigned idx = 0; idx < out_len; ++idx) { \\\n",
"            if (arg0_len == 1 && arg1_len == 1) { \\\n",
"                *res_ptr = fwd_Xnary(algorithm, convert_float(*arg0_ptr), \\\n",
"                        convert_float(*arg1_ptr), alpha, beta, scale); \\\n",
"            } else if (arg0_len == 1) { \\\n",
"                res_ptr[idx] = fwd_Xnary(algorithm, convert_float(*arg0_ptr), \\\n",
"                        convert_float(arg1_ptr[idx]), alpha, beta, scale); \\\n",
"            } else if (arg1_len == 1) { \\\n",
"                res_ptr[idx] \\\n",
"                        = fwd_Xnary(algorithm, convert_float(arg0_ptr[idx]), \\\n",
"                                convert_float(*arg1_ptr), alpha, beta, scale); \\\n",
"            } else { \\\n",
"                res_ptr[idx] = fwd_Xnary(algorithm, \\\n",
"                        convert_float(arg0_ptr[idx]), \\\n",
"                        convert_float(arg1_ptr[idx]), alpha, beta, scale); \\\n",
"            } \\\n",
"        } \\\n",
"    }\n",
"#define FMA_BLOCK( \\\n",
"        block_size, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b) \\\n",
"    unroll_for(; nof_elems >= block_size; acc_ptr += block_size, \\\n",
"               a_ptr += block_size, nof_elems -= block_size) { \\\n",
"        CONCAT2(acc_elem_dt, block_size) \\\n",
"        a_conv = CONCAT3(convert_, acc_elem_dt, block_size)( \\\n",
"                *((CONCAT2(a_elem_dt, block_size) *)a_ptr)); \\\n",
"        *((CONCAT2(acc_elem_dt, block_size) *)acc_ptr) = fma( \\\n",
"                a_conv, b, *((CONCAT2(acc_elem_dt, block_size) *)acc_ptr)); \\\n",
"    }\n",
"#define FMA_MIXED(acc_nof_elems, a, a_elem_dt, b, acc, acc_elem_dt) \\\n",
"    { \\\n",
"        unsigned nof_elems = acc_nof_elems; \\\n",
"        a_elem_dt *a_ptr = (a_elem_dt *)(&a); \\\n",
"        acc_elem_dt *acc_ptr = (acc_elem_dt *)(&acc); \\\n",
"        FMA_BLOCK(8, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \\\n",
"        FMA_BLOCK(4, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \\\n",
"        FMA_BLOCK(2, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \\\n",
"        if (nof_elems == 1) { *acc_ptr += (*a_ptr) * b; } \\\n",
"    }\n",
"#define FILL_BIN_ARG_SERIAL(idx, dest_ptr, x0, x0_s, x1, x1_s, x1_incr, x2, \\\n",
"        x2_s, x3, x3_s, x4, x4_s, x5, x5_s) \\\n",
"    unroll_for(unsigned x0_idx = x0, bin_arg_offset = 0; x0_idx < x0 + x0_s; \\\n",
"               ++x0_idx) { \\\n",
"        unroll_for(unsigned x1_idx = x1; x1_idx < x1 + x1_s; \\\n",
"                   x1_idx += x1_incr) { \\\n",
"            unroll_for(unsigned x2_idx = x2; x2_idx < x2 + x2_s; ++x2_idx) { \\\n",
"                unroll_for(unsigned x3_idx = x3; x3_idx < x3 + x3_s; \\\n",
"                           ++x3_idx) { \\\n",
"                    unroll_for(unsigned x4_idx = x4; x4_idx < x4 + x4_s; \\\n",
"                               ++x4_idx) { \\\n",
"                        unroll_for(unsigned x5_idx = x5; x5_idx < x5 + x5_s; \\\n",
"                                   ++x5_idx, ++bin_arg_offset) { \\\n",
"                            const unsigned bin_arg_glob_off = OFF_MD( \\\n",
"                                    CONCAT3(PO_, idx, _BIN_ARG), \\\n",
"                                    x0_idx % CONCAT3(PO_, idx, _BIN_ARG_D0), \\\n",
"                                    x1_idx % CONCAT3(PO_, idx, _BIN_ARG_D1), \\\n",
"                                    x2_idx % CONCAT3(PO_, idx, _BIN_ARG_D2), \\\n",
"                                    x3_idx % CONCAT3(PO_, idx, _BIN_ARG_D3), \\\n",
"                                    x4_idx % CONCAT3(PO_, idx, _BIN_ARG_D4), \\\n",
"                                    x5_idx % CONCAT3(PO_, idx, _BIN_ARG_D5)); \\\n",
"                            dest_ptr[bin_arg_offset] = CONV_BIN_ARG_TO_FLOAT( \\\n",
"                                    idx, \\\n",
"                                    CONCAT3(po_, idx, \\\n",
"                                            _binary_arg)[bin_arg_glob_off]); \\\n",
"                        } \\\n",
"                    } \\\n",
"                } \\\n",
"            } \\\n",
"        } \\\n",
"    }\n",
"// explicitly define sub group reads and data type with post fix \"1\" which are\n",
"// required in FILL_WITH_BLOCK_READ macro. In that function number of elements\n",
"// is appended to it so it works for 2,4 but for 1 there is no such name.\n",
"#define intel_sub_group_block_read_uc1 intel_sub_group_block_read_uc\n",
"#define intel_sub_group_block_read_us1 intel_sub_group_block_read_us\n",
"#define intel_sub_group_block_read1 intel_sub_group_block_read\n",
"#define uchar1 uchar\n",
"#define ushort1 ushort\n",
"#define uint1 uint\n",
"#define FILL_WITH_BLOCK_READ(idx, src_ptr, dst_ptr, nelem, data_type) \\\n",
"    { \\\n",
"        data_type tmp_storage[nelem]; \\\n",
"        if (sizeof(data_type) == 1) { \\\n",
"            *((CONCAT2(uchar, nelem) *)(&tmp_storage)) \\\n",
"                    = (CONCAT2(intel_sub_group_block_read_uc, nelem)( \\\n",
"                            (__global uchar *)(src_ptr))); \\\n",
"        } \\\n",
"        if (sizeof(data_type) == 2) { \\\n",
"            *((CONCAT2(ushort, nelem) *)(&tmp_storage)) \\\n",
"                    = CONCAT2(intel_sub_group_block_read_us, nelem)( \\\n",
"                            (__global ushort *)(src_ptr)); \\\n",
"        } \\\n",
"        if (sizeof(data_type) == 4) { \\\n",
"            *((CONCAT2(uint, nelem) *)(&tmp_storage)) \\\n",
"                    = CONCAT2(intel_sub_group_block_read, nelem)( \\\n",
"                            (__global uint *)(src_ptr)); \\\n",
"        } \\\n",
"        unroll_for(unsigned s_index = 0; s_index < nelem; ++s_index) { \\\n",
"            dst_ptr[s_index] \\\n",
"                    = CONV_BIN_ARG_TO_FLOAT(idx, tmp_storage[s_index]); \\\n",
"        } \\\n",
"    }\n",
"#define X_NELEMS(x) ({ x / SUB_GROUP_SIZE; })\n",
"#define CONDITIONAL_FILL( \\\n",
"        idx, blocked_coord, nelem, src_ptr, dst_ptr, data_type) \\\n",
"    if (blocked_coord / SUB_GROUP_SIZE == nelem) \\\n",
"        FILL_WITH_BLOCK_READ(idx, src_ptr, dst_ptr, nelem, data_type);\n",
"#define FILL_BIN_ARG_TRY_BLOCK(idx, dest_ptr, dest_size, x0, x0_s, x1, x1_s, \\\n",
"        x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s) \\\n",
"    { \\\n",
"        unroll_for(unsigned x0_idx = x0, arg_off = 0; x0_idx < x0 + x0_s; \\\n",
"                   ++x0_idx, arg_off += X_NELEMS(x1_s)) { \\\n",
"            const unsigned bin_arg_glob_off \\\n",
"                    = OFF_MD(CONCAT3(PO_, idx, _BIN_ARG), \\\n",
"                            x0_idx % CONCAT3(PO_, idx, _BIN_ARG_D0), \\\n",
"                            x1 % CONCAT3(PO_, idx, _BIN_ARG_D1), \\\n",
"                            x2 % CONCAT3(PO_, idx, _BIN_ARG_D2), \\\n",
"                            x3 % CONCAT3(PO_, idx, _BIN_ARG_D3), \\\n",
"                            x4 % CONCAT3(PO_, idx, _BIN_ARG_D4), \\\n",
"                            x5 % CONCAT3(PO_, idx, _BIN_ARG_D5)); \\\n",
"\\\n",
"            CONDITIONAL_FILL(idx, x1_s, 1, \\\n",
"                    (CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \\\n",
"                    (dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \\\n",
"            CONDITIONAL_FILL(idx, x1_s, 2, \\\n",
"                    (CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \\\n",
"                    (dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \\\n",
"            CONDITIONAL_FILL(idx, x1_s, 4, \\\n",
"                    (CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \\\n",
"                    (dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \\\n",
"        } \\\n",
"    }\n",
"#define REPLICATE_DATA( \\\n",
"        dest_ptr, dest_size, x0_s, x1_s, x2_s, x3_s, x4_s, x5_s) \\\n",
"    { \\\n",
"        const unsigned copy_size \\\n",
"                = x0_s * X_NELEMS(x1_s) * x2_s * x3_s * x4_s * x5_s; \\\n",
"        unroll_for(unsigned fid = copy_size; fid < dest_size; ++fid) { \\\n",
"            *(dest_ptr + fid) = *(dest_ptr + (fid % copy_size)); \\\n",
"        } \\\n",
"    }\n",
"#define IS_BURSTABLE(idx, x0, x0_s, x1, x1_s, x2, x2_s, x3, x3_s, x4, x4_s, \\\n",
"        x5, x5_s, is_burst) \\\n",
"    ({ \\\n",
"        bool is_burstable = is_burst; \\\n",
"        if (x0_s > CONCAT3(PO_, idx, _BIN_ARG_D0) && x0_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x1_s > CONCAT3(PO_, idx, _BIN_ARG_D1) && x1_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x2_s > CONCAT3(PO_, idx, _BIN_ARG_D2) && x2_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x3_s > CONCAT3(PO_, idx, _BIN_ARG_D3) && x3_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x4_s > CONCAT3(PO_, idx, _BIN_ARG_D4) && x4_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (x5_s > CONCAT3(PO_, idx, _BIN_ARG_D5) && x5_s > 1) \\\n",
"            is_burstable = false; \\\n",
"        if (CONCAT3(PO_, idx, _BIN_ARG_D0) * CONCAT3(PO_, idx, _BIN_ARG_D1) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D2) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D2) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D3) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D4) \\\n",
"                        * CONCAT3(PO_, idx, _BIN_ARG_D5) \\\n",
"                == 1) \\\n",
"            is_burstable = false; \\\n",
"\\\n",
"        is_burstable; \\\n",
"    })\n",
"#define BINARY_ARG_IS_SCALAR(idx) ({ false; })\n",
"#define APPLY_PO_BINARY(idx, accumulator, acc_elem_dt, x0, x0_s, x1, x1_s, \\\n",
"        x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, is_burst) \\\n",
"    { \\\n",
"        const unsigned bin_arg_size = BINARY_ARG_IS_SCALAR(idx) \\\n",
"                ? 1 \\\n",
"                : sizeof(accumulator) / sizeof(acc_elem_dt); \\\n",
"        float bin_arg[bin_arg_size]; \\\n",
"        float *bin_arg_ptr = &bin_arg[0]; \\\n",
"        const bool use_burst_read = IS_BURSTABLE(idx, x0, x0_s, x1, x1_s, x2, \\\n",
"                x2_s, x3, x3_s, x4, x4_s, x5, x5_s, is_burst); \\\n",
"        const unsigned x1_jump = is_burst ? SUB_GROUP_SIZE : 1; \\\n",
"        if (use_burst_read) { \\\n",
"            FILL_BIN_ARG_TRY_BLOCK(idx, bin_arg_ptr, bin_arg_size, x0, x0_s, \\\n",
"                    x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                    x5_s); \\\n",
"        } else { \\\n",
"            FILL_BIN_ARG_SERIAL(idx, bin_arg_ptr, x0, x0_s, (x1 + x1_incr), \\\n",
"                    x1_s, x1_jump, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s); \\\n",
"        } \\\n",
"        REPLICATE_DATA(bin_arg_ptr, bin_arg_size, x0_s, x1_s, x2_s, x3_s, \\\n",
"                x4_s, x5_s); \\\n",
"        FWD_XNARY_GENERIC_DT(CONCAT3(PO_, idx, _ALG), accumulator, \\\n",
"                acc_elem_dt, ((acc_elem_dt *)(&accumulator)), \\\n",
"                (sizeof(accumulator) / sizeof(acc_elem_dt)), bin_arg_ptr, \\\n",
"                bin_arg_size, 0.0f, 0.0f, 0.0f); \\\n",
"    }\n",
"#define APPLY_PO_SUM(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt) \\\n",
"    { \\\n",
"        unsigned acc_size = sizeof(accumulator) / sizeof(acc_elem_dt); \\\n",
"        FMA_MIXED(acc_size, sum_src, sum_elem_dt, \\\n",
"                CONCAT3(po_, idx, _sum_scale), accumulator, acc_elem_dt); \\\n",
"    }\n",
"#define APPLY_PO_ELTWISE(idx, accumulator, acc_elem_dt) \\\n",
"    { \\\n",
"        FWD_XNARY_GENERIC_DT(CONCAT3(PO_, idx, _ALG), accumulator, \\\n",
"                acc_elem_dt, ((acc_elem_dt *)(&accumulator)), \\\n",
"                (sizeof(accumulator) / sizeof(acc_elem_dt)), \\\n",
"                ((acc_elem_dt *)(&accumulator)), \\\n",
"                (sizeof(accumulator) / sizeof(acc_elem_dt)), \\\n",
"                CONCAT3(po_, idx, _eltwise_alpha), \\\n",
"                CONCAT3(po_, idx, _eltwise_beta), \\\n",
"                CONCAT3(po_, idx, _eltwise_scale)); \\\n",
"    }\n",
"#define APPLY_PO_STAGE(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"        x0, x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \\\n",
"        is_burst) \\\n",
"    switch (CONCAT3(PO_, idx, _KIND)) { \\\n",
"        case PO_BINARY: \\\n",
"            APPLY_PO_BINARY(idx, accumulator, acc_elem_dt, x0, x0_s, x1, x1_s, \\\n",
"                    x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \\\n",
"                    is_burst); \\\n",
"            break; \\\n",
"        case PO_ELTWISE: APPLY_PO_ELTWISE(idx, accumulator, acc_elem_dt); \\\n",
"                break; \\\n",
"        case PO_SUM: \\\n",
"            APPLY_PO_SUM(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt); \\\n",
"            break; \\\n",
"    }\n",
"#define APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"        x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \\\n",
"        is_burst) \\\n",
"    { \\\n",
"        APPLY_PO_STAGE(0, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(1, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(2, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(3, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(4, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(5, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(6, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(7, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(8, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"        APPLY_PO_STAGE(9, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \\\n",
"                x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \\\n",
"                x5_s, is_burst); \\\n",
"    }\n",
"#define APPLY_POST_OPS_TRY_BURST(accumulator, acc_elem_dt, sum_src, \\\n",
"        sum_elem_dt, mb_start, mb_size, oc_start, oc_size, oc_serial_incr) \\\n",
"    APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"            mb_start, mb_size, oc_start, oc_size, oc_serial_incr, 0, 1, 0, 1, \\\n",
"            0, 1, 0, 1, true)\n",
"#define APPLY_POST_OPS_SERIAL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"        mb_start, mb_size, oc_start, oc_size, d2_start, d2_size, d3_start, \\\n",
"        d3_size, d4_start, d4_size, d5_start, d5_size) \\\n",
"    APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"            mb_start, mb_size, oc_start, oc_size, 0, d2_start, d2_size, \\\n",
"            d3_start, d3_size, d4_start, d4_size, d5_start, d5_size, false)\n",
"#define APPLY_POST_OPS_SERIAL_BINARY_2D(accumulator, acc_elem_dt, sum_src, \\\n",
"        sum_elem_dt, mb_start, mb_size, oc_start, oc_size) \\\n",
"    APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"            mb_start, mb_size, oc_start, oc_size, 0, 0, 1, 0, 1, 0, 1, 0, 1, \\\n",
"            false)\n",
"#else\n",
"#define APPLY_POST_OPS_SERIAL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \\\n",
"        mb_start, mb_size, oc_start, oc_size, d2_start, d2_size, d3_start, \\\n",
"        d3_size, d4_start, d4_size, d5_start, d5_size) \\\n",
"    {}\n",
"#define APPLY_POST_OPS_SERIAL_BINARY_2D(accumulator, acc_elem_dt, sum_src, \\\n",
"        sum_elem_dt, mb_start, mb_size, oc_start, oc_size) \\\n",
"    {}\n",
"#define APPLY_POST_OPS_TRY_BURST(accumulator, acc_elem_dt, sum_src, \\\n",
"        sum_elem_dt, mb_start, mb_size, oc_start, oc_size, oc_serial_incr) \\\n",
"    {}\n",
"#endif // WITH_POST_OP\n",
"#endif\n",
"/*******************************************************************************\n",
"* Copyright 2019-2021 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_TYPES_H\n",
"#define GPU_OCL_OCL_TYPES_H\n",
"/*******************************************************************************\n",
"* Copyright 2019-2020 Intel Corporation\n",
"*\n",
"* Licensed under the Apache License, Version 2.0 (the \"License\");\n",
"* you may not use this file except in compliance with the License.\n",
"* You may obtain a copy of the License at\n",
"*\n",
"*     http://www.apache.org/licenses/LICENSE-2.0\n",
"*\n",
"* Unless required by applicable law or agreed to in writing, software\n",
"* distributed under the License is distributed on an \"AS IS\" BASIS,\n",
"* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n",
"* See the License for the specific language governing permissions and\n",
"* limitations under the License.\n",
"*******************************************************************************/\n",
"#ifndef GPU_OCL_OCL_MATH_UTILS_H\n",
"#define GPU_OCL_OCL_MATH_UTILS_H\n",
"// f32 <-> bf16 conversion.\n",
"#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \\\n",
"        || A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \\\n",
"        || POST_OP_USING_BF16\n",
"ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) {\n",
"    uint i = as_uint(f);\n",
"    i += 0x00007FFF + ((i & 0x10000) >> 16);\n",
"    ushort2 r = as_ushort2(i);\n",
"    return r[1];\n",
"}\n",
"ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) {\n",
"    ushort2 r;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) {\n",
"    ushort4 r;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) {\n",
"    ushort8 r;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        r[i] = cvt_f32_to_bf16(f[i]);\n",
"    }\n",
"    return r;\n",
"}\n",
"float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) {\n",
"    ushort2 r = {0, b};\n",
"    float f = as_float(r);\n",
"    return f;\n",
"}\n",
"float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) {\n",
"    float2 f;\n",
"    for (int i = 0; i < 2; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) {\n",
"    float4 f;\n",
"    for (int i = 0; i < 4; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) {\n",
"    float8 f;\n",
"    for (int i = 0; i < 8; i++) {\n",
"        f[i] = cvt_bf16_to_f32(b[i]);\n",
"    }\n",
"    return f;\n",
"}\n",
"#endif\n",
"int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) {\n",
"    c += a[0] * b[0];\n",
"    c += a[1] * b[1];\n",
"    c += a[2] * b[2];\n",
"    c += a[3] * b[3];\n",
"    return c;\n",
"}\n",
"int __attribute__((overloadable)) idot4(int a, int b, int c) {\n",
"    return idot4(as_char4(a), as_char4(b), c);\n",
"}\n",
"int __attribute__((overloadable)) idot4(uint a, int b, int c) {\n",
"    return idot4(as_uchar4(a), as_char4(b), c);\n",
"}\n",
"#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix(const addr_space p_type *p) { \\\n",
"        return func(p); \\\n",
"    }\n",
"#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    data_type __attribute__((overloadable)) \\\n",
"            block_read##suffix##_emu(const addr_space p_type *p) { \\\n",
"        data_type ret; \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            ((p_type *)&ret)[i] = p[idx]; \\\n",
"            idx += get_max_sub_group_size(); \\\n",
"        } \\\n",
"        return ret; \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix(addr_space p_type *p, data_type data) { \\\n",
"        func(p, data); \\\n",
"    }\n",
"#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \\\n",
"    void __attribute__((overloadable)) \\\n",
"            block_write##suffix##_emu(addr_space p_type *p, data_type data) { \\\n",
"        uint idx = get_sub_group_local_id(); \\\n",
"        for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \\\n",
"            p[idx] = ((p_type *)&data)[i]; \\\n",
"            p += get_max_sub_group_size(); \\\n",
"        } \\\n",
"    }\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint)\n",
"#ifdef cl_intel_subgroups_char\n",
"void __attribute__((overloadable))\n",
"intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data);\n",
"uchar16 __attribute__((overloadable))\n",
"intel_sub_group_block_read_uc16(const __global uchar *p);\n",
"#endif\n",
"// Emulation for cl_intel_subgroup_local_block_io. These functions are not\n",
"// defined under ifndef/endif because some kernels rely on the emulation\n",
"// functions in case when pointers are not properly aligned for the native\n",
"// extensions.\n",
"DECLARE_BLOCK_READ_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort)\n",
"#ifdef cl_intel_subgroup_local_block_io\n",
"DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(\n",
"        _us, intel_sub_group_block_write_us, ushort, __local, ushort)\n",
"#else\n",
"DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint)\n",
"DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint)\n",
"DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint)\n",
"DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint)\n",
"DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort)\n",
"#endif\n",
"// Integer matrix-matrix multiplication: ACC += A * B\n",
"// A is (m x (4 * K))\n",
"// B is ((4 * K) x sub_group_size)\n",
"#define DECLARE_MMAD(name, K, m, a_type, b_type, acc_type) \\\n",
"    acc_type __attribute__((overloadable)) \\\n",
"            name(a_type A_vectors, b_type B_vectors, acc_type acc) { \\\n",
"        for (uint i = 0; i < (m); ++i) { \\\n",
"            for (uint j = 0; j < (K); ++j) \\\n",
"                acc[i] = idot4(sub_group_broadcast(A_vectors[i], j), \\\n",
"                        B_vectors[j], acc[i]); \\\n",
"        } \\\n",
"        return acc; \\\n",
"    }\n",
"DECLARE_MMAD(mmad8x4, 8, 4, uint4, int8, int4)\n",
"DECLARE_MMAD(mmad8x4, 8, 4, int4, int8, int4)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, uint8, int8, int8)\n",
"DECLARE_MMAD(mmad8x8, 8, 8, int8, int8, int8)\n",
"#endif\n",
"#define unroll_for __attribute__((opencl_unroll_hint)) for\n",
"#define for_ for\n",
"#define CONCAt2(a, b) a##b\n",
"#define CONCAT2(a, b) CONCAt2(a, b)\n",
"#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c)\n",
"#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \\\n",
"        || defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \\\n",
"        || defined(BIA_DT_F16) || defined(ACC_DT_F16)\n",
"#pragma OPENCL EXTENSION cl_khr_fp16 : enable\n",
"#endif\n",
"#if DT_F32 == 1\n",
"#define DATA_T float\n",
"#define DATA2_T float2\n",
"#define DATA4_T float4\n",
"#define DATA8_T float8\n",
"#define DATA16_T float16\n",
"#define DATA_MAX FLT_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) (float)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_float\n",
"#define CONVERT_DATA2_T convert_float2\n",
"#define CONVERT_DATA4_T convert_float4\n",
"#define CONVERT_DATA8_T convert_float8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_float\n",
"#define AS_DATA2_T as_float2\n",
"#define AS_DATA4_T as_float4\n",
"#define AS_DATA8_T as_float8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif DT_F16 == 1\n",
"#define DATA_T half\n",
"#define DATA2_T half2\n",
"#define DATA4_T half4\n",
"#define DATA8_T half8\n",
"#define DATA16_T half16\n",
"#define DATA_MAX HALF_MAX\n",
"#define DATA_MIN -DATA_MAX\n",
"#define DATA_ZERO 0.0h\n",
"#define DATA_ONE 1.0h\n",
"#define DEF_ACC_DATA_T half\n",
"#define DEF_ACC_DATA2_T half2\n",
"#define DEF_ACC_DATA4_T half4\n",
"#define DEF_ACC_DATA8_T half8\n",
"#define POST_OP_DATA_T half\n",
"#define TO_DATA_T(v) (half)(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (half)(v)\n",
"#define DATA_TO_REF convert_half\n",
"#define CONVERT_DATA_T convert_half\n",
"#define CONVERT_DATA2_T convert_half2\n",
"#define CONVERT_DATA4_T convert_half4\n",
"#define CONVERT_DATA8_T convert_half8\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_half\n",
"#define AS_DATA2_T as_half2\n",
"#define AS_DATA4_T as_half4\n",
"#define AS_DATA8_T as_half8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_BF16 == 1\n",
"#define DATA_T ushort\n",
"#define POST_OP_DATA_T float\n",
"#define DATA2_T ushort2\n",
"#define DATA4_T ushort4\n",
"#define DATA8_T ushort8\n",
"#define DATA16_T ushort16\n",
"#define DATA_MAX as_float(0x7f7f0000)\n",
"#define DATA_MIN (-DATA_MAX)\n",
"#define DATA_ZERO 0.0f\n",
"#define DATA_ONE 1.0f\n",
"#define DEF_ACC_DATA_T float\n",
"#define DEF_ACC_DATA2_T float2\n",
"#define DEF_ACC_DATA4_T float4\n",
"#define DEF_ACC_DATA8_T float8\n",
"#define TO_DATA_T(v) cvt_f32_to_bf16(v)\n",
"#define TO_DEF_ACC_DATA_T(v) cvt_bf16_to_f32(v)\n",
"#define DATA_TO_REF cvt_bf16_to_f32\n",
"#define CONVERT_DATA_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA2_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA4_T cvt_f32_to_bf16\n",
"#define CONVERT_DATA8_T cvt_f32_to_bf16\n",
"#define CONVERT_FLOAT_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT2_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT4_T cvt_bf16_to_f32\n",
"#define CONVERT_FLOAT8_T cvt_bf16_to_f32\n",
"#define BLOCK_READ intel_sub_group_block_read_us\n",
"#define BLOCK_WRITE intel_sub_group_block_write_us\n",
"#define BLOCK_READ2 intel_sub_group_block_read_us2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_us4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_us8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_us2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_us4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_us8\n",
"#define AS_DATA_T as_ushort\n",
"#define AS_DATA2_T as_ushort2\n",
"#define AS_DATA4_T as_ushort4\n",
"#define AS_DATA8_T as_ushort8\n",
"#define AS_UINT_T as_ushort\n",
"#define AS_UINT2_T as_ushort2\n",
"#define AS_UINT4_T as_ushort4\n",
"#define AS_UINT8_T as_ushort8\n",
"#define BLOCK_DATA_T ushort\n",
"#define BLOCK_DATA2_T ushort2\n",
"#define BLOCK_DATA4_T ushort4\n",
"#define BLOCK_DATA8_T ushort8\n",
"#define AS_BLOCK_DATA_T as_ushort\n",
"#define AS_BLOCK_DATA2_T as_ushort2\n",
"#define AS_BLOCK_DATA4_T as_ushort4\n",
"#define AS_BLOCK_DATA8_T as_ushort8\n",
"#elif DT_S8 == 1\n",
"#define DATA_T char\n",
"#define DATA2_T char2\n",
"#define DATA4_T char4\n",
"#define DATA8_T char8\n",
"#define DATA16_T char16\n",
"#define DATA_MAX CHAR_MAX\n",
"#define DATA_MIN CHAR_MIN\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T int8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_char_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_char_sat_rte\n",
"#define CONVERT_DATA2_T convert_char2_sat_rte\n",
"#define CONVERT_DATA4_T convert_char4_sat_rte\n",
"#define CONVERT_DATA8_T convert_char8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_char\n",
"#define AS_DATA2_T as_char2\n",
"#define AS_DATA4_T as_char4\n",
"#define AS_DATA8_T as_char8\n",
"#define AS_DATA16_T as_char16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_int8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_U8 == 1\n",
"#define DATA_T uchar\n",
"#define DATA2_T uchar2\n",
"#define DATA4_T uchar4\n",
"#define DATA8_T uchar8\n",
"#define DATA16_T uchar16\n",
"#define DATA_MAX UCHAR_MAX\n",
"#define DATA_MIN 0\n",
"#define DATA_ZERO 0\n",
"#define DATA_ONE 1\n",
"#define INT8_T uint8\n",
"#define DEF_ACC_DATA_T int\n",
"#define DEF_ACC_DATA2_T int2\n",
"#define DEF_ACC_DATA4_T int4\n",
"#define DEF_ACC_DATA8_T int8\n",
"#define POST_OP_DATA_T float\n",
"#define TO_DATA_T(v) convert_uchar_sat_rte(v)\n",
"#define TO_DEF_ACC_DATA_T(v) (float)(v)\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_uchar_sat_rte\n",
"#define CONVERT_DATA2_T convert_uchar2_sat_rte\n",
"#define CONVERT_DATA4_T convert_uchar4_sat_rte\n",
"#define CONVERT_DATA8_T convert_uchar8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define BLOCK_READ intel_sub_group_block_read_uc\n",
"#define BLOCK_WRITE intel_sub_group_block_write_uc\n",
"#define BLOCK_READ2 intel_sub_group_block_read_uc2\n",
"#define BLOCK_READ4 intel_sub_group_block_read_uc4\n",
"#define BLOCK_READ8 intel_sub_group_block_read_uc8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write_uc2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write_uc4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write_uc8\n",
"#define AS_DATA_T as_uchar\n",
"#define AS_DATA2_T as_uchar2\n",
"#define AS_DATA4_T as_uchar4\n",
"#define AS_DATA8_T as_uchar8\n",
"#define AS_DATA16_T as_uchar16\n",
"#define AS_UINT_T as_uchar\n",
"#define AS_UINT2_T as_uchar2\n",
"#define AS_UINT4_T as_uchar4\n",
"#define AS_UINT8_T as_uchar8\n",
"#define AS_INT8_T as_uint8\n",
"#define BLOCK_DATA_T uchar\n",
"#define BLOCK_DATA2_T uchar2\n",
"#define BLOCK_DATA4_T uchar4\n",
"#define BLOCK_DATA8_T uchar8\n",
"#define AS_BLOCK_DATA_T as_uchar\n",
"#define AS_BLOCK_DATA2_T as_uchar2\n",
"#define AS_BLOCK_DATA4_T as_uchar4\n",
"#define AS_BLOCK_DATA8_T as_uchar8\n",
"#elif DT_S32 == 1\n",
"#define DATA_T int\n",
"#define DATA2_T int2\n",
"#define DATA4_T int4\n",
"#define DATA8_T int8\n",
"#define DATA16_T int16\n",
"#define DATA_TO_REF convert_float\n",
"#define CONVERT_DATA_T convert_int_sat_rte\n",
"#define CONVERT_DATA2_T convert_int2_sat_rte\n",
"#define CONVERT_DATA4_T convert_int4_sat_rte\n",
"#define CONVERT_DATA8_T convert_int8_sat_rte\n",
"#define CONVERT_FLOAT_T convert_float\n",
"#define CONVERT_FLOAT2_T convert_float2\n",
"#define CONVERT_FLOAT4_T convert_float4\n",
"#define CONVERT_FLOAT8_T convert_float8\n",
"#define POST_OP_DATA_T float\n",
"#define DATA_MIN INT_MIN\n",
"#define DATA_MAX INT_MAX\n",
"#define ROUND\n",
"#define BLOCK_READ intel_sub_group_block_read\n",
"#define BLOCK_WRITE intel_sub_group_block_write\n",
"#define BLOCK_READ2 intel_sub_group_block_read2\n",
"#define BLOCK_READ4 intel_sub_group_block_read4\n",
"#define BLOCK_READ8 intel_sub_group_block_read8\n",
"#define BLOCK_WRITE2 intel_sub_group_block_write2\n",
"#define BLOCK_WRITE4 intel_sub_group_block_write4\n",
"#define BLOCK_WRITE8 intel_sub_group_block_write8\n",
"#define AS_DATA_T as_int\n",
"#define AS_DATA2_T as_int2\n",
"#define AS_DATA4_T as_int4\n",
"#define AS_DATA8_T as_int8\n",
"#define AS_UINT_T as_uint\n",
"#define AS_UINT2_T as_uint2\n",
"#define AS_UINT4_T as_uint4\n",
"#define AS_UINT8_T as_uint8\n",
"#define BLOCK_DATA_T uint\n",
"#define BLOCK_DATA2_T uint2\n",
"#define BLOCK_DATA4_T uint4\n",
"#define BLOCK_DATA8_T uint8\n",
"#define AS_BLOCK_DATA_T as_uint\n",
"#define AS_BLOCK_DATA2_T as_uint2\n",
"#define AS_BLOCK_DATA4_T as_uint4\n",
"#define AS_BLOCK_DATA8_T as_uint8\n",
"#elif !defined(DT_UNDEF)\n",
"#error \"Unexpected data type\"\n",
"#endif\n",
"#if VECT_DT_N == 1\n",
"#define VECT_DATA_T DATA_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T\n",
"#define AS_VECT_DATA_T AS_DATA_T\n",
"#define VECT_BLOCK_READ BLOCK_READ\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE\n",
"#define VECT_UINT_READ intel_sub_group_block_read\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T\n",
"#define VECT_INT_T int\n",
"#define VECT_UINT_T uint\n",
"#define VECT_FLOAT_T float\n",
"#define VECT_CHAR_T char\n",
"#define AS_VECT_INT_T as_int\n",
"#define AS_VECT_UINT_T as_uint\n",
"#define AS_VECT_FLOAT_T as_float\n",
"#define AS_VECT_CHAR_T as_char\n",
"#elif VECT_DT_N == 2\n",
"#define VECT_DATA_T DATA2_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T\n",
"#define AS_VECT_DATA_T AS_DATA2_T\n",
"#define VECT_BLOCK_READ BLOCK_READ2\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE2\n",
"#define VECT_UINT_READ intel_sub_group_block_read2\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write2\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc2\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA2_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T\n",
"#define VECT_INT_T int2\n",
"#define VECT_UINT_T uint2\n",
"#define VECT_FLOAT_T float2\n",
"#define VECT_CHAR_T char2\n",
"#define AS_VECT_INT_T as_int2\n",
"#define AS_VECT_UINT_T as_uint2\n",
"#define AS_VECT_FLOAT_T as_float2\n",
"#define AS_VECT_CHAR_T as_char2\n",
"#elif VECT_DT_N == 4\n",
"#define VECT_DATA_T DATA4_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T\n",
"#define AS_VECT_DATA_T AS_DATA4_T\n",
"#define VECT_BLOCK_READ BLOCK_READ4\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE4\n",
"#define VECT_UINT_READ intel_sub_group_block_read4\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write4\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc4\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA4_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T\n",
"#define VECT_INT_T int4\n",
"#define VECT_UINT_T uint4\n",
"#define VECT_FLOAT_T float4\n",
"#define VECT_CHAR_T char4\n",
"#define AS_VECT_INT_T as_int4\n",
"#define AS_VECT_UINT_T as_uint4\n",
"#define AS_VECT_FLOAT_T as_float4\n",
"#define AS_VECT_CHAR_T as_char4\n",
"#elif VECT_DT_N == 8\n",
"#define VECT_DATA_T DATA8_T\n",
"#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T\n",
"#define AS_VECT_DATA_T AS_DATA8_T\n",
"#define VECT_BLOCK_READ BLOCK_READ8\n",
"#define VECT_BLOCK_WRITE BLOCK_WRITE8\n",
"#define VECT_UINT_READ intel_sub_group_block_read8\n",
"#define VECT_UINT_WRITE intel_sub_group_block_write8\n",
"#define VECT_UCHAR_READ intel_sub_group_block_read_uc8\n",
"#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8\n",
"#define VECT_BLOCK_DATA_T BLOCK_DATA8_T\n",
"#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T\n",
"#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T\n",
"#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T\n",
"#define VECT_INT_T int8\n",
"#define VECT_UINT_T uint8\n",
"#define VECT_FLOAT_T float8\n",
"#define VECT_CHAR_T char8\n",
"#define AS_VECT_INT_T as_int8\n",
"#define AS_VECT_UINT_T as_uint8\n",
"#define AS_VECT_FLOAT_T as_float8\n",
"#define AS_VECT_CHAR_T as_char8\n",
"#endif\n",
"#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T)\n",
"#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T)\n",
"#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T)\n",
"#ifdef SRC_DATA_T\n",
"#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2)\n",
"#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4)\n",
"#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8)\n",
"#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16)\n",
"#ifdef SRC_DT_U8\n",
"#define SRC_MMAD_DATA_T uint\n",
"#define SRC_MMAD_DATA4_T uint4\n",
"#define SRC_MMAD_DATA8_T uint8\n",
"#elif SRC_DT_S8\n",
"#define SRC_MMAD_DATA_T int\n",
"#define SRC_MMAD_DATA4_T int4\n",
"#define SRC_MMAD_DATA8_T int8\n",
"#endif\n",
"#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T)\n",
"#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T)\n",
"#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T)\n",
"#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T)\n",
"#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T)\n",
"#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T)\n",
"#if SRC_DT_BF16\n",
"#define SRC_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define SRC_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define SRC_TO_REF(x) (x)\n",
"#define SRC_TO_REF8(x) (x)\n",
"#define REF_TO_SRC(x) (x)\n",
"#endif\n",
"#if SRC_DT_BF16\n",
"#define TO_SRC(x) cvt_f32_to_bf16(x)\n",
"#elif SRC_DT_U8\n",
"#define TO_SRC(x) convert_uchar_sat_rte(x)\n",
"#elif SRC_DT_S8\n",
"#define TO_SRC(x) convert_char_sat_rte(x)\n",
"#elif SRC_DT_S32\n",
"#define TO_SRC(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_SRC(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef A_DATA_T\n",
"#define A_DATA8_T CONCAT2(A_DATA_T, 8)\n",
"#if A_DT_BF16\n",
"#define A_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define A_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_A(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define A_TO_REF(x) (x)\n",
"#define A_TO_REF8(x) (x)\n",
"#define REF_TO_A(x) (x)\n",
"#endif\n",
"#if A_DT_BF16\n",
"#define TO_A(x) cvt_f32_to_bf16(x)\n",
"#elif A_DT_U8\n",
"#define TO_A(x) convert_uchar_sat_rte(x)\n",
"#elif A_DT_S8\n",
"#define TO_A(x) convert_char_sat_rte(x)\n",
"#elif A_DT_S32\n",
"#define TO_A(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_A(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef WEI_DATA_T\n",
"#if WEI_DT_BF16\n",
"#define WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define WEI_TO_REF(x) (x)\n",
"#define REF_TO_WEI(x) (x)\n",
"#endif\n",
"#if WEI_DT_BF16\n",
"#define TO_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif WEI_DT_U8\n",
"#define TO_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif WEI_DT_S8\n",
"#define TO_WEI(x) convert_char_sat_rte(x)\n",
"#elif WEI_DT_S32\n",
"#define TO_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DIFF_WEI_DATA_T\n",
"#if DIFF_WEI_DT_BF16\n",
"#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define DIFF_WEI_TO_REF(x) (x)\n",
"#define REF_TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#if DIFF_WEI_DT_BF16\n",
"#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x)\n",
"#elif DIFF_WEI_DT_U8\n",
"#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S8\n",
"#define TO_DIFF_WEI(x) convert_char_sat_rte(x)\n",
"#elif DIFF_WEI_DT_S32\n",
"#define TO_DIFF_WEI(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_DIFF_WEI(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef B_DATA_T\n",
"#if B_DT_BF16\n",
"#define B_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_B(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define B_TO_REF(x) (x)\n",
"#define REF_TO_B(x) (x)\n",
"#endif\n",
"#if B_DT_BF16\n",
"#define TO_B(x) cvt_f32_to_bf16(x)\n",
"#elif B_DT_U8\n",
"#define TO_B(x) convert_uchar_sat_rte(x)\n",
"#elif B_DT_S8\n",
"#define TO_B(x) convert_char_sat_rte(x)\n",
"#elif B_DT_S32\n",
"#define TO_B(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_B(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef BIA_DATA_T\n",
"#if BIA_DT_BF16\n",
"#define BIA_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#else\n",
"#define BIA_TO_REF(x) (x)\n",
"#define REF_TO_BIA(x) (x)\n",
"#endif\n",
"#if BIA_DT_BF16\n",
"#define TO_BIA(x) cvt_f32_to_bf16(x)\n",
"#elif BIA_DT_U8\n",
"#define TO_BIA(x) convert_uchar_sat_rte(x)\n",
"#elif BIA_DT_S8\n",
"#define TO_BIA(x) convert_char_sat_rte(x)\n",
"#elif BIA_DT_S32\n",
"#define TO_BIA(x) convert_int_sat_rte(x)\n",
"#else\n",
"#define TO_BIA(x) (x)\n",
"#endif\n",
"#endif\n",
"#ifdef DST_DATA_T\n",
"#define DST_DATA2_T CONCAT2(DST_DATA_T, 2)\n",
"#define DST_DATA4_T CONCAT2(DST_DATA_T, 4)\n",
"#define DST_DATA8_T CONCAT2(DST_DATA_T, 8)\n",
"#define DST_DATA16_T CONCAT2(DST_DATA_T, 16)\n",
"#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T)\n",
"#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T)\n",
"#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T)\n",
"#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T)\n",
"#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T)\n",
"#if DST_DT_F32 || DST_DT_F16\n",
"#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T)\n",
"#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T)\n",
"#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T)\n",
"#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T)\n",
"#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T)\n",
"#else\n",
"#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte)\n",
"#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte)\n",
"#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte)\n",
"#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte)\n",
"#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte)\n",
"#endif\n",
"#if DST_DT_U8\n",
"#define MMAD_DATA_T uint\n",
"#define MMAD_DATA4_T uint4\n",
"#define MMAD_DATA8_T uint8\n",
"#elif DST_DT_S8\n",
"#define MMAD_DATA_T int\n",
"#define MMAD_DATA4_T int4\n",
"#define MMAD_DATA8_T int8\n",
"#endif\n",
"// Block read/write macros for dst.\n",
"#if DST_DT_U8 || DST_DT_S8\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v))\n",
"#elif DST_DT_S32 || DST_DT_F32\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write((__global uint *)ptr, as_uint(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#elif DST_DT_F16\n",
"#define BLOCK_READ_DST(ptr) \\\n",
"    AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST(ptr, v) \\\n",
"    intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v))\n",
"#define BLOCK_READ_DST2(ptr) \\\n",
"    AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST2(ptr, v) \\\n",
"    intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v))\n",
"#define BLOCK_READ_DST4(ptr) \\\n",
"    AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST4(ptr, v) \\\n",
"    intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v))\n",
"#define BLOCK_READ_DST8(ptr) \\\n",
"    AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr))\n",
"#define BLOCK_WRITE_DST8(ptr, v) \\\n",
"    intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v))\n",
"#define BLOCK_READ_DST16(ptr) \\\n",
"    (DST_DATA16_T)( \\\n",
"            BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE))\n",
"#define BLOCK_WRITE_DST16(ptr, v) \\\n",
"    do { \\\n",
"        BLOCK_WRITE_DST8(ptr, (v).s01234567); \\\n",
"        BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \\\n",
"    } while (0)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define DST_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define DST_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define DST_TO_REF(x) (x)\n",
"#define DST_TO_REF8(x) (x)\n",
"#define REF_TO_DST(x) (x)\n",
"#define REF_TO_DST8(x) (x)\n",
"#endif\n",
"#if DST_DT_BF16\n",
"#define TO_DST(x) cvt_f32_to_bf16(x)\n",
"#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x))\n",
"#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x))\n",
"#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif DST_DT_F16\n",
"#define TO_DST(x) convert_half(x)\n",
"#define TO_DST2(x) convert_half2(x)\n",
"#define TO_DST4(x) convert_half4(x)\n",
"#define TO_DST8(x) convert_half8(x)\n",
"#elif DST_DT_U8\n",
"#define TO_DST(x) convert_uchar_sat_rte(x)\n",
"#define TO_DST2(x) convert_uchar2_sat_rte(x)\n",
"#define TO_DST4(x) convert_uchar4_sat_rte(x)\n",
"#define TO_DST8(x) convert_uchar8_sat_rte(x)\n",
"#define TO_DST16(x) convert_uchar16_sat_rte(x)\n",
"#elif DST_DT_S8\n",
"#define TO_DST(x) convert_char_sat_rte(x)\n",
"#define TO_DST2(x) convert_char2_sat_rte(x)\n",
"#define TO_DST4(x) convert_char4_sat_rte(x)\n",
"#define TO_DST8(x) convert_char8_sat_rte(x)\n",
"#define TO_DST16(x) convert_char16_sat_rte(x)\n",
"#elif DST_DT_S32\n",
"#define TO_DST(x) convert_int_sat_rte(x)\n",
"#define TO_DST2(x) convert_int2_sat_rte(x)\n",
"#define TO_DST4(x) convert_int4_sat_rte(x)\n",
"#define TO_DST8(x) convert_int8_sat_rte(x)\n",
"#elif DST_DT_F32\n",
"#define TO_DST(x) convert_float(x)\n",
"#define TO_DST2(x) convert_float2(x)\n",
"#define TO_DST4(x) convert_float4(x)\n",
"#define TO_DST8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef C_DATA_T\n",
"#define C_DATA8_T CONCAT2(C_DATA_T, 8)\n",
"#if C_DT_BF16\n",
"#define C_TO_REF(x) cvt_bf16_to_f32(x)\n",
"#define C_TO_REF8(x) cvt_bf16_to_f32(x)\n",
"#define REF_TO_C(x) cvt_f32_to_bf16(x)\n",
"#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#else\n",
"#define C_TO_REF(x) (x)\n",
"#define C_TO_REF8(x) (x)\n",
"#define REF_TO_C(x) (x)\n",
"#define REF_TO_C8(x) (x)\n",
"#endif\n",
"#if C_DT_BF16\n",
"#define TO_C(x) cvt_f32_to_bf16(x)\n",
"#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x))\n",
"#elif C_DT_F16\n",
"#define TO_C(x) convert_half(x)\n",
"#define TO_C8(x) convert_half8(x)\n",
"#elif C_DT_U8\n",
"#define TO_C(x) convert_uchar_sat_rte(x)\n",
"#define TO_C8(x) convert_uchar8_sat_rte(x)\n",
"#elif C_DT_S8\n",
"#define TO_C(x) convert_char_sat_rte(x)\n",
"#define TO_C8(x) convert_char8_sat_rte(x)\n",
"#elif C_DT_S32\n",
"#define TO_C(x) convert_int_sat_rte(x)\n",
"#define TO_C8(x) convert_int8_sat_rte(x)\n",
"#elif C_DT_F32\n",
"#define TO_C(x) convert_float(x)\n",
"#define TO_C8(x) convert_float8(x)\n",
"#else\n",
"#error \"Not expected\"\n",
"#endif\n",
"#endif\n",
"#ifdef ACC_DATA_T\n",
"#if ACC_DT_F16\n",
"#define TO_ACC(x) convert_half(x)\n",
"#elif ACC_DT_F32\n",
"#define TO_ACC(x) convert_float(x)\n",
"#elif ACC_DT_S32\n",
"#define TO_ACC(x) convert_int(x)\n",
"#else\n",
"#error \"Unexpected accumulation data type\"\n",
"#endif\n",
"#endif\n",
"#ifdef SUM_DATA_T\n",
"#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2)\n",
"#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4)\n",
"#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8)\n",
"#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16)\n",
"#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T)\n",
"#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T)\n",
"#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T)\n",
"#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T)\n",
"#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T)\n",
"#if SUM_DT_BF16\n",
"#define SUM_TO_REF cvt_bf16_to_f32\n",
"#else\n",
"#define SUM_TO_REF\n",
"#endif\n",
"#endif\n",
"#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2)))\n",
"#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    ((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"              / CONCAT2(prefix, _B0_1)) \\\n",
"             * CONCAT2(prefix, _S0_0)) \\\n",
"            + (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \\\n",
"                       % CONCAT2(prefix, _B0_1)) \\\n",
"                    * CONCAT2(prefix, _S0_1)) \\\n",
"            + ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \\\n",
"                    * CONCAT2(prefix, _S0_2)) \\\n",
"            + (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       / CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_0)) \\\n",
"            + (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \\\n",
"                       % CONCAT2(prefix, _B1_1)) \\\n",
"                    * CONCAT2(prefix, _S1_1)) \\\n",
"            + ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \\\n",
"                    * CONCAT2(prefix, _S1_2)) \\\n",
"            + (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       / CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_0)) \\\n",
"            + (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \\\n",
"                       % CONCAT2(prefix, _B2_1)) \\\n",
"                    * CONCAT2(prefix, _S2_1)) \\\n",
"            + ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \\\n",
"                    * CONCAT2(prefix, _S2_2)) \\\n",
"            + (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       / CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_0)) \\\n",
"            + (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \\\n",
"                       % CONCAT2(prefix, _B3_1)) \\\n",
"                    * CONCAT2(prefix, _S3_1)) \\\n",
"            + ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \\\n",
"                    * CONCAT2(prefix, _S3_2)) \\\n",
"            + (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       / CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_0)) \\\n",
"            + (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \\\n",
"                       % CONCAT2(prefix, _B4_1)) \\\n",
"                    * CONCAT2(prefix, _S4_1)) \\\n",
"            + ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \\\n",
"                    * CONCAT2(prefix, _S4_2)) \\\n",
"            + (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       / CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_0)) \\\n",
"            + (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \\\n",
"                       % CONCAT2(prefix, _B5_1)) \\\n",
"                    * CONCAT2(prefix, _S5_1)) \\\n",
"            + ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \\\n",
"                    * CONCAT2(prefix, _S5_2)) \\\n",
"            + (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3)))\n",
"#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \\\n",
"    CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5)\n",
"#if NDIMS == 2\n",
"#define SRC_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, w) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, w) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1)\n",
"#elif NDIMS == 3\n",
"#define SRC_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, h, x3) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3)\n",
"#else\n",
"#define WEI_OFF(g, x0, x1, d, h, x2) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, h, x2) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2)\n",
"#elif NDIMS == 4\n",
"#define SRC_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, d, x3, x4) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, d, x3, x4) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3)\n",
"#endif\n",
"#define DST_OFF(x0, x1, d, x2, x3) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3)\n",
"#elif NDIMS == 5\n",
"#define SRC_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \\\n",
"            + ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \\\n",
"            + ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \\\n",
"            + ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \\\n",
"            + ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4)\n",
"#if WITH_GROUPS == 1\n",
"#define WEI_OFF(x0, x1, x2, x3, x4, x5) \\\n",
"    (((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \\\n",
"            + ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \\\n",
"            + ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \\\n",
"            + ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \\\n",
"            + ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \\\n",
"            + ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5)\n",
"#else\n",
"#define WEI_OFF(g, x1, x2, x3, x4, x5) \\\n",
"    (((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \\\n",
"            + ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \\\n",
"            + ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \\\n",
"            + ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \\\n",
"            + ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4)\n",
"#endif\n",
"#define DST_OFF(x0, x1, x2, x3, x4) \\\n",
"    (((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \\\n",
"            + ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \\\n",
"            + ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \\\n",
"            + ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \\\n",
"            + ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4)\n",
"#endif\n",
"// clang-format off\n",
"// Shortcut accessors for special cases.\n",
"// x - product of the current and outer dimensions in gws[idx]\n",
"// y - the current dimension\n",
"#define GWS_OP_ZERO(x, y) 0\n",
"#define GWS_OP_FIRST(x, y) (x)\n",
"#define GWS_OP_MOD(x, y) ((x) % (y))\n",
"#define ROUND_UP(a,b) (((a) + (b) - 1) / (b))\n",
"#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0\n",
"#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1\n",
"#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2\n",
"#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3\n",
"#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4\n",
"#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5\n",
"#define GWS0_GET_BLOCK0() GWS0_BLOCK0\n",
"#define GWS0_GET_BLOCK1() GWS0_BLOCK1\n",
"#define GWS0_GET_BLOCK2() GWS0_BLOCK2\n",
"#define GWS0_GET_BLOCK3() GWS0_BLOCK3\n",
"#define GWS0_GET_BLOCK4() GWS0_BLOCK4\n",
"#define GWS0_GET_BLOCK5() GWS0_BLOCK5\n",
"#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0\n",
"#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1\n",
"#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2\n",
"#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3\n",
"#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4\n",
"#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5\n",
"#define GWS1_GET_BLOCK0() GWS1_BLOCK0\n",
"#define GWS1_GET_BLOCK1() GWS1_BLOCK1\n",
"#define GWS1_GET_BLOCK2() GWS1_BLOCK2\n",
"#define GWS1_GET_BLOCK3() GWS1_BLOCK3\n",
"#define GWS1_GET_BLOCK4() GWS1_BLOCK4\n",
"#define GWS1_GET_BLOCK5() GWS1_BLOCK5\n",
"#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0\n",
"#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1\n",
"#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2\n",
"#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3\n",
"#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4\n",
"#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5\n",
"#define GWS2_GET_BLOCK0() GWS2_BLOCK0\n",
"#define GWS2_GET_BLOCK1() GWS2_BLOCK1\n",
"#define GWS2_GET_BLOCK2() GWS2_BLOCK2\n",
"#define GWS2_GET_BLOCK3() GWS2_BLOCK3\n",
"#define GWS2_GET_BLOCK4() GWS2_BLOCK4\n",
"#define GWS2_GET_BLOCK5() GWS2_BLOCK5\n",
"// clang-format on\n",
"// With work-group qualifier, without sub-group qualifier.\n",
"#define KERNEL_ATTR_SG0 \\\n",
"    __attribute__((reqd_work_group_size( \\\n",
"            GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT)))\n",
"// With work-group and sub-group qualifiers.\n",
"#define KERNEL_ATTR_SG1 \\\n",
"    KERNEL_ATTR_SG0 \\\n",
"    __attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT)))\n",
"#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT)\n",
"// Named kernel attributes - when source contains multiple kernels.\n",
"#define NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \\\n",
"            CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name))))\n",
"#define NAMED_KERNEL_ATTR_SG1(name) \\\n",
"    NAMED_KERNEL_ATTR_SG0(name) \\\n",
"    __attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name))))\n",
"#define NAMED_KERNEL_ATTR(name) \\\n",
"    CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name)\n",
"#endif\n",
"#define GRX 8\n",
"#if DT_F32 == 1\n",
"#if UNROLL_M <= 1 * GRX\n",
"#define FLOATX float\n",
"#define SIZEX 1\n",
"#elif UNROLL_M <= 2 * GRX\n",
"#define FLOATX float2\n",
"#define SIZEX 2\n",
"#elif UNROLL_M <= 3 * GRX\n",
"#define FLOATX float3\n",
"#define SIZEX 3\n",
"#else\n",
"#define FLOATX float4\n",
"#define SIZEX 4\n",
"#endif\n",
"#if UNROLL_N <= 1 * GRX\n",
"#define FLOATY float\n",
"#define SIZEY 1\n",
"#elif UNROLL_N <= 2 * GRX\n",
"#define FLOATY float2\n",
"#define SIZEY 2\n",
"#elif UNROLL_N <= 3 * GRX\n",
"#define FLOATY float3\n",
"#define SIZEY 3\n",
"#else\n",
"#define FLOATY float4\n",
"#define SIZEY 4\n",
"#endif\n",
"#define SHUFFLE(X, Y) intel_sub_group_shuffle(X, Y)\n",
"#define SHUFFLE_DOWN(X, Y) intel_sub_group_shuffle_down(X, X, Y)\n",
"#define SHUFFLE_UP(X, Y) intel_sub_group_shuffle_up(X, X, Y)\n",
"#elif DT_F16 == 1\n",
"#if UNROLL_M <= 1 * GRX\n",
"#define FLOATX half\n",
"#define SIZEX 1\n",
"#elif UNROLL_M <= 2 * GRX\n",
"#define FLOATX half2\n",
"#define SIZEX 2\n",
"#elif UNROLL_M <= 3 * GRX\n",
"#define FLOATX half3\n",
"#define SIZEX 3\n",
"#elif UNROLL_M <= 4 * GRX\n",
"#define FLOATX half4\n",
"#define SIZEX 4\n",
"#else\n",
"#define FLOATX half8\n",
"#define SIZEX 8\n",
"#endif\n",
"#if UNROLL_N <= 1 * GRX\n",
"#define FLOATY half\n",
"#define SIZEY 1\n",
"#elif UNROLL_N <= 2 * GRX\n",
"#define FLOATY half2\n",
"#define SIZEY 2\n",
"#elif UNROLL_N <= 3 * GRX\n",
"#define FLOATY half3\n",
"#define SIZEY 3\n",
"#elif UNROLL_N <= 4 * GRX\n",
"#define FLOATY half4\n",
"#define SIZEY 4\n",
"#else\n",
"#define FLOATY half8\n",
"#define SIZEY 8\n",
"#endif\n",
"#if SIZEY == 2\n",
"#define SHUFFLE(X, Y) as_half2(intel_sub_group_shuffle(as_float(X), Y))\n",
"#elif SIZEY == 4\n",
"#define SHUFFLE(X, Y) as_half4(intel_sub_group_shuffle(as_float2(X), Y))\n",
"#else\n",
"#define SHUFFLE(X, Y) as_half8(intel_sub_group_shuffle(as_float4(X), Y))\n",
"#endif\n",
"#if SIZEX == 2\n",
"#define SHUFFLE_UP(X, Y) \\\n",
"    as_half2(intel_sub_group_shuffle_up(as_float(X), as_float(X), Y))\n",
"#define SHUFFLE_DOWN(X, Y) \\\n",
"    as_half2(intel_sub_group_shuffle_down(as_float(X), as_float(X), Y))\n",
"#elif SIZEX == 4\n",
"#define SHUFFLE_UP(X, Y) \\\n",
"    as_half4(intel_sub_group_shuffle_up(as_float2(X), as_float2(X), Y))\n",
"#define SHUFFLE_DOWN(X, Y) \\\n",
"    as_half4(intel_sub_group_shuffle_down(as_float2(X), as_float2(X), Y))\n",
"#else\n",
"#define SHUFFLE_UP(X, Y) \\\n",
"    as_half8(intel_sub_group_shuffle_up(as_float4(X), as_float4(X), Y))\n",
"#define SHUFFLE_DOWN(X, Y) \\\n",
"    as_half8(intel_sub_group_shuffle_down(as_float4(X), as_float4(X), Y))\n",
"#endif\n",
"#endif\n",
"#define AS_FLOATX(X, Y) *((__global FLOATX *)(X + Y))\n",
"#define AS_FLOATY(X, Y) *((__global FLOATY *)(X + Y))\n",
"#if UNROLL_M <= 1 * GRX\n",
"#define CALC_X(x, a, b, R0, R1, R2, R3) \\\n",
"    bb = SHUFFLE(b, x); \\\n",
"    R0##x = mad(a, bb, R0##x);\n",
"#elif UNROLL_M <= 2 * GRX\n",
"#define CALC_X(x, a, b, R0, R1, R2, R3) \\\n",
"    bb = SHUFFLE(b, x); \\\n",
"    R0##x = mad(a.s0, bb, R0##x); \\\n",
"    R1##x = mad(a.s1, bb, R1##x);\n",
"#elif UNROLL_M <= 3 * GRX\n",
"#define CALC_X(x, a, b, R0, R1, R2, R3) \\\n",
"    bb = SHUFFLE(b, x); \\\n",
"    R0##x = mad(a.s0, bb, R0##x); \\\n",
"    R1##x = mad(a.s1, bb, R1##x); \\\n",
"    R2##x = mad(a.s2, bb, R2##x);\n",
"#else\n",
"#define CALC_X(x, a, b, R0, R1, R2, R3) \\\n",
"    bb = SHUFFLE(b, x); \\\n",
"    R0##x = mad(a.s0, bb, R0##x); \\\n",
"    R1##x = mad(a.s1, bb, R1##x); \\\n",
"    R2##x = mad(a.s2, bb, R2##x); \\\n",
"    R3##x = mad(a.s3, bb, R3##x);\n",
"#endif\n",
"// This is fixed; 8 threads per core\n",
"#define CALC(a, b, R0, R1, R2, R3) \\\n",
"    CALC_X(0, a, b, R0, R1, R2, R3); \\\n",
"    CALC_X(1, a, b, R0, R1, R2, R3); \\\n",
"    CALC_X(2, a, b, R0, R1, R2, R3); \\\n",
"    CALC_X(3, a, b, R0, R1, R2, R3); \\\n",
"    CALC_X(4, a, b, R0, R1, R2, R3); \\\n",
"    CALC_X(5, a, b, R0, R1, R2, R3); \\\n",
"    CALC_X(6, a, b, R0, R1, R2, R3); \\\n",
"    CALC_X(7, a, b, R0, R1, R2, R3);\n",
"#define INIT_C(n) \\\n",
"    FLOATY cc##n##0 = DATA_ZERO, cc##n##1 = DATA_ZERO; \\\n",
"    FLOATY cc##n##2 = DATA_ZERO, cc##n##3 = DATA_ZERO; \\\n",
"    FLOATY cc##n##4 = DATA_ZERO, cc##n##5 = DATA_ZERO; \\\n",
"    FLOATY cc##n##6 = DATA_ZERO, cc##n##7 = DATA_ZERO;\n",
"#if WITH_ELTWISE == 1\n",
"#define POST_OP(val) \\\n",
"    do { \\\n",
"        if (last_k_block) \\\n",
"            val = fwd_eltwise( \\\n",
"                    val, eltwise_alpha, eltwise_beta, eltwise_scale); \\\n",
"    } while (0)\n",
"#else\n",
"#define POST_OP(val)\n",
"#endif\n",
"#ifdef BETA_ZERO\n",
"#define UPDATE(c, acc) \\\n",
"    do { \\\n",
"        DATA_T val = acc; \\\n",
"        POST_OP(val); \\\n",
"        c = REF_TO_DST(val); \\\n",
"    } while (0)\n",
"#else\n",
"#define UPDATE(c, acc) \\\n",
"    do { \\\n",
"        DATA_T val = DST_TO_REF(c) + acc; \\\n",
"        POST_OP(val); \\\n",
"        c = REF_TO_DST(val); \\\n",
"    } while (0)\n",
"#endif\n",
"#if SIZEX == 1\n",
"#define UPDATE_YY(X, Y, R0, R1, R2, R3) \\\n",
"    if (n > (Y)) { \\\n",
"        if ((m > 0)) { UPDATE(c[offsetC + 0], R0); } \\\n",
"        offsetC += ldc; \\\n",
"    }\n",
"#elif SIZEX == 2\n",
"#define UPDATE_YY(X, Y, R0, R1, R2, R3) \\\n",
"    if (n > (Y)) { \\\n",
"        if ((m > 0)) { UPDATE(c[offsetC + 0], R0); } \\\n",
"        if ((m > 1)) { UPDATE(c[offsetC + 1], R1); } \\\n",
"        offsetC += ldc; \\\n",
"    }\n",
"#elif SIZEX == 3\n",
"#define UPDATE_YY(X, Y, R0, R1, R2, R3) \\\n",
"    if (n > (Y)) { \\\n",
"        if ((m > 0)) { UPDATE(c[offsetC + 0], R0); } \\\n",
"        if ((m > 1)) { UPDATE(c[offsetC + 1], R1); } \\\n",
"        if ((m > 2)) { UPDATE(c[offsetC + 2], R2); } \\\n",
"        offsetC += ldc; \\\n",
"    }\n",
"#else\n",
"#define UPDATE_YY(X, Y, R0, R1, R2, R3) \\\n",
"    if (n > (Y)) { \\\n",
"        if ((m > 0)) { UPDATE(c[offsetC + 0], R0); } \\\n",
"        if ((m > 1)) { UPDATE(c[offsetC + 1], R1); } \\\n",
"        if ((m > 2)) { UPDATE(c[offsetC + 2], R2); } \\\n",
"        if ((m > 3)) { UPDATE(c[offsetC + 3], R3); } \\\n",
"        offsetC += ldc; \\\n",
"    }\n",
"#endif\n",
"#if SIZEY == 1\n",
"#define UPDATE_Y(X, R0, R1, R2, R3) \\\n",
"    UPDATE_YY(X, X *SIZEY + 0, R0##X, R1##X, R2##X, R3##X);\n",
"#elif SIZEY == 2\n",
"#define UPDATE_Y(X, R0, R1, R2, R3) \\\n",
"    UPDATE_YY(X, X *SIZEY + 0, R0##X.s0, R1##X.s0, R2##X.s0, R3##X.s0); \\\n",
"    UPDATE_YY(X, X *SIZEY + 1, R0##X.s1, R1##X.s1, R2##X.s1, R3##X.s1);\n",
"#elif SIZEY == 3\n",
"#define UPDATE_Y(X, R0, R1, R2, R3) \\\n",
"    UPDATE_YY(X, X *SIZEY + 0, R0##X.s0, R1##X.s0, R2##X.s0, R3##X.s0); \\\n",
"    UPDATE_YY(X, X *SIZEY + 1, R0##X.s1, R1##X.s1, R2##X.s1, R3##X.s1); \\\n",
"    UPDATE_YY(X, X *SIZEY + 2, R0##X.s2, R1##X.s2, R2##X.s2, R3##X.s2);\n",
"#else\n",
"#define UPDATE_Y(X, R0, R1, R2, R3) \\\n",
"    UPDATE_YY(X, X *SIZEY + 0, R0##X.s0, R1##X.s0, R2##X.s0, R3##X.s0); \\\n",
"    UPDATE_YY(X, X *SIZEY + 1, R0##X.s1, R1##X.s1, R2##X.s1, R3##X.s1); \\\n",
"    UPDATE_YY(X, X *SIZEY + 2, R0##X.s2, R1##X.s2, R2##X.s2, R3##X.s2); \\\n",
"    UPDATE_YY(X, X *SIZEY + 3, R0##X.s3, R1##X.s3, R2##X.s3, R3##X.s3);\n",
"#endif\n",
"__attribute__((intel_reqd_sub_group_size(GRX))) __kernel void gen9_gemm_compute(\n",
"        long m, long n, long k, __global DATA_T *base, int offsetA, int offsetB,\n",
"        __global DST_DATA_T *c, long offsetC, long ldc, int last_k_block,\n",
"        DATA_T eltwise_alpha, DATA_T eltwise_beta, DATA_T eltwise_scale) {\n",
"    int idx, idy, lid;\n",
"    idx = get_group_id(0);\n",
"    idy = get_group_id(1) * get_enqueued_local_size(1) + get_local_id(1);\n",
"    lid = get_local_id(0); // local ID\n",
"    m -= UNROLL_M * idx;\n",
"    if (m > UNROLL_M) m = UNROLL_M;\n",
"    n -= UNROLL_N * idy;\n",
"    if (n > UNROLL_N) n = UNROLL_N;\n",
"    m -= UNROLL_M * lid / GRX;\n",
"    offsetA += UNROLL_M * k * idx + UNROLL_M * lid / GRX;\n",
"    offsetB += UNROLL_N * k * idy + UNROLL_N * lid / GRX;\n",
"    offsetC += UNROLL_M * idx + UNROLL_N * ldc * idy + UNROLL_M * lid / GRX;\n",
"    INIT_C(0);\n",
"    INIT_C(1);\n",
"    INIT_C(2);\n",
"    INIT_C(3);\n",
"    INIT_C(4);\n",
"    INIT_C(5);\n",
"    INIT_C(6);\n",
"    INIT_C(7);\n",
"    FLOATX blockA = AS_FLOATX(base, offsetA);\n",
"    offsetA += UNROLL_M;\n",
"    FLOATY blockB = AS_FLOATY(base, offsetB);\n",
"    offsetB += UNROLL_N;\n",
"    for (int l = k; l > 0; l--) {\n",
"        FLOATY bb;\n",
"        CALC(blockA, blockB, cc0, cc1, cc2, cc3);\n",
"        blockB = AS_FLOATY(base, offsetB);\n",
"        offsetB += UNROLL_N;\n",
"        blockA = AS_FLOATX(base, offsetA);\n",
"        offsetA += UNROLL_M;\n",
"    }\n",
"    UPDATE_Y(0, cc0, cc1, cc2, cc3);\n",
"#if UNROLL_N >= 2 * SIZEY\n",
"    UPDATE_Y(1, cc0, cc1, cc2, cc3);\n",
"#endif\n",
"#if UNROLL_N >= 3 * SIZEY\n",
"    UPDATE_Y(2, cc0, cc1, cc2, cc3);\n",
"#endif\n",
"#if UNROLL_N >= 4 * SIZEY\n",
"    UPDATE_Y(3, cc0, cc1, cc2, cc3);\n",
"#endif\n",
"#if UNROLL_N >= 5 * SIZEY\n",
"    UPDATE_Y(4, cc0, cc1, cc2, cc3);\n",
"#endif\n",
"#if UNROLL_N >= 6 * SIZEY\n",
"    UPDATE_Y(5, cc0, cc1, cc2, cc3);\n",
"#endif\n",
"#if UNROLL_N >= 7 * SIZEY\n",
"    UPDATE_Y(6, cc0, cc1, cc2, cc3);\n",
"#endif\n",
"#if UNROLL_N >= 8 * SIZEY\n",
"    UPDATE_Y(7, cc0, cc1, cc2, cc3);\n",
"#endif\n",
"}", nullptr };
}
}
}
}